#include <iostream>
#include <algorithm>
#include <vector>

#define endl '\n'
#define BEGIN 0
#define END 1

using namespace std;

struct Segment {
	int l, r, col;
	Segment(int l = 0, int r = 0, int col = 0) {
		this->l = l;
		this->r = r;
		this->col = col;
	}

	bool operator<(Segment other) {
		return l < other.l;
	}
};

struct Occasion {
	int x, type, col;
	Occasion(int x = 0, int type = 0, int col = 0) {
		this->x = x;
		this->type = type;
		this->col = col;
	}

	bool operator<(Occasion other) {
		return x < other.x;
	}
};

int n, m, pos;
vector<int> a;
vector<int> left_pos, right_pos;
vector<Segment> seg;
vector<Occasion> oc;
vector<int> checker;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> m >> n;
	a.resize(m);
	for (int i = 0; i < m; i++) {
		cin >> a[i];
		a[i]--;
	}

	left_pos.assign(n, -1);
	right_pos.assign(n, -1);
	for (int i = 0; i < m; i++) {
		if (left_pos[a[i]] == -1)
			left_pos[a[i]] = i;
		right_pos[a[i]] = i;
	}

	for (int i = 0; i < n; i++)
		if (left_pos[i] != -1) {
			seg.push_back(Segment(left_pos[i], right_pos[i], i));
			oc.push_back(Occasion(left_pos[i], BEGIN, i));
			oc.push_back(Occasion(right_pos[i], END, i));
		}
	sort(seg.begin(), seg.end());
	sort(oc.begin(), oc.end());

	pos = 0;
	for (int i = 0; i < m; i++) {
		if (pos < (int)oc.size() && oc[pos].x == i && oc[pos].type == BEGIN) {
			checker.push_back(oc[pos].col);
			pos++;
		}
		if (checker.size() == 0 || checker.back() != a[i]) {
			cout << -1 << endl;
			return 0;
		}
		if (pos < (int)oc.size() && oc[pos].x == i && oc[pos].type == END) {
			if (oc[pos].col == checker.back())
				checker.pop_back();
			else {
				cout << -1 << endl;
				return 0;
			}
			pos++;
		}
	}

	cout << seg.size() << endl;
	for (int i = 0; i < (int)seg.size(); i++)
		cout << seg[i].col + 1 << ' ' << seg[i].l + 1 << ' ' << seg[i].r + 1 << endl;

	//system("pause");
	return 0;
}