#include <iostream>
#include <algorithm>
#include <vector>
#include <Queue>

using namespace std;

const int dx[4] = { 0, 1, 0, -1 };
const int dy[4] = { 1, 0, -1, 0 };
const int N = 100;

int n, m, q, type, i1, jj1, i2, jj2, k;
int field[N][N], dist[N][N];
queue<pair<int, int>> qu;

int main() {
	cin >> n >> m >> q;

	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
			field[i][j] = 0;

	for (int t = 0; t < q; t++) {
		for (int i = 0; i < n; i++)
			for (int j = 0; j < m; j++)
				field[i][j]++;
		cin >> type;
		if (type == 1) {
			cin >> i1;
			i1--;
			for (int j = 0; j < m; j++)
				field[i1][j] = 0;
			continue;
		}
		if (type == 2) {
			cin >> jj1;
			jj1--;
			for (int i = 0; i < n; i++)
				field[i][jj1] = 0;
		}
		if (type == 3) {
			cin >> i1 >> jj1 >> i2 >> jj2 >> k;
			i1--;
			jj1--;
			i2--;
			jj2--;
			if (field[i1][jj1] > k) {
				cout << -1 << endl;
				continue;
			}
			qu.push({ i1, jj1 });
			for (int i = 0; i < n; i++)
				for (int j = 0; j < m; j++)
					dist[i][j] = -1;
			dist[i1][jj1] = 0;
			while (qu.size() > 0) {
				int i = qu.front().first;
				int j = qu.front().second;
				qu.pop();
				for (int x = 0; x < 4; x++)
					if (i + dx[x] >= 0 && j + dy[x] >= 0 && i + dx[x] < n && j + dy[x] < m)
						if (field[i + dx[x]][j + dy[x]] <= k && dist[i + dx[x]][j + dy[x]] == -1) {
							dist[i + dx[x]][j + dy[x]] = dist[i][j] + 1;
							qu.push({ i + dx[x], j + dy[x] });
						}
			}
			if (dist[i2][jj2] != -1)
				cout << dist[i2][jj2] << endl;
			else
				cout << -1 << endl;
		}
	}

	//system("pause");
	return 0;
}