#include <iostream>
#include <vector>
#include <algorithm>

const long UNDEFINED = -1000;

struct Range {
    long start;
    long end;
    long group;
};

bool find_ans(long current_bound_index, long& global_bound_index, Range bounds[], long to_call, std::vector<Range>& result) {
//    std::cout << "Ans for " << bounds[current_bound_index].start << " .. " << bounds[current_bound_index].end << std::endl;
//    std::cout << global_bound_index << std::endl;

    bool ans = true;
    result.push_back(bounds[current_bound_index]);
    global_bound_index++;
    for (; global_bound_index < to_call; ) {
        if (bounds[global_bound_index].start > bounds[current_bound_index].end)
            break;
        if (bounds[global_bound_index].end > bounds[current_bound_index].end)
            return false;
        ans = ans & find_ans(global_bound_index, global_bound_index, bounds, to_call, result);
    }
    return ans;
}

bool compare(Range& r1, Range& r2) {
    return r1.start < r2.start;
}

int main() {
    long d_size, d_count;
    std::cin >> d_size >> d_count;

    long* colors = new long[d_size]; // 0..d_size - 1
    for (long i = 0; i < d_size; i++)
        std::cin >> colors[i];

    long* groups_count = new long[d_count];
    for (long color = 0; color < d_count; color++) {
        groups_count[color] = 0;
    }
    long last_color = -1;
    for (long color = 0; color < d_size; color++) {
        if (colors[color] != last_color) {
            last_color = colors[color];
            groups_count[last_color - 1]++;
        }
    }

    Range* bounds = new Range[d_count + 1]; // 0..d_count
    bounds[0].start = -1;
    bounds[0].end = d_size;
    bounds[0].group = -1;
    for (long i = 1; i <= d_count; i++)
        bounds[i] = { UNDEFINED, UNDEFINED, i };

    long to_call = 0;
    for (long color = 0; color < d_size; color++) {
        if (bounds[colors[color]].start == UNDEFINED) {
            bounds[colors[color]].start = color;
            bounds[colors[color]].end = color;
            to_call++;
        } else {
            bounds[colors[color]].end = color;
        }
    }

    long new_bounds_len = 1;
    for (long bound = 1; bound <= d_count; bound++) {
        if (bounds[bound].start != UNDEFINED) {
            bounds[new_bounds_len] = bounds[bound];
            new_bounds_len++;
        }
    }

    std::sort(bounds, bounds + to_call + 1, compare);

    std::vector<Range> result;
    long global_bound_index = 0;
    bool ans = find_ans(0, global_bound_index, bounds, to_call + 1, result);

    if (!ans) {
        std::cout << "-1" << std::endl;
        return 0;
    }

    long* check_colors = new long[d_size];
    for (long i = 1; i < result.size(); i++) {
        std::fill(check_colors + result[i].start, check_colors + result[i].end + 1, result[i].group);
    }

    for (long color = 0; color < d_size; color++) {
        if (colors[color] != check_colors[color]) {
            std::cout << "-1" << std::endl;
            return 0;
        }
    }

    std::cout << to_call << std::endl;
    for (long i = 1; i < result.size(); i++)
        std::cout << result[i].group << " " << result[i].start + 1 << " " << result[i].end + 1 << std::endl;

    return 0;
}