#include <iostream>
#include <queue>

struct Point {
    long row;
    long col;
    long priority;
    long steps;

    bool operator>(Point other) {
        return this->priority > other.priority;
    }
};

int main() {
    long height, width, queries;
    std::cin >> height >> width >> queries;

    long* field = new long[height * width];
    std::fill(field, field + height * width, 0);

    bool* close = new bool[height * width];
    for (long query = 0; query < queries; query++) {
        long type;
        std::cin >> type;

        switch (type) {
            case 1:
                long row;
                std::cin >> row;

                for (long r = 0; r < height; r++)
                    if (r != row - 1)
                        for (long c = 0; c < width; c++)
                            field[r * width + c]++;

                std::fill(field + (row - 1) * width, field + row * width, 0);
                break;
            case 2:
                long col;
                std::cin >> col;

                for (long r = 0; r < height; r++)
                    for (long c = 0; c < width; c++)
                        field[r * width + c] = c == col - 1 ? 0 : field[r * width + c] + 1;

                break;
            case 3:
#define PUSH_POINT(r, c, s) { open.push({(r), (c), std::abs((r) - row2 + 1) + std::abs((c) - col2 + 1) + (s), (s) }); }

                long row1, col1, row2, col2, a;
                std::cin >> row1 >> col1 >> row2 >> col2 >> a;

                for (long r = 0; r < height; r++)
                    for (long c = 0; c < width; c++)
                        field[r * width + c]++;

                if (field[(row1 - 1) * width + col1 - 1] > a) {
                    std::cout << "-1" << std::endl;
                    continue;
                }

                std::priority_queue<Point, std::vector<Point>, std::greater<>> open = {};
                std::fill(close, close + height * width, false);
                PUSH_POINT(row1 - 1, col1 - 1, 0);

                long result = -1;
                while (!open.empty()) {
                    Point next = open.top();

                    // std::cout << "Next point is " << next.row << ", " << next.col << std::endl;

                    if (next.row == row2 - 1 && next.col == col2 - 1) {
                        result = next.steps;
                        break;
                    }

                    if (next.row > 0 && !close[(next.row - 1) * width + next.col] && field[(next.row - 1) * width + next.col] <= a) {
                        close[(next.row - 1) * width + next.col] = true;
                        PUSH_POINT(next.row - 1, next.col, next.steps + 1);
                    }
                    if (next.row < height - 1 && !close[(next.row + 1) * width + next.col] && field[(next.row + 1) * width + next.col] <= a) {
                        close[(next.row + 1) * width + next.col] = true;
                        PUSH_POINT(next.row + 1, next.col, next.steps + 1);
                    }
                    if (next.col > 0 && !close[next.row * width + next.col - 1] && field[next.row * width + next.col - 1] <= a) {
                        close[next.row * width + next.col - 1] = true;
                        PUSH_POINT(next.row, next.col - 1, next.steps + 1);
                    }
                    if (next.col < width - 1 && !close[next.row * width + next.col + 1] && field[next.row * width + next.col + 1] <= a) {
                        close[next.row * width + next.col + 1] = true;
                        PUSH_POINT(next.row, next.col + 1, next.steps + 1);
                    }

                    open.pop();
                }

                std::cout << result << std::endl;

                break;
        }
    }

    return 0;
}