#include <iostream>
#include <queue>
#include <algorithm>

struct Point {
    long row;
    long col;
    long steps;
    long priority;

    bool operator>(Point other) {
        return this->priority > other.priority;
    }
};

int main() {
    long height, width, queries;
    std::cin >> height >> width >> queries;

    // long* field = new long[height * width];
    // std::fill(field, field + height * width, 0);
    long* last_cleaned_row = new long[height];
    std::fill(last_cleaned_row, last_cleaned_row + height, 0);
    long* last_cleaned_col = new long[width];
    std::fill(last_cleaned_col, last_cleaned_col + width, 0);

    bool* close = new bool[height * width];
    for (long query = 0; query < queries; query++) {
        long type;
        std::cin >> type;

        switch (type) {
            case 1:
                long row;
                std::cin >> row;

                last_cleaned_row[row - 1] = query + 1;
                break;
            case 2:
                long col;
                std::cin >> col;

                last_cleaned_col[col - 1] = query + 1;
                break;
            case 3:
#define PUSH_POINT(r, c, s) { open.push({(r), (c), (s) }); }
#define SNOW_AT(r, c) (query + 1 - std::max(last_cleaned_row[r], last_cleaned_col[c]))

                long row1, col1, row2, col2, a;
                std::cin >> row1 >> col1 >> row2 >> col2 >> a;

                if (SNOW_AT(row1 - 1, col1 - 1) > a) {
                    std::cout << "-1" << std::endl;
                    continue;
                }

                std::priority_queue<Point, std::vector<Point>, std::greater<>> open = {};
                // std::queue<Point> open;
                std::fill(close, close + height * width, false);
                PUSH_POINT(row1 - 1, col1 - 1, 0);

                long result = -1;
                while (!open.empty()) {
                    Point next = open.top();
                    open.pop();

                    // std::cout << "Next point is " << next.row << ", " << next.col << std::endl;

                    if (next.row == row2 - 1 && next.col == col2 - 1) {
                        result = next.steps;
                        break;
                    }

                    if (next.row > 0 && !close[(next.row - 1) * width + next.col] && SNOW_AT(next.row - 1, next.col) <= a) {
                        close[(next.row - 1) * width + next.col] = true;
                        PUSH_POINT(next.row - 1, next.col, next.steps + 1);
                    }
                    if (next.row < height - 1 && !close[(next.row + 1) * width + next.col] && SNOW_AT(next.row + 1, next.col) <= a) {
                        close[(next.row + 1) * width + next.col] = true;
                        PUSH_POINT(next.row + 1, next.col, next.steps + 1);
                    }
                    if (next.col > 0 && !close[next.row * width + next.col - 1] && SNOW_AT(next.row, next.col - 1) <= a) {
                        close[next.row * width + next.col - 1] = true;
                        PUSH_POINT(next.row, next.col - 1, next.steps + 1);
                    }
                    if (next.col < width - 1 && !close[next.row * width + next.col + 1] && SNOW_AT(next.row, next.col + 1) <= a) {
                        close[next.row * width + next.col + 1] = true;
                        PUSH_POINT(next.row, next.col + 1, next.steps + 1);
                    }
                }

                std::cout << result << std::endl;

                break;
        }
    }

    return 0;
}