#include <bits/stdc++.h>

#define int long long

#define endl '\n'

const int INF = 1e9 + 228;

using namespace std;

int dist(int x, int y, int x1, int y1) {
    return abs(x - x1) + abs(y - y1);
}

struct ql
{
    int mx, mn;
};

struct segtree {
    vector<ql> t;
    int n;
    void  build(int _n)
    {
        n = _n;
        t.resize(4 * n);
    }
    void upd(int v, int l, int r, int L, int R, int x) {
        if (l >= R || L >= r)
            return;
        if (L <= l && r <= R) {
            t[v].mn = x;
            t[v].mx = x;
            return;
        }
        upd(v * 2, l, (l + r) / 2, L, R, x);
        upd(v * 2 + 1, (l + r) / 2, r, L, R, x);
        t[v].mn = min(t[v * 2].mn, t[v * 2 + 1].mn);
        t[v].mx = max(t[v * 2].mx, t[v * 2 + 1].mx);
    }

    ql get(int v, int l, int r, int L, int R) {
        if(l >= R || L >= r){
            ql ret;
            ret.mn = INF;
            ret.mx = -INF;
            return ret;
        }
        if(L <= l && r <= R)
        {
            return t[v];
        }
        auto get_1 = get(v * 2, l, (l + r) / 2, L, R);
        auto get_2 = get(v * 2 + 1, (l + r) / 2, r, L, R);
        ql ret;
        ret.mx = max(get_1.mx, get_2.mx);
        ret.mn = min(get_1.mn, get_2.mn);
        return ret;
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int n, m, q;
    cin >> n >> m >> q;
    vector<int> r(n);
    vector<int> c(m);
    segtree R, C;
    R.build(n);
    C.build(m);
    vector<vector<int>> v(n, vector<int> (m));
    int t = 1;
    for (int i = 0; i < q; ++i, ++t) {
        int qq;
        cin >> qq;
        if (qq == 1) {
            int rr;
            cin >> rr;
            r[rr - 1] = t;
            R.upd(1, 0, n, rr - 1, rr, t);
        } else if (qq == 2) {
            int cc;
            cin >> cc;
            c[cc - 1] = t;
            C.upd(1, 0, m, cc - 1, cc, t);
        } else {
            int ans = INF;
            int r1, c1, r2, c2, k;
            cin >> r1 >> c1 >> r2 >> c2 >> k;
            --r1;
            --c1;
            --r2;
            --c2;
            int X = dist(r1, c1, r2, c2);
            ans = X;

            auto x = R.get(1, 0, n, min(r1, r2), max(r1, r2) + 1);
            if(t - x.mn <= k)
            {
                cout << X << '\n';
                continue;
            }
            x = C.get(1, 0, m, min(c1, c2), max(c1, c2) + 1);
            if (t - x.mn <= k) {
                cout << X << endl;
                continue;
            }


            if (t - r[r1] <= k && t - c[c2] <= k) {
                cout << X << endl;
                continue;
            } else if (t - c[c1] <= k && t - r[r2] <= k) {
                cout << X << endl;
                continue;
            }
            if (t - c[c1] <= k && t - c[c2] <= k) {

                if (r1 > r2) {
                    swap(r1, r2);
                    swap(c1, c2);
                }
                for (int j = r1; j <= r2; ++j)
                    if (t - r[j] <= k)
                        ans = X;
                for (int j = 0; j <= r1; ++j) {
                    if (t - r[j] <= k) {
                        ans = min(ans, (r1 - j) + dist(j, c1, r2, c2));
                    }
                }
                for (int j = n - 1; j >= r2; --j) {
                    if (t - r[j] <= k) {
                        ans = min(ans, (j - r2) + dist(r1, c1, j, c2));
                    }
                }
            }
            if (t - r[r1] <= k && t - r[r2] <= k) {
                if (c1 > c2) {
                    swap(c1, c2);
                    swap(r1, r2);
                }
                for (int j = c1; j <= c2; ++j)
                    if (t - c[j] <= k)
                        ans = X;

                for(int j = 0; j <= c1; ++j)
                {
                    if(t - c[j] <= k)
                    {
                        ans = min(ans, dist(r1, j, r2, c2) + (c1 - j));
                    }
                }
                for(int j = m - 1; j >= c2; --j)
                {
                    if(t - c[j] <= k)
                    {
                        ans = min(ans, dist(r1, c1, r2, j) + (j - c2));
                    }
                }
            }
            if (ans == INF)
                cout << -1 << endl;
            else
                cout << ans << endl;
        }
    }
}