#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<iomanip>
#include<string>
#include<vector>
#include<stack>
#include<queue>
#include<deque>
#include<map>
#include<set>
#include<unordered_map>
#include<unordered_set>
#include<random>
#include<algorithm>
#include<math.h>
#include<cmath>
#include<assert.h>

using namespace std;

typedef long long ll;
typedef long double ld;

ll INF = 2 * (1e18);
ll inf = 1e9 + 10;
ll MOD = 1e9 + 7;
ld eps = 1e-9;

struct seg_tree {
	vector<int>tmin, tmax;
	int n;

	seg_tree(int _n) {
		n = _n;
		tmin.resize(n * 5, 0);
		tmax.resize(n * 5, 0);
	}

	void update(int v, int tl, int tr, int pos, int val) {
		if (tl == tr) {
			tmin[v] = tmax[v] = val;
		} else {
			int tm = (tl + tr) / 2;
			if (pos <= tm) {
				update(v * 2, tl, tm, pos, val);
			} else {
				update(v * 2 + 1, tm + 1, tr, pos, val);
			}
			tmin[v] = min(tmin[v * 2], tmin[v * 2 + 1]);
			tmax[v] = max(tmax[v * 2], tmax[v * 2 + 1]);
		}
	}

	void update(int pos, int val) {
		update(1, 0, n, pos, val);
	}

	int get_min(int v, int tl, int tr, int l, int r) {
		l = max(l, tl);
		r = min(r, tr);
		if (l > r) {
			return inf;
		}
		if (l == tl && r == tr) {
			return tmin[v];
		}
		int tm = (tl + tr) / 2;
		return min(get_min(v * 2, tl, tm, l, r), get_min(v * 2 + 1, tm + 1, tr, l, r));
	}

	int get_min(int l, int r) {
		return get_min(1, 0, n, l, r);
	}

	int get_max(int v, int tl, int tr, int l, int r) {
		l = max(l, tl);
		r = min(r, tr);
		if (l > r) {
			return -inf;
		}
		if (l == tl && r == tr) {
			return tmax[v];
		}
		int tm = (tl + tr) / 2;
		return max(get_max(v * 2, tl, tm, l, r), get_max(v * 2 + 1, tm + 1, tr, l, r));
	}

	int get_max(int l, int r) {
		return get_max(1, 0, n, l, r);
	}

};


signed main() {
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(0);
#ifdef DEBUG
	freopen("input.txt", "r", stdin);
#endif // DEBUG

	int n, m, q;
	cin >> n >> m >> q;
	vector<int>a(n,0), b(m,0);

	vector<int>ap, bp;
	vector<int>au(n,0), bu(m,0);

	seg_tree ta(n), tb(m);


	for (int it = 1; it <= q; it++) {
		int type;
		cin >> type;
		if (type == 1) {
			int x;
			cin >> x;
			a[x - 1] = it;
			if (au[x - 1] == 0) {
				ap.push_back(x - 1);
				au[x - 1] = 1;
			}
			ta.update(x - 1, it);
		}
		if (type == 2) {
			int x;
			cin >> x;
			b[x - 1] = it;
			if (bu[x - 1] == 0) {
				bp.push_back(x - 1);
				bu[x - 1] = 1;
			}
			tb.update(x - 1, it);
		}
		if(type == 3) {
			int i1, j1, i2, j2, k;
			cin >> i1 >> j1 >> i2 >> j2 >> k;
			i1--; j1--; i2--; j2--;
			int ans = inf;

			if (it - 0 <= k) {
				cout << abs(i1 - i2) + abs(j1 - j2) << '\n';
				continue;
			}

			if (it - a[i1] <= k && it - b[j2] <= k) {
				ans = abs(i1 - i2) + abs(j1 - j2);
			}

			if (it - a[i2] <= k && it - b[j1] <= k) {
				ans = abs(i1 - i2) + abs(j1 - j2);
			}


			int val = ta.get_min(min(i1, i2), max(i1, i2));

			if (it - val <=k ) {
				ans = abs(i1 - i2) + abs(j1 - j2);
			}

			val = tb.get_min(min(j1, j2), max(j1, j2));

			if (it - val <= k) {
				ans = abs(i1 - i2) + abs(j1 - j2);
			}

			if (ans == abs(i1 - i2) + abs(j1 - j2)) {
				cout << ans << '\n';
				continue;
			}



			if (it - a[i1] <= k && it - a[i2] <= k) {
				int mx = tb.get_max(min(j1, j2), max(j1, j2));
				if (it - mx <= k) {
					ans = abs(i1 - i2) + abs(j1 - j2);
				}

				int l = 0, r = min(j1, j2);
				while (r - l > 1) {
					int cm = (l + r) / 2;
					if (it - tb.get_max(cm, min(j1,j2)) <= k) {
						l = cm;
					} else {
						r = cm;
					}
				}

				if (it - b[l] <= k) {
					ans = min(ans, abs(l - j1) + abs(l - j2) + abs(i1 - i2));
				}

				l = max(j1, j2), r = m;
				while (r - l > 1) {
					int cm = (l + r) / 2;
					if (it - tb.get_max( max(j1, j2), cm) <= k) {
						r = cm;
					} else {
						l = cm;
					}
				}

				if (it - b[r] <= k) {
					ans = min(ans, abs(r - j1) + abs(r - j2) + abs(i1 - i2));
				}
			}





			if (it - b[j1] <= k && it - b[j2] <= k) {
				for (auto i : ap) {
					if (it - a[i] <= k) {
						if (i >= min(i1, i2) && i <= max(i1, i2)) {
							ans = abs(i1 - i2) + abs(j1 - j2);
						} else {
							ans = min(ans, abs(i - i1) + abs(i - i2) + abs(j1 - j2));
						}
					}
				}
			}


			if (ans == inf) {
				cout << -1;
			} else {
				cout << ans;
			}
			cout << '\n';

		}
	}


	return 0;
}
