#include <bits/stdc++.h>
using namespace std;

#define INF 1000000010
#define MOD 1000000007
#define pb push_back
#define f first
#define s second

using vi = vector <int>;
using ll = long long;
using pii = pair <int, int>;

void fastIO(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	#ifdef LOCAL
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif
}

const int MAXN = 1e6 + 10;

int n, m, q;
int col[MAXN], row[MAXN];

int get_case(int x, int y, int k){
	if(row[x] < k && col[y] < k) return 0;
	else if(row[x] >= k && col[y] >= k) return 3;
	else if(row[x] >= k && col[y] < k) return 1;
	return 2;
}

int solve1(int a, int b, int c, int d, int k){
	bool good = 1;
	for(int i = min(a, c) + 1; i < max(a, c); i++)
		good &= (row[i] >= k);
	if(good)	
		return abs(a - c) + abs(b - d);
	int ans = INF;
 	for(int i = 0; i < m; i++){
 		if(col[i] >= k)
 			ans = min(ans, abs(a - c) + abs(i - b) + abs(i - d));
 	}
 	if(ans == INF)
 		return -1;
	return ans;
}

int solve2(int a, int b, int c, int d, int k){
	bool good = 1;
	for(int i = min(b, d) + 1; i < max(b, d); i++)
		good &= (col[i] >= k);
	if(good)
		return abs(a - c) + abs(b - d);
	int ans = INF;
 	for(int i = 0; i < n; i++){
 		if(row[i] >= k)
 			ans = min(ans, abs(b - d) + abs(a - i) + abs(c - i));
 	}
 	if(ans == INF)
 		return -1;
 	return ans;
}

int main(){
 	fastIO();
 	cin >> n >> m >> q;
 	for(int num = 1; num <= q; num++){
 		int id;
 		cin >> id;
 		if(id == 1){
 			int r;
 			cin >> r;
 			r--;
 			row[r] = num;
 		}
 		else if(id == 2){
 			int c;
 			cin >> c;
 			c--;
 			col[c] = num;
 		}
 		else{
 			int a, b, c, d, k;
 			cin >> a >> b >> c >> d >> k;
 			a--; b--; c--; d--;
 			k = num - k;
 			int c1 = get_case(a, b, k), c2 = get_case(c, d, k);
 			if(c1 == 0 || c2 == 0)
 				cout << -1 << '\n';
 			else if(c1 == 3 || c2 == 3 || (c1 != c2))
 				cout << abs(a - c) + abs(b - d) << '\n';
 			else if(c1 == 1)
 				cout << solve1(a, b, c, d, k) << '\n';	
 			else
 				cout << solve2(a, b, c, d, k) << '\n';
 		}
 	}
 	
 	
 	
 	return 0;
}