#include <bits/stdc++.h>
using namespace std;

#define INF 1000000010
#define MOD 1000000007
#define pb push_back
#define f first
#define s second

using vi = vector <int>;
using ll = long long;
using pii = pair <int, int>;

void fastIO(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	#ifdef LOCAL
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif
}

const int MAXN = 5000 + 10;

int t, n, m, q, p;
vector <vector <pair <int, ll> > > v;
vi top;
bool was[MAXN];

void dfs(int u){
	was[u] = 1;
	for(auto to : v[u]){
		if(was[to.f] == 0)
			dfs(to.f);
	}
	top.pb(u);
}


string solve1(){
	vector <vector <ll> > dist;
	dist.resize(n);
	dist[0].pb(0);
	for(int i = 0; i < n; i++){
		int ver = top[i];
		for(auto cur : dist[ver]){
			for(auto to : v[ver])
				dist[to.f].pb(cur + to.s);
		}
	}
	for(int i = 0; i < n; i++){
		sort(dist[i].begin(), dist[i].end());
	}
	string ans;
	while(q--){
		int to;
		ll r;
		cin >> to >> r;
		to--;
		int pos = lower_bound(dist[to].begin(), dist[to].end(), r) - dist[to].begin();
		if(pos == dist[to].size() || dist[to][pos] * (ll)(p - 1) > r * (ll)p)  
			ans.pb('0');
		else
			ans.pb('1');
	}
	for(int i = 0; i < n; i++)
		dist[i].clear();
	return ans;
}

string solve2(){
	vector <vector <bool> > can;
	can.resize(n);
	for(int i = 0; i < n; i++)
		can[i].resize(2 * MAXN);
	can[0][0] = 1;
	for(int i = 0; i < n; i++){
		int ver = top[i];
		for(int j = 0; j < 2 * MAXN; j++){
			if(can[ver][j] == 0)
				continue;
			for(auto to : v[ver]){
				if(j + to.s < 2 * MAXN)
					can[to.f][j + to.s] = 1;
			}
		}
	}
	string ans;
	while(q--){
		int to;
		ll r;
		cin >> to >> r;
		to--;
		int up = r * p / (p - 1);
		bool good = 0;
		for(int i = r; i <= up; i++){
			if(can[to][i]){
				good = 1;
				break; 
			}
		}
		good ? ans.pb('1') : ans.pb('0');
	}
	for(int i = 0; i < n; i++){
		for(int j = 0; j < 2 * MAXN; j++)
			can[i][j] = 0;
	}
	return ans;
}

string solve(){
	cin >> n >> m >> q >> p;
	v.resize(n);
	for(int i = 0; i < m; i++){
		int from, to;
		ll len;
		cin >> from >> to >> len;
		v[from - 1].pb({to - 1, len});		
	}
	dfs(0);
	reverse(top.begin(), top.end());
	string ans;
	if(n <= 10 && m <= 10 && q <= 10)
		ans = solve1();
	else
		ans = solve2();
	top.clear();
	for(int i = 0; i < n; i++)
		v[i].clear();
	fill(was, was + n, 0);	
	return ans;
}


int main(){
 	fastIO();
 	cin >> t;
 	while(t--){
 		cout << solve() << '\n';
 	}
 	
 	
 	
 	
 	return 0;
}