#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
#define int ll
#define pb push_back
#define len(x) (int)(x).size()
typedef pair<int, int> pii;
#define F first
#define S second
#define all(x) (x).begin(), (x).end()

bool cmp(const pair<int, pii> &a, const pair<int, pii> &b) {
	int l1 = a.S.S - a.S.F + 1;
	int l2 = b.S.S - b.S.F + 1;
	return l1 > l2;
}

struct Segtree {
	struct Node {
		int val = -1;
		bool need_push = 0;
	};

	int n;
	vector<Node> t;

	void push(int x, int l, int r) {
		if (t[x].need_push) {
			t[x].need_push = 0;
			if (r - l != 1) {
				t[2 * x + 1].need_push = 1;
				t[2 * x + 1].val = t[x].val;
				t[2 * x + 2].need_push = 1;
				t[2 * x + 2].val = t[x].val;
			}
		}
	}

	Segtree(int n) : n(n) {
		t.resize(5 * n);
	}

	void update(int x, int l, int r, int ql, int qr, int val) {
		push(x, l, r);
		if (ql >= r || l >= qr)
			return;
		if (ql <= l && r <= qr) {
			t[x].val = val;
			t[x].need_push = 1;
			push(x, l, r);
			return;
		}
		int c = (l + r) / 2;
		update(2 * x + 1, l, c, ql, qr, val);
		update(2 * x + 2, c, r, ql, qr, val);
	}

	int query(int x, int l, int r, int i) {
		push(x, l, r);
		if (l > i || r <= i)
			return -1;
		if (r - l == 1)
			return t[x].val;
		int c = (l + r) / 2;
		return max(query(2 * x + 1, l, c, i), query(2 * x + 2, c, r, i));
	}
};

void run() {
	int m, n;
	cin >> m >> n;
	vector<int> a(m);
	vector<vector<int>> pos(n, vector<int>());
	for (auto &x : a) {
		cin >> x;
		--x;
	}
	for (int i = 0; i < m; ++i) {
		pos[a[i]].pb(i);
	}
	vector<pair<int, pii>> ans;
	vector<int> res(m, -1);
	for (int i = 0; i < n; ++i) {
		if (len(pos[i])) {
			int l = pos[i][0];
			int r = pos[i].back();
			ans.pb({i, {l, r + 1}});
		}
	}
	sort(all(ans), cmp);
	Segtree st(m);
	for (auto x : ans) {
		// cout << x.F+1 << ' ' << x.S.F+1 << ' ' << x.S.S << '\n';
		// for (int j = x.S.F; j < x.S.S; ++j) {
		// 	res[j] = x.F;
		// }
		st.update(0, 0, m, x.S.F, x.S.S, x.F);
	}
	for (int i = 0; i < m; ++i) {
		res[i] = st.query(0, 0, m, i);
	}
	// vector<int> ST;
	// ST.pb(-1);
	// for (int i = 0; i <= m; ++i) {
	// 	for (auto x : sn[i]) {
	// 		if (x != pii(-1, -1)) {
	// 			int val = x.S;
	// 			if (x.F == 1) {
	// 				ST.pb(val);
	// 			} else {
	// 				ST.pop_back();
	// 			}
	// 			res[i] = ST.back();
	// 		}
	// 	}
	// }
	// for (auto x : res)
	// 	cout << x << ' ';
	// cout << endl;
	if (res != a) {
		cout << -1 << '\n';
	} else {
		cout << len(ans) << '\n';
		for (auto x : ans) {
			cout << x.F + 1 << ' ' << x.S.F + 1 << ' ' << x.S.S << '\n';
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	run();
}