#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
#define int ll
#define pb push_back
#define len(x) (int)(x).size()
typedef pair<int, int> pii;
#define F first
#define S second
#define all(x) (x).begin(), (x).end()

const int INF = 1e9;

struct Segtree {
	struct Node {
		int mn, mx;
	};

	int n;
	vector<Node> t;

	void init(int nn) {
		n = nn;
		t.resize(5 * n);
	}

	void update(int x, int l, int r, int i, int val) {
		if (l > i || r <= i)
			return;
		if (r - l == 1) {
			t[x].mn = t[x].mx = val;
			return;
		}
		int c = (l + r) / 2;
		update(2 * x + 1, l, c, i, val);
		update(2 * x + 2, c, r, i, val);
		t[x].mn = min(t[2 * x + 1].mn, t[2 * x + 2].mn);
		t[x].mx = max(t[2 * x + 1].mx, t[2 * x + 2].mx);
	}

	void update(int i, int val) {
		update(0, 0, n, i, val);
	}

	int mn_query(int x, int l, int r, int ql, int qr) {
		if (ql >= r || l >= qr)
			return INF;
		if (ql <= l && r <= qr)
			return t[x].mn;
		int c = (l + r) / 2;
		return min(mn_query(2 * x + 1, l, c, ql, qr), mn_query(2 * x + 2, c, r, ql, qr));
	}

	int mn_query(int ql, int qr) {
		return mn_query(0, 0, n, ql, qr);
	}

	int get(int i) {
		return mn_query(i, i + 1);
	}

	int more_query_left(int x, int l, int r, int ql, int k) {
		if (r - 1 <= ql)
			return INF;
		int c = (l + r) / 2;
		if (l >= ql) {
			if (t[x].mx < k)
				return INF;
			if (r - l == 1) {
				return l;
			}
			if (t[2 * x + 1].mx >= k) {
				return more_query_left(2 * x + 1, l, c, ql, k);
			} else {
				return more_query_left(2 * x + 2, c, r, ql, k);
			}
		} else {
			if (r - l == 1) {
				return INF;
			}
			return min(more_query_left(2 * x + 1, l, c, ql, k), more_query_left(2 * x + 2, c, r, ql, k));
		}
	}

	int more_query_left(int ql, int k) {
		return more_query_left(0, 0, n, ql, k);
	}

	int more_query_right(int x, int l, int r, int qr, int k) {
		if (l > qr)
			return -INF;
		int c = (l + r) / 2;
		if (r - 1 <= qr) {
			if (t[x].mx < k)
				return -INF;
			if (r - l == 1) {
				return l;
			}
			if (t[2 * x + 2].mx >= k) {
				return more_query_right(2 * x + 2, c, r, qr, k);
			} else {
				return more_query_right(2 * x + 1, l, c, qr, k);
			}
		} else {
			if (r - l == 1) {
				return -INF;
			}
			return max(more_query_right(2 * x + 1, l, c, qr, k), more_query_right(2 * x + 2, c, r, qr, k));
		}
	}

	int more_query_right(int qr, int k) {
		return more_query_right(0, 0, n, qr, k);
	}
};

int n, m, q;
// vector<int> v1, v2;
Segtree st1, st2;

int solve(int x0, int y0, int x1, int y1, int k, int I) {
	int mn_dist = abs(x0 - x1) + abs(y0 - y1);
	int mx1 = 0;
	// for (int i = min(x0, x1); i <= max(x0, x1); ++i) {
	// 	mx1 = max(mx1, I - v1[i]);
	// }
	mx1 = I - st1.mn_query(min(x0, x1), max(x0, x1) + 1);
	if (mx1 <= k)
		return mn_dist;
	int mx2 = 0;
	// for (int i = min(y0, y1); i <= max(y0, y1); ++i) {
	// 	mx2 = max(mx2, I - v2[i]);
	// }
	mx2 = I - st2.mn_query(min(y0, y1), max(y0, y1) + 1);
	if (mx2 <= k)
		return mn_dist;
	bool b11 = (I - st1.get(x0) <= k);
	bool b12 = (I - st2.get(y0) <= k);
	bool b21 = (I - st1.get(x1) <= k);
	bool b22 = (I - st2.get(y1) <= k);
	if (!(b11 || b12))
		return -1;
	if (!(b21 || b22))
		return -1;
	if ((b11 && b22) || (b12 && b21)) {
		return mn_dist;
	}
	if (x0 == x1 && b11 && b21) {
		return mn_dist;
	}
	if (y0 == y1 && b12 && b22) {
		return mn_dist;
	}
	if (b11) {
		int l = y0;
		int r = y1;
		if (l > r)
			swap(l, r);
		int ans = INF;
		// for (int i = 0; i < m; ++i) {
		// 	if (I - st2.get(i) <= k) {
		// 		ans = min(ans, abs(l - i) + abs(r - i) + abs(x0 - x1));
		// 	}
		// }
		int idx;
		idx = st2.more_query_left(l, I - k);
		if (idx >= 0 && idx < m) {
			ans = min(ans, abs(l - idx) + abs(r - idx) + abs(x0 - x1));
		}
		idx = st2.more_query_right(r, I - k);
		if (idx >= 0 && idx < m) {
			ans = min(ans, abs(l - idx) + abs(r - idx) + abs(x0 - x1));
		}
		// cout << "+\n";
		if (ans >= INF)
			ans = -1;
		return ans;
	} else {
		int l = x0;
		int r = x1;
		if (l > r)
			swap(l, r);
		int ans = INF;
		// for (int i = 0; i < n; ++i) {
		// 	if (I - st1.get(i) <= k) {
		// 		ans = min(ans, abs(l - i) + abs(r - i) + abs(y0 - y1));
		// 	}
		// }
		int idx;
		idx = st1.more_query_left(l, I - k);
		if (idx >= 0 && idx < n) {
			ans = min(ans, abs(l - idx) + abs(r - idx) + abs(y0 - y1));
		}
		// cout << idx << "s\n";
		idx = st1.more_query_right(r, I - k);
		if (idx >= 0 && idx < n) {
			ans = min(ans, abs(l - idx) + abs(r - idx) + abs(y0 - y1));
		}
		// cout << st1.get(0) << " get\n";
		// cout << idx << "s\n";
		if (ans >= INF)
			ans = -1;
		return ans;
	}
}

void run() {
	cin >> n >> m >> q;
	// v1.resize(n);
	// v2.resize(m);
	st1.init(n);
	st2.init(m);
	for (int i = 1; i <= q; ++i) {
		int type;
		cin >> type;
		if (type == 1) {
			int x;
			cin >> x;
			--x;
			// v1[x] = i;
			st1.update(x, i);
		}
		if (type == 2) {
			int x;
			cin >> x;
			--x;
			// v2[x] = i;
			st2.update(x, i);
		}
		if (type == 3) {
			int x0, y0, x1, y1, k;
			cin >> x0 >> y0 >> x1 >> y1 >> k;
			--x0, --y0, --x1, --y1;
			int ans = solve(x0, y0, x1, y1, k, i) ;
			// int real_ans = slow(x0, y0, x1, y1, k, i);
			// cout << ans << " " << real_ans << endl;
			cout << ans << endl;
			// assert(ans == real_ans);
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	run();
}