#include <bits/stdc++.h>

#define forn(i, n) for (int i = 0; i < n; ++i)

using namespace std;

typedef long long ll;
typedef long double ld;

#ifdef DEBUG
#define io freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout)
#else
#define io ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr)
#endif

class s_tree {
private:
    struct node {
        int x = -1;
        int upd = -1;
    };

    void push(int v) {
        if (v >= t_size) return;
        if (tree[v].upd == -1) return;
        if (v < m - 1) {
            tree[v * 2 + 1].upd = tree[v].upd;
            tree[v * 2 + 2].upd = tree[v].upd;
        }
        tree[v].x = tree[v].upd;
        tree[v].upd = -1;
    }
public:

    vector<node> tree;
    int t_size;

    int m = 1;

    s_tree(int size) {
        while (m < size) m <<= 1;
        t_size = m * 2 - 1;
        tree.resize(t_size);
    }

    void push_all() {
        forn(i, t_size) {
            push(i);
        }
    }

    void segm(int l, int r, int x, int v = 0, int tl = 0, int tr = -1) {
        push(v);
        if (tr == -1) tr = m - 1;
        if (r < tl || l > tr) return;
        if (tl >= l && tr <= r) {
            tree[v].upd = x;
            push(v);
            return;
        }
        int mid = (tl + tr) / 2;
        segm(l, r, x, v * 2 + 1, tl, mid);
        segm(l, r, x, v * 2 + 2, mid + 1, tr);
    }
};

int main() {
    io;

    int n, m;
    cin >> m >> n;
    vector<int> a(n, -1), b_c;
    vector<pair<int, int> > b;
    int inp[m];
    forn(i, m) {
        cin >> inp[i];
        --inp[i];
        if (a[inp[i]] == -1) {
            a[inp[i]] = b.size();
            b.push_back({i, i});
            b_c.push_back(inp[i]);
        } else {
            b[a[inp[i]]].second = i;
        }
    }
    s_tree test(m);
    forn(i, b.size())
        test.segm(b[i].first, b[i].second, b_c[i]);
    test.push_all();
    forn(i, m) {
        if (test.tree[i + test.m - 1].x != inp[i]) return 0 * puts("-1");
    }

    cout << b.size() << endl;
    forn(i, b.size()) {
        cout << b_c[i] + 1 << " " << b[i].first + 1 << " " << b[i].second + 1 << "\n";
    }
}