#include <bits/stdc++.h>

#define forn(i, n) for (int i = 0; i < n; ++i)

using namespace std;

typedef long long ll;
typedef long double ld;

#ifdef DEBUG
#define io freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout)
#else
#define io ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr)
#endif

class s_tree_min {
private:
    struct node {
        int x = 0;
        int ind_max = -1;
    };

    void build(int v, int l, int r) {
        tree[v].ind_max = l;
        if (v >= m - 1) return;
        int m = (l + r) / 2;
        build(v * 2 + 1, l, m);
        build(v * 2 + 2, m + 1, r);
    }

public:

    vector<node> tree;
    int t_size;

    int m = 1;

    s_tree_min(int size) {
        while (m < size) m <<= 1;
        t_size = m * 2 - 1;
        tree.resize(t_size);
        build(0, 0, m - 1);
    }

    void set(int a, int x, int v = 0, int tl = 0, int tr = -1) {
        if (tr == -1) tr = m - 1;
        if (tl == tr) {
            if (tl != a)
                cout << "duck";
            tree[v].x = x;
            return;
        }
        int mid = (tl + tr) / 2;

        if (a <= mid) {
            set(a, x, v * 2 + 1, tl, mid);
        } else {
            set(a, x, v * 2 + 2, mid + 1, tr);
        }
        if (tree[v * 2 + 1].x < tree[v * 2 + 2].x) {
            tree[v] = tree[v * 2 + 1];
        } else {
            tree[v] = tree[v * 2 + 2];
        }
    }

    pair<int, int> get_min(int l, int r, int v = 0, int tl = 0, int tr = -1) {
        if (tr == -1) tr = m - 1;
        if (r < tl || l > tr) return {-1, -1};
        if (tl >= l && tr <= r) {
            return {tree[v].x, tree[v].ind_max};
        }

        int mid = (tl + tr) / 2;
        auto a = get_min(l, r, v * 2 + 1, tl, mid);
        auto b = get_min(l, r, v * 2 + 2, mid + 1, tr);
        if (a.first == -1) return b;
        if (b.first == -1) return a;
        return (a.first < a.second ? a : b);
    }
};

class s_tree_max {
private:
    struct node {
        int x = 0;
        int ind_max = -1;
    };

    void build(int v, int l, int r) {
        tree[v].ind_max = l;
        if (v >= m - 1) return;
        int m = (l + r) / 2;
        build(v * 2 + 1, l, m);
        build(v * 2 + 2, m + 1, r);
    }

public:

    vector<node> tree;
    int t_size;

    int m = 1;

    s_tree_max(int size) {
        while (m < size) m <<= 1;
        t_size = m * 2 - 1;
        tree.resize(t_size);
        build(0, 0, m - 1);
    }

    void set(int a, int x, int v = 0, int tl = 0, int tr = -1) {
        if (tr == -1) tr = m - 1;
        if (tl == tr) {
            if (tl != a)
                cout << "duck";
            tree[v].x = x;
            return;
        }
        int mid = (tl + tr) / 2;

        if (a <= mid) {
            set(a, x, v * 2 + 1, tl, mid);
        } else {
            set(a, x, v * 2 + 2, mid + 1, tr);
        }
        if (tree[v * 2 + 1].x > tree[v * 2 + 2].x) {
            tree[v] = tree[v * 2 + 1];
        } else {
            tree[v] = tree[v * 2 + 2];
        }
    }

    pair<int, int> get_max(int l, int r, int v = 0, int tl = 0, int tr = -1) {
        if (tr == -1) tr = m - 1;
        if (r < tl || l > tr) return {-1, -1};
        if (tl >= l && tr <= r) {
            return {tree[v].x, tree[v].ind_max};
        }

        int mid = (tl + tr) / 2;
        auto a = get_max(l, r, v * 2 + 1, tl, mid);
        auto b = get_max(l, r, v * 2 + 2, mid + 1, tr);
        if (a.first == -1) return b;
        if (b.first == -1) return a;
        return (a.first > a.second ? a : b);
    }

    pair<int, int> operator[](int x) {
        return {tree[x + m - 1].x, tree[x + m - 1].ind_max};
    }
};

int main() {
    io;

    int n, m, q, type, inp, ax, ay, bx, by, k;
    cin >> n >> m >> q;

    s_tree_min nmin(n), mmin(m);
    s_tree_max nmax(n), mmax(m);

    for (int i = 1; i <= q; ++i) {
        cin >> type;
        if (type == 1) {
            cin >> inp;
            --inp;
            nmin.set(inp, i);
            nmax.set(inp, i);
        }
        if (type == 2) {
            cin >> inp;
            --inp;
            mmin.set(inp, i);
            mmax.set(inp, i);
        }
        if (type == 3) {
            cin >> ax >> ay >> bx >> by >> k;
            --ax, --ay, --bx, --by;

            if (i - nmax[ax].first <= k && i - mmax[by].first <= k ||
                    i - nmax[bx].first <= k && i - mmax[ay].first <= k) {
                cout << abs(by - ay) + abs(bx - ax) << "\n";
                continue;
            }

            if (ax > bx) swap(ax, bx);
            if (ay > by) swap(ay, by);

            // n


            if (i - nmax[ax].first <= k && i - nmax[bx].first <= k) {
                if (i - mmax.get_max(ay, by).first <= k) {
                    cout << by - ay + bx - ax << "\n";
                    continue;
                }

                if (i - nmin.get_min(ax, bx).first <= k) {
                    cout << by - ay + bx - ax << "\n";
                    continue;
                }
            }

            // m
            if (i - mmax[ay].first <= k && i - mmax[by].first <= k) {
                if (i - nmax.get_max(ax, bx).first <= k) {
                    cout << by - ay + bx - ax << "\n";
                    continue;
                }

                if (i - mmin.get_min(ay, by).first <= k) {
                    cout << by - ay + bx - ax << "\n";
                    continue;
                }
            }

            /*
            // awful log^2
            if (i - nmax[ax] <= k && i - nmax[bx] <= k) {
                int l = 0, r = ay;
                while (l - r > 1) {
                    if (i - mmax.get_max(ay, by).first <= k) {
                        cout << by - ay + bx - ax << "\n";
                        continue;
                    }
                }
            }
             */
            int minn = 1e9;
            if (i - nmax[ax].first <= k && i - nmax[bx].first <= k) {
                for (int j = ay; j >= 0; --j) {
                    auto a = mmax[j];
                    if (i - a.first <= k) {
                        minn = min(minn, ay - a.second);
                        break;
                    }
                }

                for (int j = by; j < m; ++j) {
                    auto a = mmax[j];
                    if (i - a.first <= k) {
                        minn = min(minn, a.second - by);
                        break;
                    }
                }
            }

            if (i - mmax[ay].first <= k && i - mmax[by].first <= k) {
                for (int j = ax; j >= 0; --j) {
                    auto a = nmax[j];
                    if (i - a.first <= k) {
                        minn = min(minn, ax - a.second);
                        break;
                    }
                }

                for (int j = bx; j < n; ++j) {
                    auto a = nmax[j];
                    if (i - a.first <= k) {
                        minn = min(minn, a.second - bx);
                        break;
                    }
                }
            }

            if (minn == 1e9) cout << -1 << "\n";
            else cout << minn * 2 + by - ay + bx - ax << "\n";
        }
    }
}