#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <stack>
#include <set>
#include <bitset>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>

#define mp make_pair
#define pb push_back
using namespace std;
typedef long long ll;
typedef long double ld;

const int inf = 1e9, E = (1 << 20);
int n, m, q, type, r1, c1, r2, c2, k;
int d[E << 1];

void update(int v, int l, int r, int pos, int t)
{
	if (l > pos || r < pos)
		return;
	if (l == r && l == pos)
	{
		d[v] = t;
		return;
	}
	int mid = (l + r) / 2;
	update(v * 2, l, mid, pos, t);
	update(v * 2 + 1, mid + 1, r, pos, t);
	d[v] = min(d[v * 2], d[v * 2 + 1]);
}

int find_min(int v, int l, int r, int needl, int needr)
{
	if (l > needr || r < needl)
		return inf;
	if (needl <= l && r <= needr)
		return d[v];
	int mid = (l + r) / 2;
	return min(find_min(v * 2, l, mid, needl, needr), find_min(v * 2 + 1, mid + 1, r, needl, needr));
}

int query(int t)
{
	r1 += E - 1;
	r2 += E - 1;
	int s = find_min(1, E, 2 * E - 1, min(r1, r2), max(r1, r2));
	if (t - s <= k)
		return abs(r1 - r2) + abs(c1 - c2);
	return -1;
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> m >> q;
	for (int i = 1; i <= q; i++)
	{
		cin >> type >> r1;
		if (type == 1)
			update(1, E, 2 * E - 1, r1 - 1 + E, i);
		if (type == 3)
		{
			cin >> c1 >> r2 >> c2 >> k;
			cout << query(i) << '\n';
		}
	}
	return 0;
}