#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <stack>
#include <set>
#include <vector>
#include <cmath>
#include <algorithm>

#define mp make_pair
#define pb push_back
using namespace std;
typedef long long ll;
typedef long double ld;

const int E = (1 << 20), inf = 1e9;
int R[E << 1], C[E << 1], r[E << 1], c[E << 1];
int n, m, q;

void update_row(int x, int t)
{
	R[x] = r[x] = t;
	x >>= 1;
	while (x > 0)
	{
		R[x] = max(R[x * 2], R[x * 2 + 1]);
		r[x] = min(r[x * 2], r[x * 2 + 1]);
		x >>= 1;
	}
}

void update_col(int x, int t)
{
	C[x] = c[x] = t;
	x >>= 1;
	while (x > 0)
	{
		c[x] = min(c[x * 2], c[x * 2 + 1]);
		C[x] = max(C[x * 2], C[x * 2 + 1]);
		x >>= 1;
	}
}

int find_min_in_row(int v, int l, int r, int needl, int needr)
{
	if (l > needr || r < needl)
		return inf;
	if (needl <= l && r <= needr)
		return ::r[v];
	int mid = (l + r) / 2;
	return min(find_min_in_row(v * 2, l, mid, needl, needr), find_min_in_row(v * 2 + 1, mid + 1, r, needl, needr));
}

int find_max_in_row(int v, int l, int r, int needl, int needr)
{
	if (l > needr || r < needl)
		return 0;
	if (needl <= l && r <= needr)
		return ::R[v];
	int mid = (l + r) / 2;
	return max(find_max_in_row(v * 2, l, mid, needl, needr), find_max_in_row(v * 2 + 1, mid + 1, r, needl, needr));
}

int find_min_in_col(int v, int l, int r, int needl, int needr)
{
	if (l > needr || r < needl)
		return inf;
	if (needl <= l && r <= needr)
		return ::c[v];
	int mid = (l + r) / 2;
	return min(find_min_in_col(v * 2, l, mid, needl, needr), find_min_in_col(v * 2 + 1, mid + 1, r, needl, needr));
}

int find_max_in_col(int v, int l, int r, int needl, int needr)
{
	if (l > needr || r < needl)
		return 0;
	if (needl <= l && r <= needr)
		return ::C[v];
	int mid = (l + r) / 2;
	return max(find_max_in_col(v * 2, l, mid, needl, needr), find_max_in_col(v * 2 + 1, mid + 1, r, needl, needr));
}

int query(int r1, int c1, int r2, int c2, int k, int t)
{
	bool be[2], en[2];
	be[0] = be[1] = en[0] = en[1] = false;
	if (t - r[r1 + E] <= k)
		be[0] = true;
	if (t - r[r2 + E] <= k)
		en[0] = true;
	if (t - c[c1 + E] <= k)
		be[1] = true;
	if (t - c[c2 + E] <= k)
		en[1] = true;
	if ((!be[0] && !be[1]) || (!en[0] && !en[1]))
		return -1;
	if ((be[0] && en[1]) || (be[1] && en[0]))
		return abs(r1 - r2) + abs(c1 - c2);
	int qwe1 = find_min_in_col(1, E, 2 * E - 1, min(c1, c2) + E, max(c1, c2) + E);
	int qwe2 = find_min_in_row(1, E, 2 * E - 1, min(r1, r2) + E, max(r1, r2) + E);
	if(t - qwe1 <= k || t - qwe2 <= k)
		return abs(r1 - r2) + abs(c1 - c2);
	if (be[0] && en[0])
	{
		int qwe = find_max_in_col(1, E, 2 * E - 1, min(c1, c2) + E, max(c1, c2) + E);
		if (t - qwe <= k)
			return abs(r1 - r2) + abs(c1 - c2);
		int l = 0, r = min(c1, c2);
		while (r - l > 1)
		{
			int mid = (l + r) / 2;
			int qwe = find_max_in_col(1, E, 2 * E - 1, mid + E, min(c1, c2) + E);
			if (t - qwe <= k)
				l = mid;
			else
				r = mid;
		}
		int l22 = max(c1, c2), r22 = m - 1;
		while (r22 - l22 > 1)
		{
			int mid = (l22 + r22) / 2;
			int qwe = find_max_in_col(1, E, 2 * E - 1, max(c1, c2) + E, mid + E);
			if (t - qwe <= k)
				r22 = mid;
			else
				l22 = mid;
		}
		bool chl = (t - c[l + E]) <= k;
		bool chr = (t - c[r22 + E]) <= k;
		if (!chl && !chr)
			return -1;
		if (!chl)
			return abs(r1 - r2) + 2 * r22 - c1 - c2;
		if (!chr)
			return abs(r1 - r2) + c1 + c2 - 2 * l;
		return abs(r1 - r2) + min(2 * r22 - c1 - c2, c1 + c2 - 2 * l);
	}

	if (be[1] && en[1])
	{
		int qwe = find_max_in_row(1, E, 2 * E - 1, min(r1, r2) + E, max(r1, r2) + E);
		if (t - qwe <= k)
			return abs(r1 - r2) + abs(c1 - c2);


		int l = 0, r = min(r1, r2);
		while (r - l > 1)
		{
			int mid = (l + r) / 2;
			int qwe = find_max_in_row(1, E, 2 * E - 1, mid + E, min(r1, r2) + E);
			if (t - qwe <= k)
				l = mid;
			else
				r = mid;
		}
		int l22 = max(r1, r2), r22 = n - 1;
		while (r22 - l22 > 1)
		{
			int mid = (l22 + r22) / 2;
			int qwe = find_max_in_row(1, E, 2 * E - 1, max(r1, r2) + E, mid + E);
			if (t - qwe <= k)
				r22 = mid;
			else
				l22 = mid;
		}
		bool chl = (t - ::r[l + E]) <= k;
		bool chr = (t - ::r[r22 + E]) <= k;
		if (!chl && !chr)
			return -1;
		if (!chl)
			return abs(c1 - c2) + 2 * r22 - r1 - r2;
		if (!chr)
			return abs(c1 - c2) + r1 + r2 - 2 * l;
		return abs(c1 - c2) + min(2 * r22 - r1 - r2, r1 + r2 - 2 * l);
	}
}


int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> m >> q;
	for (int i = 1; i <= q; i++)
	{
		int t, r1, c1, r2, c2, k;
		cin >> t >> r1;
		if (t == 1)
			update_row(E + r1 - 1, i);
		if (t == 2)
			update_col(E + r1 - 1, i);
		if (t == 3)
		{
			cin >> c1 >> r2 >> c2 >> k;
			if (k == 6)
				k = 6;
			cout << query(r1 - 1, c1 - 1, r2 - 1, c2 - 1, k, i) << '\n';

		}

	}
	return 0;
}