#include <bits/stdc++.h>

using namespace std;

const int MAXN = 1e6 + 7;
const int INF = 2e8 + 7;

vector<int> x(MAXN, -1);
vector<int> y(MAXN, -1);

int tx[4 * MAXN];
int tx_max[4 * MAXN];
int ty[4 * MAXN];
int ty_max[4 * MAXN];

int i;

void build(int v, int l, int r)
{
    if (r - l == 1)
    {
        tx[v] = x[l];
        tx_max[v] = x[l];
        ty[v] = y[l];
        ty_max[v] = y[l];
        return;
    }
    build(2 * v + 1, l, (l + r) / 2);
    build(2 * v + 2, (l + r) / 2, r);
    tx[v] = min(tx[2 * v + 1], tx[2 * v + 2]);
    tx_max[v] = max(tx_max[2 * v + 1], tx_max[2 * v + 2]);
    ty[v] = min(ty[2 * v + 1], ty[2 * v + 2]);
    ty_max[v] = max(ty_max[2 * v + 1], ty_max[2 * v + 2]);
    return;
}

void update_x(int v, int tl, int tr, int pos, int val)
{
    if (pos < tl || pos >= tr)
    {
        return;
    }
    if (pos <= tl && tr <= pos + 1)
    {
        tx[v] = val;
        tx_max[v] = val;
        return;
    }
    update_x(2 * v + 1, tl, (tl + tr) / 2, pos, val);
    update_x(2 * v + 2, (tl + tr) / 2, tr, pos, val);
    tx[v] = min(tx[2 * v + 1], tx[2 * v + 2]);
    tx_max[v] = max(tx_max[2 * v + 1], tx_max[2 * v + 2]);
    return;
}

void update_y(int v, int tl, int tr, int pos, int val)
{
    if (pos < tl || pos >= tr)
    {
        return;
    }
    if (pos <= tl && tr <= pos + 1)
    {
        ty[v] = val;
        ty_max[v] = val;
        return;
    }
    update_y(2 * v + 1, tl, (tl + tr) / 2, pos, val);
    update_y(2 * v + 2, (tl + tr) / 2, tr, pos, val);
    ty[v] = min(ty[2 * v + 1], ty[2 * v + 2]);
    ty_max[v] = max(ty_max[2 * v + 1], ty_max[2 * v + 2]);
    return;
}

int get_min_x(int v, int tl, int tr, int l, int r)
{
    if (r <= tl || l >= tr)
    {
        return INF;
    }
    if (l <= tl && tr <= r)
    {
        return tx[v];
    }
    return min(get_min_x(2 * v + 1, tl, (tl + tr) / 2, l, r), get_min_x(2 * v + 2, (tl + tr) / 2, tr, l, r));
}

int get_min_y(int v, int tl, int tr, int l, int r)
{
    if (r <= tl || l >= tr)
    {
        return INF;
    }
    if (l <= tl && tr <= r)
    {
        return ty[v];
    }
    return min(get_min_y(2 * v + 1, tl, (tl + tr) / 2, l, r), get_min_y(2 * v + 2, (tl + tr) / 2, tr, l, r));
}

int find_first_x(int v, int tl, int tr, int l, int r, int val)
{
    if (r <= tl || l >= tr)
    {
        return INF;
    }
    if (l <= tl && tr <= r)
    {
        if (tx_max[v] < val)
        {
            return INF;
        }
        if (tr - tl == 1)
        {
            return tl;
        }
        if (tx_max[2 * v + 1] < val)
        {
            return find_first_x(2 * v + 2, (tl + tr) / 2, tr, l, r, val);
        }
        else
        {
            return find_first_x(2 * v + 1, tl, (tl + tr) / 2, l, r, val);
        }
    }
    return min(find_first_x(2 * v + 1, tl, (tl + tr) / 2, l, r, val), find_first_x(2 * v + 2, (tl + tr) / 2, tr, l, r, val));
}

int find_last_x(int v, int tl, int tr, int l, int r, int val)
{
    if (r <= tl || l >= tr)
    {
        return -INF;
    }
    if (l <= tl && tr <= r)
    {
        if (tx_max[v] < val)
        {
            return -INF;
        }
        if (tr - tl == 1)
        {
            return tl;
        }
        if (tx_max[2 * v + 2] < val)
        {
            return find_last_x(2 * v + 1, tl, (tl + tr) / 2, l, r, val);
        }
        else
        {
            return find_last_x(2 * v + 2, (tl + tr) / 2, tr, l, r, val);
        }
    }
    return max(find_last_x(2 * v + 1, tl, (tl + tr) / 2, l, r, val), find_last_x(2 * v + 2, (tl + tr) / 2, tr, l, r, val));
}

int find_last_y(int v, int tl, int tr, int l, int r, int val)
{
    if (r <= tl || l >= tr)
    {
        return -INF;
    }
    if (l <= tl && tr <= r)
    {
        if (ty_max[v] < val)
        {
            return -INF;
        }
        if (tr - tl == 1)
        {
            return tl;
        }
        if (ty_max[2 * v + 2] < val)
        {
            return find_last_y(2 * v + 1, tl, (tl + tr) / 2, l, r, val);
        }
        else
        {
            return find_last_y(2 * v + 2, (tl + tr) / 2, tr, l, r, val);
        }
    }
    return max(find_last_y(2 * v + 1, tl, (tl + tr) / 2, l, r, val), find_last_y(2 * v + 2, (tl + tr) / 2, tr, l, r, val));
}

int find_first_y(int v, int tl, int tr, int l, int r, int val)
{
    if (r <= tl || l >= tr)
    {
        return INF;
    }
    if (l <= tl && tr <= r)
    {
        if (ty_max[v] < val)
        {
            return INF;
        }
        if (tr - tl == 1)
        {
            return tl;
        }
        if (ty_max[2 * v + 1] < val)
        {
            return find_first_y(2 * v + 2, (tl + tr) / 2, tr, l, r, val);
        }
        else
        {
            return find_first_y(2 * v + 1, tl, (tl + tr) / 2, l, r, val);
        }
    }
    return min(find_first_y(2 * v + 1, tl, (tl + tr) / 2, l, r, val), find_first_y(2 * v + 2, (tl + tr) / 2, tr, l, r, val));
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    int q;
    cin >> q;
    build(0, 0, MAXN);
    for (i = 0; i < q; ++i)
    {
        int cmd;
        cin >> cmd;
        int num;
        if (cmd == 1)
        {
            cin >> num;
            --num;
            x[num] = i;
            update_x(0, 0, MAXN, num, i);
        }
        if (cmd == 2)
        {
            cin >> num;
            --num;
            y[num] = i;
            update_y(0, 0, MAXN, num, i);
        }
        if (cmd == 3)
        {
            int x1, y1, x2, y2, k;
            cin >> x1 >> y1 >> x2 >> y2 >> k;
            --x1; --y1; --x2; --y2;
            if (k > i)
            {
                cout << abs(x1 - x2) + abs(y1 - y2) << endl;
                continue;
            }
            if (i - x[x1] <= k && i - y[y2] <= k || i - x[x2] <= k && i - y[y1] <= k)
            {
                cout << abs(x1 - x2) + abs(y1 - y2) << endl;
                continue;
            }
            int ans = INF;
            if (i - get_min_x(0, 0, MAXN, min(x1, x2), max(x1, x2) + 1) <= k || i - get_min_y(0, 0, MAXN, min(y1, y2), max(y1, y2) + 1) <= k)
            {
                ans = min(ans, abs(x1 - x2) + abs(y1 - y2));
            }
            if (i - x[x1] <= k && i - x[x2] <= k)
            {
                int yy = find_first_y(0, 0, MAXN, min(y1, y2), MAXN, i - k);
                ans = min(ans, abs(x1 - x2) + abs(y1 - yy) + abs(y2 - yy));
                int yy2 = find_last_y(0, 0, MAXN, 0, max(y1, y2) + 1, i - k);
                ans = min(ans, abs(x1 - x2) + abs(y1 - yy2) + abs(y2 - yy2));
            }
            if (i - y[y1] <= k && i - y[y2] <= k)
            {
                int xx = find_first_x(0, 0, MAXN, min(x1, x2), MAXN, i - k);
                ans = min(ans, abs(y1 - y2) + abs(x1 - xx) + abs(x2 - xx));
                int xx2 = find_last_x(0, 0, MAXN, 0, max(x1, x2) + 1, i - k);
                ans = min(ans, abs(y1 - y2) + abs(x1 - xx2) + abs(x2 - xx2));
            }
            if (ans >= INF)
            {
                cout << -1 << endl;
                continue;
            }
            cout << ans << endl;
        }
    }
    return 0;
}

