#include <iostream>
#include <vector>
#include <queue>

int Drive(int r1, int c1, int r2, int c2, int kRes, std::vector < std::vector <short> > &field, int n, int m);
bool used[10000][10000];
std::vector <short> visitX, visitY;

int main(void) {
    int n = 0, m = 0, q = 0;
    std::cin >> n >> m >> q;
    std::vector < std::vector <short> > field(n);
    for (int i = 0; i < n; i++) {
        field[i].clear();
        for (int j = 0; j < m; j++)
            field[i].push_back(0);
    }
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            used[i][j] = 0;

    bool roadChange = 1;
    int successK = 0, res = 0;
    for (int globalLevel = 1; globalLevel <= q; globalLevel++) {
        int type = 0;
        int r1 = 0, r2 = 0, c1 = 0, c2 = 0, k = 0;
        std::cin >> type;
        if (type == 1) {
            std::cin >> r1;
            r1--;
            for (int i = 0; i < m; i++)
                field[r1][i] = -globalLevel;
            for (int i = 0; i < visitX.size(); i++)
                if (visitY[i] == r1) {
                    roadChange = 1;
                    break;
                }
        }
        else if (type == 2) {
            std::cin >> c1;
            c1--;
            for (int i = 0; i < n; i++)
                field[i][c1] = -globalLevel;
            for (int i = 0; i < visitX.size(); i++)
                if (visitX[i] == c1) {
                    roadChange = 1;
                    break;
                }
        }
        else { // if (type == 3)
            std::cin >> r1 >> c1 >> r2 >> c2 >> k;
            r1--; c1--; r2--; c2--;
            if (roadChange || k - globalLevel > successK) {
                res = Drive(r1, c1, r2, c2, k - globalLevel, field, n, m);
                successK = k - globalLevel;
                roadChange = 0;
            }
            std::cout << res << "\n";
        }
    }
    return 0;
}

int Drive(int r1, int c1, int r2, int c2, int kRes, std::vector < std::vector <short> > &field, int n, int m) {
    if (field[r1][c1] > kRes || field[r2][c2] > kRes)
        return -1;

    for (unsigned int i = 0; i < visitX.size(); i++)
        used[visitY[i]][visitX[i]] = 0;
    visitX.clear(); visitY.clear();

    std::queue <short> bfsX;
    std::queue <short> bfsY;
    std::queue <int> bfsStep;
    bfsX.push(c1);
    bfsY.push(r1);
    bfsStep.push(0);
    used[r1][c1] = 1;
    visitX.push_back(c1); visitY.push_back(r1);
    while (!bfsX.empty()) {
        int x = bfsX.front();
        int y = bfsY.front();
        int step = bfsStep.front();
        bfsX.pop(); bfsY.pop(); bfsStep.pop();
        step++;
        if (x > 0 && field[y][x - 1] <= kRes && !used[y][x - 1]) {
            if (x - 1 == c2 && y == r2) {
                return step;
            }
            bfsX.push(x - 1);
            bfsY.push(y);
            bfsStep.push(step);
            used[y][x - 1] = 1;
            visitX.push_back(x - 1); visitY.push_back(y);
        }
        if (x < m - 1 && field[y][x + 1] <= kRes && !used[y][x + 1]) {
            if (x + 1 == c2 && y == r2) {
                return step;
            }
            bfsX.push(x + 1);
            bfsY.push(y);
            bfsStep.push(step);
            used[y][x + 1] = 1;
            visitX.push_back(x + 1); visitY.push_back(y);
        }
        if (y > 0 && field[y - 1][x] <= kRes && !used[y - 1][x]) {
            if (x == c2 && y - 1 == r2) {
                return step;
            }
            bfsX.push(x);
            bfsY.push(y - 1);
            bfsStep.push(step);
            used[y - 1][x] = 1;
            visitX.push_back(x); visitY.push_back(y - 1);
        }
        if (y < n - 1 && field[y + 1][x] <= kRes && !used[y + 1][x]) {
            if (x == c2 && y + 1 == r2) {
                return step;
            }
            bfsX.push(x);
            bfsY.push(y + 1);
            bfsStep.push(step);
            used[y + 1][x] = 1;
            visitX.push_back(x); visitY.push_back(y + 1);
        }
    }

    return -1; // no way found
}
