#include <iostream>

#define ABS(x) ( ((x) > 0) ? (x) : (-(x)))

struct Tree {
    int L, R;
    Tree *left, *right;
    int val;
};

void BuildTree(Tree *root, int l, int r);
void Change(Tree *root, int i, int target);
int Get(Tree *root, int l, int r);

int main(void) {
    int n = 0, m = 0, q = 0;
    std::cin >> n >> m >> q;
    Tree *root = new Tree;
    BuildTree(root, 0, n);
    for (int globalLevel = 1; globalLevel <= q; globalLevel++) {
        int type = 0;
        int r1 = 0, r2 = 0, c1 = 0, c2 = 0, k = 0;
        std::cin >> type;
        if (type == 1) {
            std::cin >> r1;
            r1--;
            Change(root, r1, -globalLevel);
        }
        else if (type == 3) {
            std::cin >> r1 >> c1 >> r2 >> c2 >> k;
            r1--; c1--; r2--; c2--;
            int kRes = k - globalLevel;
            if (kRes < Get(root, std::min(r1, r2), std::max(r1, r2)))
                std::cout << "-1\n";
            else
                std::cout << ABS(r1 - r2) + ABS(c1 - c2) << "\n";
        }
        // on type 2 - do nothing
    }
    return 0;
}

void BuildTree(Tree *root, int l, int r) {
    root->L = l; root->R = r;
    root->val = 0;
    if (l != r) {
        root->left = new Tree;
        BuildTree(root->left, l, (l + r) / 2);
        root->right = new Tree;
        BuildTree(root->right, (l + r) / 2 + 1, r);
    }
    else
        root->left = root->right = NULL;
}

void Change(Tree *root, int i, int target) {
    if (root->L == root->R) {
        root->val = target;
        return;
    }
    // else
    if (i <= (root->L + root->R) / 2)
        Change(root->left, i, target);
    else
        Change(root->right, i, target);
    root->val = std::max(root->left->val, root->right->val);
}

int Get(Tree *root, int l, int r) {
    if (l <= root->L && root->R <= r)
        return root->val;
    // else
    int ans = 0;
    if (l <= (root->L + root->R) / 2)
        ans = Get(root->left, l, r);
    if (r >= (root->L + root->R) / 2 + 1)
        ans = std::max(ans, Get(root->right, l, r));
    return ans;
}
