#include <iostream>
#include <vector>
#include <set>

const long long INF = 1e18;

bool CheckWay(std::vector <long long> &fastWays, long long r, long long p);

int main(void) {
    int t = 0;
    std::cin >> t;
    for (int testId = 0; testId < t; testId++) {
        long long n = 0, m = 0, q = 0, p = 0;
        std::cin >> n >> m >> q >> p;
        std::vector < std::set <long long> > ways(n);
        std::vector < std::vector <long long> > graph(n);
        std::vector < std::vector <long long> > cost(n);
        for (int i = 0; i < m; i++) {
            long long v = 0, u = 0, d = 0;
            std::cin >> v >> u >> d;
            v--; u--;
            graph[u].push_back(v);
            cost[u].push_back(d);
        }

        ways[0].insert(0);
        for (int i = 1; i < n; i++)
            ways[i].insert(INF);

        for (int i = 1; i < n; i++)
            for (unsigned int j = 0; j < graph[i].size(); j++)
                for (std::set <long long>::iterator it = ways[graph[i][j]].begin(); it != ways[graph[i][j]].end(); it++)
                    if (*it + cost[i][j] <= 10000)
                        ways[i].insert(*it + cost[i][j]);

        std::vector < std::vector <long long> > fastWays(n);
        for (int i = 1; i < n; i++) {
            for (std::set <long long>::iterator it = ways[i].begin(); it != ways[i].end(); it++)
                fastWays[i].push_back(*it);
        }

        std::string ans = "";
        for (int i = 0; i < q; i++) {
            long long f = 0, r = 0;
            std::cin >> f >> r;
            f--;
            if (CheckWay(fastWays[f], r, p))
                ans += "1";
            else
                ans += "0";
        }

        std::cout << ans << std::endl;
    }
    return 0;
}

bool CheckWay(std::vector <long long> &fastWays, long long r, long long p) {
    long long L = 0, R = fastWays.size() - 1;
    while ((fastWays[L] < r || fastWays[R] * (p - 1) > p * r) && L < R - 1) {
        long long med = (L + R) / 2;
        if (fastWays[med] * (p - 1) <= p * r)
            L = med;
        if (fastWays[med] >= r)
            R = med;
    }
    if (L != R - 1)
        return (fastWays[L] >= r && fastWays[R] * (p - 1) <= p * r && L <= R);
    else
        return (fastWays[L] >= r && fastWays[L] * (p - 1) <= p * r) || (fastWays[R] >= r && fastWays[R] * (p - 1) <= p * r);
}
