#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <stdio.h>
#include <math.h>
#include <set>
#include <map>
#include <stack>
#include <queue>
#include <tuple>

#define forn(i,n) for(int i=0;i<n;i++)
#define ll long long
#define ld long double
#define pii pair<int,int>
#define mp make_pair

#pragma optimize

using namespace std;

const int INF = 1e9, MAXN = 4e6;

struct node {
	int l, r;
	int mx,mn;
	int left = -1, right = -1;
	node() {};
	node(int l, int r, int mx = 0) :mx(mx),mn(mx), l(l), r(r) {};
};

node V[MAXN];
int id = 0;

void recalc(int a) {
	if (V[a].left == -1) {
		return;
	}
	V[a].mx = max(V[V[a].left].mx, V[V[a].right].mx);
	V[a].mn = min(V[V[a].left].mn, V[V[a].right].mn);
}

void build_tree(int a, bool deep = 1) {
	if (V[a].r - V[a].l == 1)return;
	if (V[a].left != -1)return;
	int m = (V[a].r + V[a].l) / 2;
	V[id] = node(V[a].l, m);
	V[a].left = id++;
	V[id] = node(m, V[a].r);
	V[a].right = id++;
	if (deep) {
		build_tree(V[a].left);
		build_tree(V[a].right);
	}
}

void add(int a, int x, int n) {
	build_tree(a, 0);
	if (V[a].l > x || V[a].r <= x) {
		return;
	}
	if (V[a].l == x && V[a].r == x + 1) {
		V[a].mx = n;
		V[a].mn = n;
		return;
	}
	add(V[a].left, x, n);
	add(V[a].right, x, n);
	recalc(a);
}

int get(int  a, int l, int r) {
	build_tree(a, 0);
	if (V[a].l >= r || V[a].r <= l) {
		return 0;
	}
	if (V[a].l >= l && V[a].r <= r) {
		return V[a].mx;
	}
	return max(get(V[a].left, l, r), get(V[a].right, l, r));
}

int get_mn(int  a, int l, int r) {
	build_tree(a, 0);
	if (V[a].l >= r || V[a].r <= l) {
		return INF;
	}
	if (V[a].l >= l && V[a].r <= r) {
		return V[a].mn;
	}
	return min(get_mn(V[a].left, l, r), get_mn(V[a].right, l, r));
}

int to_l(int a, int l, int r, int n) {
	build_tree(a, 0);
	if (V[a].mx < n)return -1;
	if (V[a].l >= r || V[a].r <= l) {
		return -1;
	}
	if (V[a].r - V[a].l == 1) {
		return V[a].l;
	}
	int ans = to_l(V[a].left, l, r, n);
	if (ans != -1)return ans;
	return to_l(V[a].right, l, r, n);
}

int to_r(int a, int l, int r, int n) {
	build_tree(a, 0);
	if (V[a].mx < n)return -1;
	if (V[a].l >= r || V[a].r <= l) {
		return -1;
	}
	if (V[a].r - V[a].l == 1) {
		return V[a].l;
	}
	int ans = to_r(V[a].right, l, r, n);
	if (ans != -1)return ans;
	return to_r(V[a].left, l, r, n);
}

int main() {
//	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	ios_base::sync_with_stdio(0);
	int n, m,q;
	cin >> n >> m >> q;
	vector<int>h_val(n, 0), w_val(m, 0);
	V[id] = node(0, n);
	int h = id++;
	V[id] = node(0, m);
	int w = id++;
	build_tree(h,0);
	build_tree(w,0);
	forn(i, q+1)if(i>0) {
		int t;
		cin >> t;
		if (t == 1) {
			int x;
			cin >> x;
			--x;
			h_val[x] = i;
			add(h, x, i);
		}
		else if (t == 2) {
			int x;
			cin >> x;
			--x;
			w_val[x] = i;
			add(w, x, i);
		}
		else {
			int x1, y1, x2, y2, k;
			cin >> x1 >> y1 >> x2 >> y2 >> k;
			--x1;
			--y1;
			--x2;
			--y2;
			int d = i - k;
			int ac = abs(x1 - x2) + abs(y1 - y2);
			if (h_val[x1] < d && w_val[y1] < d) {
				cout << -1 << '\n';
				continue;
			}
			if (h_val[x2] < d && w_val[y2] < d) {
				cout << -1 << '\n';
				continue;
			}
			if (h_val[x1] >= d && w_val[y2] >= d) {
				cout << ac << '\n';
				continue;
			}
			if (h_val[x2] >= d && w_val[y1] >= d) {
				cout << ac << '\n';
				continue;
			}
			if (h_val[x1] >= d) {
				if (abs(x1 - x2) <= 1) {
					cout << ac << '\n';
					continue;
				}
				int l = min(y1, y2);
				int r = max(y1, y2);
				if (get(w, l, r) >= d) {
					cout << ac << '\n';
					continue;
				}
				int g1 = get_mn(h, min(x1, x2), max(x1, x2));
				if (g1 >= d) {
					cout << ac << '\n';
					continue;
				}
				int ans = m+1;
				int idl = to_r(w, 0, l, d);
				if (idl != -1)ans = l - idl;
				int idr = to_l(w, r, m, d);
				if (idr != -1) {
					ans = min(ans, idr - r);
				}
				if (ans == m + 1) {
					cout << -1 << '\n';
					continue;
				}
				cout << ac + 2 * ans << '\n';
				continue;
			}
			if (abs(y1 - y2) <= 1) {
				cout << ac << '\n';
				continue;
			}
			int l = min(x1, x2);
			int r = max(x1, x2);
			if (get(h, l, r) >= d) {
				cout << ac << '\n';
				continue;
			}
			if (get_mn(w, min(y1, y2), max(y1, y2)) >= d) {
				cout << ac << '\n';
				continue;
			}
			int ans = n + 1;
			int idl = to_r(h, 0, l, d);
			if (idl != -1)ans = l - idl;
			int idr = to_l(h, r, n, d);
			if (idr != -1) {
				ans = min(ans, idr - r);
			}
			if (ans == n + 1) {
				cout << -1 << '\n';
				continue;
			}
			cout << ac + 2 * ans << '\n';
			continue;
		}
	}
}