#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#define int long long
#define MAXN 1000005
#define INF 1000000000
//#define first ff
//#define second ss

using namespace std;

int n, m, i, v1[MAXN], v2[MAXN];
vector <pair<int, int> > p;

struct ST{
    int t1[MAXN * 4], t2[MAXN * 4], sz;

    void build(int v, int tl, int tr){
        sz = tr - tl + 1;
        fill(t1, t1 + 4 * sz, 1);
        fill(t2, t2 + 4 * sz, 1);
    }

    void upd(int v, int tl, int tr, int pos, int x){
        int m = (tl + tr) / 2;

        if(tl == tr){
            t1[v] = t2[v] = x;
            return;
        }

        if(pos <= m)
            upd(v * 2, tl, m, pos, x);
        else
            upd(v * 2 + 1, m + 1, tr, pos, x);

        t1[v] = max(t1[v * 2], t1[v * 2 + 1]);
        t2[v] = min(t2[v * 2], t2[v * 2 + 1]);
    }

    int getL(int v, int tl, int tr, int l, int r, int k){
        int m = (tl + tr) / 2;

        if(l > r)
            return -INF;

        if(tl == l && tr == r){
            if(t2[v] > k)
                return -INF;

            while(tl != tr){
                int m = (tl + tr) / 2;
                if(t2[v * 2 + 1] <= k)
                    v = v * 2 + 1, tl = m + 1;
                else
                    v = v * 2, tr = m;
            }
            return tl;
        }

        int res = getL(v * 2 + 1, m + 1, tr, max(l, m + 1), r, k);
        if(res == -INF)
            return getL(v * 2, tl, m, l, min(r, m), k);
    }

    int getR(int v, int tl, int tr, int l, int r, int k){
        int m = (tl + tr) / 2;
        if(l > r)
            return INF;

        if(tl == l && tr == r){
            if(t2[v] > k)
                return INF;

            while(tl != tr){
                int m = (tl + tr) / 2;
                if(t2[v * 2] <= k)
                    v = v * 2, tr = m;
                else
                    v = v * 2 + 1, tl = m + 1;
            }
            return tl;
        }

        int res = getR(v * 2, tl, m, l, min(r, m), k);
        if(res == INF)
            return getR(v * 2 + 1, m + 1, tr, max(l, m + 1), r, k);
    }

    int getM(int v, int tl, int tr, int l, int r){
        int m = (tl + tr) / 2;

        if(l > r)
            return -INF;

        if(tl == l && tr == r)
            return t1[v];

        return max(getM(v * 2, tl, m, l, min(r, m)),
                getM(v * 2 + 1, m + 1, tr, max(l, m + 1), r));
    }

} t1, t2;
main(){
    int n, m, q, type, x;
    //freopen("input.txt", "r", stdin);
    cin >> n >> m >> q;

    t1.build(1, 0, n - 1);
    t2.build(1, 0, m - 1);
    fill(v1, v1 + n, 1);
    fill(v2, v2 + m, 1);

    for(i = 0; i < q; i++){
        cin >> type;

        if(type == 3){
            int x1, y1, x2, y2, k;
            cin >> x1 >> y1 >> x2 >> y2 >> k;
            x1--; y1--; x2--; y2--;

            //if(i == q - 1)
            //    cout << "*"<< i << " " << t1.get(1, 0, n - 1, x1) + i << endl;
            if(v1[x1] + i <= k && v2[y2] + i <= k){
                cout << abs(x1 - x2) + abs(y1 - y2) << endl;
                continue;
            }
            if(v2[y1] + i <= k && v1[x2] + i <= k){
                cout << abs(x1 - x2) + abs(y1 - y2) << endl;
                continue;
            }

            int ans = INF;

           // cout << t2.get(1, 0, m - 1, y1) + i << endl;
            if(v2[y1] + i <= k && v2[y2] + i <= k){
                int lf = t1.getL(1, 0, n - 1, 0, x1, k - i);
                int rg = t1.getR(1, 0, n - 1, x1, n - 1, k - i);
               // if(q - 1 == i)
               //     cout <<t1.getM(1, 0, n - 1, min(x1, x2), max(x1, x2)) + i << endl;
                if(t2.getM(1, 0, m - 1, min(y1, y2), max(y1, y2)) + i <= k)
                    ans = min(ans, abs(x1 - x2) + abs(y1 - y2));
                else
                    ans = min(ans, min(abs(lf - x1) + abs(lf - x2),
                        abs(rg - x1) + abs(rg - x2)) + abs(y1 - y2));
            }

            if(v1[x1] + i <= k && v1[x2] + i <= k){
                int lf = t2.getL(1, 0, m - 1, 0, y1, k - i);
                int rg = t2.getR(1, 0, m - 1, y1, m - 1, k - i);

                if(t1.getM(1, 0, n - 1, min(x1, x2), max(x1, x2)) + i <= k)
                    ans = min(ans, abs(x1 - x2) + abs(y1 - y2));
                else
                    ans = min(ans, min(abs(lf - y1) + abs(lf - y2),
                        abs(rg - y1) + abs(rg - y2)) + abs(x1 - x2));
            }

            if(ans > INF / 2)
                cout << -1 << endl;
            else
                cout << ans << endl;
        }
        else{
            cin >> x;
            x--;

            if(type == 1)
                v1[x] = -i, t1.upd(1, 0, n - 1, x, -i);
            else
                v2[x] = -i, t2.upd(1, 0, m - 1, x, -i);
        }
    }

    return 0;
}
