#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cstring>
#include <set>
#include <map>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <iomanip>
#include <random>
#include <ctime>
#include <cassert>

using namespace std;
typedef long long ll;
typedef unsigned long long ull;

#ifdef DEBUG
	const int MAXN = 100;
	const int MAXLOG = 4;
	const int MAXSQRT = 4;
#else
	const int MAXN = 5e3 + 1;
	const int MAXLOG = 20;
	const int MAXSQRT = 400;
	#define cerr if (false) cerr
#endif

mt19937 rng(time(0));
const int MOD = 1e9 + 7;
const int INF = 1e9;

int n, m, q, p;

int dp[MAXN][2 * MAXN];
vector<pair<int, ll>> g[MAXN];



void init() {
	memset(dp, 0, sizeof(dp));
	for (int i = 0; i < n; i++) {
		g[i].clear();
		g[i].shrink_to_fit();
	}
}

void solve() {
	init();
	for (int i = 0; i < m; i++) {
		int a, b;
		ll c;
		cin >> a >> b >> c;
		a--, b--;
		g[a].emplace_back(b, c);
	}
	dp[0][0] = 1;
	for (int i = 0; i < n; i++) {
		for (auto to : g[i]) {
			for (int w = 0; w < 2 * MAXN; w++) {
				if (dp[i][w] == 0) {
					continue;
				}
				if (w + to.second < 2 * MAXN) {
					dp[to.first][w + to.second] = 1;
				}
			}
		}
	}
	for (int i = 0; i < q; i++) {
		int a, b;
		cin >> a >> b;
		a--;
		bool ok = 0;
		for (int w = 0; w < 2 * MAXN; w++) {
			if (1.0 * b * p / (p - 1) >= w && w >= b) {
				if (dp[a][w]) {
					ok = 1;
					break;
				}
			}
		}
		cout << ok;
	}
	cout << '\n';
}

signed main() {
	#ifdef DEBUG
		freopen("C.in", "r", stdin);
		freopen("C.out", "w", stdout);
	#else

	#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t;
	cin >> t;
	while (t--) {
		cin >> n >> m >> q >> p;
		solve();
	}
	return 0;
}