#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cstring>
#include <set>
#include <map>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <iomanip>
#include <random>
#include <ctime>
#include <cassert>

using namespace std;
typedef long long ll;
typedef unsigned long long ull;

#ifdef DEBUG
	const int MAXN = 100;
	const int MAXLOG = 4;
	const int MAXSQRT = 4;
#else
	const int MAXN = 5e5 + 1;
	const int MAXLOG = 20;
	const int MAXSQRT = 400;
	#define cerr if (false) cerr
#endif

mt19937 rng(time(0));
const int MOD = 1e9 + 7;
const int INF = 1e9;

int n, m, q, p;

struct Q {
	ll l, r;
	Q(){}
	Q(ll a, ll b) {
		l = a, r = b;
	}
};

bool in(Q a, Q b) {
	return a.r <= b.r && a.l >= b.l;
}

bool can(Q a, Q b) {
	if (in(a, b)) {
		return 1;
	}
	if (in(b, a)) {
		return 1;
	}
	if (a.r > b.r) {
		swap(a, b);
	}
	if (p * a.r >= (p - 1) *  b.l) {
		return 1;
	}
	return 0;
}

vector<pair<int, ll>> g[MAXN];
vector<Q> dp[MAXN];
vector<int> query[MAXN];
ll cost[MAXN];
int ans[MAXN];

void init() {
	memset(ans, 0, sizeof(ans));
	for (int i = 0; i < n; i++) {
		g[i].clear();
		g[i].shrink_to_fit();
		query[i].clear();
		query[i].shrink_to_fit();
		dp[i].clear();
		dp[i].shrink_to_fit();
	}
}

void solve() {
	init();
	for (int i = 0; i < m; i++) {
		int a, b;
		ll c;
		cin >> a >> b >> c;
		a--, b--;
		g[b].emplace_back(a, c);
	}
	for (int i = 0; i < q; i++) {
		int a;
		ll b;
		cin >> a >> b;
		a--;
		cost[i] = b;
		query[a].push_back(i);
	}
	dp[0].emplace_back(0, 0);
	for (int i = 0; i < n; i++) {
		// cerr << "creating " << i << '\n';
		for (auto edge : g[i]) {
			for (auto it : dp[edge.first]) {
				// cerr << it.l + edge.second << ' ' << it.r + edge.second << '\n';
				dp[i].emplace_back(it.l + edge.second, it.r + edge.second);
			}
		}
		sort(dp[i].begin(), dp[i].end(), [&](Q a, Q b){
			return make_pair(a.l, a.r) < make_pair(b.l, b.r);
		});
		// cerr << "current is " << i << '\n';
		// for (auto it : dp[i]) {
		// 	cerr << it.l << ' ' << it.r << '\t';
		// }
		// cerr << '\n';
		vector<Q> nx;
		for (int j = 0; j < dp[i].size(); j++) {
			if (nx.empty()) {
				nx.push_back(dp[i][j]);
			}
			else {
				if (in(dp[i][j], nx.back())) {
					continue;
				}
				else if (can(dp[i][j], nx.back())) {
					int tmp = nx.back().l;
					nx.pop_back();
					nx.emplace_back(tmp, dp[i][j].r);
				}
				else {
					nx.push_back(dp[i][j]);
				}
			}
		}
		dp[i].swap(nx);
		cerr << "current is " << i << '\n';
		for (auto it : dp[i]) {
			cerr << it.l << ' ' << it.r << '\t';
		}
		cerr << '\n';
		for (auto it : query[i]) {
			for (auto itt : dp[i]) {
				if (itt.r >= cost[it] && cost[it] * p >= (p - 1) * itt.l) {
					ans[it] = 1;
				}
			}
		}
	}
	for (int i = 0; i < q; i++) {
		cout << ans[i];
	}
	cout << '\n';
}

signed main() {
	#ifdef DEBUG
		freopen("C.in", "r", stdin);
		freopen("C.out", "w", stdout);
	#else

	#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t;
	cin >> t;
	while (t--) {
		cin >> n >> m >> q >> p;
		solve();
	}
	return 0;
}