#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cstring>
#include <set>
#include <map>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <iomanip>
#include <random>
#include <ctime>
#include <cassert>
 
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
 
#ifdef DEBUG
    const int MAXN = 10;
    const int MAXLOG = 4;
    const int MAXSQRT = 4;
#else
    const int MAXN = 3e5;
    const int MAXLOG = 20;
    const int MAXSQRT = 400;
    #define cerr if (false) cerr
#endif
 
mt19937 rng(time(0));
const int MOD = 1e9 + 7;
const int INF = 1e9;
 
int n;

map<vector<pair<int, int>>, int> mapa;
map<vector<pair<int, int>>, int> splits;

int gen(vector<pair<int, int>> a) {
	for (auto it : a) {
		cerr << it.first << ' ' << it.second << '\t';
	}
	cerr << '\n';
	sort(a.begin(), a.end());
	if (mapa.count(a)) {
		return mapa[a];
	}
	int d = 0;
	for (int i = 1; i <= n; i++) {
		int c = 0;
		int ca = 0;
		int cb = 0;
		for (auto it : a) {
			if (it.first == i) {
				c++;
				if (it.second) {
					ca++;
				}
				else {
					cb++;
				}
			}
		}
		if (ca && !cb && c > 2) {
			return INF;
		}
		if (cb && !ca && c > 2) {
			return INF;
		}
		if (c > 3) {
			return INF;
		}
		if (c == 3) {
			d++;
		}
	}
	if (d > 1) {
		return INF;
	}
	int minl = n + 1;
	int maxr = 0;
	for (int i = 0; i < a.size(); i++) {
		int l = 1;
		int r = n;
		for (int j = 0; j < i; j++) {
			if (a[j].second == 1) {
				l = max(l, a[j].first);
			}
			else {
				r = min(r, a[j].first - 1);
			}
		}
		for (int j = i + 1; j < a.size(); j++) {
			if (a[j].second == 1) {
				l = max(l, a[j].first);
			}
			else {
				r = min(r, a[j].first - 1);
			}
		}
		if (l <= r) {
			minl = min(minl, l);
			maxr = max(maxr, r);
		}
	}
	if (a.empty()) {
		minl = 1;
		maxr = n;
	}
	if (minl == maxr) {
		splits[a] = -minl;
		return mapa[a] = 0;
	}
	if (minl > maxr) {
		return 0;
	}
	int ans = INF;
	int spl = 0;
	for (int i = minl; i <= maxr; i++) {
		int kek_1 = 0, kek_2 = 0;
		a.emplace_back(i, 0);
		kek_1 = gen(a);
		a.pop_back();
		if (1 + kek_1 >= ans) {
			continue;
		}
		a.emplace_back(i, 1);
		kek_2 = gen(a);
		a.pop_back();
		if (ans > 1 + max(kek_1, kek_2)) {
			ans = 1 + max(kek_1, kek_2);
			spl = i;
		}
	}
	splits[a] = spl;
	return mapa[a] = ans;
}

void init() {
	vector<pair<int, int>> kek = {};
	gen(kek);
}
 
void solve() {
	vector<pair<int, int>> lel;
	// assert(splits.count(lel));
	cerr << mapa[lel] << '\n';
	while (splits[lel] > 0) {
		int sp = splits[lel];
		cout << "? " << sp << endl;
		string x;
		cin >> x;
		if (x == "Yes") {
			lel.push_back(make_pair(sp, 1));
		}
		else {
			lel.push_back(make_pair(sp, 0));
		}
		sort(lel.begin(), lel.end());
		// assert(splits.count(lel));
		for (auto it : lel) {
			cerr << it.first << ' ' << it.second << '\t';
		}
		cerr << '\n';
	}
	cout << "! " << -splits[lel] << endl;
	string s;
	cin >> s;
	if (s == "Done") {
		exit(0);
	}
}
 
signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    init();
    while (1) 
        solve();
    return 0;
}