#include <bits/stdc++.h>

#define mp make_pair

using namespace std;

const int MAX_N = 1000, MAX_M = 1000;
int snow[MAX_N][MAX_M];
bool used[MAX_N][MAX_M];
int n, m;
const pair<int, int> DIRS[4] = {{-1, 0}, {1, 0}, {0, -1}, {0, 1}};

int bfs(int r1, int c1, int r2, int c2, int prohod) {
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            used[i][j] = false;
        }
    }
    queue<pair<int, pair<int, int>>> queue1;
    queue1.push(mp(0, mp(r1, c1)));
    while (!queue1.empty()) {
        int rn = queue1.front().second.first, cn = queue1.front().second.second, val = queue1.front().first;
        queue1.pop();
        if (rn == r2 && cn == c2) {
            return val;
        }
        for (auto d : DIRS) {
            int r_new = rn + d.first, c_new = cn + d.second;
            if (r_new >= n || r_new < 0) continue;
            if (c_new >= m || c_new < 0) continue;
            if (used[r_new][c_new]) continue;
            if (prohod < snow[r_new][c_new]) continue;
            queue1.push(mp(val + 1, mp(r_new, c_new)));
        }
    }
    return -1;
}

int main() {

    cin.tie(0); cout.tie(0);
    ios::sync_with_stdio(false);

    int q;
    cin >> n >> m >> q;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            snow[i][j] = 0;
        }
    }
    for (int ii = 0; ii < q; ++ii) {
        for (int rnow = 0; rnow < n; ++rnow) {
            for (int cnow = 0; cnow < m; ++cnow) {
                snow[rnow][cnow]++;
            }
        }
        int code;
        cin >> code;
        if (code == 1) {
            int r;
            cin >> r;
            r--;
            for (int j = 0; j < m; ++j) {
                snow[r][j] = 0;
            }
        }
        if (code == 2) {
            int c;
            cin >> c;
            c--;
            for (int i = 0; i < n; ++i) {
                snow[i][c] = 0;
            }
        }
        if (code == 3) {
            int r1, c1, r2, c2, k;
            cin >> r1 >> c1 >> r2 >> c2 >> k;
            r1--; c1--; r2--; c2--;
            if (snow[r1][c1] > k) {
                cout << -1 << '\n';
                continue;
            }
            cout << bfs(r1, c1, r2, c2, k) << '\n';
        }
    }
}