#include<iostream>
#include<vector>
#include<algorithm>
#include <stack>
#include<set>
#include<map>

using namespace std;

vector<pair<int, int>> t1, t2;

void up1(int v, int l, int r, int l1, int n) {
	if (r - l == 1 && l1 == l) {
		t1[v].first = n;
		t1[v].second = n;
		return;
	}
	if (r <= l1 || l > l1) {
		return;
	}
	up1(v * 2 + 1, l, (l + r) / 2, l1, n);
	up1(v * 2 + 2, (l + r) / 2, r, l1, n);
	t1[v].first = min(t1[v * 2 + 1].first, t1[v * 2 + 2].first);
	t1[v].second = max(t1[v * 2 + 1].second, t1[v * 2 + 2].second);
}

void up2(int v, int l, int r, int l1, int n) {
	if (r - l == 1 && l1 == l) {
		t2[v].first = n;
		t2[v].second = n;
		return;
	}
	if (r <= l1 || l > l1) {
		return;
	}
	up2(v * 2 + 1, l, (l + r) / 2, l1, n);
	up2(v * 2 + 2, (l + r) / 2, r, l1, n);
	t2[v].first = min(t2[v * 2 + 1].first, t2[v * 2 + 2].first);
	t2[v].second = max(t2[v * 2 + 1].second, t2[v * 2 + 2].second);
}

int gx1(int v, int l, int r, int ql, int qr) {
	if (l >= ql && r <= qr) {
		return t1[v].second;
	}
	if (qr <= l || ql >= r) {
		return -1e8;
	}
	return max(gx1(v * 2 + 1, l, (l + r) / 2, ql, qr), gx1(v * 2 + 2, (l + r) / 2, r, ql, qr));
}

int gx2(int v, int l, int r, int ql, int qr) {
	if (l >= ql && r <= qr) {
		return t2[v].second;
	}
	if (qr <= l || ql >= r) {
		return -1e8;
	}
	return max(gx2(v * 2 + 1, l, (l + r) / 2, ql, qr), gx2(v * 2 + 2, (l + r) / 2, r, ql, qr));
}

int gn1(int v, int l, int r, int ql, int qr) {
	if (l >= ql && r <= qr) {
		return t1[v].first;
	}
	if (qr <= l || ql >= r) {
		return 0;
	}
	return min(gn1(v * 2 + 1, l, (l + r) / 2, ql, qr), gn1(v * 2 + 2, (l + r) / 2, r, ql, qr));
}

int gn2(int v, int l, int r, int ql, int qr) {
	if (l >= ql && r <= qr) {
		return t2[v].first;
	}
	if (qr <= l || ql >= r) {
		return 0;
	}
	return min(gn2(v * 2 + 1, l, (l + r) / 2, ql, qr), gn2(v * 2 + 2, (l + r) / 2, r, ql, qr));
}


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	long long n, m, q;
	cin >> n >> m >> q;
	vector<vector<int>> qe(q);
	for (int i = 0; i < q; i++) {
		int t;
		cin >> t;
		if (t == 1) {
			int r;
			cin >> r;
			r--;
			qe[i] = { t,r };
		}
		if (t == 2) {
			int c;
			cin >> c;
			c--;
			qe[i] = { t,c };
		}
		if (t == 3) {
			int r1, c1, r2, c2, k;
			cin >> r1 >> c1 >> r2 >> c2 >> k;
			r1--;
			c1--;
			r2--;
			c2--;
			qe[i] = { t, r1,c1,r2,c2, k };
		}
	}
	t1.resize(n * 4, { 0,0 });
	t2.resize(m * 4, { 0,0 });
	int t = 0;
	for (int i = 0; i < q; i++) {
		t++;
		if (qe[i][0] == 1) {
			up1(0, 0, n, qe[i][1], -t);
		}
		if (qe[i][0] == 2) {
			up2(0, 0, m, qe[i][1], -t);
		}
		if (qe[i][0] == 3) {
			int r1, c1, r2, c2, k;
			r1 = qe[i][1];
			c1 = qe[i][2];
			r2 = qe[i][3];
			c2 = qe[i][4];
			k = qe[i][5];
			if (t + gx1(0, 0, n, r1, r1 + 1) <= k && t + gx2(0, 0, m, c2, c2 + 1) <= k) {
				cout << abs(r1 - r2) + abs(c1 - c2) << "\n";
			}
			else {
				if (t + gx1(0, 0, n, r2, r2 + 1) <= k && t + gx2(0, 0, m, c1, c1 + 1) <= k) {
					cout << abs(r1 - r2) + abs(c1 - c2) << "\n";
				}
				else {
					if (t + gx1(0, 0, n, min(r2, r1), max(r2, r1) + 1) <= k) {
						cout << abs(r1 - r2) + abs(c1 - c2) << "\n";
					}
					else {
						if (t + gx2(0, 0, m, min(c2, c1), max(c2, c1) + 1) <= k) {
							cout << abs(r1 - r2) + abs(c1 - c2) << "\n";
						}
						else {
							if ((t + gx1(0, 0, n, r2, r2 + 1) > k && t + gx2(0, 0, m,c2, c2 + 1) > k) || (t + gx1(0, 0, n, r1, r1 + 1) > k && t + gx2(0, 0, m, c1, c1 + 1) > k)) {
								cout << -1 << "\n";
							}
							else {
								int ans = 1e8;
								if (t + gx1(0, 0, n , r2, r2 + 1) <= k) {
									if (t + gn2(0, 0, m, min(c2, c1), max(c2, c1) + 1) <= k) {
										ans = min(ans,abs(r1 - r2) + abs(c1 - c2));
									}
									else {
										int l = 0, r = m;
										while (r - l > 1) {
											int s = (l + r) / 2;
											if (t + gn2(0, 0, m, max(0,min(c2, c1)-s), min(c2, c1)+1) <= k) {
												r = s;
											}
											else {
												l = s;
											}
										}
										if (r != m) {
											ans = min(ans, abs(r1 - r2) + abs(c1 - min(c1,c2)+r)+abs(c2-min(c1,c2)+r));
										}
										l = 0;
										r = m;
										while (r - l > 1) {
											int s = (l + r) / 2;
											if (t + gn2(0, 0, m,max(c2,c1),min((int)m, max(c2, c1) + s+1)) <= k) {
												r = s;
											}
											else {
												l = s;
											}
										}
										if (r != m) {
											ans = min(ans, abs(r1 - r2) + abs(c1 - max(c1, c2) - r) + abs(c2 - max(c1, c2) - r));
										}
									}
								}
								else {
									if (t + gn1(0, 0, n, min(r2, r1), max(r2, r1) + 1) <= k) {
										ans = min(ans, abs(r1 - r2) + abs(c1 - c2));
									}
									else {
										int l = 0, r = m;
										while (r - l > 1) {
											int s = (l + r) / 2;
											if (t + gn1(0, 0, n, max(0, min(r2, r1) - s), min(r2, r1) + 1) <= k) {
												r = s;
											}
											else {
												l = s;
											}
										}
										if (r != m) {
											ans = min(ans, abs(c1 - c2) + abs(r1 - min(r1, r2) + r) + abs(r2 - min(r1, r2) + r));
										}
										l = 0;
										r = m;
										while (r - l > 1) {
											int s = (l + r) / 2;
											if (t + gn1(0, 0, n, max(r2, r1), min((int)n,max(r2, r1) + s + 1)) <= k) {
												r = s;
											}
											else {
												l = s;
											}
										}
										if (r != m) {
											ans = min(ans, abs(c1 - c2) + abs(r1 - max(r1, r2) - r) + abs(r2 - max(r1, r2) - r));
										}
									}
								}
								if (ans == 1e8) {
									ans = -1;
								}
								cout << ans << "\n";
							}
						}
					}
				}
			}
		}
	}
	//system("pause");
}