#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

using namespace std;

#define left left228
#define right right228

template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}

template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}

const int N = 300 * 1000 + 228;

struct node
{
	int mx, mod;
	int l, r;
	node() {
		mod = -1;
		mx = l = r = 0;
	}
};

vector< node > d;

void build(int l, int r, int v = 1) {
	d[v].l = l;
	d[v].r = r;
	if (l == r) return;
	int m = (l + r) >> 1;
	build(l, m, v << 1);
	build(m + 1, r, v << 1 | 1);
}

void init(int n) {
	int ss = 1;
	while (ss < n) ss <<= 1;
	ss <<= 1;
	d.resize(ss + 3, node());
	build(1, n);
}

int gets(int v) {
	if (d[v].mod == -1) return d[v].mx;
	return d[v].mod;
}

void push(int v) {
	if (d[v].mod != -1) {
		d[v << 1].mod = d[v << 1 | 1].mod = d[v].mod;
		d[v].mod = -1;
	}
	d[v].mx = max(gets(v << 1), gets(v << 1 | 1));
}

void update(int l, int r, int x, int v = 1) {
	if (l > r || d[v].l > r || d[v].r < l) return;
	if (l <= d[v].l && d[v].r <= r) {
		d[v].mod = x;
	} else {
		push(v);
		update(l, r, x, v << 1);
		update(l, r, x, v << 1 | 1);
		d[v].mx = max(d[v << 1].mx, d[v << 1 | 1].mx);
	}
}

int get(int i, int v = 1) {
	if (d[v].l == d[v].r) {
		return gets(v);
	}
	int m = (d[v].l + d[v].r) >> 1;
	push(v);
	if (i <= m) return get(i, v << 1);
	return get(i, v << 1 | 1);
}

int a[N], b[N], fir[N], last[N];

bool cmp(int i, int j) {
	return fir[i] < fir[j];
}


signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int n, m;
	cin >> n >> m;
	init(n);
	for (int i = 1; i <= n; ++i) {
		cin >> a[i];
		if (!fir[a[i]]) fir[a[i]] = i;
		last[a[i]] = i;
	}
	vector<int> v;
	for (int c = 1; c <= m; ++c) {
		if (fir[c]) {
			v.push_back(c);
		}
	}
	sort(v.begin(), v.end(), cmp);
	for (int c : v) {
		update(fir[c], last[c], c);
	}
	for (int i = 1; i <= n; ++i) {
		if (a[i] != get(i)) {
			cout << -1 << endl;
			return 0;
		}
	}
	cout << (int)v.size() << endl;
	for (int c : v) {
		cout << c << " " << fir[c] << " " << last[c] << endl;
	}
	return 0;
}