#pragma GCC optimize("Ofast")
// #pragma GCC optimize("no-stack-protector")
#include <bits/stdc++.h>

using namespace std;

#define left left228
#define right right228

template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}

template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}

const int N = 1000 * 1000 + 7, Q = 300 * 1000 + 7, INF = 1e8 + 228;

int T[Q], X1[Q], Y1[Q], X2[Q], Y2[Q], K[Q];
int row[Q], col[Q], lastrow[N], lastcol[N];

struct node
{
	vector<int> rw, cl;
	int l, r;
	node() {
		l = r = 0;
		rw.clear();
		cl.clear();
	}
};

vector< node > d;

void merg(vector<int> &v, vector<int> a, vector<int> b) {
	int s1 = (int)a.size(), s2 = (int)b.size();
	int i = 0, j = 0;
	while (i < s1 || j < s2) {
		if (i == s1) v.push_back(b[j++]);
		else if (j == s2) v.push_back(a[i++]);
		else {
			if (a[i] < b[j]) v.push_back(a[i++]);
			else v.push_back(b[j++]);
		}
	}
}

void build(int l, int r, int v = 1) {
	d[v].l = l;
	d[v].r = r;
	if (l == r) {
		if (row[l] != INF) {
			d[v].rw.push_back(row[l]);
		}
		if (col[l] != INF) {
			d[v].cl.push_back(col[l]);
		}
	} else {
		int m = (l + r) >> 1;
		build(l, m, v << 1);
		build(m + 1, r, v << 1 | 1);
		merg(d[v].rw, d[v << 1].rw, d[v << 1 | 1].rw);
		merg(d[v].cl, d[v << 1].cl, d[v << 1 | 1].cl);
	}
}

void init(int n) {
	int ss = 1;
	while (ss < n) ss <<= 1;
	ss <<= 1;
	d.resize(ss + 3, node());
	build(1, n);
}

pair<int, int> P = {-INF, INF};

void getrow(int l, int r, int x, int v = 1) {
	if (l > r || d[v].l > r || d[v].r < l) {
		return ;
	}
	if (l <= d[v].l && d[v].r <= r) {
		int i = lower_bound(d[v].rw.begin(), d[v].rw.end(), x) - d[v].rw.begin();
		if (i < (int)d[v].rw.size()) uin(P.second, d[v].rw[i]);
		if (i) uax(P.first, d[v].rw[i - 1]);
	} else {
		getrow(l, r, x, v << 1);
		getrow(l, r, x, v << 1 | 1);
	}
}

void getcol(int l, int r, int x, int v = 1) {
	if (l > r || d[v].l > r || d[v].r < l) {
		;
	}
	if (l <= d[v].l && d[v].r <= r) {
		int i = lower_bound(d[v].cl.begin(), d[v].cl.end(), x) - d[v].cl.begin();
		if (i < (int)d[v].cl.size()) uin(P.second, d[v].cl[i]);
		if (i) uax(P.first, d[v].cl[i - 1]);
	} else {
		getcol(l, r, x, v << 1);
		getcol(l, r, x, v << 1 | 1);
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int n, m, q;
	cin >> n >> m >> q;
	for (int it = 1; it <= q; ++it) {
		cin >> T[it];
		row[it] = col[it] = INF;
		if (T[it] == 1) {
			cin >> row[it];
		} else if (T[it] == 2) {
			cin >> col[it];
		} else {
			cin >> X1[it] >> Y1[it] >> X2[it] >> Y2[it] >> K[it];
		}
	}
	init(q);
	for (int it = 1; it <= q; ++it) {
		if (T[it] == 1) {
			lastrow[row[it]] = it;
		} else if (T[it] == 2) {
			lastcol[col[it]] = it;
		} else {
			int x1 = X1[it], y1 = Y1[it], x2 = X2[it], y2 = Y2[it], k = K[it];
			int x = it - k;
			if (x <= 0) {
				cout << abs(x1 - x2) + abs(y1 - y2) << endl;
				continue;
			}
			bool ok = 1;
            for (int i = min(x1, x2); i <= max(x1, x2); ++i) {
                if (lastrow[i] < x) {
                    ok = 0;
                    break;
                }
            }
            if (ok) {
                cout << abs(x1 - x2) + abs(y1 - y2) << endl;
                continue;
            }
            ok = 1;
            for (int i = min(y1, y2); i <= max(y1, y2); ++i) {
                if (lastcol[i] < x) {
                    ok = 0;
                    break;
                }
            }
            if (ok) {
                cout << abs(x1 - x2) + abs(y1 - y2) << endl;
                continue;
            }
			bool r1 = (lastrow[x1] >= x), r2 = (lastrow[x2] >= x);
			bool c1 = (lastcol[y1] >= x), c2 = (lastcol[x2] >= x);
			if ((r1 && c2) || (r2 && c1)) {
				cout << abs(x1 - x2) + abs(y1 - y2) << endl;
				continue;
			}
			if ((!r1 && !c1) || (!r2 && !c2)) {
				cout << -1 << endl;
				continue;
			}
			if (r1 && r2) {
				if (x1 == x2) {
					cout << abs(x1 - x2) + abs(y1 - y2) << endl;
					continue;
				}
				// cout << "it=" << it << endl;
				int res = INF;
				vector<int> inter;
				P = {-INF, INF};
				getcol(x, it, x1);
				inter.push_back(P.first), inter.push_back(P.second);
				P = {-INF, INF};
				inter.push_back(P.first), inter.push_back(P.second);
				getcol(x, it, x2);
				for (int c : inter) {
					uin(res, abs(x1 - x2) + abs(y1 - c) + abs(y2 - c));
				}
				if (res == INF) res = -1;
				cout << res << endl;
			} else {
				if (y1 == y2) {
					cout << abs(x1 - x2) + abs(y1 - y2) << endl;
					continue;
				}
				int res = INF;
				vector<int> inter;
				// cout << "it=" << it << endl;
				P = {-INF, INF};
				getrow(x, it, y1);
				inter.push_back(P.first), inter.push_back(P.second);
				P = {-INF, INF};
				getrow(x, it, y2);
				inter.push_back(P.first), inter.push_back(P.second);
				for (int r : inter) {
					// cout << "r=" << r << endl;
					uin(res, abs(y1 - y2) + abs(x1 - r) + abs(x2 - r));
				}
				if (res == INF) res = -1;
				cout << res << endl;
			}
		}
	}
	return 0;
}