#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
typedef long long ll;
#define all(x) x.begin(), x.end()
using namespace std;

struct segment {
	vector<int> sx, sy;
	segment() {}
	friend segment operator+(const segment a, const segment b) {
		segment res;
		res.sx.resize(a.sx.size() + b.sx.size());
		merge(all(a.sx), all(b.sx), res.sx.begin());
		res.sy.resize(a.sy.size() + b.sy.size());
		merge(all(a.sy), all(b.sy), res.sy.begin());
		return res;
	}
};

const int N 	= 3e5 + 64;
const int INF 	= 1e9;
int n, m, q;
segment t[N];
int h = 0;

int read_int() {
	int i;
	cin >> i;
	return i;
}

int dist(vector<int> &v, int l, int r) {
	assert(l <= r);
	int answer = INF;
	auto it = lower_bound(all(v), l);
	if (it != v.end()) {
		if (l <= *it && *it <= r) {
			return 0;
		}
		assert(*it > r);
		answer = min(answer, *it - r);
	}
	if (it != v.begin()) {
		--it;
		assert(*it < l);
		answer = min(answer, l - *it);
	}
	return answer;
}

int dist(vector<int> &v, int val) {
	/*int ans = INF;
	auto it = lower_bound(all(v), val);
	if (it != v.end()) {
		ans = min(ans, *it - val);
	}
	if (it != v.begin()) {
		--it;
		ans = min(ans, val - *it);
	}
	assert(ans >= 0);
	return ans;*/
	return dist(v, val, val);
}

int solve_inf(int x1, int y1, int x2, int y2, int k) {
	int mind = abs(x1 - x2) + abs(y1 - y2);
	if (k >= h) {
		return mind;
	}
	vector<segment*> intr;
	intr.reserve(k + 1);
	for (int i = h - k; i <= h; ++i) {
		intr.push_back(&t[i]);
	}
	bool hx1 = false,
		 hx2 = false,
		 hy1 = false,
		 hy2 = false;
	segment slow;
	for (auto ptr : intr) {
		segment &s = *ptr;
		slow = slow + s;
		hx1 |= binary_search(all(s.sx), x1);
		hx2 |= binary_search(all(s.sx), x2);
		hy1 |= binary_search(all(s.sy), y1);
		hy2 |= binary_search(all(s.sy), y2);
	}
	int cntx = (int)(upper_bound(all(slow.sx), max(x1, x2)) - lower_bound(all(slow.sx), min(x1, x2)));
	int lenx = abs(x1 - x2) + 1;
	assert(cntx <= lenx);
	if (cntx == lenx) {
		return mind;
	}
	int cnty = (int)(upper_bound(all(slow.sy), max(y1, y2)) - lower_bound(all(slow.sy), min(y1, y2)));
	int leny = abs(y1 - y2) + 1;
	assert(cnty <= leny);
	if (cnty == leny) {
		return mind;
	}
	int answer = INF;
	if (x1 == x2) {
		assert(hx1 == hx2);
		if (hx1) {
			return mind;
		}
		if (hy1 && hy2) {
			for (auto ptr : intr) {
				segment &s = *ptr;
				answer = min(answer, dist(s.sx, x1));
				assert(answer > mind);
			}
		}
		return answer;
	}
	if (y1 == y2) {
		assert(hy1 == hy2);
		if (hy1) {
			return mind;
		}
		if (hx1 && hx2) {
			for (auto ptr : intr) {
				segment &s = *ptr;
				answer = min(answer, dist(s.sy, y1));
				assert(answer > mind);
			}
		}
		return answer;
	}
	if ((hx1 && hy2) || (hy1 && hx2)) {
		return mind;
	}
	if (hx1 && hx2) {
		for (auto ptr : intr) {
			segment &s = *ptr;
			answer = min(answer, mind + 2 * dist(s.sy, min(y1, y2), max(y1, y2)));
		}
	}
	if (hy1 && hy2) {
		for (auto ptr : intr) {
			segment &s = *ptr;
			answer = min(answer, mind + 2 * dist(s.sx, min(x1, x2), max(x1, x2)));
		}
	}
	assert(answer >= mind);
	return answer;
}

int solve(int a, int b, int c, int d, int e) {
	int ans = solve_inf(a, b, c, d, e);
	if (ans >= INF) {
		return -1;
	}
	return ans;
}

int main() {
#ifdef LC
	assert(freopen("input.txt", "r", stdin));
#endif
	ios::sync_with_stdio(0);
	cin.tie(0);
	
	cin >> n >> m >> q;
	for (int i = 0; i < q; ++i) {
		++h;
		switch (read_int()) {
			case 1:
			t[h].sx.push_back(read_int());
			break;
			case 2:
			t[h].sy.push_back(read_int());
			break;
			case 3:
			int a = read_int(),
				b = read_int(),
				c = read_int(),
				d = read_int(),
				e = read_int();
			cout << solve(a, b, c, d, e) << "\n";
			break;
		}
	}
	return 0;
}
