#define _USE_MATH_DEFINES
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <deque>
#include <set>
#include <cmath>
using namespace std;

#define kekek ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0)

vector<int> dx = { 1, 0, -1, 0 }, dy = { 0, 1, 0, -1 };

const int inf = 1e9;
int n, m, q;
vector<int> r, c;

int getsnow(int r1, int c1, int t) {
	if (r1 <= 0 || c1 <= 0 || r1 > n || c1 > m) return inf;
	return t - max(r[r1], c[c1]);
}

int gc(int c1, int t) {
	return t - c[c1];
}

int gr(int r1, int t) {
	return t - r[r1];
}

int dijkstra(int r1, int c1, int r2, int c2, int k, int t) {
	if ((gr(r1, t) > k && gc(c1, t) > k) || (t - r[r2] > k && t - c[c2] > k)) return -1;

	if (r1 == r2 && t - r[r1] <= k) return abs(r2 - r1);
	if (c1 == c2 && t - c[c1] <= k) return abs(c2 - c1);
	if ((t - r[r1] <= k && t - c[c2] <= k) || (t - r[r2] <= k && t - c[c1] <= k)) return abs(r2 - r1) + abs(c2 - c1);

	if (t - r[r1] <= k && t - r[r2] <= k) {
		if (c1 > c2) {
			swap(r1, r2);
			swap(c1, c2);
		}

		for (int i = 1; c1 + i <= c2; i++) {
			if (t-c[i] <= k) return abs(r2 - r1) + abs(c2 - c1);
		}
		int ans1 = inf, ans2 = inf;
		for (int i = 1; c1 - i > 0; i++) {
			if (t-c[c1 - i] <= k) {
				ans1 = i;
				break;
			}
		}
		for (int i = 1; c2 + i <= m; i++) {
			if (t-c[c2 + i] <= k) {
				ans2 = i;
				break;
			}
		}

		if (ans1 == inf && ans2 == inf) {
			return -1;
		}
		else return abs(r2 - r1) + abs(c2 - c1) + 2 * min(ans1, ans2);
	}

	if (t - c[c1] <= k && t - c[c2] <= k) {
		if (r1 > r2) {
			swap(c1, c2);
			swap(r1, r2);
		}

		for (int i = r1 + 1; i < r2; i++) {
			if (t - r[i] <= k) return abs(r2 - r1) + abs(c2 - c1);
		}

		int ans1 = inf, ans2 = inf;
		for (int i = 1; r1 - i > 0; i++) {
			if (t - r[r1 - i] <= k) {
				ans1 = i;
				break;
			}
		}
		for (int i = 1; r2 + i <= n; i++) {
			if (t - r[r2 + i] <= k) {
				ans2 = i;
				break;
			}
		}

		if (ans1 == inf && ans2 == inf) {
			return -1;
		}
		else return abs(r2 - r1) + abs(c2 - c1) + 2 * min(ans1, ans2);
	}

	return -1;
}

signed main() {
	kekek;

	cin >> n >> m >> q;
	r.resize(n + 1);
	c.resize(m + 1);

	for (int t = 1; t <= q; t++) {
		int z;
		cin >> z;

		if (z == 1) {
			int aaa;
			cin >> aaa;
			r[aaa] = t;
		}
		else if (z == 2) {
			int aaa;
			cin >> aaa;
			c[aaa] = t;
		}
		else {
			int r1, c1, r2, c2, k;
			cin >> r1 >> c1 >> r2 >> c2 >> k;

			if (max(getsnow(r1, c1, t), getsnow(r2, c2, t)) > k) {
				cout << -1 << '\n';
			}
			else {
				cout << dijkstra(r1, c1, r2, c2, k, t) << '\n';
			}
		}
	}

	system("pause");
	return 0;
}

/*
4 3 9
3 2 1 3 3 1
3 2 1 3 3 1
2 1
2 3
1 1
3 2 1 3 3 3
3 2 1 3 3 3
2 2
3 2 1 3 3 6
*/