#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using pii = pair<int, int>;
#define rep(i, n) for (int (i) = 0; (i) < (n); ++(i))
#define f first
#define s second

struct edge {
    int to;
    ll w;
};

const int MAXN = 1e6 + 5;
int n, m, q, p;
vector<edge> g[MAXN];
vector<edge> gr[MAXN];
vector<pair<ll, ll>> a[MAXN];

void add(vector<pair<ll, ll>> &s, pair<ll, ll> seg) {
    int i = s.size();
    s.push_back(seg);
    while (i > 0 && s[i].f < s[i - 1].f) {
        swap(s[i], s[i - 1]);
        i--;
    }

    if (i != 0 && s[i - 1].s >= s[i].f) {
        s[i].f = s[i - 1].f;
        s.erase(s.begin() + i - 1);
        i--;
    }
    if (i + 1 != s.size() && s[i + 1].f <= seg.s) {
        s[i].s = s[i + 1].s;
        s.erase(s.begin() + i + 1);
    }
}

bool need[MAXN];
bool ans[MAXN];
vector<pair<int, ll>> qe;

void solve() {
    cin >> n >> m >> q >> p;
    qe.clear();
    rep(i, n) {
        g[i].clear();
        gr[i].clear();
        ans[i] = false;
        need[i] = false;
    }
    rep(i, m) {
        int p, q;
        ll w;
        cin >> p >> q >> w;
        p--; q--;
        g[p].push_back({q, w});
        gr[q].push_back({p, w});
    }

    if (q == 0) return;

    rep(i, q) {
        int vv;
        ll c;
        cin >> vv >> c;
        vv--;
        need[vv] = true;
        qe.push_back({vv, c});
    }

    rep(vv, n) {
        if (!need[vv]) continue;
        ll c = qe.back().s;
        rep(i, n) {
            a[i].clear();
        }

        a[vv].push_back({c, c * p / (p - 1)});
        for (int v = vv; v >= 0; --v) {
            for (auto it : gr[v]) {
                int to = it.to;
                ll w = it.w;

                for (auto &seg : a[v]) {
                    add(a[to], {seg.f - w, seg.s - w});
                }
            }
        }

        if (!a[0].empty() && a[0].begin()->f == 0) {
            ans[vv] = true;
        }
    }

    string res(q, '0');
    rep(i, q) {
        int vv = qe[i].f;
        ll c = qe[i].s;
        if (c != qe.back().s) {
            rep(i, n) {
                a[i].clear();
            }

            a[vv].push_back({c, c * p / (p - 1)});
            for (int v = vv; v >= 0; --v) {
                for (auto it : gr[v]) {
                    int to = it.to;
                    ll w = it.w;

                    for (auto &seg : a[v]) {
                        add(a[to], {seg.f - w, seg.s - w});
                    }
                }
            }

            if (!a[0].empty() && a[0].begin()->f == 0) {
                res[i] = '1';
            }
        } else {
            res[i] = ('0' + ans[vv]);
        }
    }
    cout << res << '\n';
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int tt;
    cin >> tt;
    rep(ttt, tt) {
        solve();
    }
}