#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <set>

using namespace std;

const int N = (1 << 21);
const int NN = N * 5;

int tc[NN], tr[NN], tr_mn[NN], tc_mn[NN];
int c[N], r[N];

void update_c(int v, int i = 1, int l = 1, int r = N) {
	if (l <= v && v <= r) {
		if (l == v && l == r) {
			tc[i] = c[v - 1];
			tc_mn[i] = c[v - 1];
		}
		else {
			update_c(v, 2 * i, l, (l + r) / 2);
			update_c(v, 2 * i + 1, (l + r) / 2 + 1, r);
			tc[i] = max(tc[2 * i], tc[2 * i + 1]);
			tc_mn[i] = min(tc_mn[2 * i], tc_mn[2 * i + 1]);
		}
	}

}

void update_r(int v, int i = 1, int l = 1, int R = N) {
	if (l <= v && v <= R) {
		if (l == v && l == R) {
			tr[i] = r[v - 1];
			tr_mn[i] = r[v - 1];
		}
		else {
			update_r(v, 2 * i, l, (l + R) / 2);
			update_r(v, 2 * i + 1, (l + R) / 2 + 1, R);
			tr[i] = max(tr[2 * i], tr[2 * i + 1]);
			tr_mn[i] = min(tr_mn[2 * i], tr_mn[2 * i + 1]);
		}
	}
}

int mx_c(int L, int R, int i = 1, int L_ = 1, int R_ = N) {
	if (R < L_ || R_ < L || L > R)  return -1;
	else {
		if (L <= L_ && R_ <= R) {
			return tc[i];
		}
		else {
			return max(mx_c(L, R, 2 * i, L_, (L_ + R_) / 2), mx_c(L, R, 2 * i + 1, (L_ + R_) / 2 + 1, R_));
		}
	}
}
int mn_c(int L, int R, int i = 1, int L_ = 1, int R_ = N) {
	if (R < L_ || R_ < L || L > R)  return 1e9;
	else {
		if (L <= L_ && R_ <= R) {
			return tc_mn[i];
		}
		else {
			return min(mn_c(L, R, 2 * i, L_, (L_ + R_) / 2), mn_c(L, R, 2 * i + 1, (L_ + R_) / 2 + 1, R_));
		}
	}
}

int mx_r(int L, int R, int i = 1, int L_ = 1, int R_ = N) {
	if (R < L_ || R_ < L || L > R)  return -1;
	else {
		if (L <= L_ && R_ <= R) {
			return tr[i];
		}
		else {
			return max(mx_r(L, R, 2 * i, L_, (L_ + R_) / 2), mx_r(L, R, 2 * i + 1, (L_ + R_) / 2 + 1, R_));
		}
	}
}
int mn_r(int L, int R, int i = 1, int L_ = 1, int R_ = N) {
	if (R < L_ || R_ < L || L > R)  return 1e9;
	else {
		if (L <= L_ && R_ <= R) {
			return tr_mn[i];
		}
		else {
			return min(mn_r(L, R, 2 * i, L_, (L_ + R_) / 2), mn_r(L, R, 2 * i + 1, (L_ + R_) / 2 + 1, R_));
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
#ifdef local
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int n, m;
	cin >> n >> m;
	int q; cin >> q;
	for (int i = 1; i <= q; i++) {
		int type;
		cin >> type;
		if (type == 1) {
			int R; cin >> R;
			r[R - 1] = i;
			update_r(R);
		}
		else if (type == 2) {
			int C; cin >> C;
			c[C - 1] = i;
			update_c(C);
		}
		else {
			int x1, y1, x2, y2, k;
			cin >> x1 >> y1 >> x2 >> y2 >> k;
			x1--, x2--, y2--, y1--;
			int mn = i - k;
			if (!(max(r[x1], c[y1]) >= mn && max(r[x2], c[y2]) >= mn)) cout << "-1\n";
			else if (
				max(r[x1], mn_c(min(y1 + 1, y2 + 1), max(y1 + 1, y2 + 1))) >= mn &&
				max(c[y2], mn_r(min(x1 + 1, x2 + 1), max(x1 + 1, x2 + 1))) >= mn ||
				max(c[y1], mn_r(min(x1 + 1, x2 + 1), max(x1 + 1, x2 + 1))) >= mn &&
				max(r[x2], mn_c(min(y1 + 1, y2 + 1), max(y1 + 1, y2 + 1))) >= mn
			)
			{
				cout << abs(x1 - x2) + abs(y1 - y2) << "\n";
			}
			else {
				int ANS = 1e9;
				if (r[x1] >= mn && r[x2] >= mn) {
					if (mx_c(min(y1+1, y2+1), max(y1 + 1, y2 + 1)) >= mn) ANS = min(ANS, abs(x1 - x2) + abs(y1 - y2));
					else {
						if (mx_c(1, min(y1 + 1, y2 + 1) - 1) >= mn) {
							int L = 1, R = min(y1 + 1, y2 + 1); // left binary search
							while (L < R - 1) {
								int D = (L + R) / 2;
								if (mx_c(D, min(y1 + 1, y2 + 1)) >= mn) L = D;
								else R = D;
							}
							ANS = min(ANS, abs(x1 - x2) + abs(y1 - (L - 1)) + abs((L - 1) - y2));
						}
						if (mx_c(max(y1 + 1, y2 + 1) + 1, m) >= mn) {
							int L = max(y1 + 1, y2 + 1), R = m; // right binary search
							while (L < R - 1) {
								int D = (L + R + 1) / 2;
								if (mx_c(max(y1 + 1, y2 + 1), D) >= mn) R = D;
								else L = D;
							}
							ANS = min(ANS, abs(x1 - x2) + abs(y1 - (R - 1)) + abs((R - 1) - y2));
						}
					}
				}
				if (c[y1] >= mn && c[y2] >= mn) {
					if (mx_r(min(x1 + 1, x2 + 1), max(x1 + 1, x2 + 1)) >= mn) ANS = min(ANS, abs(x1 - x2) + abs(y1 - y2));
					else {
						if (mx_r(1, min(x1 + 1, x2 + 1) - 1) >= mn) {
							int L = 1, R = min(x1 + 1, x2 + 1); // left binary search
							while (L < R - 1) {
								int D = (L + R) / 2;
								if (mx_r(D, min(x1 + 1, x2 + 1)) >= mn) L = D;
								else R = D;
							}
							ANS = min(ANS, abs(y1 - y2) + abs(x1 - (L - 1)) + abs((L - 1) - x2));
						}
						if (mx_r(max(x1 + 1, x2 + 1) + 1, n) >= mn) {
							int L = max(x1 + 1, x2 + 1), R = n; // right binary search
							while (L < R - 1) {
								int D = (L + R + 1) / 2;
								if (mx_r(max(x1 + 1, x2 + 1), D) >= mn) R = D;
								else L = D;
							}
							ANS = min(ANS, abs(y1 - y2) + abs(x1 - (R - 1)) + abs((R - 1) - x2));
						}
					}
				}
				if (ANS == 1e9)
					cout << "-1\n";
				else cout << ANS << "\n";
			}
		}
	}
}