#pragma GCC optimize("Ofast", "unroll-loops")

#include <bits/stdc++.h>

using namespace std;

#define FAST ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define FIXED cout << fixed << setprecision(12);
#define RANDOM srand(342308)
#define ll long long
#define ld long double
#define pii pair<int, int>
#define pll pair<ll, ll>
#define graph vector<vector<int>>
#define pb push_back
#define popb pop_back
#define f first
#define s second
#define hashset unordered_set
#define hashmap unordered_map
#define eps 1e-9
#define mod 1000000007
#define inf 3000000000000000007ll
#define sz(a) int(a.size())
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

template<class T, class U> inline void checkmin(T &x, U y) { if (y < x) x = y; }
template<class T, class U> inline void checkmax(T &x, U y) { if (y > x) x = y; }
template<class T, class U> inline bool ifmin(T &x, U y) { if (y < x) return x = y, true; return false; }
template<class T, class U> inline bool ifmax(T &x, U y) { if (y > x) return x = y, true; return false; }
template<class T> inline void sort(T &a) { sort(all(a)); }
template<class T> inline void rsort(T &a) { sort(rall(a)); }
template<class T> inline void reverse(T &a) { reverse(all(a)); }
template<class T> inline istream& operator>>(istream& str, vector<T> &a) { for (auto &i : a) str >> i; return str; }

const int MAXN = 1e6 + 10;
const int B = 620;
const int BLOCKS = (MAXN + B - 1) / B;

int link[MAXN];

struct decomp {
	int cnt[MAXN];
	int cntB[BLOCKS];
	void add(int x) {
		if (cnt[x]++ == 0) ++cntB[link[x]];
	}
	void del(int x) {
		if (--cnt[x] == 0) --cntB[link[x]];
	}
	int getcnt(int l, int r) { //all queries [l; r)
		int ans = 0;
		if (link[l] == link[r]) {
			for (int i = l; i < r; ++i) ans += cnt[i] > 0;
			return ans;
		}
		int sl = link[l];
		while (link[l] == sl) {
			ans += cnt[l++] > 0;
		}
		int sr = link[r];
		--r;
		while (link[r] == sr) {
			ans += cnt[r--] > 0;
		}
		for (int i = link[l]; i <= link[r]; ++i) ans += cntB[i];
		return ans;
	}
	int getcnt(int l) {
		return cnt[l];
	}
	int more(int x) {
		int sx = link[x];
		while (sx == link[x]) {
			if (cnt[x]) return x;
			++x;
		}
		++sx;
		while (sx < BLOCKS && cntB[sx] == 0) ++sx;
		if (sx == BLOCKS) return -1;
		x = sx * B;
		for (int i = x; i < MAXN; ++i) 
			if (cnt[i]) return i;
		return -1;
	}
	int lower(int x) {
		int sx = link[x];
		while (x >= 0 && sx == link[x]) {
			if (cnt[x] > 0) return x;
			--x;
		}
		if (x < 0) return -1;
		--sx;
		while (sx >= 0 && cntB[sx] == 0) --sx;
		if (sx < 0) return -1;
		x = sx * B + B - 1;
		for (int i = x; i >= 0; --i) {
			if (cnt[i] > 0) return i;
		} 
		return -1;
	}
} byx, byy;

struct query {
	int y1, x1, y2, x2, l, r, ind;
	query(int y1, int x1, int y2, int x2, int l, int r, int ind) {
		this->y1 = y1;
		this->y2 = y2;
		this->x1 = x1;
		this->x2 = x2;
		this->l = l;
		this->r = r;
		this->ind = ind;
	}
};

bool operator<(const query &a, const query &b) {
	if (a.l / B == b.l / B) return a.r < b.r;
	return a.l < b.l;
}

signed main() {
	FAST; FIXED; RANDOM;
	for (int i = 0; i < MAXN; ++i) link[i] = i / B;
	int n, m, q;
	cin >> n >> m >> q;
	vector<pii> arr;
	vector<query> que;
	for (int i = 0; i < q; ++i) {
		int mode;
		cin >> mode;
		if (mode == 3) {
			arr.pb({0, -1});
			int y1, x1, y2, x2, k;
			cin >> y1 >> x1 >> y2 >> x2 >> k;
			--y1, --x1, --y2, --x2;
			int c = sz(que);
			que.pb(query(y1, x1, y2, x2, sz(arr) - k - 1, sz(arr), c));
		} else {
			int x;
			cin >> x;
			arr.pb({mode, x - 1});
		}
	}
	sort(que);
	vector<int> ans(sz(que), mod);
	int l = 0, r = 0;
	for (auto i : que) {
		if (i.l < 0) {
			ans[i.ind] = abs(i.x1 - i.x2) + abs(i.y1 - i.y2);
			continue;
		}
		while (l > i.l) {
			--l;
			if (arr[l].f == 1) byy.add(arr[l].s);
			if (arr[l].f == 2) byx.add(arr[l].s);
		}
		while (r < i.r) {
			if (arr[r].f == 1) byy.add(arr[r].s);
			if (arr[r].f == 2) byx.add(arr[r].s);
			++r;
		}
		while (r > i.r) {
			--r;
			if (r < sz(arr)) {
				if (arr[r].f == 1) byy.del(arr[r].s);
				if (arr[r].f == 2) byx.del(arr[r].s);
			}
		}
		while (l < i.l) {
			if (arr[l].f == 1) byy.del(arr[l].s);
			if (arr[l].f == 2) byx.del(arr[l].s);
			++l;
		}
		int x1 = i.x1, x2 = i.x2, y1 = i.y1, y2 = i.y2;
		if (x1 == x2 && y1 == y2) ans[i.ind] = 0;
		bool canx1 = byx.getcnt(x1);
		bool canx2 = byx.getcnt(x2);
		bool cany1 = byy.getcnt(y1);
		bool cany2 = byy.getcnt(y2);
		if (byx.getcnt(min(x1, x2), max(x1, x2) + 1) == abs(x1 - x2) + 1 || 
			byy.getcnt(min(y1, y2), max(y1, y2) + 1) == abs(y1 - y2) + 1 || 
			canx1 && cany2 || canx2 && cany1) checkmin(ans[i.ind], abs(x1 - x2) + abs(y1 - y2));
		if (x1 == x2 && canx1) checkmin(ans[i.ind], abs(y1 - y2));
		if (y1 == y2 && cany1) checkmin(ans[i.ind], abs(x1 - x2));
		if (canx1 && canx2) {
			int mny = byy.lower(y1), mxy = byy.more(y1);
			if (mny >= 0) checkmin(ans[i.ind], abs(y1 - mny) + abs(y2 - mny) + abs(x1 - x2));
			if (mxy >= 0) checkmin(ans[i.ind], abs(y1 - mxy) + abs(y2 - mxy) + abs(x1 - x2));
		}
		if (cany1 && cany2) {
			int mnx = byx.lower(x1), mxx = byx.more(x1);
			if (mnx >= 0) checkmin(ans[i.ind], abs(x1 - mnx) + abs(x2 - mnx) + abs(y1 - y2));
			if (mxx >= 0) checkmin(ans[i.ind],  abs(x1 - mxx) + abs(x2 - mxx) + abs(y1 - y2));
		}
	}
	for (auto i : ans) cout << (i + 1) % (mod + 1) - 1 << '\n';
	return 0;
}