#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif
#define $ if (DEV)

#include <bits/stdc++.h>

using namespace std;

void entry(int test_id);

int main() {
    int test_count = 1;
    if (DEV) {
        test_count = 228;
        freopen("input.txt", "r", stdin);
    }
    for (int t = 0; t < test_count; ++t) {
        if (feof(stdin)) break;
        $ printf("--- TEST CASE %d ---\n", t);
        entry(t);
    }
}

struct Seg {
    int c;
    int l;
    int r;

    struct CmpLen {
        int len(const Seg s) const {
            return s.r - s.l + 1;
        }

        bool operator()(Seg lhs, Seg rhs) const {
            if (len(lhs) != len(rhs)) return len(lhs) > len(rhs);
            return lhs.c < rhs.c;
        }
    };
};

struct Node {
    int il;
    int ir;
    Node *pl = nullptr;
    Node *pr = nullptr;
    int x;
};

Node *make(int il, int ir) {
    Node *v = new Node;
    v->il = il;
    v->ir = ir;
    v->x= -1;
    if (ir-il>1) {
        int im = (il+ir)/2;
        v->pl = make(il, im);
        v->pr = make(im, ir);
    }
    return v;
}

void st_assign(Node* v, int ql, int qr, int x) {
    if (qr <= v->il || v->ir <= ql) {
        return;
    }
    if (ql <= v->il && v->ir <= qr) {
        v->x = x;
        return;
    }
   if (v->x != -1) {
       v->pl->x = v->x;
       v->pr->x = v->x;
       v->x = -1;
   }
    st_assign(v->pl, ql, qr, x);
    st_assign(v->pr, ql, qr, x);
}

void st_restore(Node* v, vector<int>& out) {
    if (v->x != -1) {
        for (int i = v->il; i < v->ir; ++i) {
            out[i] = v->x;
        }
        return;
    }
    st_restore(v->pl,  out);
    st_restore(v->pr,  out);
}

void entry(int test_id) {
    int m, n;
    {
        int res = scanf("%d %d", &m, &n);
        if (res < 2) {
            exit(0);
        }
    }
    vector<int> a(m);
    for (int i = 0; i < m; ++i) {
        int x;
        scanf("%d", &x);
        a[i] = x - 1;
    }
    vector<bool> had(n);
    vector<int> lb(n, n);
    vector<int> rb(n, -1);
    for (int i = 0; i < m; ++i) {
        int x = a[i];
        if (!had[x]) {
            had[x] = true;
            lb[x] = i;
        }
        rb[x] = i;
    }
    vector<Seg> seg;
    for (int x = 0; x < n; ++x) {
        if (!had[x]) continue;
        seg.push_back({x, lb[x], rb[x]});
    }
    sort(seg.begin(), seg.end(), Seg::CmpLen{});
    vector<int> b(m);
    Node* st = make(0, m);
    for (auto s : seg) {
        //for (int i = s.l; i <= s.r; ++i) {
        //    b[i] = s.c;
        //}
        st_assign(st, s.l, s.r+1, s.c);
    }
    st_restore(st, b);
    if (a == b) {
        printf("%d\n", (int) seg.size());
        for (auto s : seg) {
            printf("%d %d %d\n", s.c + 1, s.l + 1, s.r + 1);
        }
    } else {
        printf("-1\n");
    }

    $ printf("\n");
}