#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif
#define $ if (DEV)

#include <bits/stdc++.h>

using namespace std;

void entry(int test_id);

int main() {
    int test_count = 1;
    if (DEV) {
        test_count = 228;
        freopen("input.txt", "r", stdin);
    }
#ifdef SILENT
    freopen("/dev/null", "w", stdout);
#endif
    for (int t = 0; t < test_count; ++t) {
        if (feof(stdin)) break;
        $ printf("--- TEST CASE %d ---\n", t);
        entry(t);
    }
    $ printf("\n");
    return 0;
}

using ll = long long;

int solve(int n, int m, int k, vector<int>& a, vector<int>& b, int r1, int c1, int r2, int c2) {
    if (r1 > r2) {
        swap(r1, r2);
        swap(c1, c2);
    }
    assert(a[r1] <= k);
    assert(a[r2] <= k);
    assert(0 <= min(c1, c2));
    assert(max(c1, c2) < m);
    assert(0 <= min(r1, r2));
    assert(max(r1, r2) < n);
    int opt = abs(r2-r1) + abs(c2-c1);
    //case 2.1
    {
        int s = 0;
        for (int r = r1+1; r < r2; ++r) {
            s = max(s, a[r]);
        }
        if (s <= k) {
            return opt;
        }
    }
    //case 2.2
    const int INF = 1'000'000'000;
    int ans = INF;
    int cl = min(c1, c2);
    int cr = max(c1, c2);
    for (int c = cl; c < m; ++c) {
        if (b[c] <= k) {
            int res = opt;
            if (c > cr) {
                res += 2 * (c-cr);
            }
            ans = min(ans, res);
            break;
        }
    }
    for (int c = cl; c > -1; --c) {
        if (b[c] <= k) {
            int res = opt;
            res += 2 * (cl-c);
            ans = min(ans, res);
            break;
        }
    }

    if (ans == INF) {
        ans = -1;
    }
    return ans;
}

void entry(int test_id) {
    int n, m, q;
    {
        int res = scanf("%d %d %d", &n, &m, &q);
        if (res < 3) {
            exit(0);
        }
    }
    vector<int> a(n);
    vector<int> b(m);
    for (int _q = 0; _q < q; ++_q) {
        for (int i = 0; i < m; ++i) {
            ++a[i];
        }
        for (int j = 0; j < m; ++j) {
            ++b[j];
        }
        int cmd_code;
        int q1;
        scanf("%d %d", &cmd_code, &q1);
        if (cmd_code == 1) {
            a[q1-1] =0;
            continue;
        }
        if (cmd_code == 2) {
            b[q1-1] =0;
            continue;
        }
        int c1, r2, c2, k;
        scanf("%d %d %d %d", &c1, &r2, &c2, &k);
        int r1 = q1-1;
        --c1;
        --r2;
        --c2;
        int opt = abs(r1-r2) + abs(c1-c2);
        if ((a[r1] > k && b[c1] > k) || (a[r2] > k && b[c2] > k)) {
            printf("-1\n");
            continue;
        }
        if ((a[r1] <= k && b[c2] <= k) || (a[r2] <= k && b[c1] <= k)) {
            printf("%d\n", opt);
            continue;
        }
        int ans;
        if (a[r1] <= k) {
            ans = solve(n, m, k, a, b, r1, c1, r2, c2);
        } else {
            ans = solve(m, n, k, b, a, c1, r1, c2, r2);
        }
        printf("%d\n", ans);
    }
    $ printf("\n");
}