#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif
#define $ if (DEV)

#include <bits/stdc++.h>

using namespace std;

void entry(int test_id);

int main() {
    int test_count = 1;
    if (DEV) {
        test_count = 228;
        freopen("input.txt", "r", stdin);
    }
#ifdef SILENT
    freopen("/dev/null", "w", stdout);
#endif
    for (int t = 0; t < test_count; ++t) {
        if (feof(stdin)) break;
        $ printf("--- TEST CASE %d ---\n", t);
        entry(t);
    }
    $ printf("\n");
    return 0;
}

using ll = long long;

const int U = 1'000 + 1'000'000 * (1-DEV);
struct Tree {
    int data_min[U];
    int data_max[U];
    int sz;
    void init(int n) {
        sz = n;
        init(0, 0, n);
    }
    void init(int v, int l, int r) {
        data_min[v] = data_max[v] = 0;
        if (r-l>1) {
            int m = (r+l)/2;
            init(2*v+1, l, m);
            init(2*v+2, m, r);
        }
    }
    void assign(int i, int x) {
        assign(0, 0, sz, i, x);
    }
    void assign(int v, int il, int ir, int qi, int x) {
        if (qi < il || ir <= qi) return;
        if (ir-il == 1) {
            data_min[v] = data_max[v] = x;
            return;
        }
        int im = (il+ir)/2;
        assign(2*v+1, il, im, qi, x);
        assign(2*v+2, im, ir, qi, x);
        data_max[v] = max(data_max[2*v+1], data_max[2*v+2]);
        data_min[v] = min(data_min[2*v+1], data_min[2*v+2]);
    }
    int getmin(int l, int r) const {
        return getmin(0, 0, sz, l, r);
    }
    int getmin(int v, int il, int ir, int ql, int qr) const {
        if (ir <= ql || qr <= il) return 1'000'000'000;
        if (ql <= il && ir <= qr) {
            return data_min[v];
        }
        int im = (il+ir)/2;
        int t1 = getmin(2*v+1, il, im, ql, qr);
        int t2 = getmin(2*v+2, im, ir, ql, qr);
        return min(t1, t2);
    }
    int getmax(int l, int r) const {
        return getmin(0, 0, sz, l, r);
    }
    int getmax(int v, int il, int ir, int ql, int qr) const {
        if (ir <= ql || qr <= il) return -1'000'000'000;
        if (ql <= il && ir <= qr) {
            return data_max[v];
        }
        int im = (il+ir)/2;
        int t1 = getmin(2*v+1, il, im, ql, qr);
        int t2 = getmin(2*v+2, im, ir, ql, qr);
        return max(t1, t2);
    }
};

int find(const Tree& a, int i, int dir, int md, int x) {
    int lb = 0;
    int rb = md-1;
    {
        int L = i;
        int R = i + md*dir;
        if (L>R) swap(L, R);
        int t = a.getmin(L, R);
        if (t > x) return (int) 1e9;
    }
    while (rb-lb > 1) {
        int m = (lb+rb-1)/2+1;
        int L = i;
        int R = i + m*dir;
        if (L>R) swap(L, R);
        if (a.getmin(L, R) <= x)  {
            rb = m;
        } else {
            lb = m;
        }
    }
    return rb;
}

int solve(int n, int m, int k, vector<int>& a, vector<int>& b, const Tree& ta, const Tree& tb, int r1, int c1, int r2, int c2) {
    if (r1 > r2) {
        swap(r1, r2);
        swap(c1, c2);
    }
    assert(a[r1] <= k);
    assert(a[r2] <= k);
    assert(0 <= min(c1, c2));
    assert(max(c1, c2) < m);
    assert(0 <= min(r1, r2));
    assert(max(r1, r2) < n);
    int opt = abs(r2-r1) + abs(c2-c1);
    //case 2.1
    {
        int s;
        //for (int r = r1+1; r < r2; ++r) {
        //    s = max(s, a[r]);
        //}
        s = ta.getmax(r1+1, r2);
        if (s <= k) {
            return opt;
        }
    }
    //case 2.2
    const int INF = 1'000'000'000;
    int ans = INF;
    int cl = min(c1, c2);
    int cr = max(c1, c2);
    if (tb.getmin(cl, cr) <= k) {
        return opt;
    }
    if (tb.getmin(0, m) > k) return -1;
    int dx = 2*m;
    {
        int t1 = find(tb, cr, 1, m-cr, k);
        dx = min(dx, t1);
        int t2 = find(tb, cl, -1, cl+1, k);
        dx = min(dx, t2);
    }
    ans = opt + 2*dx;

    if (ans == INF) {
        ans = -1;
    }
    return ans;
}

void entry(int test_id) {
    int n, m, q;
    {
        int res = scanf("%d %d %d", &n, &m, &q);
        if (res < 3) {
            exit(0);
        }
    }
    vector<int> a(n);
    vector<int> b(m);
    Tree ta;
    Tree tb;
    ta.init(n);
    tb.init(m);
    int prom = 0;
    for (int _q = 0; _q < q; ++_q) {
       /* for (int i = 0; i < n; ++i) {
            ++a[i];
        }
        for (int j = 0; j < m; ++j) {
            ++b[j];
        }*/
        prom++;
        int cmd_code;
        int q1;
        scanf("%d %d", &cmd_code, &q1);
        if (cmd_code == 1) {
            a[q1-1] =-prom;
            ta.assign(q1-1, -prom);
            continue;
        }
        if (cmd_code == 2) {
            b[q1-1] =-prom;
            tb.assign(q1-1, -prom);
            continue;
        }
        int c1, r2, c2, k;
        scanf("%d %d %d %d", &c1, &r2, &c2, &k);
        int r1 = q1-1;
        --c1;
        --r2;
        --c2;
        k -= prom;
        auto solve_smart = [&]() {
            int opt = abs(r1-r2) + abs(c1-c2);
            if ((a[r1] > k && b[c1] > k) || (a[r2] > k && b[c2] > k)) {
                return -1;
            }
            if ((a[r1] <= k && b[c2] <= k) || (a[r2] <= k && b[c1] <= k)) {
                return opt;
            }
            int ans;
            if (a[r1] <= k) {
                ans = solve(n, m, k, a, b, ta, tb, r1, c1, r2, c2);
            } else {
                ans = solve(m, n, k, b, a, tb, ta, c1, r1, c2, r2);
            }
            return ans;
        };

        auto solve_silly = [&]() {
            queue<tuple<int, int, int>> q;
            map<pair<int, int>, int> used;
            used[{r1, c1}] = 0;
            q.emplace(r1, c1, 0);
            if (a[r1] > k && b[c1] > k) return -1;
            while (!q.empty()) {
                auto [r, c, d] = q.front();
                q.pop();
                const int dx[4] = {1, -1, 0, 0};
                const int dy[4] = {0, 0, 1, -1};
                for (int k = 0; k < 4; ++k) {
                    int nr = r + dx[k];
                    int nc = c + dy[k];
                    if (nr < 0 || nc < 0 || nr >= n || nc >= m) continue;
                    if (min(a[nr], b[nc]) > k) continue;
                    if (used.count({nr, nc}) == 0) {
                        used[{nr, nc}] = d+1;
                        q.push({nr, nc, d+1});
                    }
                }
            }
            if (!used.count({r2, c2})) return -1;
            return used[{r2, c2}];
        };
        int ans = solve_smart();
        printf("%d\n", ans);
    }
    $ printf("\n");
}