#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif
#define $ if (DEV)

#include <bits/stdc++.h>

using namespace std;

void entry(int test_id);

int main() {
    int test_count = 1;
    if (DEV) {
        test_count = 228;
        freopen("input.txt", "r", stdin);
    } else {
        scanf("%d", &test_count);
    }
    for (int t = 0; t < test_count; ++t) {
        if (feof(stdin)) break;
        $ printf("--- TEST CASE %d ---\n", t);
        entry(t);
    }
    $ printf("\n");
}

using ll = long long;
vector<vector<pair<int, ll>>> g;
vector<int> order;

struct G {
    bitset<5001> bs;
    set<ll> oth;
    void add(ll x) {
        if (x <= 5000) {
            bs[x] = 1;
        } else {
            oth.insert(x);
        }
    }

    bool has(ll x) {
        if (x <= 5000) return bs[x];
        return oth.count(x) == 1;
    }
};

void entry(int test_id) {
    {
        g.clear();
        order.clear();
    }
    int n, m, q, p;
    {
        int res = scanf("%d %d %d %d", &n, &m, &q, &p);
        if (res < 2) {
            exit(0);
        }
    }
    g.resize(n);
    for (int i = 0; i < m; ++i) {
        int u, v;
        ll d;
        scanf("%d %d %lld", &u, &v, &d);
        --u;
        --v;
        g[u].push_back({v, d});
    }
    {
        order.clear();
        order.resize(n);
        queue<int> Q;
        vector<int> inpow(n);
        for (int v = 0; v < n; ++v) {
            for (auto e : g[v]) {
                ++inpow[e.first];
            }
        }
        for (int v = 0; v < n; ++v) {
            if (inpow[v] == 0){
                Q.push(v);
            }
        }
        int k = 0;
        while (k < n) {
            int v = Q.front();
            Q.pop();
            order[k++] = v;
            for (auto e : g[v]) {
                if (--inpow[e.first] == 0) Q.push(e.first);
            }
        }
    }
    vector<set<ll>> good(n);
    good[0] = {0};
    for (int v : order) {
        for (auto e : g[v]) {
            for (ll x : good[v]) {
                good[e.first].insert(e.second + x);
            }
        }
    }
    for (int i = 0; i < q; ++i) {
        int f; ll r;
        scanf("%d %lld", &f, &r);
        --f;
        ll lb = r;
        ll rb = r * p / (p-1);
        char c = '0';
        for (auto x : good[f]) {
            ll y = x;
            if (lb <= y && y <= rb) {
                c = '1';
            }
        }
        printf("%c", c);
    }
    printf("\n");
}