#include <bits/stdc++.h>
using namespace std;

int it;

class Segment_tree {
public:
    int size;
    vector<int> t, arr;

    void build(int size_) {
        size = size_;
        t.resize(size_ * 4);
        arr.resize(size);
        build_tree(0, 0, size);
    }

    void build_tree(int v, int l, int r) {
        if (l + 1 == r) {
            t[v] = 0;
        } else {
            int m = (l + r) / 2, vl = v*2 + 1, vr = vl + 1;
            build_tree(vl, l, m);
            build_tree(vr, m, r);
        }
    }

    int get_el(int ind) {
        return arr[ind];
    }

    update_node(int v, int vl, int vr) {
        t[v] = max(t[vl], t[vr]);
    }

    void update_vertex(int ind, int value) {
        update_tree(0, 0, size, ind, value);
    }

    void update_tree(int v, int l, int r, int ind, int value) {
        if (l + 1 == r) {
            t[v] += value;
            arr[l] += value;
        } else {
            int m = (l + r) / 2, vl = v*2 + 1, vr = vl + 1;
            if (ind < m) {
                update_tree(vl, l, m, ind, value);
            } else {
                update_tree(vr, m, r, ind, value);
            }
            update_node(v, vl, vr);
        }
    }

    int get_segment(int s, int e) {
        return get_tree(0, 0, size, s, e);
    }

    int get_tree(int v, int l, int r, int s, int e) {
//        cout << s << " " << e << endl;
        if (s == e) return -1;
        else if (l == s && r == e) {
            return t[v];
        } else {
            int m = (l + r) / 2, vl = v*2 + 1, vr = vl + 1;
            int a, b;
            a = get_tree(vl, l, m, min(s, m), min(m, e));
            b = get_tree(vr, m, r, max(s, m), max(m, e));
            return a + b;
        }
    }
 };

 int main() {

     int n, m, q;
     cin >> n >> m >> q;

     Segment_tree st;
     st.build(n);

     for (int it = 1; it <= q; it++) {
        char com;
        cin >> com;
        if (com == '1') {
            int r;
            cin >> r;
            st.update_vertex(r-1, -(st.get_el(r-1) + it));
        } else {
            int r1, c1, r2, c2, k;
            cin >> r1 >> c1 >> r2 >> c2 >> k;
            if (st.get_segment(r1-1, r2) + it <= k) {
                cout << abs(r1 - r2) + abs(c1 - c2) << "\n";
            } else {
                cout << "-1\n";
            }
        }
     }

    return 0;
 }
