
#include <iostream>
#include <vector>
#include <queue>
#include <cassert>
#include <utility>
using namespace std;

const int N = 1e4 + 10;
const int oo = 1e9;

struct DO {
	vector <int> t, p;

	DO(int n) {
		t.resize(n);
		p.resize(n);
		for (int i = 0; i < n; ++i)
			t[i] = p[i] = 0;
	}

	void push(int i, int tl, int tr) {
		t[i] += p[i];
		if (tl + 1 != tr) {
			p[i * 2] += p[i];
			p[i * 2 + 1] += p[i];
		}
		p[i] = 0;
	}

	void add() {
		p[1]++;
		push(1, 0, N);
	}

	void upd(int i, int l, int r, int pos) {
		push(i, l, r);
		if (l + 1 == r) {
			t[i] = 0;
			return;
		}
		int mid = (l + r) / 2;
		if (pos < mid)
			upd(i * 2, l, mid, pos);
		else
			upd(i * 2 + 1, mid, r, pos);
		push(i * 2, l, mid);
		push(i * 2 + 1, mid, r);
		t[i] = max(t[i * 2], t[i * 2 + 1]);
	}

	int get_max(int i, int tl, int tr, int l, int r) {
		push(i, tl, tr);
		if (l <= tl && tr <= r) {
			return t[i];
		}
		else if (tl >= r || l >= tr) {
			return 0;
		}
		int mid = (tl + tr) / 2;
		return max(get_max(i * 2, tl, mid, l, r), get_max(i * 2 + 1, mid, tr, l, r));
	}

	int get(int i, int tl, int tr, int pos) {
		push(i, tl, tr);
		if (tl + 1 == tr) {
			return t[i];
		}
		int mid = (tl + tr) / 2;
		if (pos < mid)
			return get(i * 2, tl, mid, pos);
		else
			return get(i * 2 + 1, mid, tr, pos);
	}
};


int main() {
//	freopen("true.txt", "r", stdin);
	int n, m, q;
	cin >> n >> m >> q;
	DO row(4 * N), col(4 * N);
	while (q--) {
		row.add();
		col.add();
		int t;
		cin >> t;
		if (t == 1) {
			int pos;
			cin >> pos;
			row.upd(1, 0, N, pos);
		}
		else if (t == 2) {
			int pos;
			cin >> pos;
			col.upd(1, 0, N, pos);
		}
		else {
			int r1, c1, r2, c2, k;
			cin >> r1 >> c1 >> r2 >> c2 >> k;
			
			int d = oo;
			for (int i = 1; i <= n; ++i) {
				int er = 0;
				er = max(er, min(row.get(1, 0, N, i), col.get_max(1, 0, N, min(c1, c2), max(c1, c2) + 1)));
				er = max(er, min( row.get_max(1, 0, N, min(r1, i), max(r1, i) + 1), col.get(1, 0, N, c1)));
				er = max(er, min( row.get_max(1, 0, N, min(r2, i), max(r2, i) + 1), col.get(1, 0, N, c2)));
				if (er <= k) {
					d = min(d, abs(r1 - i) + abs(r2 - i) + abs(c2 - c1));
				}
			}

			for (int j = 1; j <= m; ++j) {
				int er = 0;
				er = max(er, min(col.get(1, 0, N, j), row.get_max(1, 0, N, min(r1, r2), max(r1, r2) + 1)));
				er = max(er, min(row.get(1, 0, N, r1), col.get_max(1, 0, N, min(c1, j), max(c1, j) + 1)) );
				er = max(er, min(row.get(1, 0, N, r2), col.get_max(1, 0, N, min(c2, j), max(c2, j) + 1)));
				if (er <= k) {
					d = min(d, abs(r1 - r2) + abs(j - c1) + abs(j - c2));
				}
			}

			if (d == oo) d = -1;
			cout << d << '\n';
		
		}
	}
	return 0;
}