
#include <iostream>
#include <vector>
#include <queue>
#include <utility>
using namespace std;

const int oo = 1e9;

const int N = 1e4 + 10;

int ar[N][N], d[N][N];

int dx[] = { -1, 1, 0, 0 };
int dy[] = { 0, 0, -1, 1 };

void solve() {
	int n, m, q;
	cin >> n >> m >> q;
	while (q--) {
		for (int i = 1; i <= n; ++i) {
			for (int j = 1; j <= m; ++j) {
				ar[i][j]++;
			}
		}
		int t;
		cin >> t;
		if (t == 1) {
			int r;
			cin >> r;
			for (int j = 1; j <= m; ++j) ar[r][j] = 0;
		}
		else if (t == 2) {
			int c;
			cin >> c;
			for (int j = 1; j <= n; ++j) ar[j][c] = 0;
		}
		else {
			int r1, c1, r2, c2, k;
			cin >> r1 >> c1 >> r2 >> c2 >> k;
			if (ar[r1][c1] > k) {
				cout << -1 << '\n';
				continue;
			}
			for (int i = 1; i <= n; ++i)
				for (int j = 1; j <= m; ++j)
					d[i][j] = oo;
			d[r1][c1] = 0;
			queue <pair<int, int>> q;
			q.push({ r1, c1 });
			while (q.size()) {
				auto cur = q.front();
				q.pop();
				int x = cur.first;
				int y = cur.second;
				for (int p = 0; p < 4; ++p) {
					int nx = x + dx[p];
					int ny = y + dy[p];
					if (nx < 1 || ny < 1 || nx > n || ny > m) continue;
					if (ar[nx][ny] > k) continue;
					if (d[nx][ny] > d[x][y] + 1) {
						d[nx][ny] = d[x][y] + 1;
						q.push({ nx, ny });
					}
				}
			}
			if (d[r2][c2] == oo) d[r2][c2] = -1;
			cout << d[r2][c2] << '\n';
		}
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	//freopen("true.txt", "r", stdin);
	solve();
	return 0;
}