
#include <iostream>
#include <vector>
#include <queue>
#include <cassert>
#include <utility>
using namespace std;

typedef long long ll;

#define debug(x) cout << #x << " = " << x << '\n';

#include <iostream>
#include <vector>
#include <utility>
using namespace std;

const int N = 1e6 + 15;
int tree[4 * N], p[4 * N];

void push(int i, int tl, int tr)
{
	if (p[i] != 0) {
		tree[i] += p[i];
		if (tl + 1 != tr) {
			p[i * 2] += p[i];
			p[i * 2 + 1] += p[i];
		}
		p[i] = 0;
	}
}

void modify(int i, int tl, int tr, int l, int r) {
	push(i, tl, tr);
	if (l <= tl && tr <= r) {
		p[i]++;
		push(i, tl, tr);
		return;
	}
	else if (l >= tr || tl >= r) {
		return;
	}
	int mid = (tl + tr) / 2;
	modify(i * 2, tl, mid, l, r);
	modify(i * 2 + 1, mid, tr, l, r);
	tree[i] = max(tree[i * 2], tree[i * 2 + 1]);
}

void upd(int i, int tl, int tr, int pos) {
	push(i, tl, tr);
	if (tl + 1 == tr) {
		tree[i] = 0;
		return;
	}
	else {
		int mid = (tl + tr) / 2;
		if (pos < mid)
			return upd(i * 2, tl, mid, pos);
		else
			return upd(i * 2 + 1, mid, tr, pos);
		tree[i] = max(tree[i * 2], tree[i * 2 + 1]);
	}
}

int get_max(int i, int tl, int tr, int l, int r) {
	push(i, tl, tr);
	if (l <= tl && tr <= r) {
		return tree[i];
	}
	else if (tl >= r || l >= tr) {
		return 0;
	}
	int mid = (tl + tr) / 2;
	return max(get_max(i * 2, tl, mid, l, r), get_max(i * 2 + 1, mid, tr, l, r));
}


void solve() {
	int n, m, q;
	cin >> n >> m >> q;
	while (q--) {
		modify(1, 0, N, 1, n);
		int t;
		cin >> t;
		if (t == 1) {
			int pos; cin >> pos;
			upd(1, 0, N, pos);
		}
		else if (t == 3) {
			int r1, c1;
			int r2, c2;
			int k;
			cin >> r1 >> c1 >> r2 >> c2 >> k;
			if (r1 > r2) {
				swap(r1, r2);
				swap(c1, c2);
			}
			int r = get_max(1, 0, N, r1, r2 + 1);
			if (r > k) {
				cout << -1 << '\n';
			}
			else {
				cout << abs(r1 - r2) + abs(c1 - c2) << '\n';
			}
		}
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	//freopen("true.txt", "r", stdin);
	solve();
	return 0;
}