
#include <iostream>
#include <vector>
#include <queue>
#include <cassert>
#include <utility>
using namespace std;

typedef long long ll;

#define debug(x) cout << #x << " = " << x << '\n';

const int N = 1e6 + 4;
int tree[4 * N], p[4 * N];

void push(int i, int tl, int tr){
	tree[i] += p[i];
	if (tl + 1 != tr) {
		p[i * 2] += p[i];
		p[i * 2 + 1] += p[i];
	}
	p[i] = 0;
}

void modify(int i, int tl, int tr, int l, int r) {
	push(i, tl, tr);
	if (l <= tl && tr <= r) {
		p[i]++;
		push(i, tl, tr);
		return;
	}
	else if (l >= tr || tl >= r) {
		return;
	}
	int mid = (tl + tr) / 2;
	modify(i * 2, tl, mid, l, r);
	modify(i * 2 + 1, mid, tr, l, r);
	tree[i] = max(tree[i * 2], tree[i * 2 + 1]);
}

void upd(int i, int tl, int tr, int pos) {
	push(i, tl, tr);
	if (tl + 1 == tr) {
		tree[i] = 0;
		return;
	}
	else {
		int mid = (tl + tr) / 2;
		if (pos < mid)
			 upd(i * 2, tl, mid, pos);
		else
			 upd(i * 2 + 1, mid, tr, pos);
		tree[i] = max(tree[i * 2], tree[i * 2 + 1]);
	}
}

int get_max(int i, int tl, int tr, int l, int r) {
	push(i, tl, tr);
	if (l <= tl && tr <= r) {
		return tree[i];
	}
	else if (tl >= r || l >= tr) {
		return 0;
	}
	int mid = (tl + tr) / 2;
	return max(get_max(i * 2, tl, mid, l, r), get_max(i * 2 + 1, mid, tr, l, r));
}

int ar[N];

void solve() {
	int n, m, q;
	cin >> n >> m >> q;

	while (q--) {
		for (int j = 1; j <= n; ++j) ar[j]++;
		int t;
		cin >> t;
		if (t == 1) {
			int pos; cin >> pos;
			ar[pos] = 0;
		}
		else if (t == 3) {
			int r1, c1, r2, c2, k;
			cin >> r1 >> c1 >> r2 >> c2 >> k;
			if (r1 > r2) {
				swap(r1, r2), swap(c1, c2);
			}
			int mx = 0;
			for (int i = r1; i <= r2; ++i) {
				mx = max(mx, ar[i]);
			}
			if (mx > k) {
				cout << -1;
			}
			else {
				cout << abs(r1 - r2) + abs(c1 - c2);
			}
			cout << '\n';
		}
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	//freopen("true.txt", "r", stdin);
	solve();
	return 0;
}