#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define all(a) (a).begin(), (a).end()
#define endl '\n'

typedef long long ll;
typedef vector<int> vi;
typedef vector<vector<int>> vvi;

bool first(int n, int m, int q) {
    return (max(n, m) <= 50 && q <= 4000);
}

int const inf = (int) 2e9;

bool good(int x, int y, int n, int m) {
    return (1 <= x && x <= n && 1 <= y && y <= m);
}

vi tree;

int get(int v, int tl, int tr, int l, int r) {
    if (l > r) return -inf;
    if (tl == l && tr == r) return tree[v];
    int tm = (tl + tr) / 2;
    return max(get(2 * v, tl, tm, l, min(tm, r)),
               get(2 * v + 1, tm + 1, tr, max(l, tm), r));
}

void upd(int v, int tl, int tr, int ind, int val) {
    if (tl == tr) {
        tree[v] = val;
        return;
    }
    int tm = (tl + tr) / 2;
    if (ind <= tm) upd(2 * v, tl, tm, ind, val);
    else upd(2 * v + 1, tm + 1, tr, ind, val);
    tree[v] = max(tree[2 * v], tree[2 * v + 1]);
}

int main() {
    //freopen("input.txt", "r", stdin);
    int n, m, q;
    cin >> n >> m >> q;
    if (first(n, m, q)) {
        vvi snow(n + 1, vi(m + 1, 0));
        int time = 0;
        while (q--) {
            time++;
            int t;
            cin >> t;
            if (t == 1) {
                int r;
                cin >> r;
                for (int i = 1; i <= m; ++i) snow[r][i] = -time;
            } else if (t == 2) {
                int c;
                cin >> c;
                for (int i = 1; i <= n; ++i) snow[i][c] = -time;
            } else {
                int x1, y1, x2, y2, k;
                cin >> x1 >> y1 >> x2 >> y2 >> k;
                if (snow[x1][y1] + time > k) {
                    cout << "-1\n";
                    continue;
                }
                queue<pair<int, int>> q;
                vvi dist(n + 1, vi(m + 1, inf));
                q.push({x1, y1});
                dist[x1][y1] = 0;
                vector<vector<char>> used(n + 1, vector<char>(m + 1, false));
                while (!q.empty()) {
                    auto cur = q.front();
                    q.pop();
                    int x, y;
                    tie(x, y) = cur;
                    if (used[x][y]) continue;
                    used[x][y] = true;
                    for (int dx = -1; dx < 2; ++dx) {
                        for (int dy = -1; dy < 2; ++dy) {
                            if (abs(dx) != abs(dy) && good(x + dx, y + dy, n, m)) {
                                if (dist[x + dx][y + dy] > dist[x][y] + 1 && k >= snow[dx + x][dy + y] + time) {
                                    dist[x + dx][y + dy] = dist[x][y] + 1;
                                    q.push({x + dx, y + dy});
                                }
                            }
                        }
                    }
                }
                cout << (dist[x2][y2] == inf ? -1 : dist[x2][y2]) << endl;
            }
        }
        return 0;
    }
    tree.resize(4 * n, 0);
    int time = 0;
    while (q--) {
        time++;
        int t;
        cin >> t;
        if (t == 1) {
            int r;
            cin >> r;
            upd(1, 1, n, r, -time);
        } else {
            int x1, y1, x2, y2, k;
            if (x1 > x2) swap(x1, x2);
            if (get(1, 1, n, x1, x2) > k) cout << "-1\n";
            else cout << x2 - x1 + abs(y2 - y1) << endl;
        }
    }
    return 0;
}