#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

pair <int, int> t1[1 << 21], t2[1 << 21];
const int inf = 1e9;

int get_min(int v, int l, int r, int tl, int tr) {
    if (tl > tr)
        return inf;
    if (l == tl && r == tr)
        return t1[v].first;
    int m = (r + l) / 2;
    return min(get_min(2 * v, l, m, tl, min(m, tr)), get_min(2 * v + 1, m + 1, r, max(tl, m + 1), tr));
}

int get_min2(int v, int l, int r, int tl, int tr) {
    if (tl > tr)
        return inf;
    if (l == tl && r == tr)
        return t2[v].first;
    int m = (r + l) / 2;
    return min(get_min2(2 * v, l, m, tl, min(m, tr)), get_min2(2 * v + 1, m + 1, r, max(tl, m + 1), tr));
}

int get_max(int v, int l, int r, int tl, int tr) {
    if (tl > tr)
        return 0;
    if (l == tl && r == tr)
        return t1[v].second;
    int m = (r + l) / 2;
    return max(get_max(2 * v, l, m, tl, min(m, tr)), get_max(2 * v + 1, m + 1, r, max(tl, m + 1), tr));
}

int get_max2(int v, int l, int r, int tl, int tr) {
    if (tl > tr)
        return 0;
    if (l == tl && r == tr)
        return t2[v].second;
    int m = (r + l) / 2;
    return max(get_max2(2 * v, l, m, tl, min(m, tr)), get_max2(2 * v + 1, m + 1, r, max(tl, m + 1), tr));
}

void upd(int v, int x) {
    v += (1 << 20);
    t1[v] = {x, x};
    v /= 2;
    while (v) {
        t1[v].first = min(t1[2 * v].first, t1[2 * v + 1].first);
        t1[v].second = max(t1[2 * v].second, t1[2 * v + 1].second);
        v /= 2;
    }
}

void upd2(int v, int x) {
    v += (1 << 20);
    t2[v] = {x, x};
    v /= 2;
    while (v) {
        t2[v].first = min(t2[2 * v].first, t2[2 * v + 1].first);
        t2[v].second = max(t2[2 * v].second, t2[2 * v + 1].second);
        v /= 2;
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, typ, m, q, x, x1, y1, x2, y2, k, l, r, mid;
    cin >> n >> m >> q;
    for (int i = 1; i <= q; i++) {
        cin >> typ;
        if (typ == 1) {
            cin >> x;
            x--;
            upd(x, i);
        }
        else if (typ == 2) {
            cin >> x;
            x--;
            upd2(x, i);
        }
        else {
            cin >> x1 >> y1 >> x2 >> y2 >> k;
            x1--;
            y1--;
            x2--;
            y2--;
            int d = abs(x1 - x2) + abs(y1 - y2);
            bool cond1 = (i - t1[x1 + (1 << 20)].first <= k);
            bool cond2 = (i - t2[y1 + (1 << 20)].first <= k);
            bool cond3 = (i - t1[x2 + (1 << 20)].first <= k);
            bool cond4 = (i - t2[y2 + (1 << 20)].first <= k);
            //cout << cond1 << " " << cond4 << endl;
            if (cond1 && cond4 || cond2 && cond3) {
                cout << d << '\n';
                continue;
            }
            if (x1 > x2)
                swap(x1, x2);
            if (y1 > y2)
                swap(y1, y2);
            if (i - get_min(1, 0, (1 << 20) - 1, x1, x2) <= k) {
                cout << d << '\n';
                continue;
            }
            //cout << "!!!" << get_min2(1, 0, (1 << 20) - 1, min(y1, y2), max(y1, y2)) << endl;
            if (i - get_min2(1, 0, (1 << 20) - 1, y1, y2) <= k) {
                cout << d << '\n';
                continue;
            }
            if (cond1 && cond3) {
                l = -1;
                r = m;
                while (r > l + 1) {
                    mid = (r + l) / 2;
                    if (i - get_max2(1, 0, (1 << 20) - 1, max(0, y1 - mid), min(m - 1, y2 + mid)) <= k)
                        r = mid;
                    else
                        l = mid;
                }
                if (i - get_max2(1, 0, (1 << 20) - 1, max(0, y1 - r), min(m - 1, y2 + r)) <= k) {
                    cout << d + 2 * r << '\n';
                    continue;
                }
            }
            if (cond2 && cond4){
                l = -1;
                r = n;
                while (r > l + 1) {
                    mid = (r + l) / 2;
                    if (i - get_max(1, 0, (1 << 20) - 1, max(0, x1 - mid), min(n - 1, x2 + mid)) <= k)
                        r = mid;
                    else
                        l = mid;
                }
                //cout << "!!!" << r << endl;
                if (i - get_max(1, 0, (1 << 20) - 1, max(0, x1 - r), min(n - 1, x2 + r)) <= k) {
                    cout << d + 2 * r << '\n';
                    continue;
                }
            }
            cout << -1 << '\n';
        }
    }
}
