#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

typedef long long ll;

struct segm_tree {
    vector<int> st, stmin;
    int n;
    segm_tree(int nn) {
        n = nn;
        st.resize(4 * n);
        stmin.resize(4 * n);
    }
    void upd(int ind, int x, int l = 0, int r = -1, int cv = 1) {
        if (r == -1) {
            r = n;
        }
        if (l + 1 == r) {
            st[cv] = x;
            stmin[cv] = x;
        }
        else {
            int mid = (l + r) / 2;
            if (ind < mid) {
                upd(ind, x, l, mid, cv * 2);
            }
            else {
                upd(ind,x, mid, r, cv * 2  + 1);
            }
            st[cv] = max(st[cv * 2], st[cv * 2 + 1]);
            stmin[cv] = min(stmin[cv * 2], stmin[cv * 2 + 1]);
        }
    }
    int get_max(int ll, int rr, int l = 0, int r = -1, int cv = 1) {
        if (r == -1) {
            r = n;
        }
        if (ll >= rr) {
            return -1e9;
        }
        if (ll == l && rr == r) {
            return st[cv];
        }
        else {
            int mid = (l + r) / 2;
            return max(get_max(ll, min(rr, mid), l, mid, cv * 2),
                    get_max(max(ll, mid), rr, mid, r, cv * 2 + 1));
        }
    }
    int get_min(int ll, int rr, int l = 0, int r = -1, int cv = 1) {
        if (r == -1) {
            r = n;
        }
        if (ll >= rr) {
            return 1e9;
        }
        if (ll == l && rr == r) {
            return stmin[cv];
        }
        else {
            int mid = (l + r) / 2;
            return min(get_min(ll, min(rr, mid), l, mid, cv * 2),
                       get_min(max(ll, mid), rr, mid, r, cv * 2 + 1));
        }
    }
};

int main() {
    int n, m, q;
    cin >> n >> m >> q;
    vector<int> row(n), col(m);
    segm_tree rowst(n), colst(m);
    int t = 0;
    while (q) {
        t++;
        q--;
        int c;
        cin >> c;
        if (c == 1) {
            int x;
            cin >> x;
            row[x - 1] = t;
            rowst.upd(x - 1, t);

        }
        else if (c == 2) {
            int x;
            cin >> x;
            col[x - 1] = t;
            colst.upd(x - 1, t);
        }
        else {
            int r1, c1, r2, c2, k;
            cin >> r1 >> c1 >> r2 >> c2 >> k;
            r1--;
            c1--;
            r2--;
            c2--;
            if ((t - row[r1] <= k && t - col[c2] <= k) || (t - col[c1] <= k && t - row[r2] <= k)) {
                cout << abs(c1 - c2) + abs(r1 - r2) << endl;
                continue;
            }
            int ans = 1e9;
            if (t - row[r1] <= k && t - row[r2] <= k) {
                if (rowst.get_min(min(r1, r2), max(r1, r2) + 1) >= t - k) {
                    cout << abs(c1 - c2) + abs(r1 - r2) << endl;
                    continue;
                }
                if (colst.get_max(min(c1, c2), max(c1, c2) + 1) >= t - k) {
                    cout << abs(c1 - c2) + abs(r1 - r2) << endl;
                    continue;
                }

                int l = 0, r = m;
                while (l + 1 < r) {
                    int mid = (l + r) / 2;
                    if (colst.get_max(max(c1, c2), min(m, max(c1, c2) + mid) + 1) >= t - k ||
                    colst.get_max(max(0, min(c1, c2) - mid), min(c1, c2)) >= t - k) {
                        r = mid;
                    }
                    else {
                        l = mid;
                    }
                }
                if (min(c1, c2) - r >= 0 || max(c1, c2) + r <= m) {
                    ans = min(ans, abs(c1 - c2) + abs(r1 - r2) + r * 2);
                }
            }
            if (t - col[c1] <= k && t - col[c2] <= k) {
                if (colst.get_min(min(c1, c2), max(c1, c2) + 1) >= t - k) {
                    cout << abs(c1 - c2) + abs(r1 - r2) << endl;
                    continue;
                }

                for (int i = 0; i < n; ++i) {
                    if (t - row[i] <= k) {
                        ans = min(ans, abs(c1 - c2) + abs(r1 - i) + abs(r2 - i));
                    }
                }
            }
            if (ans == 1e9) {
                cout << -1 << endl;
            }
            else {
                cout << ans << endl;
            }
        }
    }
}