#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

typedef long long ll;

vector<vector<pair<int, ll>>> g;
vector<bool> used;
vector<vector<bool>> dp;

void topsort(int cv, vector<int> &ts) {
    used[cv] = true;
    for (auto nv : g[cv]) {
        if (!used[nv.first]) {
            topsort(nv.first, ts);
        }
    }
    ts.push_back(cv);
}

void calc(int cv) {
    for (auto nv : g[cv]) {
        for (int i = 0; i <= 10000; ++i) {
            if (!dp[cv][i]) {
                continue;
            }
            if (i + nv.second <= 10000) {
                dp[nv.first][i + nv.second] = true;
            }
        }
    }
}

int main() {
    int t;
    cin >> t;
    while (t) {
        t--;
        int n, m, q, p;
        cin >> n >> m >> q >> p;

        g.clear();
        used.clear();
        dp.clear();

        g.resize(n);
        used.resize(n);
        dp.resize(n, vector<bool>(10001));

        for (int i = 0; i < m; ++i) {
            int a, b;
            ll d;
            cin >> a >> b >> d;
            g[a - 1].push_back({b - 1, d});
        }

        vector<int> ts;
        for (int i = 0; i < n; ++i) {
            if (!used[i]) {
                topsort(i, ts);
            }
        }
        reverse(ts.begin(), ts.end());
        dp[0][0] = 1;
        for (int i = 0; i < n; ++i) {
            calc(ts[i]);
        }

        vector<bool> ans;
        while (q) {
            q--;
            int f;
            ll r;
            cin >> f >> r;
            int rr = min(r, 10001ll);
            int rrr = min((ll)floor(1.0 * r * p / (p - 1)), 10000ll) + 1;
            ans.push_back(*max_element(dp[f - 1].begin() + rr, dp[f - 1].begin() + rrr));
        }
        for (auto i : ans) {
            if (i) {
                cout << 1;
            }
            else {
                cout << 0;
            }
        }
        cout << endl;
    }
}