#include <bits/stdc++.h>

using namespace std;

const int INF = 2e9;

bool correct(int x, int y, int n, int m) {
    return 0 <= x && x < n && 0 <= y && y < m;
}

struct node {
    int val;
    int l, r;
    node *left, *right;
    node(){};
    node(int l1, int r1) {
        val = 0;
        l = l1; r = r1;
        left = nullptr;
        right = nullptr;
    }
};

void build(node* v, int L, int R) {
    int m = (L + R) / 2;
    if (R - L == 1) return;
    if (L != m) {
        v -> left = new node(L, m);
        build(v -> left, L, m);
    }
    if (m != R) {
        v -> right = new node(m, R);
        build(v -> right, m, R);
    }
}

int getval(node* v) {
    return (v == nullptr ? 0 : v -> val);
}

void upd(node* v) {
    v -> val = max(getval(v -> left), getval(v -> right));
}

void update(node* v, int i, int x) {
    if (v == nullptr) return;
    if (i < v -> l || v -> r <= i) return;
    if (v -> r - v -> l == 1) {
        v -> val = x;
        return;
    }
    update(v -> left, i, x);
    update(v -> right, i, x);
    upd(v);
}

int get(node*v, int L, int R) {
    if (L == R) return -INF;
    if (v == nullptr) return -INF;
    if (R <= v -> l || v -> r <= L) return -INF;
    if (L <= v -> l && v -> r <= R) return getval(v);
    int Lget = get(v -> left, L, R);
    int Rget = get(v -> right, L, R);
    return max(Lget, Rget);
}

int main()
{
    //ios_base::sync_with_stdio(false);
    //cin.tie(0); cout.tie(0);
    int n, m, q;
    cin >> n >> m >> q;
    if (n <= 50 && m <= 50) {
        vector <vector <int> > f(n, vector <int>(m));
        for (int iq = 0; iq < q; iq++) {
            for (int i = 0; i < n; i++)
                for (int j = 0; j < m; j++)
                    f[i][j]++;
            int type; cin >> type;
            if (type == 1) {
                int i; cin >> i; i--;
                for (int j = 0; j < m; j++)
                    f[i][j] = 0;
            } else if (type == 2){
                int j; cin >> j; j--;
                for (int i = 0; i < n; i++)
                    f[i][j] = 0;
            } else {
                int i1, j1, i2, j2, k;
                cin >> i1 >> j1 >> i2 >> j2 >> k;
                i1--; j1--; i2--; j2--;
                vector <vector <int> > d(n, vector <int> (m, INF));
                d[i1][j1] = 0;
                queue <pair <int, int> > q;
                if (f[i1][j1] <= k)
                    q.push(make_pair(i1, j1));
                while (!q.empty()) {
                    auto p = q.front();
                    q.pop();
                    vector <pair <int, int> > turns = {{0, 1}, {0, -1}, {1, 0}, {-1, 0}};
                    for (auto turn : turns) {
                        int x = p.first + turn.first;
                        int y = p.second + turn.second;
                        if (correct(x, y, n, m) && f[x][y] <= k && d[x][y] > d[p.first][p.second] + 1) {
                            d[x][y] = d[p.first][p.second] + 1;
                            q.push(make_pair(x, y));
                        }
                    }
                }
                if (d[i2][j2] == INF) {
                    cout << -1 << "\n";
                } else {
                    cout << d[i2][j2] << "\n";
                }
            }
        }
    } else {
        int h = 0;
        node* tree = new node(0, n);
        build(tree, 0, n);
        for (int iq = 0; iq < q; iq++) {
            h++;
            int type;
            cin >> type;
            if (type == 1) {
                int snum;
                cin >> snum;
                update(tree, snum - 1, -h);
            } else if (type == 2) {
                int pass; cin >> pass;
            } else {
                int i1, j1, i2, j2, k;
                cin >> i1 >> j1 >> i2 >> j2 >> k;
                i1--; j1--; i2--; j2--;
                int maxs = get(tree, min(i1, i2), max(i1, i2) + 1);
                if (maxs + h <= k) {
                    cout << abs(i1 - i2) + abs(j1 - j2) << "\n";
                } else cout << -1 << "\n";
            }
        }
    }
    return 0;
}
