#include <bits/stdc++.h>

using namespace std;

const int INF = 2e9;

bool correct(int x, int y, int n, int m) {
    return 0 <= x && x < n && 0 <= y && y < m;
}

struct node {
    int val;
    int l, r;
    node *left, *right;
    node(){};
    node(int val1, int l1, int r1) {
        val = val1;
        l = l1; r = r1;
        left = nullptr;
        right = nullptr;
    }
};

void build1(node* v, int L, int R) {
    int m = (L + R) / 2;
    if (R - L == 1) return;
    if (L != m) {
        v -> left = new node(-INF, L, m);
        build1(v -> left, L, m);
    }
    if (m != R) {
        v -> right = new node(-INF, m, R);
        build1(v -> right, m, R);
    }
}

void build2(node* v, int L, int R) {
    int m = (L + R) / 2;
    if (R - L == 1) return;
    if (L != m) {
        v -> left = new node(INF, L, m);
        build2(v -> left, L, m);
    }
    if (m != R) {
        v -> right = new node(INF, m, R);
        build2(v -> right, m, R);
    }
}

int getval(node* v) {
    return (v == nullptr ? 0 : v -> val);
}

void upd1(node* v) {
    v -> val = max(getval(v -> left), getval(v -> right));
}

void upd2(node* v) {
    v -> val = min(getval(v -> left), getval(v -> right));
}

void update1(node* v, int i, int x) {
    if (v == nullptr) return;
    if (i < v -> l || v -> r <= i) return;
    if (v -> r - v -> l == 1) {
        v -> val = x;
        return;
    }
    update1(v -> left, i, x);
    update1(v -> right, i, x);
    upd1(v);
}

void update2(node* v, int i, int x) {
    if (v == nullptr) return;
    if (i < v -> l || v -> r <= i) return;
    if (v -> r - v -> l == 1) {
        v -> val = x;
        return;
    }
    update2(v -> left, i, x);
    update2(v -> right, i, x);
    upd2(v);
}

int get1(node*v, int L, int R) {
    if (L == R) return -INF;
    if (v == nullptr) return -INF;
    if (R <= v -> l || v -> r <= L) return -INF;
    if (L <= v -> l && v -> r <= R) return getval(v);
    int Lget = get1(v -> left, L, R);
    int Rget = get1(v -> right, L, R);
    return max(Lget, Rget);
}

int get2(node*v, int L, int R) {
    if (L == R) return INF;
    if (v == nullptr) return INF;
    if (R <= v -> l || v -> r <= L) return INF;
    if (L <= v -> l && v -> r <= R) return getval(v);
    int Lget = get2(v -> left, L, R);
    int Rget = get2(v -> right, L, R);
    return min(Lget, Rget);
}

int main()
{
    //ios_base::sync_with_stdio(false);
    //cin.tie(0); cout.tie(0);
    int n, m, q;
    cin >> n >> m >> q;
    node* tree1 = new node(-INF, 0, n);
    build1(tree1, 0, n);
    node* tree2 = new node(-INF, 0, m);
    build1(tree2, 0, m);
    node* tree3 = new node(INF, 0, n);
    build2(tree3, 0, n);
    node* tree4 = new node(INF, 0, m);
    build2(tree4, 0, m);
    if (true) {
        int h = 0;
        int last1 = -1, last2 = -1;
        vector <int> changed1(n), changed2(m);
        for (int iq = 0; iq < q; iq++) {
            h++;
            int type; cin >> type;
            if (type == 1) {
                int i; cin >> i; i--;
                last1 = i;
                changed1[i] = h;
                update1(tree1, i, h);
                update2(tree1, i, h);
            } else if (type == 2){
                int j; cin >> j; j--;
                last2 = j;
                changed2[j] = h;
                update1(tree2, j, h);
                update2(tree2, j, h);
            } else {
                int i1, j1, i2, j2, k;
                cin >> i1 >> j1 >> i2 >> j2 >> k;
                i1--; j1--; i2--; j2--;
                if (h - max(changed1[i1], changed2[j1]) > k) {
                    cout << -1 << "\n";
                    continue;
                }
                if (h - max(changed1[i2], changed2[j2]) > k) {
                    cout << -1 << "\n";
                    continue;
                }
                if (changed1[i1] > changed2[j1]) {
                    if (changed1[i2] > changed2[j2]) {
                        if (h - changed2[last2] > k) {
                            cout << -1 << "\n";
                            continue;
                        } else {
                            if (last2 < 0 || h - get1(tree2, min(j1, j2), max(j1,j2) + 1) <= k || h - get2(tree3, min(i1, i2), max(i1,i2) + 1) <= k) {
                                cout << abs(i1 - i2) + abs(j1 - j2) << "\n";
                            } else {
                                cout << abs(j1 - last2) + abs(i1 - i2) + abs(j2 - last2) << "\n";
                            }
                        }
                    } else {
                        cout << abs(i1 - i2) + abs(j1 - j2) << "\n";
                    }
                } else {
                    if (changed1[i2] > changed2[j2]) {
                        cout << abs(i1 - i2) + abs(j1 - j2) << "\n";
                    } else {
                        if (h - changed1[last1] > k) {
                            cout << -1 << "\n";
                            continue;
                        } else {
                            if (last1 < 0 || h - get1(tree1, min(i1, i2), max(i1,i2) + 1) <= k || h - get2(tree4, min(j1, j2), max(j1,j2) + 1) <= k) {
                                cout << abs(i1 - i2) + abs(j1 - j2) << "\n";
                            } else {
                                cout << abs(i1 - last1) + abs(j1 - j2) + abs(i2 - last1) << "\n";
                            }
                        }
                    }
                }
            }
        }
    }
    return 0;
}
