#include <iostream>
#include <algorithm>
#include <cmath>

using namespace std;

/*#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("Ofast")*/

const int inf = (int)1e9;
const int SIZ = 1 << 21;
const int N = (int)1e6 + 10000;
int tmin[2][SIZ], d[2], tmax[2][SIZ], cnt = 0;

void change(int ind, int v, int kek)
{
    tmin[ind][v] = kek;
    tmax[ind][v] = kek;
    while (v > 0)
    {
        v /= 2;
        tmin[ind][v] = min(tmin[ind][2 * v], tmin[ind][2 * v + 1]);
        tmax[ind][v] = min(tmax[ind][2 * v], tmax[ind][2 * v + 1]);
    }
}

int get_min(int ind, int v, int l, int r, int nl, int nr)
{
    if (l > nr || r < nl)
        return inf;
    if (nl <= l && r <= nr)
        return tmin[ind][v];
    int m = (l + r) / 2;
    return min(get_min(ind, 2 * v, l, m, nl, nr),
               get_min(ind, 2 * v + 1, m + 1, r, nl, nr));
}

int get_max(int ind, int v, int l, int r, int nl, int nr)
{
    if (l > nr || r < nl)
        return -inf;
    if (nl <= l && r <= nr)
        return tmax[ind][v];
    int m = (l + r) / 2;
    return max(get_max(ind, 2 * v, l, m, nl, nr),
               get_max(ind, 2 * v + 1, m + 1, r, nl, nr));
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m, q;
    cin >> n >> m >> q;
    d[0] = 1;
    d[1] = 1;
    while (d[0] < n)
        d[0] *= 2;
    while (d[1] < m)
        d[1] *= 2;

    int typ, now, x1, y1, x2, y2, l, r, mid, mb, k, ans;
    for (int kek = 1; kek <= q; kek++)
    {
        cnt++;


        /*cout << "----------\na = \n";
        for (int i = 1; i < 2 * d[0]; i++)
            cout << i << ") " << tmin[0][i] << ' ' << push[0][i] << '\n';
        cout << "+++++++++\nb = \b\n";
        for (int i = 1; i < 2 * d[1]; i++)
            cout << i << ") " << tmin[1][i] << ' ' << push[1][i] << '\n';
        cout << "____________________\n";*/


        typ;
        cin >> typ;
        typ--;
        if (typ <= 1)
        {
            now;
            cin >> now;
            now--;
            change(typ, now + d[typ], kek);
        }
        else
        {
            cin >> y1 >> x1 >> y2 >> x2 >> k;
            y1--;
            x1--;
            y2--;
            x2--;
            bool dx = (cnt - get_min(1, 1, 0, d[1] - 1, min(x1, x2), max(x1, x2)) <= k);
            bool dy = (cnt - get_min(0, 1, 0, d[0] - 1, min(y1, y2), max(y1, y2)) <= k);
            bool dy1 = (cnt - get_max(0, 1, 0, d[0] - 1, y1, y1) <= k);
            bool dy2 = (cnt - get_max(0, 1, 0, d[0] - 1, y2, y2) <= k);
            bool dx1 = (cnt - get_max(1, 1, 0, d[1] - 1, x1, x1) <= k);
            bool dx2 = (cnt - get_max(1, 1, 0, d[1] - 1, x2, x2) <= k);

            if (y1 > y2)
                swap(y1, y2);
            if (x1 > x2)
                swap(x1, x2);

            if (y1 == y2 && (dy1 || dx))
            {
                cout << x2 - x1 << '\n';
                continue;
            }
            if (x1 == x2 && (dx1 || dy))
            {
                cout << y2 - y1 << '\n';
                continue;
            }
            //cout << "get_min = " << get_min(0, 1, 0, d[0] - 1, y1, y1) << ' ' << get_min(1, 1, 0, d[1] - 1, x2, x2) << '\n';
            if (dy && dx)
            {
                cout << x2 + y2 - x1 - y1 << '\n';
                continue;
            }
            if ((dx || dy1) && (dy || dx2))
            {
                cout << x2 + y2 - x1 - y1 << '\n';
                continue;
            }
            if ((dx || dy2) && (dy || dx1))
            {
                cout << x2 + y2 - x1 - y1 << '\n';
                continue;
            }

            if ((dy1 && dy2 || dx) && cnt - get_max(1, 1, 0, d[1] - 1, x1, x2) <= k)
            {
                cout << x2 + y2 - x1 - y1 << '\n';
                continue;
            }

            if ((dx1 && dx2 || dy) && cnt - get_max(0, 1, 0, d[0] - 1, y1, y2) <= k)
            {
                cout << x2 + y2 - x1 - y1 << '\n';
                continue;
            }

            ans = inf;
            if (dy1 && dy2)
            {
                mb = inf;
                if (cnt - get_max(1, 1, 0, d[1] - 1, 0, x1 - 1) <= k)
                {
                    l = 0, r = x1, mid;
                    while (r - l > 1)
                    {
                        mid = (l + r) / 2;
                        if (cnt - get_max(1, 1, 0, d[1] - 1, mid, x1) <= k)
                            l = mid;
                        else
                            r = mid;
                    }
                    mb = x1 + x2 - 2 * l;
                }
                if (cnt - get_max(1, 1, 0, d[1] - 1, x2 + 1, m - 1) <= k)
                {
                    l = x2, r = m - 1, mid;
                    while (r - l > 1)
                    {
                        mid = (l + r) / 2;
                        if (cnt - get_max(1, 1, 0, d[1] - 1, x2, mid) <= k)
                            r = mid;
                        else
                            l = mid;
                    }
                    mb = min(mb, 2 * r - x1 - x2);
                }
                ans = min(ans, y2 - y1 + mb);
            }
            if (dx1 && dx2)
            {
                mb = inf;
                if (cnt - get_max(0, 1, 0, d[0] - 1, 0, y1 - 1) <= k)
                {
                    l = 0, r = y1, mid;
                    while (r - l > 1)
                    {
                        mid = (l + r) / 2;
                        if (cnt - get_max(0, 1, 0, d[0] - 1, mid, y1) <= k)
                            l = mid;
                        else
                            r = mid;
                    }
                    mb = y1 + y2 - 2 * l;
                }
                if (cnt - get_max(0, 1, 0, d[0] - 1, y2 + 1, n - 1) <= k)
                {
                    l = y2, r = n - 1, mid;
                    while (r - l > 1)
                    {
                        mid = (l + r) / 2;
                        if (cnt - get_max(0, 1, 0, d[0] - 1, y2, mid) <= k)
                            r = mid;
                        else
                            l = mid;
                    }
                    mb = min(mb, 2 * r - y1 - y2);
                }
                ans = min(ans, x2 - x1 + mb);
            }
            if (ans == inf)
                cout << "-1\n";
            else
                cout << ans << '\n';
        }
    }
    return 0;
}

/*
4 3 9
3 2 1 3 3 1
3 2 1 3 3 1
2 1
2 3
1 1
3 2 1 3 3 3
3 2 1 3 3 3
2 2
3 2 1 3 3 6

ans = 3 -1 5 -1 3
*/
