#include <iostream>
#include <vector>
#include <cstdlib>
#include <queue>

using namespace std;

#define F first
#define S second

typedef long long ll;
const int N = (int)5e5;
const ll inf = (ll)1e16;
const int byben = 7500;
vector<pair<int, ll> > edges[N];
int siz[N], fin, nex, in[N];
ll kek, p, r, tmin[N], tmax[N];

void f(int now)
{
    if (kek * (p - 1) > r * p)
    {
        kek = -1;
        return ;
    }
    if (now == fin)
        return ;
    if (!siz[now])
    {
        kek = -1;
        return ;
    }
    nex = rand() % siz[now];
    kek += edges[now][nex].S;
    f(edges[now][nex].F);
}

void solve()
{
    ll n, m, q;
    cin >> n >> m >> q >> p;
    for (int i = 0; i < n; i++)
    {
        edges[i].clear();
        siz[i] = 0;
        in[i] = 0;
        tmin[i] = inf;
        tmax[i] = -inf;
    }
    for (int i = 0; i < m; i++)
    {
        int s1, s2;
        ll c;
        cin >> s1 >> s2 >> c;
        edges[s1 - 1].push_back({s2 - 1, c});
        in[s2 - 1]++;
        siz[s1 - 1]++;
    }

    queue<int> qu;
    for (int i = 0; i < n; i++)
    {
        if (!in[i])
        {
            qu.push(i);
            tmin[i] = 0;
            tmax[i] = 0;
        }
    }
    while (!qu.empty())
    {
        int ver = qu.front();
        qu.pop();
        for (int i = 0; i < siz[ver]; i++)
        {
            int to = edges[ver][i].F;
            kek = edges[ver][i].S;
            tmin[to] = min(tmin[to], tmin[ver] + kek);
            tmax[to] = max(tmax[to], tmax[ver] + kek);
            in[to]--;
            if (in[to] == 0)
                qu.push(to);
        }
    }

    for (; q; q--)
    {
        cin >> fin >> r;
        fin--;
        int _find = 0;
        for (int i = 0; i < byben; i++)
        {
            kek = 0;
            f(0);
            if (kek >= r)
            {
                _find = 1;
                break;
            }
        }
        cout << _find;
    }
    cout << '\n';
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    for (; t; t--)
        solve();
}

/*
2
3 3 5 20
1 2 20
2 3 1
1 3 10
2 19
2 20
3 20
3 21
3 9
7 10 5 5
1 2 15
1 3 10
2 4 21
3 4 30
2 5 14
3 5 31
4 6 3
5 6 14
1 7 39
5 7 13
7 42
7 43
7 44
5 39
6 44
*/
