#include<iostream>
#include<cmath>
#include<algorithm>
#include<string>
#include<vector>
#include<map>
#include<set>
#include<iomanip>
#include<random>
using namespace std;
#define x first
#define y second
#define pb push_back
#define sz(a) int(a.size())
#define all(a) a.begin(), a.end()
#define ll long long
mt19937 rng(time(NULL));
struct que {
	int t, r1, c1, r2, c2, k;
	que(int _t, int _r1): t(_t), r1(_r1), c1(), r2(), c2(), k() {};
	que(int _t, int _r1, int _c1, int _r2, int _c2, int _k) : t(_t), r1(_r1), c1(_c1), r2(_r2), c2(_c2), k(_k) {};
};
const int N = 1e6 + 2, INF = 1e9;
vector<int> b[2], t[2][4 * N];
vector<que> vq;
int ct[2][N], l[2][N], tm[2][4 * N];
void change(int t1, int v, int L, int R, int p, int x) {
	if (L == R)
		tm[t1][v] = x;
	else {
		int M = (L + R) / 2;
		if (p <= M)
			change(t1, v * 2 + 1, L, M, p, x);
		else
			change(t1, v * 2 + 2, M + 1, R, p, x);
		tm[t1][v] = min(tm[t1][v * 2 + 1], tm[t1][v * 2 + 2]);
	}
}
int get(int t1, int v, int L, int R, int l, int r) {
	if (L == l && R == r)
		return tm[t1][v];
	int M = (L + R) / 2, ans = INF;
	if (l <= M)
		ans = min(ans, get(t1, v * 2 + 1, L, M, l, min(M, r)));
	if (r > M)
		ans = min(ans, get(t1, v * 2 + 2, M + 1, R, max(M + 1, l), r));
	return ans;
}
void merge(int t1, int L, int R, int v) {
	int i = 0, j = 0;
	while (i < sz(t[t1][L]) || j < sz(t[t1][R])) {
		if (i == sz(t[t1][L])) {
			t[t1][v].pb(t[t1][R][j]);
			j++;
			continue;
		}
		if (j == sz(t[t1][R])) {
			t[t1][v].pb(t[t1][L][i]);
			i++;
			continue;
		}
		if (t[t1][L][i] < t[t1][R][j]) {
			t[t1][v].pb(t[t1][L][i]);
			i++;
		}
		else {
			t[t1][v].pb(t[t1][R][j]);
			j++;
		}
	}
}
void build(int t1, int v, int L, int R) {
	if (L == R)
		t[t1][v].pb(b[t1][L]);
	else {
		int M = (L + R) / 2;
		build(t1, v * 2 + 1, L, M);
		build(t1, v * 2 + 2, M + 1, R);
		merge(t1, v * 2 + 1, v * 2 + 2, v);
	}
}
int get_low(int t1, int v, int L, int R, int l, int r, int p) {
	if (L == l && R == r) {
		int i = lower_bound(all(t[t1][v]), p) - t[t1][v].begin();
		if (!i)
			return -1;
		i--;
		return t[t1][v][i];
	}
	else {
		int M = (L + R) / 2, ans = -1;
		if (l <= M)
			ans = max(ans, get_low(t1, v * 2 + 1, L, M, l, min(M, r), p));
		if (r > M)
			ans = max(ans, get_low(t1, v * 2 + 2, M + 1, R, max(M + 1, l), r, p));
		return ans;
	}
}
int get_up(int t1, int v, int L, int R, int l, int r, int p) {
	if (L == l && R == r) {
		int i = upper_bound(all(t[t1][v]), p) - t[t1][v].begin();
		if (i == sz(t[t1][v]))
			return INF;
		return t[t1][v][i];
	}
	else {
		int M = (L + R) / 2, ans = INF;
		if (l <= M)
			ans = min(ans, get_up(t1, v * 2 + 1, L, M, l, min(M, r), p));
		if (r > M)
			ans = min(ans, get_up(t1, v * 2 + 2, M + 1, R, max(M + 1, l), r, p));
		return ans;
	}
}
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, m, q;
	cin >> n >> m >> q;
	for (int i = 0; i < q; i++) {
		int t;
		cin >> t;
		if (t == 3) {
			int r1, c1, r2, c2, k;
			cin >> r1 >> c1 >> r2 >> c2 >> k;
			vq.pb(que(t, r1 - 1, c1 - 1, r2 - 1, c2 - 1, k));
		}
		else {
			int r1;
			cin >> r1;
			vq.pb(que(t, r1 - 1));
			b[t - 1].pb(r1 - 1);
		}
	}
	build(0, 0, 0, sz(b[0]) - 1);
	build(1, 0, 0, sz(b[1]) - 1);
	for (int i = 0; i < q; i++) {
		if (i) {
			ct[0][i] = ct[0][i - 1];
			ct[1][i] = ct[1][i - 1];
		}
		if (vq[i].t < 3) {
			ct[vq[i].t - 1][i]++;
			l[vq[i].t - 1][vq[i].r1] = i + 1;
			if (vq[i].t == 1)
				change(0, 0, 0, n - 1, vq[i].r1, i + 1);
			else
				change(1, 0, 0, m - 1, vq[i].r1, i + 1);
			continue;
		}
		int t1 = -1, t2 = -1, k = vq[i].k, m0 = get(0, 0, 0, n - 1, min(vq[i].r1, vq[i].r2), max(vq[i].r1, vq[i].r2)), m1 = get(1, 0, 0, m - 1, min(vq[i].c1, vq[i].c2), max(vq[i].c1, vq[i].c2));
		//cout << m0 << ' ' << m1 << endl;
		if (vq[i].k >= i + 1 - max(m1, l[0][vq[i].r1]))
			t1 += 1;
		if (vq[i].k >= i + 1 - max(m0, l[1][vq[i].c1]))
			t1 += 2;
		if (vq[i].k >= i + 1 - max(m1, l[0][vq[i].r2]))
			t2 += 1;
		if (vq[i].k >= i + 1 - max(m0, l[1][vq[i].c2]))
			t2 += 2;
		//cout << t1 << ' ' << t2 << endl;
		if (t1 == -1 || t2 == -1) {
			cout << -1 << endl;
			continue;
		}
		if (t1 == 2 || t1 != t2) {
			cout << abs(vq[i].r1 - vq[i].r2) + abs(vq[i].c1 - vq[i].c2) << endl;
			continue;
		}
		int d = INF, p1, p2, l1, r1;
		if (!t1) {
			r1 = ct[1][i] - 1;
			l1 = ct[1][max(0, i - k + 1)];
			if (r1 < l1) {
				cout << -1 << endl;
				continue;
			}
			p1 = get_low(1, 0, 0, sz(b[1]) - 1, l1, r1, min(vq[i].c1, vq[i].c2));
			p2 = get_up(1, 0, 0, sz(b[1]) - 1, l1, r1, min(vq[i].c1, vq[i].c2));
			if (p1 != -1) 
				d = min(d, min(vq[i].c1, vq[i].c2) - p1);
			if (p2 != INF)
				if (p2 < max(vq[i].c1, vq[i].c2))
					d = 0;
				else
					d = min(d, p2 - max(vq[i].c1, vq[i].c2));
			if (d == INF)
				cout << -1 << endl;
			else
				cout << abs(vq[i].r1 - vq[i].r2) + abs(vq[i].c1 - vq[i].r2) + 2 * d << endl;
		}
		else {
			r1 = ct[0][i] - 1;
			l1 = ct[0][max(0, i - k + 1)];
			if (r1 < l1) {
				cout << -1 << endl;
				continue;
			}
			p1 = get_low(0, 0, 0, sz(b[0]) - 1, l1, r1, min(vq[i].r1, vq[i].r2));
			p2 = get_up(0, 0, 0, sz(b[0]) - 1, l1, r1, min(vq[i].r1, vq[i].r2));
			if (p1 != -1)
				d = min(d, min(vq[i].r1, vq[i].r2) - p1);
			if (p2 != INF)
				if (p2 < max(vq[i].r1, vq[i].r2))
					d = 0;
				else
					d = min(d, p2 - max(vq[i].r1, vq[i].r2));
			if (d == INF)
				cout << -1 << endl;
			else
				cout << abs(vq[i].r1 - vq[i].r2) + abs(vq[i].c1 - vq[i].r2) + 2 * d << endl;
		}
	}
	return 0;
}