#include <iostream>
#include <ios>
#include <set>
#include <queue>
#include <map>
#include <cassert>
using namespace std;

int cur_time = 0;
int type_1_clean_time[1000000];
int t_1[1000000 * 4];  /// MIN
const int INF = 1e9;

void update(int t[], int v, int tl, int tr, int pos, int new_val){
    if(tl == tr){
        t[v] = new_val;
        return;
    }
    int tm = (tl + tr) / 2;
    if(pos <= tm)
        update(t, 2 * v, tl, tm, pos, new_val);
    else
        update(t, 2 * v + 1, tm + 1, tr, pos, new_val);
    t[v] = min(t[2 * v], t[2 * v + 1]);
}
int min(int t[], int v, int tl, int tr, int l, int r){
    l = max(l, tl);
    r = min(r, tr);
    if(l > r)
        return INF;
    if(tl == tr)
        return t[v];
    int tm = (tl + tr) / 2;
    return min( min(t, 2 * v, tl, tm, l, r),
               min(t, 2 * v + 1, tm + 1, tr, l, r) );
}

int last_type_1 = 0;
int cur_strength;
int f_x, f_y;

bool is_ok(int clean_time){
    return clean_time >= cur_time - cur_strength;
}

int main(){
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n, m, q;
    cin >> n >> m >> q;
    for(int i=0; i<q; i++){
        int type;
        cin >> type;
        cur_time++;
        if(type == 1){
            int x;
            cin >> x;
            x--;
            type_1_clean_time[x] = cur_time;
            update(t_1, 1, 0, n - 1, x, cur_time);
            last_type_1 = cur_time;
        }
        else{
            int x1, y1, x2, y2, k;
            cin >> x1 >> y1 >> x2 >> y2 >> k;
            x1--; y1--; x2--; y2--;
            cur_strength = k;
            int min_time = cur_time - cur_strength;
            if(min(t_1, 1, 0, n - 1, min(x1, x2), max(x1, x2)) >= min_time){
                cout << abs(x1 - x2) + abs(y1 - y2) << "\n";
            }
            else
                cout << -1 << "\n";
        }
    }
    return 0;
}
