#include <iostream>
#include <ios>
#include <set>
#include <queue>
#include <map>
#include <cassert>
using namespace std;

int cur_time = 0;
int type_1_clean_time[1000000];
int type_2_clean_time[1000000];
pair<int, int> t_1[1000000 * 4];  /// MIN, MAX
pair<int, int> t_2[1000000 * 4];
const int INF = 1e9;

pair<int, int> min_max(pair<int, int> a, pair<int, int> b){
    return {min(a.first, b.first), max(a.second, b.second)};
}
void update(pair<int, int> t[], int v, int tl, int tr, int pos, int new_val){
    if(tl == tr){
        t[v] = {new_val, new_val};
        return;
    }
    int tm = (tl + tr) / 2;
    if(pos <= tm)
        update(t, 2 * v, tl, tm, pos, new_val);
    else
        update(t, 2 * v + 1, tm + 1, tr, pos, new_val);
    t[v] = min_max(t[2 * v], t[2 * v + 1]);
}
pair<int, int> min_max(pair<int, int> t[], int v, int tl, int tr, int l, int r){
    l = max(l, tl);
    r = min(r, tr);
    if(l > r)
        return {INF, -INF};
    if(tl == tr)
        return t[v];
    int tm = (tl + tr) / 2;
    return min_max( min_max(t, 2 * v, tl, tm, l, r),
               min_max(t, 2 * v + 1, tm + 1, tr, l, r) );
}
int min(pair<int, int> t[], int v, int tl, int tr, int l, int r){
    return min_max(t, v, tl, tr, l, r).first;
}
int max(pair<int, int> t[], int v, int tl, int tr, int l, int r){
    return min_max(t, v, tl, tr, l, r).second;
}
int last_type_1 = 0, last_type_2 = 0;
int cur_strength;
int f_x, f_y;

bool is_ok(int clean_time){
    return clean_time >= cur_time - cur_strength;
}

int main(){
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n, m, q;
    cin >> n >> m >> q;
    bool fail = (n > 50 || m > 50 || q > 4000);
    for(int i=0; i<q; i++){
        int type;
        cin >> type;
        cur_time++;
        if(type == 1){
            int x;
            cin >> x;
            x--;
            type_1_clean_time[x] = cur_time;
            update(t_1, 1, 0, n - 1, x, cur_time);
            last_type_1 = cur_time;
        }
        else if(type == 2){
            int x;
            cin >> x;
            x--;
            type_2_clean_time[x] = cur_time;
            update(t_2, 1, 0, m - 1, x, cur_time);
            last_type_2 = cur_time;
        }
        else{
            int x1, y1, x2, y2, k;
            cin >> x1 >> y1 >> x2 >> y2 >> k;
            x1--; y1--; x2--; y2--;
            cur_strength = k;
            int min_time = cur_time - cur_strength;
            bool exists_1_type_1 = is_ok(type_1_clean_time[x1]), exists_1_type_2 = is_ok(type_2_clean_time[y1]);
            bool exists_2_type_1 = is_ok(type_1_clean_time[x2]), exists_2_type_2 = is_ok(type_2_clean_time[y2]);

            int default_answer = abs(x1 - x2) + abs(y1 - y2);
            if(!exists_1_type_1 && !exists_1_type_2){
                goto no;
            }
            if(!exists_2_type_1 && !exists_2_type_2){
                goto no;
            }
            /// both types:
            if((exists_1_type_1 && exists_2_type_2) || (exists_1_type_2 && exists_2_type_1)){
                goto def;
            }
            /// only type_1, vertical
            if(exists_1_type_1){
                if(x1 == x2)
                    goto def;
                if(min(t_1, 1, 0, n - 1, min(x1, x2), max(x1, x2)) >= min_time){
                    goto def;
                }
                if(!is_ok(last_type_2)){  /// no horizontal lines
                    goto no;
                }

                int min_y = min(y1, y2), max_y = max(y1, y2);
                if(max(t_2, 1, 0, m - 1, min_y, max_y) >= min_time)  /// exists between
                    goto def;
                if(fail)
                    goto no;
                int s = 0, f = m;  /// f is ok, s is not
                while(f - s > 1){
                    int mm = (f + s) / 2;
                    if(max(t_2, 1, 0, m - 1, min_y - mm, max_y + mm) >= min_time)
                        f = mm;
                    else
                        s = mm;
                }
                cout << default_answer + 2 * f << "\n";
            }
            /// only type_2, horizontal
            else{
                if(y1 == y2)
                    goto def;
                if(min(t_2, 1, 0, m - 1, min(y1, y2), max(y1, y2)) >= min_time){
                    goto def;
                }
                if(!is_ok(last_type_1)){  /// no vertical lines
                    goto no;
                }

                int min_x = min(x1, x2), max_x = max(x1, x2);
                if(max(t_1, 1, 0, n - 1, min_x, max_x) >= min_time)  /// exists between
                    goto def;
                if(fail)
                    goto no;
                int s = 0, f = n;  /// f is ok, s is not
                while(f - s > 1){
                    int m = (f + s) / 2;
                    if(max(t_1, 1, 0, n - 1, min_x - m, max_x + m) >= min_time)
                        f = m;
                    else
                        s = m;
                }
                cout << default_answer + 2 * f << "\n";
            }
            continue;
            no:
                cout << -1 << "\n";
                continue;
            def:
                cout << default_answer << "\n";
        }
    }
    return 0;
}
