#include <iostream>
#include <ios>
#include <set>
#include <queue>
#include <map>
using namespace std;

int n, m;

int cur_time = 0;
int type_1_clean_time[1000000];
int type_2_clean_time[1000000];

int cur_strength;
int f_x, f_y;

int snow_count(int x, int y){
    int last_clean_time = max(type_1_clean_time[x], type_2_clean_time[y]);
    return cur_time - last_clean_time;
}
const int mask[4][2] = {{-1, 0}, {1, 0}, {0, -1}, {0, 1}};

int bfs(int x_s, int y_s){
    map<pair<int, int>, int> d;
    queue<pair<int, int>> q;
    set<pair<int, int>> used;
    pair<int, int> start_pair = {x_s, y_s};
    q.push(start_pair);
    used.insert(start_pair);
    d[start_pair] = 0;
    while(!q.empty()){
        auto cur_pair = q.front();
        q.pop();
        int x = cur_pair.first, y = cur_pair.second;
        int our_dist = d[cur_pair];
        if(x == f_x && y == f_y){
            return our_dist;
        }
        for(int k=0; k<4; k++){
            int new_x = x + mask[k][0], new_y = y + mask[k][1];
            if(!(0 <= new_x && new_x < n && 0 <= new_y && new_y < m))
                continue;
            if(snow_count(new_x, new_y) > cur_strength)
                continue;
            pair<int, int> new_pair = {new_x, new_y};
            if(used.find(new_pair) != used.end())
                continue;
            used.insert(new_pair);
            q.push(new_pair);
            d[new_pair] = our_dist + 1;
        }
    }
    return -1;
}

int main(){
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int q;
    cin >> n >> m >> q;
    for(int i=0; i<q; i++){
        int type;
        cin >> type;
        cur_time++;
        if(type == 1){
            int x;
            cin >> x;
            x--;
            type_1_clean_time[x] = cur_time;
        }
        else if(type == 2){
            int x;
            cin >> x;
            x--;
            type_2_clean_time[x] = cur_time;
        }
        else{
            int x1, y1, x2, y2, k;
            cin >> x1 >> y1 >> x2 >> y2 >> k;
            x1--; y1--; x2--; y2--;
            cur_strength = k;
            f_x = x2; f_y = y2;
            cout << bfs(x1, y1) << "\n";
        }
    }
    return 0;
}
