#include <iostream>
#include <bits/stdc++.h>

using namespace std;

struct line {
int l, r, id;

line(int l1, int r1, int id1) {
    l = l1;
    r = r1;
    id = id1;
}
line() {}
    bool operator < (const line a)const {
        return r - l < a.r - a.l;
}
};

struct segment_tree {
    vector<int> _max;
    int last;

    segment_tree(int n) {
        _max.resize(n * 4, 0);
        last = n - 1;
    }

    void add(int v, int l, int r, int id, int c) {
        if (l > id || r < id) return;
        if (l == id && r == id) {
            _max[v] = c;
            return;
        }
        int m = (l + r) / 2;
        add(v * 2 + 1, l, m, id, c);
        add(v * 2 + 2, m + 1, r, id, c);
        _max[v] = max(_max[v * 2 + 1], _max[v * 2 + 2]);
    }

    void add(int id, int c) {
        add(0, 0, last, id, c);
    }

    int get(int v, int l, int r, int left, int right) {
        if (left > right) return -1;
        if (l > right || r < left) return -1;
        if (l >= left && r <= right) return _max[v];
        int m = (l + r) / 2;
        return max(get(v * 2 + 1, l, m, left, right), get(v * 2 + 2, m + 1, r, left, right));
    }

    int get(int l, int r) {
        return get(0, 0, last, l, r);
    }
};
static int m, n;
static vector<int> l, r, a;
static bool check() {
    bool ans = true;
    segment_tree b = segment_tree(m);
    for(int i = 0;i < m;i++) b.add(i, r[a[i]]);
    vector<int> c[n];
    for(int i = 0;i < m;i++) c[a[i]].push_back(i);
    for(int i = 0;i < n;i++) {
        for(int j = 1;j < c[i].size();j++) {
            int id1 = c[i][j - 1];
            int id2 = c[i][j];
            if (b.get(id1 + 1, id2 - 1) > id2) ans = false;
        }
    }
    return ans;
}
int main() {
    cin >> m >> n;
    for (int i = 0; i < m; i++) {
        int b; cin >> b;
        a.push_back(b - 1);
    }
    l.resize(n, -1);
    r.resize(n, - 1);
    for (int i = 0; i < m; i++) r[a[i]] = i;
    for (int i = m - 1; i >= 0; i--) l[a[i]] = i;
    if (!check()) {
        cout << -1;
    }else {
        line sorted[n];
        for (int i = 0; i < n; i++) sorted[i] = line(l[i], r[i], i);
        sort(sorted, sorted + n);
        vector<int> ans[3];
        for (int i = n - 1; i >= 0; i--) {
            if (sorted[i].l == -1) continue;
            ans[0].push_back(sorted[i].id + 1);
            ans[1].push_back(sorted[i].l + 1);
            ans[2].push_back(sorted[i].r + 1);
        }
        cout << ans[0].size() << endl;
        for (int i = 0; i < ans[0].size(); i++) {
            cout << ans[0][i] << " " << ans[1][i] << " " << ans[2][i] << endl;
        }
    }
}