import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Scanner;

class line implements Comparator<line> {
    int l, r, id;

    line(int l, int r, int id) {
        this.l = l;
        this.r = r;
        this.id = id;
    }

    line() {
    }

    ;

    @Override
    public int compare(line o1, line o2) {
        return Integer.compare(o1.r - o1.l, o2.r - o2.l);
    }

}

class dsu {
    int parent[];

    dsu(int n) {
        parent = new int[n];
        for (int i = 0; i < n; i++) parent[i] = i;
    }

    int get(int a) {
        int p = a;
        while (a != parent[a]) a = parent[a];
        while (p != a) {
            int t = parent[p];
            parent[p] = a;
            p = t;
        }
        return a;
    }

    void union(int a, int b) {
        parent[get(a)] = get(b);
    }
}

public class Main {
    static int m, n, l[], r[], a[];
    static line sorted[];

    static ArrayList<Integer>[] sol() {
        boolean bad = false;
        dsu next = new dsu(m);
        for (int i = 0; i < n; i++) {
            if (sorted[i].l == -1) continue;
            int id = sorted[i].l;
            while (id <= sorted[i].r) {
                if (r[a[id]] > sorted[i].r || l[a[id]] < sorted[i].l) bad = true;
                int last_id = id;
                id = next.get(id) + 1;
                if (id == m) break;
                next.union(last_id, id);
            }
            if (id > sorted[i].r + 1) bad = true;
        }
        if (bad) return new ArrayList[1];
        ArrayList<Integer> ans[] = new ArrayList[3];
        for (int i = 0; i < 3; i++) ans[i] = new ArrayList<>();
        for (int i = n - 1; i >= 0; i--) {
            if (sorted[i].l == -1) continue;
            ans[0].add(sorted[i].id + 1);
            ans[1].add(sorted[i].l + 1);
            ans[2].add(sorted[i].r + 1);
        }
        return ans;
    }

    static ArrayList<Integer>[] tup_sol() {
        boolean bad = false;
        for (int i = 0; i < n; i++) {
            if (sorted[i].l == -1) continue;
            for (int j = sorted[i].l + 1; j < sorted[i].r; j++) {
                if (l[a[j]] < sorted[i].l || r[a[j]] > sorted[i].r) bad = true;
            }
        }
        if (bad) return new ArrayList[1];
        ArrayList<Integer> ans[] = new ArrayList[3];
        for(int i = n - 1;i >= 0;i--) {
            if (sorted[i].l == -1) continue;
            ans[0].add(sorted[i].id + 1);
            ans[1].add(sorted[i].l + 1);
            ans[2].add(sorted[i].r + 1);
        }
        return ans;
    }

    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        m = sc.nextInt();
        n = sc.nextInt();
        a = new int[m];
        for (int i = 0; i < m; i++) a[i] = sc.nextInt() - 1;
        int l[] = new int[n];
        int r[] = new int[n];
        for (int i = 0; i < n; i++) {
            l[i] = -1;
            r[i] = -1;
        }
        for (int i = 0; i < m; i++) r[a[i]] = i;
        for (int i = m - 1; i >= 0; i--) l[a[i]] = i;
        sorted = new line[n];
        for (int i = 0; i < n; i++) sorted[i] = new line(l[i], r[i], i);
        Arrays.sort(sorted, new line());
        ArrayList<Integer> ans[] = tup_sol();
        if (ans.length == 1) pw.println(-1);
        else{
            pw.println(ans[0].size());
            for(int i = 0;i < ans[0].size();i++) {
                pw.println(ans[0].get(i) + " " + ans[1].get(i) + " " + ans[2].get(i));
            }
        }
        pw.close();
    }

    static PrintWriter pw = new PrintWriter(System.out);
}
