import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.*;
class line implements Comparator<line> {
    int l, r, id;

    line(int l, int r, int id) {
        this.l = l;
        this.r = r;
        this.id = id;
    }

    line() {
    }

    @Override
    public int compare(line o1, line o2) {
        return Integer.compare(o1.r - o1.l, o2.r - o2.l);
    }

}

class segment_tree {
    int max[];
    int last;
    segment_tree(int n) {
        max = new int [n * 4];
        last = n - 1;
    }
    void add(int v, int l, int r,int id, int c) {
        if (l > id || r < id) return;
        if (l == id && r == id) {
            max[v] = c;
            return;
        }
        int m = (l + r) / 2;
        add(v * 2 + 1, l, m, id, c);
        add(v * 2 + 2, m + 1, r, id, c);
        max[v] = Math.max(max[v * 2 + 1], max[v * 2 + 2]);
    }
    void add(int id, int c) {
        add(0, 0, last, id, c);
    }
    int get(int v, int l, int r, int left,int right) {
        if (l > right || r < left) return -1;
        if (l >= left && r <= right) return max[v];
        int m = (l + r) / 2;
        return Math.max(get(v * 2 + 1, l, m, left, right), get(v * 2 + 2, m + 1, r, left, right));
    }
    int get(int l, int r) {
        return get(0, 0, last, l, r);
    }
}
public class Main {
    static int inf = (int) 1e9;
    static int m, n, l[], r[], a[];
    static boolean check() {
        boolean ans = true;
        segment_tree b = new segment_tree(m);
        for(int i = 0;i < m;i++) b.add(i, r[a[i]]);
        ArrayList<Integer> c[] = new ArrayList[n];
        for(int i = 0;i < n;i++) c[i] = new ArrayList<>();
        for(int i = 0;i < m;i++) c[a[i]].add(i);
        for(int i = 0;i < n;i++) {
            for(int j = 1;j < c[i].size();j++) {
                int id1 = c[i].get(j - 1);
                int id2 = c[i].get(j);
                if (b.get(id1 + 1, id2 - 1) > id2) ans = false;
            }
        }
        return ans;
    }
    public static void main(String[] args) throws IOException {
        m = nextInt();
        n = nextInt();
        a = new int[m];
        for (int i = 0; i < m; i++) a[i] = nextInt() - 1;
        l = new int[n];
        r = new int[n];
        for (int i = 0; i < n; i++) {
            l[i] = -1;
            r[i] = -1;
        }
        for (int i = 0; i < m; i++) r[a[i]] = i;
        for (int i = m - 1; i >= 0; i--) l[a[i]] = i;
        if (!check()) {
            pw.println(-1);
        }else {
            line sorted[] = new line[n];
            for (int i = 0; i < n; i++) sorted[i] = new line(l[i], r[i], i);
            Arrays.sort(sorted, new line());
            ArrayList<Integer> ans[] = new ArrayList[3];
            for (int i = 0; i < 3; i++) ans[i] = new ArrayList<>();
            for (int i = n - 1; i >= 0; i--) {
                if (sorted[i].l == -1) continue;
                ans[0].add(sorted[i].id + 1);
                ans[1].add(sorted[i].l + 1);
                ans[2].add(sorted[i].r + 1);
            }
            pw.println(ans[0].size());
            for (int i = 0; i < ans[0].size(); i++) {
                pw.println(ans[0].get(i) + " " + ans[1].get(i) + " " + ans[2].get(i));
            }
        }
        pw.close();
    }

    static PrintWriter pw = new PrintWriter(System.out);
    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static StringTokenizer st = new StringTokenizer("");
    static int nextInt() throws IOException {
        while(!st.hasMoreTokens()) st = new StringTokenizer(br.readLine());
        return Integer.parseInt(st.nextToken());
    }
}
