#include<iostream>
#include<vector>
#include<algorithm>

using namespace std;

#pragma warning(disable : 4996)

const int N = 1e6 + 5, INF = 1e9;
int a[N], b[N], t[2][N * 4], tm[2][N * 4];

void upd(int z, int x, int y, int v, int L, int R) {
	if (L == R) {
		t[z][v] = y;
		tm[z][v] = y;
	}
	else {
		int m = (L + R) >> 1;
		if (x <= m)
			upd(z, x, y, v * 2, L, m);
		else
			upd(z, x, y, v * 2 + 1, m + 1, R);
		t[z][v] = max(t[z][v * 2], t[z][v * 2 + 1]);
		tm[z][v] = min(tm[z][v * 2], tm[z][v * 2 + 1]);
	}
}

int quelg(int z, int x, int y, int v, int L, int R) {
	if (L > x || t[z][v] < y)
		return -1;
	if (L == R)
		return L;
	int m = (L + R) >> 1,
		w = quelg(z, x, y, v * 2 + 1, m + 1, R);
	if (w == -1)
		return quelg(z, x, y, v * 2, L, m);
	return w;
}

int querg(int z, int x, int y, int v, int L, int R) {
	if (R < x || t[z][v] < y)
		return -1;
	if (L == R)
		return L;
	int m = (L + R) >> 1,
		w = querg(z, x, y, v * 2, L, m);
	if (w == -1)
		return w = querg(z, x, y, v * 2 + 1, m + 1, R);
	return w;
}

int quelb(int z, int x, int y, int v, int L, int R) {
	if (L > x || tm[z][v] >= y)
		return -1;
	if (L == R)
		return L;
	int m = (L + R) >> 1,
		w = quelb(z, x, y, v * 2 + 1, m + 1, R);
	if (w == -1)
		return quelb(z, x, y, v * 2, L, m);
	return w;
}

int querb(int z, int x, int y, int v, int L, int R) {
	if (R < x || tm[z][v] >= y)
		return -1;
	if (L == R)
		return L;
	int m = (L + R) >> 1,
		w = querb(z, x, y, v * 2, L, m);
	if (w == -1)
		return w = querb(z, x, y, v * 2 + 1, m + 1, R);
	return w;
}

int quemx(int z, int l, int r, int v, int L, int R) {
	if (l > r)
		return 0;
	if (l == L && r == R)
		return t[z][v];
	int m = (L + R) >> 1;
	return max(quemx(z, l, min(m, r), v * 2, L, m),
		quemx(z, max(m + 1, l), r, v * 2 + 1, m + 1, R));
}

int quemn(int z, int l, int r, int v, int L, int R) {
	if (l > r)
		return INF;
	if (l == L && r == R)
		return t[z][v];
	int m = (L + R) >> 1;
	return min(quemn(z, l, min(m, r), v * 2, L, m),
		quemn(z, max(m + 1, l), r, v * 2 + 1, m + 1, R));
}

int main() {
#ifdef HOME
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int n, m, q;
	cin >> n >> m >> q;

	for (int i = 1; i <= q; i++) {
		int type;
		cin >> type;
		if (type == 1) {
			int r;
			cin >> r;
			a[r] = i;
			upd(0, r, i, 1, 1, n);
		}
		else if (type == 2) {
			int c;
			cin >> c;
			b[c] = i;
			upd(1, c, i, 1, 1, m);
		}
		else {
			int r1, c1, r2, c2, k;
			cin >> r1 >> c1 >> r2 >> c2 >> k;

			int ans = INF;

			{
				if (c1 > c2) {
					swap(c1, c2);
					swap(r1, r2);
				}

				int x1 = quelb(1, c1, i - k, 1, 1, m),
					y1 = querb(1, c1, i - k, 1, 1, m),
					x2 = quelb(1, c2, i - k, 1, 1, m),
					y2 = querb(1, c2, i - k, 1, 1, m);

				if (x1 == -1)
					x1 = 1;
				else
					x1++;

				if (y1 == -1)
					y1 = m;
				else
					y1--;

				if (x2 == -1)
					x2 = 1;
				else
					x2++;

				if (y2 == -1)
					y2 = m;
				else
					y2--;

				int lb = max(x1, x2), rb = min(y1, y2);

				if (lb <= rb) {
					ans = abs(r1 - r2) + abs(c1 - c2);
				}

				if (i - a[r1] <= k)
					x1 = 1, y1 = m;
				if (i - a[r2] <= k)
					x2 = 1, y2 = m;

				lb = max(x1, x2), rb = min(y1, y2);

				int p = max(lb, c1), q = min(rb, c2);

				if (i - quemx(1, p, q, 1, 1, m) <= k) {
					ans = abs(r1 - r2) + abs(c1 - c2);
				}

				p = quelg(1, c1, i - k, 1, 1, m),
					q = querg(1, c2, i - k, 1, 1, m);

				if (p != -1 && p >= lb && p <= rb) {
					ans = min(ans, abs(c1 - p) + abs(c2 - p) + abs(r1 - r2));
				}

				if (q != -1 && q >= lb && q <= rb) {
					ans = min(ans, abs(c1 - q) + abs(c2 - q) + abs(r1 - r2));
				}
			}

			{
				if (r1 > r2) {
					swap(c1, c2);
					swap(r1, r2);
				}

				int x1 = quelb(0, r1, i - k, 1, 1, n),
					y1 = querb(0, r1, i - k, 1, 1, n),
					x2 = quelb(0, r2, i - k, 1, 1, n),
					y2 = querb(0, r2, i - k, 1, 1, n);

				if (x1 == -1)
					x1 = 1;
				else
					x1++;

				if (y1 == -1)
					y1 = m;
				else
					y1--;

				if (x2 == -1)
					x2 = 1;
				else
					x2++;

				if (y2 == -1)
					y2 = m;
				else
					y2--;

				int lb = max(x1, x2), rb = min(y1, y2);

				if (lb <= rb) {
					ans = abs(r1 - r2) + abs(c1 - c2);
				}

				if (i - b[c1] <= k)
					x1 = 1, y1 = m;
				if (i - b[c2] <= k)
					x2 = 1, y2 = m;

				lb = max(x1, x2), rb = min(y1, y2);

				int p = max(lb, r1), q = min(rb, r2);

				if (i - quemx(0, p, q, 1, 1, n) <= k) {
					ans = abs(r1 - r2) + abs(c1 - c2);
				}

				p = quelg(0, r1, i - k, 1, 1, n),
					q = querg(0, r2, i - k, 1, 1, n);

				if (p != -1 && p >= lb && p <= rb) {
					ans = min(ans, abs(r1 - p) + abs(r2 - p) + abs(c1 - c2));
				}

				if (q != -1 && q >= lb && q <= rb) {
					ans = min(ans, abs(r1 - q) + abs(r2 - q) + abs(c1 - c2));
				}
			}

			if (ans == INF)
				cout << "-1\n";
			else
				cout << ans << "\n";
		}
	}
	return 0;
}