#define REL
#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <math.h>
#include <algorithm>
#include <vector>
#include <string>
#include <iomanip>
#include <set>
#include <map>
#include <queue>
#include <set>
#include <map>
#include <set>

#define mp make_pair
#define pb push_back
#define pp " "
#define nn "\n"
#define all(x) x.begin(), x.end()

using namespace std;

struct Zap {
	int ty;
	int a;
	pair <int, int> s, f;
	Zap() {}
	Zap(int ty_, int a_) {
		ty = ty_;
		a = a_;
	}
	Zap(int ty_, int a_, pair <int, int> s_, pair <int, int> f_) {
		ty = ty_;
		a = a_;
		s = s_;
		f = f_;
	}
};

int n, m, q;
vector <Zap> zap;
vector <vector <pair <int, int>>> tg, tv;
vector <pair <int, int>> g, v;
vector <vector <int>> kg, kv;
vector <vector <int>> rg, rv;

void build(vector <pair<int, int>> &a, vector <vector <int>> &t, int v, int tl, int tr) {
	if (tl == tr) {
		t[v].pb(a[tl].first);
	}
	else {
		int m = (tl + tr) / 2;
		build(a, t, v * 2 + 1, tl, m);
		build(a, t, v * 2 + 2, m + 1, tr);
		t[v].resize(t[v * 2 + 1].size() + t[v * 2 + 2].size());
		merge(all(t[v * 2 + 1]), all(t[v * 2 + 2]), t[v].begin());
		t[v].resize(unique(all(t[v])) - t[v].begin());
		return;
	}
}

void build(vector <pair <int, int>> &a, vector <vector <pair <int, int>>> &t, int v, int tl, int tr) {
	if (tl == tr) {
		t[v].pb(a[tl]);
	}
	else {
		int m = (tl + tr) / 2;
		build(a, t, v * 2 + 1, tl, m);
		build(a, t, v * 2 + 2, m + 1, tr);
		t[v].resize(t[v * 2 + 1].size() + t[v * 2 + 2].size());
		merge(all(t[v * 2 + 1]), all(t[v * 2 + 2]), t[v].begin());
		return;
	}
}

bool finnd(vector <int> &t, int l, int r) {
	int lg = lower_bound(all(t), l) - t.begin();
	int rg = upper_bound(all(t), r) - t.begin();
	if (rg > lg) return true;
	return false;
}

const int INF = 1e9 + 7;

int minn(vector <vector <pair <int, int>>> &t, int v, int tl, int tr, int l, int r, int x, int y) {
	if (l > r) return INF;
	if (tl == l && tr == r) {
		int lg = lower_bound(all(t[v]), mp(x, 0)) - t[v].begin();
		int rg = upper_bound(all(t[v]), mp(y, 0)) - t[v].begin() - 1;
		if (lg <= rg) return 0;
		int ret = INF;
		if (lg < t[v].size()) {
			ret = min(ret, abs(t[v][lg].first - y));
		}
		if (rg >= 0) {
			ret = min(ret, abs(t[v][rg].first - x));
		}
		return ret;
	}
	else {
		int m = (tl + tr) / 2;
		return min(minn(t, v * 2 + 1, tl, m, l, min(m, r), x, y),
			minn(t, v * 2 + 2, m + 1, tr, max(l, m + 1), r, x, y));
	}
}

int dist(int i) {
	return abs(zap[i].f.first - zap[i].s.first) + abs(zap[i].f.second - zap[i].s.second);
}

pair <int, int> get_gp(vector <pair <int, int>> &v, int lg, int rg) {
	pair<int, int> ret;
	int l = -1, r = v.size(), m;
	while (r - l > 1) {
		m = (l + r) / 2;
		if (v[m].second >= lg) {
			r = m;
		}
		else {
			l = m;
		}
	}
	ret.first = r;
	l = -1; r = v.size();  m = 0;
	while (r - l > 1) {
		m = (l + r) / 2;
		if (v[m].first > rg) {
			r = m;
		}
		else {
			l = m;
		}
	}
	ret.second = r - 1;
	return ret;
}

vector <int> used;
int tpro;

bool pro(int l, int r, int ty, int x, int y) {
	tpro++;
	for (int i = l; i <= r; i++) {
		if (ty == zap[i].ty) {
			used[zap[i].a] = tpro;
		}
	}
	for (int i = x; i <= y; i++) {
		if (used[i] != tpro) {
			return false;
		}
	}
	return true;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> m >> q;
	used.resize(max(n, m));
	zap.resize(q);
	for (int i = 0; i < q; i++) {
		cin >> zap[i].ty;
		if (zap[i].ty <= 2) {
			cin >> zap[i].a;
			zap[i].a--;
		}
		else {
			cin >> zap[i].s.first >> zap[i].s.second >> zap[i].f.first >> zap[i].f.second >> zap[i].a;
			zap[i].s.first--; zap[i].s.second--; zap[i].f.first--; zap[i].f.second--;
			if (zap[i].s > zap[i].f) swap(zap[i].s, zap[i].f);
		}
	}
	kg.resize(n);
	kv.resize(m);
	for (int i = 0; i < zap.size(); i++) {
		if (zap[i].ty == 1) {
			g.pb(mp(zap[i].a, i));
			kg[zap[i].a].pb(i);
		}
		if (zap[i].ty == 2) {
			v.pb(mp(zap[i].a, i));
			kv[zap[i].a].pb(i);
		}
	}
	tg.resize(4 * g.size());
	tv.resize(4 * v.size());
	build(g, tg, 0, 0, g.size() - 1);
	build(v, tv, 0, 0, v.size() - 1);
	for (int i = 0; i < zap.size(); i++) {
		if (zap[i].ty == 3) {
			int tim = i - zap[i].a;
			bool sv, sg, fv, fg;
			sv = finnd(kv[zap[i].s.second], tim , i);
			sg = finnd(kg[zap[i].s.first], tim, i);
			fv = finnd(kv[zap[i].f.second], tim, i);
			fg = finnd(kg[zap[i].f.first], tim, i);
			if ((sv && fg) || (sg && fv)) {
				cout << dist(i) << nn;
			}
			else {
				if (sg && fg) {
					auto gp = get_gp(v, tim, i);
					auto rr = minn(tv, 0, 0, v.size() - 1, gp.first, gp.second, zap[i].s.second, zap[i].f.second);
					bool ep = pro(tim, i, 1, zap[i].s.first, zap[i].f.first);
					if (ep) {
						cout << dist(i) << nn;
					}
					else {
						if (rr == INF) {
							cout << -1;
						}
						else {
							cout << dist(i) + rr * 2 << nn;
						}
					}
					continue;
				}
				if (sv && fv){
					auto gp = get_gp(g, tim, i);
					auto rr = minn(tg, 0, 0, g.size() - 1, gp.first, gp.second, zap[i].s.first, zap[i].f.first);
					bool ep = pro(tim, i, 2, zap[i].s.second, zap[i].f.second);
					if (ep) {
						cout << dist(i) << nn;
					}
					else {
						if (rr == INF) {
							cout << -1;
						}
						else {
							cout << dist(i) + rr * 2 << nn;
						}
					}
					continue;
				}
				if (tim == -1) {
					cout << dist(i) << nn;
				}
				else {
					cout << -1 << nn;
				}
			}
		}
	}
}