#include <iostream>
#include <stdio.h>
#include <algorithm>

using namespace std;

struct node
{
	int mn, mx;
	node* l;
	node* r;
	node() : mn(0), mx(0), l(NULL), r(NULL) {};
};

void recalc(node* &root)
{
	root->mn = 1e9;
	root->mx = -1;
	if (root->l != NULL)
		root->mx = max(root->mx, root->l->mx), root->mn = min(root->mn, root->l->mn);
	if (root->r != NULL)
		root->mx = max(root->mx, root->r->mx), root->mn = min(root->mn, root->r->mn);
}

void build(node* &root, int l, int r)
{
	if (l + 1 > r)
		return;
	root = new node();
	if (l + 1 == r)
		return;
	int m = (l + r) / 2;
	build(root->l, l, m);
	build(root->r, m, r);
	recalc(root);
}

int get(node* &root, int l, int r, int id)
{
	if (l + 1 > r || l > id || r <= id)
		return -2;
	if (l + 1 == r)
		return root->mn;
	int m = (l + r) / 2;
	int q1 = get(root->l, l, m, id);
	int q2 = get(root->r, m, r, id);
	return (q1 == -2 ? q2 : q1);
}

int getmax(node* &root, int l, int r, int l1, int r1)
{
	int mx = -2;
	for (int i = l1; i < r1; i++)
		mx = max(mx, get(root, l, r, i));
	return mx;

	if (l + 1 > r || l >= r1 || l1 >= r)
		return -2;
	if (l1 <= l && r <= r1)
		return root->mx;
	int m = (l + r) / 2;
	int q1 = getmax(root->l, l, m, l1, r1);
	int q2 = getmax(root->r, m, r, l1, r1);
	return max(q1, q2);
}

int getmin(node* &root, int l, int r, int l1, int r1)
{
	int mn = 1e9;
	for (int i = l1; i < r1; i++)
		mn = min(mn, get(root, l, r, i));
	return mn;

	if (l + 1 > r || l >= r1 || l1 >= r)
		return 1e9;
	if (l1 <= l && r <= r1)
		return root->mn;
	int m = (l + r) / 2;
	int q1 = getmin(root->l, l, m, l1, r1);
	int q2 = getmin(root->r, m, r, l1, r1);
	return min(q1, q2);
}


void inc(node* &root, int l, int r, int id, int x)
{
	if (l + 1 > r || l > id || r <= id)
		return;
	if (l + 1 == r)
	{
		root->mn = x, root->mx = x;
		return;
	}
	int m = (l + r) / 2;
	inc(root->l, l, m, id, x);
	inc(root->r, m, r, id, x);
	recalc(root);
}

int tp, x, y, x2, y2, k, tx, ty, tx2, ty2;

int more(node* root, int l, int r, int id)
{
	for (int i = id; i < r; i++)
		if (get(root, l, r, i) >= k)
			return i;


	int ll = id, rr = r, m;
	if (getmax(root, l, r, id, r) < k)
		return 1e9;
	while (ll + 1 < rr)
	{
		m = (ll + rr) / 2;
		if (getmax(root, l, r, id, m) >= k)
			rr = m;
		else
			ll = m;
	}
	return rr - 1;
}

int les(node* root, int l, int r, int id)
{
	for (int i = id; i >= 0; i--)
		if (get(root, l, r, i) >= k)
			return i;


	int ll = 0, rr = id, m;
	if (getmax(root, l, r, 0, id) < k)
		return 1e9;
	while (ll + 1 < rr)
	{
		m = (ll + rr) / 2;
		if (getmax(root, l, r, m, id) >= k)
			ll = m;
		else
			rr = m;
	}
	return ll;
}

node* sb;
node* sr;

int n, m;

int chstr()
{
	int norm = abs(x - x2) + abs(y - y2);
	if (getmax(sb, 0, m, y, y2 + 1) >= k || getmin(sr, 0, n, x, x2 + 1) >= k)
		return norm;
	int mn = (more(sb, 0, m, max(y, y2)) - max(y, y2)) * 2;
	mn = min(mn, (min(y, y2) - les(sb, 0, m, min(y, y2))) * 2);
	return (mn + norm >= 1e9 ? -1 : mn + norm);
}

int chstlb()
{
	int norm = abs(x - x2) + abs(y - y2);
	if (getmax(sr, 0, n, x, x2 + 1) >= k || getmin(sb, 0, m, y, y2 + 1) >= k)
		return norm;
	int mn = (more(sr, 0, n, max(x, x2)) - max(x, x2)) * 2;
	mn = min(mn, (min(x, x2) - les(sr, 0, n, min(x, x2))) * 2);
	return (mn + norm >= 1e9 ? -1 : mn + norm);
}

int main()
{
	ios_base::sync_with_stdio(0), cin.tie(0);
	cin >> n >> m;
	build(sr, 0, n);
	build(sb, 0, m);
	int q;
	cin >> q;
	for (int i = 1; i <= q; i++)
	{
		cin >> tp;
		if (tp == 1)
		{
			cin >> x;
			inc(sr, 0, n, x - 1, i);
		}
		else if (tp == 2)
		{
			cin >> x;
			inc(sb, 0, m, x - 1, i);
		}
		else
		{
			cin >> x >> y >> x2 >> y2 >> k;
			k = i - k;
			x--, y--, x2--, y2--;
			tx = get(sr, 0, n, x), ty = get(sb, 0, m, y), tx2 = get(sr, 0, n, x2), ty2 = get(sb, 0, m, y2);
			if (x == x2 && tx >= k || y == y2 && ty >= k || tx >= k && ty2 >= k || ty >= k && tx2 >= k)
				cout << abs(x - x2) + abs(y - y2) << "\n";
			else
			{
				int mn = 1e9;
				if (tx >= k && tx2 >= k)
					mn = min(mn, chstr());
				if (ty >= k && ty2 >= k)
					mn = min(mn, chstlb());
				mn = (mn == 1e9 ? -1 : mn);
				cout << mn << "\n";
			}
		}
	}
	cin >> n;

	return 0;
}