#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

#define x first
#define y second
#define int long long
#define vert int v, int tl, int tr
#define left v * 2, tl, tm
#define right v * 2 + 1, tm, tr
#define tm (tl + tr) / 2

const int MAXN = 1000009;
const int MAXQ = 300009;
const int inf = 1e15;

int treecols[MAXN * 4][2];
int treerows[MAXN * 4][2];
int treeques[MAXQ * 4];

int lastcols[MAXN];
int lastrows[MAXN];

void upd_cols(vert, int ind, int x) {
    if (tr - tl == 1) {
        treecols[v][0] = x;
        treecols[v][1] = x;
        return;
    }

    if (ind < tm) {
        upd_cols(left, ind, x);
    }

    else {
        upd_cols(right, ind, x);
    }

    treecols[v][0] = min(treecols[v * 2][0], treecols[v * 2 + 1][0]);
    treecols[v][1] = max(treecols[v * 2][1], treecols[v * 2 + 1][1]);
}

void upd_rows(vert, int ind, int x) {
    if (tr - tl == 1) {
        treerows[v][0] = x;
        treerows[v][1] = x;
        return;
    }

    if (ind < tm) {
        upd_rows(left, ind, x);
    }

    else {
        upd_rows(right, ind, x);
    }

    treerows[v][0] = min(treerows[v * 2][0], treerows[v * 2 + 1][0]);
    treerows[v][1] = max(treerows[v * 2][1], treerows[v * 2 + 1][1]);
}

int getmn_cols(vert, int l, int r) {
    if (l >= tr || tl >= r) return 0;
    if (tl >= l && tr <= r) return treecols[v][0];
    return min(getmn_cols(left, l, r), getmn_cols(right, l, r));
}

int getmn_rows(vert, int l, int r) {
    if (l >= tr || tl >= r) return 0;
    if (tl >= l && tr <= r) return treerows[v][0];
    return min(getmn_rows(left, l, r), getmn_rows(right, l, r));
}

int getmx_cols(vert, int l, int r) {
    if (l >= tr || tl >= r) return 0;
    if (tl >= l && tr <= r) return treecols[v][1];
    return min(getmx_cols(left, l, r), getmx_cols(right, l, r));
}

int getmx_rows(vert, int l, int r) {
    if (l >= tr || tl >= r) return 0;
    if (tl >= l && tr <= r) return treerows[v][1];
    return max(getmx_rows(left, l, r), getmx_rows(right, l, r));
}

int find_pref_more_rows(vert, int ind, int x) {
    if (tr - tl == 1) {
        if (treerows[v][1] >= x) return tl;
        return -1;
    }

    if (ind < tm) {
        return find_pref_more_rows(left, ind, x);
    }

    if (getmx_rows(right, tm, ind) >= x) {
        return find_pref_more_rows(right, ind, x);
    }

    if (treerows[v * 2][1] < x) return -1;
    return find_pref_more_rows(left, ind, x);
}

int find_suff_more_rows(vert, int ind, int x) {
    if (tr - tl == 1) {
        if (treerows[v][1] >= x) return tl;
        return -1;
    }

    if (ind >= tm) {
        return find_suff_more_rows(right, ind, x);
    }

    if (getmx_rows(left, ind, tm) >= x) {
        return find_suff_more_rows(left, ind, x);
    }

    if (treerows[v * 2 + 1][1] < x) return -1;
    return find_suff_more_rows(right, ind, x);
}

int find_pref_more_cols(vert, int ind, int x) {
    if (tr - tl == 1) {
        if (treecols[v][1] >= x) return tl;
        return -1;
    }

    if (ind < tm) {
        return find_pref_more_cols(left, ind, x);
    }

    if (getmx_cols(right, tm, ind) >= x) {
        return find_pref_more_cols(right, ind, x);
    }

    if (treecols[v * 2][1] < x) return -1;
    return find_pref_more_cols(left, ind, x);
}

int find_suff_more_cols(vert, int ind, int x) {
    if (tr - tl == 1) {
        if (treecols[v][1] >= x) return tl;
        return -1;
    }

    if (ind >= tm) {
        return find_suff_more_cols(right, ind, x);
    }

    if (getmx_cols(left, ind, tm) >= x) {
        return find_suff_more_cols(left, ind, x);
    }

    if (treecols[v * 2 + 1][1] < x) return -1;
    return find_suff_more_cols(right, ind, x);
}

signed main() {
    ios :: sync_with_stdio(0);
    cin.tie(0);

    int n, m, q;
    cin >> n >> m >> q;

    for (int i = 1; i <= q; i++) {
        char type;
        cin >> type;

        if (type == '1') {
            int r;
            cin >> r;
            r--;
            lastrows[r] = i;

            upd_rows(1, 0, n, r, i);
        }

        else if (type == '2') {
            int c;
            cin >> c;
            c--;
            lastcols[c] = i;

            upd_cols(1, 0, m, c, i);
        }

        else {
            int r1, c1, r2, c2, k;
            cin >> r1 >> c1 >> r2 >> c2 >> k;
            r1--;
            c1--;
            r2--;
            c2--;

            if (k >= i) {
                cout << abs(r1 - r2) + abs(c1 - c2) << "\n";
                continue;
            }

            if (i - lastcols[c1] > k && i - lastrows[r1] > k) {
                cout << -1 << "\n";
                continue;
            }

            if (i - lastcols[c2] > k && i - lastrows[r2] > k) {
                cout << -1 << "\n";
                continue;
            }

            if ((i - lastcols[c1] <= k && i - lastrows[r2] <= k) || (i - lastcols[c2] <= k && i - lastrows[r1] <= k)) {
                cout << abs(r1 - r2) + abs(c1 - c2) << "\n";
                continue;
            }

            if (i - lastcols[c1] <= k && i - lastcols[c2] <= k) {
                if (i - treerows[1][1] > k) { // MAX_OF_ROWS
                    auto ret = getmn_cols(1, 0, m, min(c1, c2), max(c1, c2) + 1);
                    if (i - ret <= k) {
                        cout << abs(r1 - r2) + abs(c1 - c2) << "\n";
                        continue;
                    }

                    else {
                        cout << -1 << "\n";
                        continue;
                    }
                }

                else {
                    auto ret = getmn_cols(1, 0, m, min(c1, c2), max(c1, c2) + 1);
                    if (i - ret <= k) {
                        cout << abs(r1 - r2) + abs(c1 - c2) << "\n";
                        continue;
                    }

                    ret = getmx_rows(1, 0, n, min(r1, r2), max(r1, r2) + 1);
                   // cout << "\t" << ret << endl;
                    if (i - ret <= k) {
                        cout << abs(r1 - r2) + abs(c1 - c2) << "\n";
                        continue;
                    }

                    auto ret1 = find_pref_more_rows(1, 0, n, min(r1, r2), i - k);
                    int answ = inf;
                    if (ret1 != -1) {
                        answ = min(answ, abs(c1 - c2) + (min(r1, r2) - ret1) + (max(r1, r2) - ret1));
                    }

                    ret1 = find_suff_more_rows(1, 0, n, max(r1, r2) + 1, i - k);
                    if (ret1 != -1) {
                        answ = min(answ, abs(c1 - c2) + (ret1 - min(r1, r2)) + (ret1 - max(r1, r2)));
                    }

                    if (answ == inf) {
                        answ = -1;
                    }

                    cout << answ << "\n";
                    continue;
                }
            }

            if (i - treecols[1][1] > k) { // MAX_OF_COLS
                auto ret = getmn_rows(1, 0, n, min(r1, r2), max(r1, r2) + 1);
                if (i - ret <= k) {
                    cout << abs(r1 - r2) + abs(c1 - c2) << "\n";
                    continue;
                }

                else {
                    cout << -1 << "\n";
                    continue;
                }
            }

            else {
                auto ret = getmn_rows(1, 0, n, min(r1, r2), max(r1, r2) + 1);
                if (i - ret <= k) {
                    cout << abs(r1 - r2) + abs(c1 - c2) << "\n";
                    continue;
                }

                ret = getmx_cols(1, 0, m, min(c1, c2), max(c1, c2) + 1);
               // cout << "\t" << ret << endl;
                if (i - ret <= k) {
                    cout << abs(r1 - r2) + abs(c1 - c2) << "\n";
                    continue;
                }

                auto ret1 = find_pref_more_cols(1, 0, m, min(c1, c2), i - k);
                int answ = inf;
                if (ret1 != -1) {
                    answ = min(answ, abs(r1 - r2) + (min(c1, c2) - ret1) + (max(c1, c2) - ret1));
                }

                ret1 = find_suff_more_cols(1, 0, m, max(c1, c2) + 1, i - k);
                if (ret1 != -1) {
                    answ = min(answ, abs(r1 - r2) + (ret1 - min(c1, c2)) + (ret1 - max(c1, c2)));
                }

                if (answ == inf) {
                    answ = -1;
                }

                cout << answ << "\n";
                continue;
            }
        }
    }

    return 0;
}


