import java.io.PrintWriter;
import java.util.*;

public class Main {
    public static void main(String [] arg) {
        new Main().run();
    }

    PrintWriter out;
    Scanner sc;
    public void run() {
        out = new PrintWriter(System.out);
        sc = new Scanner(System.in);

        solve();


        out.close();
    }

    public int nextInt() {
        return sc.nextInt();
    }

    class Pair {
        int x, y;
        int len;

        public Pair(int x, int y) {
            this.x = x;
            this.y = y;
            len = 0;
        }

        public Pair(int x, int y, int len) {
            this.x = x;
            this.y = y;
            this.len = len;
        }

        @Override
        public boolean equals(Object obj) {
            Pair p = (Pair) obj;
            return p.x == x && p.y == y;
        }
    }

    public boolean f(Pair p, int k) {
        return  !(p.x < 0 || p.y < 0 || p.x >= n || p.y >= m || pol[p.x][p.y] > k || used[p.x][p.y] == count);
    }
    int n;
    int m;
    int [][] pol;
    int [][] used;
    int count = 1;
    public void solve() {
        n = nextInt();
        m = nextInt();
        int q = nextInt();
        pol = new int[n][m];
        used = new int[n][m];
        ArrayDeque<Pair> queue = new ArrayDeque<>();
        for (int i = 0; i < q; i++) {
            for (int j = 0; j < n; j++) {
                for (int k = 0; k < m; k++) {
                    pol[j][k]++;
                }
            }
            int ask = nextInt();
            if (ask == 1) {
                int r = nextInt() - 1;
                for (int j = 0; j < m; j++) {
                    pol[r][j] = 0;
                }
            } else if (ask == 2) {
                int r = nextInt() - 1;
                for (int j = 0; j < n; j++) {
                    pol[j][r] = 0;
                }
            } else {
                count++;
                queue.clear();
                queue.add(new Pair(nextInt() - 1, nextInt() - 1));
                Pair fin = new Pair(nextInt() - 1, nextInt() - 1);
                int k = nextInt();
                if (!f(queue.peekFirst(), k)) {
                    out.println(-1);
                    continue;
                }
                while (!queue.isEmpty()) {
                    Pair p = queue.peekFirst();
                    if (p.equals(fin)) {
                        out.println(p.len);
                        break;
                    }
                    int x = p.x;
                    int y = p.y;
                    int len = p.len;
                    if (f(new Pair(x + 1, y), k)) {
                        queue.add(new Pair(x + 1, y, len + 1));
                    }
                    if (f(new Pair(x, y + 1), k)) {
                        queue.add(new Pair(x, y + 1, len + 1));
                    }
                    if (f(new Pair(x - 1, y), k)) {
                        queue.add(new Pair(x - 1, y, len + 1));
                    }
                    if (f(new Pair(x, y - 1), k)) {
                        queue.add(new Pair(x, y - 1, len + 1));
                    }
                    queue.removeFirst();
                    used[p.x][p.y] = count;
                }
                if (queue.isEmpty()) {
                    out.println(-1);
                }
            }

        }

    }

}
