#include <bits/stdc++.h>

using namespace std;

int n, m, q;

const int MAX_N = 1e4 + 2;

int r[MAX_N], c[MAX_N], z;

pair<int, int> dist[MAX_N][MAX_N];

int dx[] = {+1, -1, 0, 0};
int dy[] = {0, 0, +1, -1};

bool ok(int i, int j, int k)
{
  return (i >= 1 && i <= n && j >= 1 && j <= m && z - max(r[i], c[j]) <= k);
}

int bfs(int i1, int j1, int i2, int j2, int k)
{
  queue<pair<int, int>> q;
  if (z - max(r[i1], c[j1]) > k)
  {
    return -1;
  }
  dist[i1][j1] = {z, 0};
  q.push({i1, j1});
  while (q.size())
  {
    auto [i, j] = q.front();
    q.pop();
    for (int mod = 0; mod < 4; mod++)
    {
      int ii = i + dx[mod];
      int jj = j + dy[mod];
      if (ok(ii, jj, k) && dist[ii][jj].first != z)
      {
        dist[ii][jj].first = z;
        dist[ii][jj].second = dist[i][j].second + 1;
        q.push({ii, jj});
      }
    }
  }
  if (dist[i2][j2].first != z)
  {
    return -1;
  }
  return dist[i2][j2].second;
}

void $main()
{
  cin >> n >> m >> q;
  for (z = 1; z <= q; z++)
  {
    int t;
    cin >> t;
    if (t == 1)
    {
      int rr;
      cin >> rr;
      r[rr] = z;
    }
    else if (t == 2)
    {
      int cc;
      cin >> cc;
      c[cc] = z;
    }
    else
    {
      int i1, j1, i2, j2, k;
      cin >> i1 >> j1 >> i2 >> j2 >> k;
      cout << bfs(i1, j1, i2, j2, k) << '\n';
    }
  }
}

signed main()
{
  ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
  #ifdef _47
    freopen("4.cpp", "r", stdin), freopen("7.cpp", "w", stdout);
  #endif // _47
  $main();
  return 0;
}
