#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

struct query{
	int c, l, r;
	query() {}
	query(int c, int l, int r) {
		this->c = c;
		this->l = l;
		this->r = r;
	}
};

const int MAX_N = 3e5 + 7;
int a[MAX_N];
int b[MAX_N];
query segm[MAX_N];
vector <int> op[MAX_N], cl[MAX_N];
int prior_to_color[MAX_N];

bool cmp(query a, query b) {
	int len1 = a.r - a.l;
	int len2 = b.r - b.l;
	return (len1 > len2);
}

int main() {
	//freopen("Desktop/input.txt", "r", stdin);
	ios_base :: sync_with_stdio(0);
	cin.tie(0);
	int n, m;
	cin >> m >> n;
	for (int i = 1; i <= n; i++) {
		segm[i] = query(i, -1, -1);
	}
	for (int i = 0; i < m; i++) {
		cin >> a[i];
		if (segm[a[i]].l == -1) segm[a[i]].l = i;
		segm[a[i]].r = i;
	}
	sort(segm + 1, segm + n + 1, cmp);
	vector <query> ans;
	for (int i = 1; i <= n; i++) {
		if (segm[i].l != -1) {
			ans.push_back(segm[i]);
			prior_to_color[i] = segm[i].c;
			op[segm[i].l].push_back(i);
			cl[segm[i].r].push_back(i);
			//cout << segm[i].c << ' ' << segm[i].l << ' ' << segm[i].r << endl;
		}
	}
	set <int, greater <int>> now;
	for (int i = 0; i < m; i++) {
		for (int elem : op[i]) now.insert(elem);
		if (now.empty()) {
			cout << "-1" << endl;
			return 0;
		}
		int fi = *now.begin();
		b[i] = prior_to_color[fi];	
		for (int elem : cl[i]) now.erase(elem);
	}
	for (int i = 0; i < m; i++) {
		if (a[i] != b[i]) {
			cout << "-1" << endl;
			return 0;
		}
	}
	cout << ans.size() << endl;
	for (query elem : ans) {
		cout << elem.c << ' ' << elem.l + 1 << ' ' << elem.r + 1 << endl;
	}
	return 0;
}
