#include <iostream>
#include <vector>

using namespace std;

const int MAX_N = 1e6 + 7;
int vert[MAX_N], gor[MAX_N];
int n, m;

int get_point(int x, int y) {
	return max(gor[x], vert[y]);
}

pair <int, int> get_nearest_vert(int y, int k) {
	pair <int, int> ans(-1, -1);
	for (int i = y; i >= 1; i--) {
		if (vert[i] >= k) {
			ans.first = i;
			break;
		}
	}
	for (int i = y; i <= m; i++) {
		if (vert[i] >= k) {
			ans.second = i;
			break;
		}
	}
	return ans;
}


pair <int, int> get_nearest_gor(int y, int k) {
	pair <int, int> ans(-1, -1);
	for (int i = y; i >= 1; i--) {
		if (gor[i] >= k) {
			ans.first = i;
			break;
		}
	}
	for (int i = y; i <= n; i++) {
		if (gor[i] >= k) {
			ans.second = i;
			break;
		}
	}
	return ans;
}

int min_gor(int l, int r) {
	if (l > r) swap(l, r);
	int res = gor[l];
	for (int i = l; i <= r; i++) res = min(res, gor[i]);
	return res;
}

int min_vert(int l, int r) {
	if (l > r) swap(l, r);
	int res = vert[l];
	for (int i = l; i <= r; i++) res = min(res, vert[i]);
	return res;
}

int main() {
	//freopen("Desktop/input.txt", "r", stdin);
	ios_base :: sync_with_stdio(0);
	cin.tie(0);
	int q;
	cin >> n >> m >> q;
	for (int i = 1; i <= n; i++) gor[i] = 0;
	for (int i = 1; i <= m; i++) vert[i] = 0;
	for (int i = 1; i <= q; i++) {
		int t;
		cin >> t;
		if (t == 1) {
			int pos;
			cin >> pos;
			gor[pos] = i;
			continue;
		}
		if (t == 2) {
			int pos;
			cin >> pos;
			vert[pos] = i;
			continue;
		}
		//cout << 86 << endl;
		int x1, y1, x2, y2, k;
		cin >> x1 >> y1 >> x2 >> y2 >> k;
		k = i - k;
		if (get_point(x1, y1) < k || get_point(x2, y2) < k) {
			cout << -1 << "\n";
			continue;
		}
		if (gor[x1] >= k && vert[y2] >= k) {
			cout << abs(x1 - x2) + abs(y1 - y2) << "\n";
			continue;
		}
		if (gor[x2] >= k && vert[y1] >= k) {
			cout << abs(x1 - x2) + abs(y1 - y2) << "\n";
			continue;
		}
		//cout << 101 << endl;
		int ans = MAX_N * 2;
		if (gor[x1] >= k && gor[x2] >= k) {
			pair <int, int> a = get_nearest_vert(y1, k);
			pair <int, int> b = get_nearest_vert(y2, k);
			vector <int> now = {a.first, a.second, b.first, b.second};
			for (int elem : now) {
				if (elem == -1) continue;
				ans = min(ans, abs(y1 - elem) + abs(elem - y2) + abs(x1 - x2));
			}
			int t = min_gor(x1, x2);
			if (t >= k) ans = min(ans, abs(x1 - x2) + abs(y1 - y2));
		}
		if (vert[y1] >= k && vert[y2] >= k) {
			pair <int, int> a = get_nearest_gor(x1, k);
			pair <int, int> b = get_nearest_gor(x2, k);
			vector <int> now = {a.first, a.second, b.first, b.second};
			for (int elem : now) {
				if (elem == -1) continue;
				ans = min(ans, abs(x1 - elem) + abs(elem - x2) + abs(y1 - y2));
			}
			int t = min_vert(y1, y2);
			if (t >= k) ans = min(ans, abs(x1 - x2) + abs(y1 - y2));
		}
		if (ans == MAX_N * 2) cout << -1 << "\n";
		cout << ans << "\n";
	}
}
