#include <iostream>
#include <vector>

using namespace std;

int check(int n, vector <pair <int, bool>> asked) {
	int c = 0;
	int d;
	for (int i = 1; i <= n; i++) {
		int cnt = 0;
		for (pair <int, bool> elem : asked) {
			int x = elem.first;
			if (i >= x && !elem.second) cnt++;
			if (i < x && elem.second) cnt++;
		}
		if (cnt <= 1) {
			c++;
			d = i;
		}
	}
	if (c == 0) return -1;
	if (c == 1) return d;
	return 0;
}


pair <vector <int>, int> gen_tree(int n, vector <pair <int, bool>> &asked, int cur_ans = 1000) {
	int d = check(n, asked);
	pair <vector <int>, int> ans;
	if (d == -1) {
		ans.first.push_back(-1);	
		ans.first.push_back(-1);
		ans.first.push_back(-1);
		ans.second = 0;
		return ans;
	}
	if (d != 0) {
		ans.first.push_back(d);
		ans.first.push_back(-1);
		ans.first.push_back(-1);
		ans.second = 0;
		return ans;
	}
	ans.second = 1000000;
	if (asked.size() > cur_ans + 2) return ans;
	vector <int> cur_left, cur_right;
	int maxi = n + 5;
	int poss = -1;
	for (int i = 1; i <= n; i++) {
		asked.push_back({i, 0});
		auto now_left = gen_tree(n, asked, maxi);
		asked.pop_back();
		asked.push_back({i, 1});
		auto now_right = gen_tree(n, asked, maxi);
		asked.pop_back();
		int now_res = max(now_left.second, now_right.second);
		if (now_res < maxi) {
			poss = i;
			maxi = now_res;
			cur_left = now_left.first;
			cur_right = now_right.first;
		}
	}
	ans.first.push_back(poss);
	for (int elem : cur_left) ans.first.push_back(elem);
	for (int elem : cur_right) ans.first.push_back(elem);
	ans.second = maxi + 1;
	return ans;
}

const int MAX_N = 100000;
pair <int, int> g[MAX_N];
int ask[MAX_N];
int tail = 1;
vector <int> best;

void build(int v, int &pos) {
	//cout << 77 << endl;
	if (best[pos + 1] == -1) {
		g[v] = {-1, -1};
		ask[v] = best[pos];
		pos++;
		pos++;
		return;
	}
	g[v] = {tail + 1, tail + 2};
	tail += 2;
	ask[v] = best[pos];
	pos++;
	build(g[v].first, pos);
	pos++;
	build(g[v].second, pos);
}

void go(int v) {
	if (g[v].first == -1) {
		cout << "! " << ask[v] << endl;
		return;
	}
	cout << "? " << ask[v] << endl;
	string x;
	cin >> x;
	if (x == "No") go(g[v].first);
	else go(g[v].second);
}

int main() {
	int n;
	cin >> n;
	vector <pair <int, bool>> cur;
	best = gen_tree(n, cur).first;
	//cout << 112 << endl;
	int p = 0;
	build(1, p);
	//for (int elem : best) cout << elem << ' ';
	while (1) {
		go(1);
		string s;
		cin >> s;
		if (s == "Done") return 0;
	}
	return 0;
}
