#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>

using namespace std;
#define int long long
#define double long double
int n, m, q;
void read() {
	cin >> n >> m >> q;
}

const int MAXN = 100;
int table[MAXN][MAXN];

void del_r(int r) {
	for (int i = 1; i <= m; i++) {
		table[r][i] = 0;
	}
}

void del_c(int c) {
	for (int i = 1; i <= n; i++) {
		table[i][c] = 0;
	}
}

void add() {
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= m; j++) {
			table[i][j]++;
		}
	}
}

int dist[MAXN][MAXN];
const int INF = 1e9;


int fans(int r1, int c1, int r2, int c2, int k) {
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= m; j++) {
			dist[i][j] = INF;
		}
	}

	if (table[r1][c1] > k) {
		return -1;
	}

	dist[r1][c1] = 0;

	set < pair <int, pair <int, int> > > q;
	q.insert({ 0, {r1, c1} });

	while (!q.empty()) {
		auto p = *q.begin();
		int d = p.first;
		int x = p.second.first;
		int y = p.second.second;
		q.erase(q.begin());

		int dx, dy;

		dx = 1, dy = 0;
		if (table[x + dx][y + dy] <= k && dist[x + dx][y + dy] > d + 1) {
			q.erase({ dist[x + dx][y + dy], {x + dx, y + dy} });
			dist[x + dx][y + dy] = d + 1;
			q.insert({ dist[x + dx][y + dy], {x + dx, y + dy} });
		}
	
		dx = -1, dy = 0;
		if (table[x + dx][y + dy] <= k && dist[x + dx][y + dy] > d + 1) {
			q.erase({ dist[x + dx][y + dy], {x + dx, y + dy} });
			dist[x + dx][y + dy] = d + 1;
			q.insert({ dist[x + dx][y + dy], {x + dx, y + dy} });
		}

		dx = 0, dy = 1;
		if (table[x + dx][y + dy] <= k && dist[x + dx][y + dy] > d + 1) {
			q.erase({ dist[x + dx][y + dy], {x + dx, y + dy} });
			dist[x + dx][y + dy] = d + 1;
			q.insert({ dist[x + dx][y + dy], {x + dx, y + dy} });
		}
	
		dx = 0, dy = -1;
		if (table[x + dx][y + dy] <= k && dist[x + dx][y + dy] > d + 1) {
			q.erase({ dist[x + dx][y + dy], {x + dx, y + dy} });
			dist[x + dx][y + dy] = d + 1;
			q.insert({ dist[x + dx][y + dy], {x + dx, y + dy} });
		}
	}
	if (dist[r2][c2] == INF)
		dist[r2][c2] = -1;
	return dist[r2][c2];
}

vector <int> ans;

void run() {
	for (int i = 0; i <= MAXN; i++) {
		table[i][0] = INF;
		table[0][i] = INF;
		table[n + 1][i] = INF;
		table[i][m + 1] = INF;
	}

	for (int test = 0; test < q; test++) {
		add();
		int type;
		cin >> type;
		if (type == 1) {
			int r;
			cin >> r;
			del_r(r);
		}
		if (type == 2) {
			int c;
			cin >> c;
			del_c(c);
		}
		if (type == 3) {
			int r1, c1, r2, c2, k;
			cin >> r1 >> c1 >> r2 >> c2 >> k;
			int ax;
			ax = fans(r1, c1, r2, c2, k);
			ans.push_back(ax);
		}
	}
}

void write() {
	for (auto i : ans) {
		cout << i << '\n';
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	read();
	run();
	write();
	return 0;
}