#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>

using namespace std;
#define int long long

int n, m, q, p;
vector <vector <pair <int, int> > > g;

void read() {
	cin >> n >> m >> q >> p;
	g.assign(n, {});
	for (int i = 0; i < m; i++) {
		int v, u, d;
		cin >> v >> u >> d;
		v--;
		u--;
		g[v].push_back({ u, d });
	}
}

vector <vector <int> > dp_min, dp_max;

vector <unordered_set <int> > fcheck;

void dfs(int v, int t) {
	if (fcheck[v].find(t) != fcheck[v].end())
		return;
	fcheck[v].insert(t);
	dp_min[v].push_back(t);
	dp_max[v].push_back(t * (p - 1));
	for (auto i : g[v]) {
		dfs(i.first, t + i.second);
	}
}

bool check(int my_time, int r, int p) {
	return my_time >= r && (my_time * (p - 1) <= p * r);
}

string ans;

void run() {
	dp_min.assign(n, {});
	dp_max.assign(n, {});
	fcheck.assign(n, unordered_set <int> (10000000));

	for (int i = 0; i < n; i++) {
		dp_min[i].push_back(1e18);
		dp_max[i].push_back(-1e18);
	}
	dfs(0, 0);
	for (int i = 0; i < n; i++) {
		sort(dp_min[i].begin(), dp_min[i].end());
		sort(dp_max[i].begin(), dp_max[i].end());
	}
	string ans = ""; 
	for (int test = 0; test < q; test++) {
		int f, r;
		cin >> f >> r;
		f--;
		int l1 = r;
		int r1 = r * p;
		int x_min = *lower_bound(dp_min[f].begin(), dp_min[f].end(), l1);
		int x_max = *(--upper_bound(dp_max[f].begin(), dp_max[f].end(), r1));
		x_max /= (p - 1);
		if (x_min <= x_max) {
			ans += "1";
		}
		else {
			ans += "0";
		}
	}
	cout << ans;
	cout << '\n';
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t;
	cin >> t;
	for (int test = 0; test < t; test++) {
		read();
		run();
	}
	return 0;
}