#include <iostream>
#include <algorithm>>
#include <iomanip>
#include <vector>
#include <cmath>
#include <string>

using namespace std;

typedef long double ld;
typedef long long ll;

#define all(x) x.begin(), x.end()

const int INF = 1e9;

struct events
{
	int x;
	bool type;
	int color;
	events() {};
	events(int _x, bool _type, int _color)
	{
		x = _x;
		type = _type;
		color = _color;
	}

	bool operator < (const events &other)const
	{
		if (x != other.x)
			return x < other.x;
		return type < other.type;
	}
};

struct ansType
{
	int color, mini, maxi;
	ansType(int _color, int _mini, int _maxi)
	{
		color = _color;
		mini = _mini;
		maxi = _maxi;
	}
	ansType() {};

	void print()
	{
		cout << color << " " << mini + 1 << " " << maxi + 1 << endl;
	}
};

signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int m, n;
	cin >> m >> n;

	vector <int> a(m);
	vector <int> maxis(n + 1, -1);
	vector <int> minis(n + 1, INF);
	for (int i = 0; i < m; i++)
	{
		cin >> a[i];
		maxis[a[i]] = max(maxis[a[i]], i);
		minis[a[i]] = min(minis[a[i]], i);
	}

	vector <int> prevForColor(n + 1, -1);
	vector <int> prevPt(m);

	for (int i = 0; i < m; i++)
	{
		prevPt[i] = prevForColor[a[i]];
		prevForColor[a[i]] = i;
	}

	vector <events> eve;


	vector <int> times(n + 1, -1);
	int timer = 0;

	for (int i = 0; i < m; i++)
	{
		if (times[a[i]] == -1)
			times[a[i]] = timer++;
		if (prevPt[i] != -1)
		{
			eve.push_back(events(prevPt[i], true, a[i]));
			eve.push_back(events(i, false, a[i]));
		}
	}

	sort(all(eve));

	vector <int> stack;
	for (int i = 0; i < eve.size(); i++)
	{
		if (!eve[i].type)
		{
			if (stack.back() == eve[i].color)
			{
				stack.pop_back();
			}
			else
			{
				stack.push_back(eve[i].color);
			}
		}
		else
		{
			stack.push_back(eve[i].color);
		}
	}
	if (stack.size() != 0)
	{
		cout << -1;
		return 0;
	}


	vector <ansType> answer(timer);
	for (int i = 1; i <= n; i++)
	{
		if (times[i] != -1)
		{
			answer[times[i]] = { i, minis[i], maxis[i] };
		}
	}
	cout << timer << endl;
	for (int i = 0; i < timer; i++)
	{
		answer[i].print();
	}
	return 0;
}