﻿#include <iostream>
#include <algorithm>>
#include <iomanip>
#include <vector>
#include <cmath>
#include <string>
#include <queue>

using namespace std;

typedef long double ld;
typedef long long ll;
typedef unsigned short us;

#define all(x) x.begin(), x.end()

const int INF = 1e9;

int times;

vector <int> horiz;
vector <int> vert;

bool canHor(int l, int r, int k)
{
	for (int i = l; i <= r; i++)
	{
		if (vert[i] > k)
			return false;
	}
	return true;
}

bool canVert(int l, int r, int k)
{
	for (int i = l; i <= r; i++)
	{
		if (horiz[i] > k)
			return false;
	}
	return true;
}


signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int q, n, m;
	cin >> n >> m >> q;
	
	horiz.resize(n + 1, 0);
	vert.resize(m + 1, 0);

	for (int zz = 1; zz <= q; zz++)
	{
		times = zz;
		int type;
		cin >> type;
		if (type == 1 || type == 2)
		{
			int line;
			cin >> line;
			if (type == 1) //Горизонтальные линии обновление 
			{
				horiz[line] = -times;
			}
			else //Вертикальные линии
			{
				vert[line] = -times; //Вертикальные линии обновление
			}
		}
		else
		{
			int lx, ly, rx, ry, k;
			cin >> lx >> ly >> rx >> ry >> k;
			k -= times;
			if (lx > rx)
				swap(lx, rx);
			if (ly > ry)
				swap(ly, ry);
			//Обновление через две горизонтальных 


			int minAns = INF;

			if (canHor(ly, ry, k) || canVert(lx, rx, k))
				minAns = rx - lx + ry - ly;

			if (horiz[lx] <= k && vert[ry] <= k || vert[ly] <= k && horiz[rx] <= k)
				minAns = min(minAns, rx - lx + ry - ly);

			if (horiz[lx] <= k && horiz[rx] <= k)
			{
				for (int i = 1; i <= m; i++)
				{
					if (vert[i] <= k)
					{
						minAns = min(minAns, abs(i - ly) + abs(i - ry) + rx - lx);
					}
				}
			}
			if (vert[ly] <= k && vert[ry] <= k)
			{
				for (int i = 1; i <= n; i++)
				{
					if (horiz[i] <= k)
					{
						minAns = min(minAns, abs(i - lx) + abs(i - rx) + ry - ly);
					}
				}
			}
			if (minAns == INF)
			{
				cout << -1 << endl;
			}
			else
			{
				cout << minAns << endl;
			}
		}

	}
	return 0;
}