﻿#include <iostream>
#include <algorithm>>
#include <iomanip>
#include <vector>
#include <cmath>
#include <string>
#include <queue>

using namespace std;

typedef long double ld;
typedef long long ll;
typedef unsigned short us;

#define all(x) x.begin(), x.end()

const int INF = 1e9;


vector <int> horiz;
vector <int> vert;
bool canHor(int l, int r, int k)
{
	if (l > r)
		swap(l, r);
	for (int i = l; i <= r; i++)
	{
		if (vert[i] > k)
			return false;
	}
	return true;
}

bool canVert(int l, int r, int k)
{
	if (l > r)
		swap(l, r);
	for (int i = l; i <= r; i++)
	{
		if (horiz[i] > k)
			return false;
	}
	return true;
}

struct qr
{
	int type;
	int line;
	int lx, ly, rx, ry, k;
	qr(int _type, int _line, int _lx, int _ly, int _rx, int _ry, int _k)
	{
		type = _type;
		line = _line;
		lx = _lx;
		rx = _rx;
		ly = _ly;
		ry = _ry;
		k = _k;
	}
	qr() {};
	void scan()
	{
		cin >> type;
		if (type == 1 || type == 2)
			cin >> line;
		else
			cin >> lx >> ly >> rx >> ry >> k;
	}
};

vector <int> solveSmart(int n, int m, int q, vector <qr> querys)
{
	horiz.resize(n + 1, 0);
	vert.resize(m + 1, 0);
	vector <int> answer;
	for (int zz = 1; zz <= q; zz++)
	{
		int type = querys[zz].type;
		if (type == 1 || type == 2)
		{
			int line = querys[zz].line;

			if (type == 1) //Горизонтальные линии обновление 
			{
				horiz[line] = -zz;
			}
			else //Вертикальные линии
			{
				vert[line] = -zz; //Вертикальные линии обновление
			}
		}
		else
		{
			int lx, ly, rx, ry, k;
			lx = querys[zz].lx;
			ly = querys[zz].ly;
			rx = querys[zz].rx;
			ry = querys[zz].ry;
			k = querys[zz].k;

			k -= zz;

			int minAns = INF;
			if (canHor(ly, ry, k) || canVert(lx, rx, k)) //онли вертикальные и горизонтальные 
				minAns = abs(rx - lx) + abs(ry - ly);

			if (horiz[lx] <= k && vert[ry] <= k || vert[ly] <= k && horiz[rx] <= k)
				minAns = min(minAns, abs(rx - lx) + abs(ry - ly));

			if (lx > rx)
				swap(lx, rx);
			if (ly > ry)
				swap(ly, ry);
			//Обновление через две горизонтальных 

			if (horiz[lx] <= k && horiz[rx] <= k) //По двум горизонтальным и вертикальной
			{
				for (int i = 1; i <= m; i++)
				{
					if (vert[i] <= k)
					{
						minAns = min(minAns, abs(i - ly) + abs(i - ry) + rx - lx);
					}
				}
			}

			if (vert[ly] <= k && vert[ry] <= k) //По двум вертикальным и горизонтальной
			{
				for (int i = 1; i <= n; i++)
				{
					if (horiz[i] <= k)
					{
						minAns = min(minAns, abs(i - lx) + abs(i - rx) + ry - ly);
					}
				}
			}
			if (minAns == INF)
			{
				answer.push_back(-1);
			}
			else
			{
				answer.push_back(minAns);
			}
		}

	}
	return answer;
}


int times;
vector <vector <int>> dp;
vector <vector <int>> distanceTo;
const int dx[4] = { +1, -1, 0, 0 };
const int dy[4] = { 0, 0, -1, +1 };

void bfs(int fx, int fy, int k, const vector <vector <int>> &a, int n, int m)
{
	queue <pair<int, int>> que;
	if (a[fx][fy] <= k)
	{
		distanceTo[fx][fy] = 0;
		que.push({ fx, fy });
	}
	while (!que.empty())
	{
		pair<int, int> current = que.front();
		que.pop();
		int x = current.first;
		int y = current.second;

		if (dp[x][y] == times)
			continue;
		dp[x][y] = times;

		for (int j = 0; j < 4; j++)
		{
			int nx = x + dx[j];
			int ny = y + dy[j];
			if (nx >= 1 && nx <= n && ny >= 1 && ny <= m && dp[nx][ny] != times && a[nx][ny] <= k)
			{
				que.push({ nx, ny });
				distanceTo[nx][ny] = distanceTo[x][y] + 1;
			}
		}
	}
}

vector <int> solveStupid(int n, int m, int q, vector <qr> querys)
{
	vector <vector <int>> a(n + 1, vector <int>(m + 1));
	dp.assign(n + 1, vector <int>(m + 1, 0));
	distanceTo.assign(n + 1, vector <int>(m + 1, 0));
	vector <int> answer;

	for (int zz = 1; zz <= q; zz++)
	{
		times = zz;
		int type = querys[zz].type;
		if (type == 1 || type == 2)
		{
			int line = querys[zz].line;
			if (type == 1)
			{
				//строка line
				for (int j = 1; j <= m; j++)
				{
					a[line][j] = -times;;
				}
			}
			else
			{
				//столбец line
				for (int j = 1; j <= n; j++)
				{
					a[j][line] = -times;
				}
			}
		}
		else
		{
			int sx, sy, fx, fy, k;
			sx = querys[zz].lx;
			sy = querys[zz].ly;
			fx = querys[zz].rx;
			fy = querys[zz].ry;
			k = querys[zz].k;

			k -= times;
			bfs(sx, sy, k, a, n, m);
			/*for (int i = 1; i <= n; i++)
			{
				for (int j = 1; j <= m; j++)
				{
					if (dp[fx][fy] == times)
						cout << distanceTo[fx][fy] << " ";
					else
						cout << -1 << " ";
				}
				cout << endl;
			}
			cout << endl;
			cout << string(40, '-') << endl;*/
			if (dp[fx][fy] == times)
				answer.push_back(distanceTo[fx][fy]);
			else
				answer.push_back(-1);
		}
	}
	return answer;
}


signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int q, n, m;
	cin >> n >> m >> q;
	vector <qr> querys(q + 1);
	for (int i = 1; i <= q; i++)
		querys[i].scan();

	vector <int> answer = solveStupid(n, m, q, querys);
	vector <int> answer2 = solveSmart(n, m, q, querys);

	for (int i = 0; i < answer2.size(); i++)
	{
		cout << answer2[i] << endl;
	}

	return 0;
}