﻿#include <iostream>
#include <algorithm>>
#include <iomanip>
#include <vector>
#include <cmath>
#include <string>
#include <queue>

using namespace std;

typedef long double ld;
typedef long long ll;
typedef unsigned short us;

#define all(x) x.begin(), x.end()
#define int ll

const int INF = 1e9;

vector <vector <pair<int, int>>> a;

bool dfs(int now, int to, int times, int p, int spend)
{
	if (now == to)
	{
		if (spend >= times && spend <= times * p / (p - 1))
			return true;
		else
			return false;
	}
	if (now > to)
		return false;

	bool curAns = false;
	for (auto v : a[now])
	{
		curAns = max(curAns, dfs(v.first, to, times, p, spend + v.second));
	}
	return curAns;
}

signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int t;
	cin >> t;
	for (int i = 0; i < t; i++)
	{
		int n, m, q, p;
		cin >> n >> m >> q >> p;
		a.assign(n + 1, vector <pair<int, int>>(0, { 0, 0 }));
		for (int j = 0; j < m; j++)
		{
			int f, s, w;
			cin >> f >> s >> w;
			a[f].push_back({ s, w });
		}
		for (int z = 0; z < q; z++)
		{
			int to, times;
			cin >> to >> times;
			cout << dfs(1, to, times, p, 0);
		}
		cout << endl;
	}

	return 0;
}