#include <bits/stdc++.h>

#define f first
#define s second
#define pb push_back
#define mp make_pair
using namespace std;

template<typename T1, typename T2> inline void chkmin(T1 & x, T2 y) {if (x > y) x = y;}
template<typename T1, typename T2> inline void chkmax(T1 & x, T2 y) {if (x < y) x = y;}

const int MAXN = 1 << 20, INF = 1e9;

int n, m;
int rows[MAXN], cols[MAXN];

struct seg_tree_mx {
	int *t;
	seg_tree_mx() {
		t = new int[MAXN * 2];
		memset(t, 0, sizeof(int) * MAXN * 2);
	}
	void set(int pos, int nv) {
		pos += MAXN;
		t[pos] = nv;
		while (pos > 1) {
			pos /= 2;
			t[pos] = max(t[pos * 2], t[pos * 2 + 1]);
		}
	}
	int get(int v, int vl, int vr, int l, int r) {
		if (vl > r || vr < l) return -INF;
		if (l <= vl && vr <= r) return t[v];
		int vm = (vl + vr) / 2;
		return max(get(v * 2, vl, vm, l, r), 
					get(v * 2 + 1, vm + 1, vr, l, r));
	}
	int get(int l, int r) {
		return get(1, 0, MAXN - 1, l, r);
	}
};

seg_tree_mx col_mx, row_mx;

int get_rrr(int r, int c, int r1, int c1, int k, int t) {
	int res = abs(r - r1);
	if (r < r1 && row_mx.get(r + 1, r1) + t > k)
		return INF;
	if (r > r1 && row_mx.get(r1 + 1, r) + t > k)
		return INF;
	if (c != c1 && rows[r1] + t > k) return INF;
	return abs(r - r1) + abs(c - c1);
}

int get_ccc(int r, int c, int r1, int c1, int k, int t) {
	int res = abs(c - c1);
	if (c < c1 && col_mx.get(c + 1, c1) + t > k)
		return INF;
	if (c > c1 && col_mx.get(c1 + 1, c) + t > k) 
		return INF;
	if (r != r1 && cols[c1] + t > k) return INF;
	return abs(r - r1) + abs(c - c1);
}

unordered_set<int> av_rows, av_cols;

int solve(int t, int r, int c, int r1, int c1, int k) {
	if (rows[r] + t > k && cols[c] + t > k) return -1;
	if (rows[r1] + t > k && cols[c1] + t > k) return -1;
	// c
	if (c == c1 && cols[c] + t <= k) return abs(r - r1);
	// r
	if (r == r1 && rows[r] + t <= k) return abs(c - c1);


	int res = INF;
	chkmin(res, get_rrr(r, c, r1, c1, k, t));
	chkmin(res, get_ccc(r, c, r1, c1, k, t));

	// r->c->r
	for (int col : av_cols) {
		if (cols[col] + t > k) continue;
		if (abs(col - c) > 1 && rows[r] + t > k) continue;
		if (abs(col - c1) > 1 && rows[r1] + t > k) continue;
		
		chkmin(res, abs(c - col) + abs(c1 - col) + abs(r - r1));
	}
	// c->r->c
	for (int row : av_rows) {
		if (rows[row] + t > k) continue;
		if (abs(row - r) > 1 && cols[c] + t > k) continue;
		if (abs(row - r1) > 1 && cols[c1] + t > k) continue;
		
		chkmin(res, abs(r - row) + abs(r1 - row) + abs(c - c1));
	}
	return res == INF ? -1 : res;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	// freopen("input.txt", "r", stdin);
	int q;
	cin >> n >> m >> q;
	for (int i = 1; i <= q; ++i) {
		int tp;
		cin >> tp;
		if (tp == 1) {
			int row;
			cin >> row;
			row_mx.set(row, -i);
			rows[row] = -i;
			av_rows.insert(row);
			continue;
		}
		if (tp == 2) {
			int col;
			cin >> col;
			col_mx.set(col, -i);
			cols[col] = -i;
			av_cols.insert(col);
			continue;
		}
		if (tp == 3) {
			int r1, c1, r2, c2, k;
			cin >> r1 >> c1 >> r2 >> c2 >> k;
			if (k > i) {
				cout << abs(r1 - r2) + abs(c1 - c2) << '\n';
			}
			else {
				cout << solve(i, r1, c1, r2, c2, k) << '\n';
			}
		}
	}
	return 0;
}