#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <set>
#include <map>
#include <vector>
#include <string>
#include <cmath>
#include <time.h>

using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("fast-math")

typedef long long ll;
typedef long double ld;

#define int long long

const int inf = 1e9 + 7;
const int eps = 1e-9;

struct Edge
{
	int v;
	int w;
};

struct Ask
{
	int f;
	int r;
	bool ex;
};

void topsort(int v, vector<vector<Edge>>& g, vector<bool>& used, vector<int>& ts)
{
	used[v] = true;

	for (Edge u : g[v])
	{
		if (!used[u.v])
			topsort(u.v, g, used, ts);
	}

	ts.push_back(v);
}

void getans(int v, int t, int p, vector<vector<Edge>>& g, vector<Ask>& ask)
{
	for (int i = 0; i < ask.size(); i++)
	{
		if (ask[i].f == v)
		{
			if (ask[i].r <= t && t * (p - 1) <= ask[i].r * p)
				ask[i].ex = true;
		}
	}

	for (Edge u : g[v])
	{
		getans(u.v, t + u.w, p, g, ask);
	}
}

signed main()
{
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	int t;
	cin >> t;

	for (int y = 0; y < t; y++)
	{
		int n, m, q, p;
		cin >> n >> m >> q >> p;

		vector<vector<Edge>> g(n);
		for (int i = 0; i < m; i++)
		{
			int a, b, w;
			cin >> a >> b >> w;
			a--; b--;
			g[a].push_back({ b, w });
		}

		vector<int> ts;
		vector<bool> used(n, false);
		topsort(0, g, used, ts);
		reverse(ts.begin(), ts.end());

		vector<int> tsind(n);
		for (int i = 0; i < n; i++)
		{
			tsind[ts[i]] = i;
		}

		vector<set<int>> dp(n);
		dp[0].insert(0);

		for (int i = 0; i < n; i++)
		{
			int v = ts[i];
			for (int t : dp[i])
			{
				for (Edge u : g[v])
				{
					int ind = tsind[u.v];
					dp[ind].insert(t + u.w);
				}
			}
		}

		string ans;
		for (int i = 0; i < q; i++)
		{
			int f, r;
			cin >> f >> r;
			f--;

			int ind = tsind[f];
			auto it = dp[ind].lower_bound(r);
			if (it != dp[ind].end() && (*it) * (p - 1) <= p * r)
				ans += '1';
			else
				ans += '0';
		}
		cout << ans << '\n';
	}



	//system("pause");
	return 0;
}