#include<bits/stdc++.h>

#define ll long long
#define pb push_back
#define mp make_pair
#define pii pair<int, int>
#define X first
#define Y second
#define is insert
#define er erase
#define sz(a) (int)a.size();

using namespace std;

const int MAX_N = 1e6 + 5;
const int INF = 1e9;

int solve();

int main()
{
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // DEBUG
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}

int n;
int m;
int q;

int row[MAX_N];
int column[MAX_N];

int run;

int get(int x, int y)
{
    return min(run - row[x], run - column[y]);
}

pii t[2][4 * MAX_N];

void build(int b, int v, int LG, int RG)
{
    t[b][v] = mp(0, 0);
    if (LG == RG)
    {
        return;
    }
    int MG = (LG + RG) / 2;
    build(b, v * 2, LG, MG);
    build(b, v * 2 + 1, MG + 1, RG);
}

pii merge(pii p1, pii p2)
{
    return mp(min(p1.X, p2.X), max(p1.Y, p2.Y));
}

void update(int b, int v, int LG, int RG, int pos, int x)
{
    if (LG == RG)
    {
        t[b][v].X = t[b][v].Y = x;
        return;
    }
    int MG = (LG + RG) / 2;
    if (pos <= MG)
    {
        update(b, v * 2, LG, MG, pos, x);
    }
    else
    {
        update(b, v * 2 + 1, MG + 1, RG, pos, x);
    }
    t[b][v] = merge(t[b][v * 2], t[b][v * 2 + 1]);
}

pii get(int b, int v, int LG, int RG, int l, int r)
{
    if (r < l)
    {
        return mp(INF, -INF);
    }
    if (LG == l && RG == r)
    {
        return t[b][v];
    }
    int MG = (LG + RG) / 2;
    return merge(get(b, v * 2, LG, MG, l, min(MG, r)), get(b, v * 2 + 1, MG + 1, RG, max(MG + 1, l), r));
}

pii findR(int r1, int c1, int k)
{
    pii res;
    int lg = 0;
    int rg = c1;
    while (rg - lg > 1)
    {
        int mg = (lg + rg) / 2;
        pii cur = get(1, 1, 1, m, mg, c1);
        if (run - cur.X > k)
        {
            lg = mg;
        }
        else
        {
            rg = mg;
        }
    }
    res.X = rg;
    lg = c1;
    rg = m + 1;
    while (rg - lg > 1)
    {
        int mg = (lg + rg) / 2;
        pii cur = get(1, 1, 1, m, c1, mg);
        if (run - cur.X > k)
        {
            rg = mg;
        }
        else
        {
            lg = mg;
        }
    }
    res.Y = lg;
    return res;
}

int findRL(int lc, int rc, int k)
{
    if (rc < lc)
    {
        return 0;
    }
    int lg = lc - 1;
    int rg = rc + 1;
    while (rg - lg > 1)
    {
        int mg = (lg + rg) / 2;
        pii cur = get(1, 1, 1, m, mg, rc);
        if (run - cur.Y <= k)
        {
            lg = mg;
        }
        else
        {
            rg = mg;
        }
    }
    return lg;
}

int findRR(int lc, int rc, int k)
{
    if (rc < lc)
    {
        return m + 5;
    }
    int lg = lc - 1;
    int rg = rc + 1;
    while (rg - lg > 1)
    {
        int mg = (lg + rg) / 2;
        pii cur = get(1, 1, 1, m, lc, mg);
        if (run - cur.Y <= k)
        {
            rg = mg;
        }
        else
        {
            lg = mg;
        }
    }
    return rg;
}

bool in(pii p, int x)
{
    return p.X <= x && x <= p.Y;
}

int goRow(int r1, int c1, int r2, int c2, int k)
{
    int res = INF;
    int lg, rg;
    pii cur = findR(r1, c1, k);
    lg = cur.X;
    rg = cur.Y;
    if (run - row[r1] <= k)
    {
        lg = 1;
        rg = m;
    }
    cur = findR(r2, c2, k);
    if (run - row[r2] <= k)
    {
        cur.X = 1;
        cur.Y = m;
    }
    //cerr << "0 " << run << ' ' << lg << ' ' << rg << ' ' << cur.X << ' ' << cur.Y << '\n';
    lg = max(lg, cur.X);
    rg = min(rg, cur.Y);
    lg = max(1, lg);
    rg = min(m, rg);
    pii segL = mp(lg, min(c1, c2));
    pii segM = mp(max(lg, min(c1, c2)), min(rg, max(c1, c2)));
    pii segR = mp(max(c1, c2), rg);
    int ind = findRL(segL.X, segL.Y, k);
    if (in(segL, ind))
    {
        res = min(res, abs(c1 - ind) + abs(r1 - r2) + abs(c2 - ind));
    }
    if (segM.X <= segM.Y)
    {
        pii cur = get(1, 1, 1, m, segM.X, segM.Y);
        if (run - cur.Y <= k)
        {
            res = min(res, abs(r1 - r2) + abs(c1 - c2));
        }
    }
    ind = findRR(segR.X, segR.Y, k);
    if (in(segR, ind))
    {
        res = min(res, abs(c1 - ind) + abs(r1 - r2) + abs(c2 - ind));
    }
    return res;
}

pii findC(int r1, int c1, int k)
{
    pii res;
    int lg = 0;
    int rg = r1;
    while (rg - lg > 1)
    {
        int mg = (lg + rg) / 2;
        pii cur = get(0, 1, 1, n, mg, r1);
        if (run - cur.X > k)
        {
            lg = mg;
        }
        else
        {
            rg = mg;
        }
    }
    //cerr << run << ' ' << rg << '\n';
    res.X = rg;
    lg = r1;
    rg = n + 1;
    while (rg - lg > 1)
    {
        int mg = (lg + rg) / 2;
        pii cur = get(0, 1, 1, n, r1, mg);
        if (run - cur.X > k)
        {
            rg = mg;
        }
        else
        {
            lg = mg;
        }
    }
    res.Y = lg;
    return res;
}

int findCL(int lr, int rr, int k)
{
    if (rr < lr)
    {
        return 0;
    }
    int lg = lr - 1;
    int rg = rr + 1;
    while (rg - lg > 1)
    {
        int mg = (lg + rg) / 2;
        pii cur = get(0, 1, 1, n, mg, rr);
        if (run - cur.Y <= k)
        {
            lg = mg;
        }
        else
        {
            rg = mg;
        }
    }
    return lg;
}

int findCR(int lr, int rr, int k)
{
    if (rr < lr)
    {
        return n + 5;
    }
    int lg = lr - 1;
    int rg = rr + 1;
    while (rg - lg > 1)
    {
        int mg = (lg + rg) / 2;
        pii cur = get(0, 1, 1, n, lr, mg);
        if (run - cur.Y <= k)
        {
            rg = mg;
        }
        else
        {
            lg = mg;
        }
    }
    return rg;
}

int goColumn(int r1, int c1, int r2, int c2, int k)
{
    int res = INF;
    int lg, rg;
    pii cur = findC(r1, c1, k);
    lg = cur.X;
    rg = cur.Y;
    if (run - column[c1] <= k)
    {
        lg = 1;
        rg = n;
    }
    cur = findC(r2, c2, k);
    if (run - column[c2] <= k)
    {
        cur.X = 1;
        cur.Y = n;
    }
    lg = max(lg, cur.X);
    rg = min(rg, cur.Y);
    lg = max(1, lg);
    rg = min(n, rg);
    pii segL = mp(lg, min(r1, r2));
    pii segM = mp(max(lg, min(r1, r2)), min(rg, max(r1, r2)));
    pii segR = mp(max(r1, r2), rg);
    int ind = findCL(segL.X, segL.Y, k);
    if (in(segL, ind))
    {
        res = min(res, abs(r1 - ind) + abs(c1 - c2) + abs(r2 - ind));
    }
    if (segM.X <= segM.Y)
    {
        pii cur = get(0, 1, 1, n, segM.X, segM.Y);
        if (run - cur.Y <= k)
        {
            res = min(res, abs(r1 - r2) + abs(c1 - c2));
        }
    }
    ind = findCR(segR.X, segR.Y, k);
    if (in(segR, ind))
    {
        res = min(res, abs(r1 - ind) + abs(c1 - c2) + abs(r2 - ind));
    }
    return res;
}

int solve()
{
    cin >> n >> m >> q;
    memset(row, 0, sizeof(row));
    memset(column, 0, sizeof(column));
    build(0, 1, 1, n);
    build(1, 1, 1, m);
    for (int i = 1; i <= q; ++i)
    {
        run = i;
        int z;
        cin >> z;
        if (z == 1)
        {
            int r;
            cin >> r;
            row[r] = run;
            update(0, 1, 1, n, r, run);
        }
        else if (z == 2)
        {
            int c;
            cin >> c;
            column[c] = run;
            update(1, 1, 1, m, c, run);
        }
        else
        {
            int r1, c1, r2, c2, k;
            cin >> r1 >> c1 >> r2 >> c2 >> k;
            int ans = INF;

            if (get(r1, c1) > k || get(r2, c2) > k)
            {
                cout << "-1\n";
                continue;
            }
            int r = goRow(r1, c1, r2, c2, k);
            int c = goColumn(r1, c1, r2, c2, k);
            //cerr << i << ' ' << r << ' ' << c << '\n';
            ans = min(r, c);
            if (ans == INF)
            {
                cout << "-1\n";
                continue;
            }
            cout << ans << '\n';
        }
    }
    return 0;
}
