#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>

using namespace std;

const int N = 1e6 + 7;

const int INF = 1e9;

vector<int> tree(4 * N);
vector<int> val(N);

int ls(int u) {
	return 2 * u + 1;
}

int rs(int u) {
	return 2 * u + 2;
}

void set_val(int u, int l, int r, int ind, int val) {
	if (r - l == 1) {
		tree[u] = val;
		return;
	}
	int mid = (l + r) / 2;
	if (ind < mid) {
		set_val(ls(u), l, mid, ind, val);
	} else {
		set_val(rs(u), mid, r, ind, val);
	}
	tree[u] = max(tree[ls(u)], tree[rs(u)]);
}

int find_max(int u, int l, int r, int left, int right) {
	if (right <= l || r <= left) {
		return -INF;
	}
	if (left <= l && r <= right) {
		return tree[u];
	}
	int mid = (l + r) / 2;
	return max(find_max(ls(u), l, mid, left, right), find_max(rs(u), mid, r, left, right));
}

int main() {
	int n, m, q;
	cin >> n >> m >> q;
	int t;
	int s;
	int r1, c1, r2, c2, k;
	val.resize(n);
	int h = 0;
	for (int i = 0; i < q; i++) {
		cin >> t;
		h++;
		if (t != 3) {
			cin >> s;
			s--;
			if (t == 1) {
				set_val(0, 0, n, s, -h);
			}
		}
		if (t == 3) {
			cin >> r1 >> c1 >> r2 >> c2 >> k;
			r1--;
			if (find_max(0, 0, n, min(r1, r2) - 1, max(r1, r2)) + h <= k) {
				cout << abs(r1 - r2) + abs(c1 - c2) << endl;
			}
			else {
				cout << -1 << endl;
			}
		}
	}
	return 0;
}