#include <iostream>
#include <vector>
#include <algorithm>

#define ll long long

bool debug() {
    return true;
}

using namespace std;

struct answer {
    ll i, l, r;
};

int main() {
    if (debug()) {
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
        ios_base::sync_with_stdio(false);
        cin.tie(0); cout.tie(0);
    }

    ll m, n;
    cin >> m >> n;
    vector<ll> a(m);
    vector<ll> ents(n + 1);
    vector<ll> exits(n + 1);
    for (int i = 0; i < m; i++) {
        cin >> a[i];
        if (ents[a[i]]) {
            exits[a[i]] = i + 1;
        } else {
            ents[a[i]] = exits[a[i]] = i + 1;
        }
    }

    vector<answer> ans;
    vector<pair<ll, ll>> st;
    for (ll i = 0; i < m; i++) {
        if (st.size() > 0 && st[st.size() - 1].first == a[i]) {
            if (i + 1 != exits[a[i]]) continue;

            auto [ai, l] = st[st.size() - 1];
            st.pop_back();
            ans.push_back(answer{ai, l, i + 1});
        } else {
            if (ents[a[i]] != i + 1 && a[i - 1] != a[i]) {
                cout << -1 << endl;
                exit(0);
            }
            if (ents[a[i]] == exits[a[i]]) ans.push_back(answer{a[i], i + 1, i + 1});
            else if (i + 1 == ents[a[i]]) st.emplace_back(a[i], i + 1);
        }
    }
    reverse(ans.begin(), ans.end());

    cout << ans.size() << endl;
    for (ll i = 0; i < ans.size(); i++) {
        auto [ai, l, r] = ans[i];
        cout << ai << " " << l << " " << r << endl;
    }
    return 0;
}