#include <bits/stdc++.h>
using namespace std;

#define X first
#define Y second

const int MAX_N = 1e4 + 10, INF = 1e9;

int rows[MAX_N], columns[MAX_N];
int n, m;

int used[MAX_N][MAX_N];
int dist[MAX_N][MAX_N];

int dx[] = {0, -1, 0, 1}, dy[] = {1, 0, -1, 0};

bool ok(int x, int y) {
	if (x < 0 || y < 0 || x >= n || y >= m)
		return false;
	return true;
}

bool can(int x, int y, int delta) {
	return max(rows[x], columns[y]) >= delta;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int q;
	cin >> n >> m >> q;
	for (int currentT = 1; currentT <= q; ++currentT) {
		int type;
		cin >> type;
		if (type == 1) {
			int r;
			cin >> r;
			rows[--r] = currentT;
		} else if (type == 2) {
			int c;
			cin >> c;
			columns[--c] = currentT;
		} else {
			int r1, c1, r2, c2, k;
			cin >> r1 >> c1 >> r2 >> c2 >> k;
			--r1, --c1, --r2, --c2;
			int delta = currentT - k;
			if (!can(r1, c1, delta) || !can(r2, c2, delta)) {
				cout << "-1\n";
				continue;
			}
			bool firstS = 1;
			for (int i = r1; i <= r2 && firstS; ++i)
				if (rows[i] < delta)
					firstS = 0;
			bool secondS = 1;
			for (int i = c1; i <= c2 && secondS; ++i)
				if (columns[i] < delta)
					secondS = 0;
			if (firstS || secondS || (rows[r1] >= delta && columns[c2] >= delta) ||
				(rows[r2] >= delta && columns[c1] >= delta)) {
				cout << abs(r1 - r2) + abs(c1 - c2) << "\n";
				continue;
			}
			if (rows[r1] >= delta && rows[r2] >= delta) {
				int ans = +INF;
				for (int i = 0; i < m; ++i) {
					if (columns[i] < delta)
						continue;
					ans = min(ans, abs(c1 - i) + abs(r2 - r1) + abs(c2 - i));
				}
				if (ans == +INF)
					cout << "-1\n";
				else
					cout << ans << "\n";
			} else {
				assert(columns[c1] >= delta && columns[c2] >= delta);
				int ans = +INF;
				for (int i = 0; i < n; ++i) {
					if (rows[i] < delta)
						continue;
					ans = min(ans, abs(r1 - i) + abs(c1 - c2) + abs(r2 - i));
				}
				if (ans == +INF)
					cout << "-1\n";
				else
					cout << ans << "\n";
			}
		}
	}
	return 0;
}