#include <bits/stdc++.h>
using namespace std;

int numOfTests, currentTest, currentLevel, badQuery, currentQuery;
char buffer[50];

void initializeInteractor() {
	cin >> numOfTests >> currentLevel >> badQuery;
	currentTest = 0;
	currentQuery = 0;
}

int ask(int x) {
	cout << "? " << x << endl;
#ifdef DEBUG
	++currentQuery;
	if (currentQuery == badQuery)
		return x <= currentLevel;
	else
		return currentLevel >= x;
#else
	cin >> buffer;
	return buffer[0] == 'Y';
#endif
}

void answer(int x) {
	cout << "! " << x << endl;
#ifdef DEBUG
	if (x == currentLevel)
		cout << "Test #" << currentTest << " AC Found answer in " << currentQuery << " queries" << endl;
	else
		cout << "Test #" << currentTest << " WA Found different answer" << endl;
	++currentTest;
	if (currentTest == numOfTests) {
		exit(0);
	} else {
		cin >> currentLevel >> badQuery;
		currentQuery = 0;
	}
#else
	cin >> buffer;
	if (buffer[0] == 'C')
		return;
	exit(0);
#endif
}

void interact(int n) {
	while (1) {
		int l = 0, r = n + 1;
		bool hadBad = 0;
		while (r - l != 1) {
			int mid = (l + r) / 2;
			bool res = ask(mid);
			if (!hadBad) {
				if (ask(mid) != res) {
					hadBad = 1;
					res = ask(mid);
				}
			}
			if (res)
				l = mid;
			else
				r = mid;
		}
		answer(l);
	}
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int n;
	cin >> n;
#ifdef DEBUG
	initializeInteractor();
#endif
	interact(n);
	return 0;
}