#include <bits/stdc++.h>

using namespace std;

#define enl "\n"

const int INF = INT_MAX;
const int N = 1024;

vector<int> st_rmx(2 * N, 0);
vector<int> st_rmn(2 * N, 0);

vector<int> st_cmx(2 * N, 0);
vector<int> st_cmn(2 * N, 0);

int st_rmx_get_max(int v, int l, int r, int vl, int vr) {
    if (l <= vl && vr <= r) {
        return st_rmx[v];
    }
    int vm = (vl + vr) / 2;
    return max(st_rmx_get_max(2 * v, l, r, vl, vr), st_rmx_get_max(2 * v + 1, l, r, vm, vr));
}

int st_cmx_get_max(int v, int l, int r, int vl, int vr) {
    if (l <= vl && vr <= r) {
        return st_cmx[v];
    }
    int vm = (vl + vr) / 2;
    return max(st_cmx_get_max(2 * v, l, r, vl, vr), st_cmx_get_max(2 * v + 1, l, r, vm, vr));
}

int st_rmn_get_min(int v, int l, int r, int vl, int vr) {
    if (l <= vl && vr <= r) {
        return st_rmn[v];
    }
    int vm = (vl + vr) / 2;
    return min(st_rmn_get_min(2 * v, l, r, vl, vr), st_rmn_get_min(2 * v + 1, l, r, vm, vr));
}

int st_cmn_get_min(int v, int l, int r, int vl, int vr) {
    if (l <= vl && vr <= r) {
        return st_cmn[v];
    }
    int vm = (vl + vr) / 2;
    return min(st_cmn_get_min(2 * v, l, r, vl, vr), st_cmn_get_min(2 * v + 1, l, r, vm, vr));
}



void st_rmn_update(int x, int v) {
    int pos = N + x;
    st_rmn[pos] = v;
    pos /= 2;
    while (pos > 0) {
        st_rmn[pos] = min(st_rmn[pos * 2], st_rmn[pos * 2 + 1]);
        pos /= 2;
    }
}

void st_rmx_update(int x, int v) {
    int pos = N + x;
    st_rmx[pos] = v;
    pos /= 2;
    while (pos > 0) {
        st_rmx[pos] = max(st_rmx[pos * 2], st_rmx[pos * 2 + 1]);
        pos /= 2;
    }
}

void st_cmn_update(int x, int v) {
    int pos = N + x;
    st_cmn[pos] = v;
    pos /= 2;
    while (pos > 0) {
        st_cmn[pos] = min(st_cmn[pos * 2], st_cmn[pos * 2 + 1]);
        pos /= 2;
    }
}

void st_cmx_update(int x, int v) {
    int pos = N + x;
    st_cmx[pos] = v;
    pos /= 2;
    while (pos > 0) {
        st_cmx[pos] = max(st_cmx[pos * 2], st_cmx[pos * 2 + 1]);
        pos /= 2;
    }
}


signed main() {
    int n, m, q;
    cin >> n >> m >> q;

    vector<int> rows(n, 0);
    vector<int> cols(m, 0);
//    int dist[n][m];

    int t = 0;
    for (int qi = 0; qi < q; ++qi) {
        t++;
        int type;
        cin >> type;
        if (type == 1) {
            int ri;
            cin >> ri;
            st_rmn_update(ri - 1, t);
            st_rmx_update(ri - 1, t);
            rows[ri - 1] = t;

        } else if (type == 2) {
            int ci;
            cin >> ci;
            st_cmn_update(ci - 1, t);
            st_cmx_update(ci - 1, t);
            cols[ci - 1] = t;
        } else {
            int x1, y1, x2, y2, k;
            cin >> x1 >> y1 >> x2 >> y2 >> k;
            x1--;
            y1--;
            x2--;
            y2--;

            int vt = t - k;
            if (rows[x1] < vt && cols[y1] < vt) {
                cout << -1 << enl;
                continue;
            }
            if (rows[x2] < vt && cols[y2] < vt) {
                cout << -1 << enl;
                continue;
            }

            int simple = abs(x1 - x2) + abs(y1 - y2);
            if (rows[x1] >= vt && cols[y2] >= vt) {
                cout << simple << enl;
                continue;
            }
            if (cols[y1] >= vt && rows[x2] >= vt) {
                cout << simple << enl;
                continue;
            }
            int res = INF;
            if (rows[x1] >= vt) {
                int mn = st_rmn_get_min(1, min(x1, x2), max(x1, x2), 0, N);
                if (mn >= vt) {
                    cout << simple << enl;
                    continue;
                }

                for (int col = 0; col < m; ++col) {
                    if (cols[col] >= vt) {
                        if (min(y1, y2) <= col && col <= max(y1, y2)) {
                            res = simple;
                            break;
                        } else {
                            int add = min(abs(y1 - col), abs(y2 - col));
                            res = min(res, simple + add * 2);
                        }
                    }

                }
                if (res == INF) {
                    cout << -1 << enl;
                } else {
                    cout << res << enl;
                }
            } else {
                int mn = INF;
                for (int col = min(y1, y2); col < max(y1, y2); ++col) {
                    mn = min(mn, cols[col]);
                }
                if (mn >= vt) {
                    cout << simple << enl;
                    continue;
                }

                for (int row = 0; row < n; ++row) {
                    if (rows[row] >= vt) {
                        if (min(x1, x2) <= row && row <= max(x1, x2)) {
                            res = simple;
                            break;
                        } else {
                            int add = min(abs(x1 - row), abs(x2 - row));
                            res = min(res, simple + add * 2);
                        }
                    }

                }
                if (res == INF) {
                    cout << -1 << enl;
                } else {
                    cout << res << enl;
                }
            }
        }

    }
}