#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

struct req {
	int L;
	int R;
	int c;
	req() {

	}
	req(int L1, int R1, int c1) {
		L = L1;
		R = R1;
		c = c1;
	}
};

struct even {
	int x;
	int t; //0 - open // 1- close
	int c;
	even(){}
	even(int x1, int t1, int c1) {
		x = x1;
		t = t1;
		c = c1;
	}
};

bool cmp(even A, even B) {
	return (A.x < B.x);
}

struct node {
	int l = -1;
	int r = -1;
	int more = -1;
	node(){}
};

vector<node> pool;

int build(int L, int R) {
	node A;
	if (L == R - 1) {
		int ind = pool.size();
		pool.push_back(A);
		return ind;
	}
	int M = (L + R) / 2;
	A.l = build(L, M);
	A.r = build(M, R);
	int ind = pool.size();
	pool.push_back(A);
	return ind;
}

void upd(int root, int L, int R, int l, int r, int x) {
	if (L == l && R == r) {
		pool[root].more = x;
		return;
	}
	int M = (L + R) / 2;
	int left = pool[root].l;
	int right = pool[root].r;
	if (pool[root].more != -1) {
		int val = pool[root].more;
		pool[left].more = val;
		pool[right].more = val;
		pool[root].more = -1;
	}
	if (l < M) upd(left, L, M, l, min(M, r), x);
	if (r > M) upd(right, M, R, max(l, M), r, x);
}

int get(int root, int L, int R, int x) {
	if (L == R - 1) {
		return pool[root].more;
	}
	int M = (L + R) / 2;
	int left = pool[root].l;
	int right = pool[root].r;
	if (pool[root].more != -1) {
		int val = pool[root].more;
		pool[left].more = val;
		pool[right].more = val;
		pool[root].more = -1;
	}
	if (x < M) return get(left, L, M, x);
	else return get(right, M, R, x);
}

int main() {
	int m, n;
	cin >> m >> n;
	vector<int> a(m);
	int el;
	for (int i = 0; i < m; i++) {
		cin >> el;
		a[i] = el - 1;
	}
	vector<int> last(n);
	vector<int> st(n);
	for (int i = 0; i < n; i++) {
		last[i] = -1;
		st[i] = -1;
	}
	for (int i = 0; i < m; i++) {
		last[a[i]] = i;
	}
	for (int i = m - 1; i >= 0; i--) {
		st[a[i]] = i;
	}
	int root = build(0, m);
	vector<req> ans;
	vector<bool> used(n);
	for (int i = 0; i < n; i++) used[i] = 0;
	for (int i = 0; i < m; i++) {
		int c = get(root, 0, m, i);
		if (c != a[i]) {
			int L = i;
			int R = last[a[i]];
			if (used[a[i]] == 1) {
				cout << -1 << endl;
				//cin >> n;
				return 0;
			}
			upd(root, 0, m, L, R + 1, a[i]);
			used[a[i]] = 1;
			ans.push_back({ L + 1, R + 1, a[i] + 1});
		}
	}
	cout << ans.size() << endl;
	for (auto elem : ans) {
		cout << elem.c << " " << elem.L << " " << elem.R << endl;
	}
	//cin >> n;
	return 0;
	/*
	vector<int> cnt(n);
	for (int i = 0; i < n; i++) cnt[i] = 0;
	for (int i = m - 1; i >= 0; i--) {
		int c = a[i];
		if (last[c] == i) continue;
		if (a[i + 1] != c) cnt[c]++;
	}
	vector<req> all;
	set<pair<int, int> > now;
	for (int i = 0; i < n; i++) {
		if (last[i] == -1) continue;
		now.insert({ cnt[i], i });
	}
	while (now.size() > 0) {
		auto elem = *now.begin();
		if (elem.first != 0) {
			cout << -1 << endl;
			return 0;
		}
		now.erase(elem);
		int c = elem.second;
		int L = st[c];
		int R = last[c];
		req A = { L, R, c };
		all.push_back(A);
		if (L > 0 && R < m - 1 && a[L - 1] == a[R + 1]) {
			int c1 = a[L - 1];

		}
	}
	

	vector<even> all;
	for (int i = 0; i < n; i++) {
		if (last[i] == -1) continue;
		int L = st[i];
		int R = last[i];
		even A = { L, 0, i };
		even B = { R, 1, i };
		all.push_back(A);
		all.push_back(B);
	}
	sort(all.begin(), all.end(), cmp);
	vector<even> now;
	for (auto elem : all) {
		if (elem.t == 0) now.push_back(elem);
		else {
			if (now.size() == 0) {
				cout << -1 << endl;
				return 0;
			}
			auto el1 = now[now.size() - 1];
			now.pop_back();
			if (elem.c != el1.c) {
				cout << -1 << endl;
				return 0;
			}

		}
	}
	*/
}