#pragma GCC optimize("Ofast")
#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
#include <map>
#include <math.h>
#define ll long long


using namespace std;

struct obj{
	int t; //1 - row // 2 -  col
	int tim;
	int ind;
	obj(){}
	obj(int t1, int time1, int id) {
		t = t1;
		tim = time1;
		ind = id;
	}
};

struct node {
	int l = -1;
	int r = -1;
	int x = 0;
	int maxim = 0;
	int id = -1;
	node() {}
};

vector<node> pool;

int build(int L, int R) {
	node A;
	if (L == R - 1) {
		int ind = pool.size();
		pool.push_back(A);
		return ind;
	}
	int M = (L + R) / 2;
	A.l = build(L, M);
	A.r = build(M, R);
	int ind = pool.size();
	pool.push_back(A);
	return ind;
}

void upd(int root, int L, int R, int id, int x) {
	if (L == R - 1) {
		pool[root].x = x;
		pool[root].maxim = x;
		pool[root].id = L;
		return;
	}
	int M = (L + R) / 2;
	if (id < M) upd(pool[root].l, L, M, id, x);
	else upd(pool[root].r, M, R, id, x);
	pool[root].x = min(pool[pool[root].l].x, pool[pool[root].r].x);
	int left = pool[root].l;
	int right = pool[root].r;
	if (pool[left].maxim >= pool[right].maxim) {
		pool[root].maxim = pool[left].maxim;
		pool[root].id = pool[left].id;
	}
	else {
		pool[root].maxim = pool[right].maxim;
		pool[root].id = pool[right].id;
	}
}

int get(int root, int L, int R, int l, int r) {
	if (L == l && R == r) {
		return pool[root].x;
	}
	int M = (L + R) / 2;
	int res1 = 1e9;
	int res2 = 1e9;
	if (l < M) res1 = get(pool[root].l, L, M, l, min(M, r));
	if (r > M) res2 = get(pool[root].r, M, R, max(l, M), r);
	return min(res1, res2);
}

int get1(int root, int L, int R, int l, int r) {
	if (L == l && R == r) {
		return pool[root].maxim;
	}
	int M = (L + R) / 2;
	int res1 = 0;
	int res2 = 0;
	if (l < M) res1 = get1(pool[root].l, L, M, l, min(M, r));
	if (r > M) res2 = get1(pool[root].r, M, R, max(l, M), r);
	return max(res1, res2);
}

int getleft(int root, int L, int R, int l, int r, int k) {
	if (L == R - 1) return L;
	int M = (L + R) / 2;
	if (l < M) {
		int help = get1(pool[root].l, L, M, l, min(M, r));
		if (help >= k) return getleft(pool[root].l, L, M, l, min(M, r), k);
	}
	return getleft(pool[root].r, M, R, max(l, M), r, k);
}

int getright(int root, int L, int R, int l, int r, int k) {
	if (L == R - 1) return L;
	int M = (L + R) / 2;
	if (r > M) {
		int help = get1(pool[root].r, M, R, max(l, M), r);
		if (help >= k) return getright(pool[root].r, M, R, max(l, M), r, k);
	}
	return getright(pool[root].l, L, M, l, min(M, r), k);
}

/*
struct nd {
	int l = -1;
	int r = -1;
	int x = 0;
	ll y = (rand() << 15) + rand();
	int now = 0;
	int now1 = -1;
	int val = 0;
	int id = -1;
	nd(){}
};

vector<nd> pl;

pair<int, int> safe(int root) {
	if (root == -1) {
		return { 0, -1 };
	}
	return { pl[root].val, pl[root].id };
}

void relax(int root) {
	auto res1 = safe(pl[root].l);
	auto res2 = safe(pl[root].r);
	pair<int, int> res3 = { pl[root].now, pl[root].now1 };
	if (res3.first > res1.first) swap(res1, res3);
	if (res2.first > res1.first) swap(res1, res2);
	pl[root].id = res1.second;
	pl[root].val = res1.first;
}

pair<int, int> split(int root, int k) {
	if (root == -1) return { -1, -1 };
	if (pl[root].x < k) {
		auto res = split(pl[root].r, k);
		pl[root].r = res.first;
		relax(root);
		return { root, res.second };
	}
	else {
		auto res = split(pl[root].l, k);
		pl[root].l = res.second;
		relax(root);
		return { res.first, root };
	}
}

int merge(int L, int R) {
	if (L == -1) return R;
	if (R == -1) return L;
	if (pl[L].y > pl[R].y) {
		pl[L].r = merge(pl[L].r, R);
		relax(L);
		return L;
	}
	else {
		pl[R].l = merge(L, pl[R].l);
		relax(R);
		return R;
	}
}

int add(int root, int ind, int val) {

}
*/

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, m, q;
	cin >> n >> m >> q;
	vector<int> row(n);
	int rootn = build(0, n);
	int rootm = build(0, m);
	vector<int> col(m);
	for (int i = 0; i < n; i++) row[i] = 0;
	for (int i = 0; i < m; i++) col[i] = 0;
	int tim = 0;
	vector<obj> way1;
	vector<obj> way2;
	for (int ijk = 0; ijk < q; ijk++) {
		tim++;
		int type;
		cin >> type;
		if (type == 1) {
			int r;
			cin >> r;
			r--;
			row[r] = tim;
			way1.push_back({ 1, tim, r });
			upd(rootn, 0, n, r, tim);
		}
		if (type == 2) {
			int c;
			cin >> c;
			c--;
			col[c] = tim;
			way2.push_back({ 2, tim, c });
			upd(rootm, 0, m, c, tim);
		}
		if (type == 3) {
			int x1, y1, x2, y2;
			int k;
			cin >> x1 >> y1 >> x2 >> y2 >> k;
			x1--; y1--; x2--; y2--;
			int manhet = abs(x1 - x2) + abs(y1 - y2);
			if (k >= tim) {
				cout << manhet << "\n";
				continue;
			}
			int r1 = 0, r2 = 0, c1 = 0, c2 = 0;
			int need = tim - k;
			if (row[x1] >= need) r1 = 1;
			if (col[y1] >= need) c1 = 1;
			if (row[x2] >= need) r2 = 1;
			if (col[y2] >= need) c2 = 1;
			if ((r1 == 0 && c1 == 0) || (r2 == 0 && c2 == 0)) {
				cout << -1 << "\n";
				continue;
			}
			if (r1 == 1 && c2 == 1) {
				cout << manhet << "\n";
				continue;
			}
			if (r2 == 1 && c1 == 1) {
				cout << manhet << "\n";
				continue;
			}
			if (r1 == 1 && r2 == 1) {

				int ans = 1e9;
				if (x1 > x2) {
					swap(y1, y2);
					swap(x1, x2);
				}
				int res = get(rootn, 0, n, x1, x2 + 1);
				if (res >= need) {
					cout << manhet << "\n";
					continue;
				}

				if (y1 > y2) {
					swap(y1, y2);
					swap(x1, x2);
				}
				if (get1(rootm, 0, m, y1, y2 + 1) >= need) {
					cout << manhet << "\n";
					continue;
				}
				if (get1(rootm, 0, m, 0, y1 + 1) >= need) {
					int help = getright(rootm, 0, m, 0, y1, need);
					ans = min(ans, manhet + (y1 - help) * 2);
				}
				if (get1(rootm, 0, m, y2, m) >= need) {
					int help = getleft(rootm, 0, m, y2, m, need);
					ans = min(ans, manhet + (help - y2) * 2);
				}

				if (ans == 1e9) ans = -1;
				cout << ans << "\n";
				continue;
			}
			else{


				int ans = 1e9;
				if (y1 > y2) {
					swap(x1, x2);
					swap(y1, y2);
				}
				int res = get(rootm, 0, m, y1, y2 + 1);
				if (res >= need) {
					cout << manhet << "\n";
					continue;
				}
				if (x1 > x2) {
					swap(x1, x2);
					swap(y1, y2);
				}

				if (get1(rootn, 0, n, x1, x2 + 1) >= need) {
					cout << manhet << "\n";
					continue;
				}

				if (get1(rootn, 0, n, 0, x1 + 1) >= need) {
					int help = getright(rootn, 0, n, 0, x1 + 1, need);
					ans = min(ans, manhet + (x1 - help) * 2);
				}

				if (get1(rootn, 0, n, x2, n) >= need) {
					int help = getleft(rootn, 0, n, x2, n, need);
					ans = min(ans, manhet + (help - x2) * 2);
				}

				if (ans == 1e9) ans = -1;
				cout << ans << "\n";
				continue;
			}
		}
	}
	//cin >> n;
}
