#include <bits/stdc++.h>

#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()

using namespace std;

typedef long long ll;
typedef long double ld;

void io() {
#ifdef HOME
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

const int inf = 1000000000;

struct node {
    int x, y, sz, mn, mx;
    node *l, *r;
    node(int x_) {
        x = x_;
        y = rand();
        sz = 1;
        mn = x;
        mx = x;
        l = nullptr;
        r = nullptr;
    }
};

typedef node* treap;

int sz(treap t) {
    if(t) {
        return t->sz;
    }else {
        return 0;
    }
}

int mn(treap t) {
    if(t) {
        return t->mn;
    }else {
        return inf;
    }
}

int mx(treap t) {
    if(t) {
        return t->mx;
    }else {
        return -inf;
    }
}

void upd(treap t) {
    if(t) {
        t->sz = sz(t->l) + sz(t->r) + 1;
        t->mn = t->x;
        t->mn = min(t->mn, mn(t->l));
        t->mn = min(t->mn, mn(t->r));
        t->mx = t->x;
        t->mx = max(t->mx, mx(t->l));
        t->mx = max(t->mx, mx(t->r));
    }
}

void merge(treap &t, treap l, treap r) {
    if(!l) {
        t = r;
    }else if(!r) {
        t = l;
    }else if(l->y > r->y) {
        merge(l->r, l->r, r);
        t = l;
    }else {
        merge(r->l, l, r->l);
        t = r;
    }
    upd(t);
}

void split(treap t, treap &l, treap &r, int x, int add = 0) {
    if(!t) {
        l = nullptr;
        r = nullptr;
        return;
    }
    int cur = add + sz(t->l);
    if(x <= cur) {
        split(t->l, l, t->l, x, add);
        r = t;
    }else {
        split(t->r, t->r, r, x, cur + 1);
        l = t;
    }
    upd(t);
}

int getr(treap t, int x, int add = 0) {
    if(!t) {
        return -1;
    }
    int cur = add + sz(t->l);
    if(mn(t->r) <= x) {
        return getr(t->r, x, cur + 1);
    }else if(t->x <= x) {
        return cur;
    }else {
        return getr(t->l, x, add);
    }
}

int getl(treap t, int x, int add = 0) {
    if(!t) {
        return -1;
    }
    int cur = add + sz(t->l);
    if(mn(t->l) <= x) {
        return getl(t->l, x, add);
    }else if(t->x <= x) {
        return cur;
    }else {
        return getl(t->r, x, cur + 1);
    }
}

void push_back(treap &t, int x) {
    treap it = new node(x);
    merge(t, t, it);
}

void set_value(treap &t, int x, int pos) {
    treap t1, t2, t3;
    split(t, t1, t2, pos);
    split(t2, t2, t3, 1);
    t2->x = x;
    merge(t, t1, t2);
    merge(t, t, t3);
}

int get_value(treap &t, int l, int r, int k) {
    treap t1, t2, t3;
    split(t, t1, t2, l);
    split(t2, t2, t3, r - l + 1);
    int tt = getl(t2, k);

    int tt1 = getr(t1, k);
    int tt2 = getl(t3, k);
    int szl = sz(t1);
    merge(t, t1, t2);
    merge(t, t, t3);
    if(tt != -1) {
        return tt + szl;
    }

    if(tt1 == -1 && tt2 == -1) {
        return -1;
    }

    if(tt1 == -1) {
        return tt2 + szl + r - l + 1;
    }else if(tt2 == -1) {
        return tt1;
    }else if(abs(l - tt1) < abs(r - tt2 - szl - r + l - 1)) {
        return tt1;
    }else {
        return tt2 + szl + r - l + 1;
    }
}

int get_val(treap &t, int pos) {
    treap t1, t2, t3;
    split(t, t1, t2, pos);
    split(t2, t2, t3, 1);
    int x = t2->x;
    merge(t, t1, t2);
    merge(t, t, t3);
    return x;
}

int getmx(treap &t, int l, int r) {
    treap t1, t2, t3;
    split(t, t1, t2, l);
    split(t2, t2, t3, r - l + 1);
    int mx = t2->mx;
    merge(t, t1, t2);
    merge(t, t, t3);
    return mx;
}

int main() {
    io();
    int n, m, q;
    cin >> n >> m >> q;
    int t = 0;
    treap r = nullptr, c = nullptr;
    for(int i = 0; i < n; i++) {
        push_back(r, 0);
    }
    for(int i = 0; i < m; i++) {
        push_back(c, 0);
    }
    while(q--) {
        t++;
        int type;
        cin >> type;
        if(type == 1) {
            int i;
            cin >> i;
            i--;
            set_value(r, -t, i);
        }else if(type == 2) {
            int i;
            cin >> i;
            i--;
            set_value(c, -t, i);
        }else {
            int x1, y1, x2, y2, k;
            cin >> x1 >> y1 >> x2 >> y2 >> k;
            x1--;
            y1--;
            x2--;
            y2--;
            k -= t;
            int ans = 1000000000;
            int ax1 = get_val(r, x1);
            int ax2 = get_val(r, x2);
            int by1 = get_val(c, y1);
            int by2 = get_val(c, y2);
            if(x1 == x2 && (ax1 <= k || getmx(c, min(y1, y2), max(y1, y2)) <= k)) {
                ans = min(ans, abs(y1 - y2));
            }
            if(y1 == y2 && (by1 <= k || getmx(r, min(x1, x2), max(x1, x2)) <= k)) {
                ans = min(ans, abs(x1 - x2));
            }
            if(ax1 <= k && by2 <= k) {
                ans = min(ans, abs(x1 - x2) + abs(y1 - y2));
            }
            if(by1 <= k && ax2 <= k) {
                ans = min(ans, abs(x1 - x2) + abs(y1 - y2));
            }
            if(ax1 <= k && ax2 <= k) {
                int pos = get_value(c, min(y1, y2), max(y1, y2), k);
                if(pos != -1) {
                    ans = min(ans, abs(y1 - pos) + abs(x1 - x2) + abs(y2 - pos));
                }
                if(getmx(r, min(x1, x2), max(x1, x2)) <= k) {
                    ans = min(ans, abs(x1 - x2) + abs(y1 - y2));
                }
            }
            if(by1 <= k && by2 <= k) {
                int pos = get_value(r, min(x1, x2), max(x1, x2), k);
                if(pos != -1) {
                    ans = min(ans, abs(x1 - pos) + abs(y1 - y2) + abs(x2 - pos));
                }
                if(getmx(c, min(y1, y2), max(y1, y2)) <= k) {
                    ans = min(ans, abs(x1 - x2) + abs(y1 - y2));
                }
            }
            if(ans == 1000000000) {
                cout << -1 << "\n";
            }else {
                cout << ans << "\n";
            }
        }
    }
    return 0;
}

/*
4 3 9
3 2 1 3 3 1
3 2 1 3 3 1
2 1
2 3
1 1
3 2 1 3 3 3
3 2 1 3 3 3
2 2
3 2 1 3 3 6
 */