#pragma GCC optimize("Ofast", "unroll-loops")

#include <iostream>
#include <algorithm>
#include <cmath>

using namespace std;

#define sz(x) ((int)(x).size())
#define INF 2000111222
#define pii pair<int, int>
#define MAXN 300005
#define l first
#define r second

int n, m;
int a[MAXN];
int b[4*MAXN];
pair<pii, int> p[MAXN];

void push(int v) {
	if(b[v])
		b[2*v] = b[2*v + 1] = b[v];
	b[v] = 0;
}

void update(int v, int tl, int tr, int l, int r, int val) {
	if(l > tr || r < tl)
		return;
	if(tl == l && tr == r) {
		b[v] = val;
		return;
	}
	int tm = (tl + tr) / 2;
	push(v);
	update(2*v, tl, tm, l, min(r, tm), val);
	update(2*v + 1, tm + 1, tr, max(l, tm + 1), r, val);
}

int get(int v, int tl, int tr, int pos) {
	if(tl == pos && tr == pos)
		return b[v];
	push(v);
	int tm = (tl + tr) / 2;
	if(pos > tm)
		return get(2*v + 1, tm + 1, tr, pos);
	else
		return get(2*v, tl, tm, pos);
}

int main() {
	cin >> n >> m;

	for(int i = 1; i <= m; ++i)
		p[i - 1] = make_pair(make_pair(INF, -INF), i);

	for(int i = 1; i <= n; ++i) {
		cin >> a[i];
		if(p[a[i] - 1].l.l == INF)
			p[a[i] - 1].l.l = i;
		p[a[i] - 1].l.r = i;
	}

	sort(p, p + m);

	int p_size = 0;

	for(int i = 0; i < m; ++i) {
		if(p[i].l.l == INF)
			break;
		update(1, 1, n, p[i].l.l, p[i].l.r, p[i].r);
		p_size++;
	}

	for(int i = 1; i <= n; ++i) {
		if(get(1, 1, n, i) != a[i]) {
			cout << -1 << endl;
			return 0;
		}
	}

	cout << p_size << endl;
	for(int i = 0; i < p_size; ++i) 
		cout << p[i].r << " " << p[i].l.l << " " << p[i].l.r << endl;
	return 0;
}