#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>

using namespace std;

struct cor {
	int x, y;
	cor() {}
	cor(int x, int y) : x(x), y(y) {}
	void input() {
		cin >> x >> y;
		--x;
		--y;
	}
};

int delta_x[4] = { -1, 0, 1, 0 };
int delta_y[4] = { 0, -1, 0, 1 };

bool in_desk(int x, int y, int n, int m) {
	return (0 <= x) && (x < n) && (0 <= y) && (y < m);
}

int main() {
	int n, m, qstn;
	cin >> n >> m >> qstn;
	vector<int> x_line(n), y_line(m);
	for (int k = 1; k <= qstn; ++k) {
		int type;
		cin >> type;
		if (type == 1) {
			int x;
			cin >> x;
			x_line[x - 1] = k;
		}
		else if (type == 2) {
			int y;
			cin >> y;
			y_line[y - 1] = k;
		}
		else if (type == 3) {
			cor start, finish;
			start.input();
			finish.input();
			int can;
			cin >> can;
			vector<vector<int>> dist(n, vector<int>(m, -1));
			dist[start.x][start.y] = 0;
			queue<cor> q;
			if (min(k - x_line[start.x], k - y_line[start.y]) <= can)
				q.push(start);
			while (!q.empty()) {
				cor v = q.front();
				int x = v.x, y = v.y;
				q.pop();
				for (int to = 0; to < 4; ++to) {
					int new_x = x + delta_x[to], new_y = y + delta_y[to];
					if (in_desk(new_x, new_y, n, m) && (dist[new_x][new_y] == -1)) {
						int todo = min(k - x_line[new_x], k - y_line[new_y]);
						if (todo <= can) {
							dist[new_x][new_y] = dist[x][y] + 1;
							q.push(cor(new_x, new_y));
						}
					}
				}
			}
			cout << dist[finish.x][finish.y] << "\n";
		}
	}
}
