#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>

using namespace std;

const int inf = 1e9;

struct cor {
	int x, y;
	cor() {}
	cor(int x, int y) : x(x), y(y) {}
	void input() {
		cin >> x >> y;
		--x;
		--y;
	}
};

struct seg_tree {
	vector<int> tree;
	seg_tree(int n) : tree(4 * n) {}
	void update(int v, int left, int right, int pos, int val) {
		if (left + 1 == right)
			tree[v] = val;
		else {
			int mid = (left + right) / 2;
			if (pos < mid)
				update(2 * v, left, mid, pos, val);
			else
				update(2 * v + 1, mid, right, pos, val);
			tree[v] = min(tree[2 * v], tree[2 * v + 1]);
		}
	}
	int get_min(int v, int left, int right, int qleft, int qright) {
		if ((right <= qleft) || (qright <= left))
			return inf;
		if ((qleft <= left) && (right <= qright))
			return tree[v];
		int mid = (left + right) / 2;
		return min(get_min(2 * v, left, mid, qleft, qright), get_min(2 * v + 1, mid, right, qleft, qright));
	}
};

int main() {
	int n, m, qstn;
	cin >> n >> m >> qstn;
	seg_tree tree(n);
	for (int k = 1; k <= qstn; ++k) {
		int type;
		cin >> type;
		if (type == 1) {
			int x;
			cin >> x;
			tree.update(1, 0, n, x - 1, k);
		}
		else if (type == 3) {
			cor s, f;
			s.input();
			f.input();
			int can;
			cin >> can;
			int must = k - tree.get_min(1, 0, n, min(s.x, f.x), max(s.x, f.x) + 1);
			if (must <= can)
				cout << abs(s.x - f.x) + abs(s.y - f.y) << "\n";
			else
				cout << "-1\n";
		}
	}
}
