#pragma GCC optimize("Ofast,unroll-loops,fast-math")
#pragma GCC target("avx,abm,sse,sse2,sse3,ssse3,sse4,tune=native")

#include <bits/stdc++.h>

#define int ll
#define mp make_pair
#define pb emplace_back
#define all(C) (C).begin(), (C).end()
#define rall(C) (C).rbegin(), (C).rend()
#define dbg(x) cerr << #x << " : " << x << endl 

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using pld = pair<ld, ld>;

/*
const int MAX_MEM = 1e8;
char MEM[MAX_MEM];
int MEM_POS = 0;
inline void* operator new(size_t x)
{
    auto ret = MEM + MEM_POS;
    MEM_POS += x;
    assert(MEM_POS < MAX_MEM);
    return ret;
}
inline void operator delete(void*) {}
*/

template<class T> istream& operator>> (istream &in, vector <T> &a)
{
    for (auto &i : a)
        in >> i;
    return in;
}
template<class T> ostream& operator<< (ostream &out, vector <T> a)
{
    for (auto &i : a)
        out << i << " ";
    return out;
}
template<class T, class U> istream& operator>> (istream &in, pair <T, U> &a)
{
    in >> a.first >> a.second;
    return in;
}
template<class T, class U> ostream& operator<< (ostream &out, pair <T, U> a)
{
    out << a.first << " " << a.second;
    return out;
}

inline void Start()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
}

struct node
{
    int val, pt;
    int vl, vr;
    node *l = 0, *r = 0;
    node() {}
    node(int tl, int tr)
    {
        vl = tl, vr = tr;
        if (vr - vl == 1)
        {
            val = 0, pt = -1;
            return;
        }
        l = new node(vl, vl + vr >> 1), r = new node(vl + vr >> 1, vr);
        val = l->val + r->val;
        pt = -1;
    }
    void push()
    {
        if (pt != -1)
        {
            val = (vr - vl) * pt;
            if (vr - vl != 1)
            {
                l->pt = pt;
                r->pt = pt;
            }
            pt = -1;
        }
    }
    void update(int ql, int qr, int x)
    {
        push();
        if (ql == vl && qr == vr)
        {
            pt = x;
            return;
        }
        int vm = vl + vr >> 1;
        if (qr <= vm)
            l->update(ql, qr, x);
        else if (ql >= vm)
            r->update(ql, qr, x);
        else
            l->update(ql, vm, x), r->update(vm, qr, x);
    }
    int get(int pos)
    {
        push();
        if (vr - vl == 1)
            return val;
        int vm = vl + vr >> 1;
        if (pos < vm)
            return l->get(pos);
        else
            return r->get(pos);
    }
};

signed main()
{
    Start();
    int m, n;
    cin >> m >> n;
    vector <int> a(m);
    cin >> a;
    for (auto &i : a)
        --i;
    vector <int> st(n, 1e9), fi(n, -1);
    for (int i = 0; i < m; ++i)
    {
        st[a[i]] = min(st[a[i]], i);
        fi[a[i]] = max(fi[a[i]], i);
    }
    vector <pair<pii, int>> q;
    for (int i = 0; i < n; ++i)
    {
        q.pb(mp(st[i], fi[i]), i);
    }
    sort(all(q));
    node *t = new node(0, m);
    for (int i = 0; i < n; ++i)
    {
        if (q[i].first.first == 1e9)
            break;
        t->update(q[i].first.first, q[i].first.second + 1, q[i].second);
    }
    vector <int> b(m);
    for (int i = 0; i < m; ++i)
        b[i] = t->get(i);
    if (a != b)
        return cout << -1, 0;
    vector <pair <pii, int>> ans;
    for (int i = 0; i < n; ++i)
    {
        if (q[i].first.first != 1e9)
            ans.pb(mp(q[i].first.first + 1, q[i].first.second + 1), q[i].second + 1);
    }
    cout << ans.size() << endl;
    for (auto &i : ans)
        cout << i.second << " " << i.first << "\n";
    return 0;
}

