#pragma GCC optimize("Ofast,unroll-loops,fast-math")
#pragma GCC target("avx,abm,sse,sse2,sse3,ssse3,sse4,tune=native")

#include <bits/stdc++.h>

#define int ll
#define mp make_pair
#define pb emplace_back
#define all(C) (C).begin(), (C).end()
#define rall(C) (C).rbegin(), (C).rend()
#define dbg(x) cerr << #x << " : " << x << endl 

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using pld = pair<ld, ld>;

/*
const int MAX_MEM = 1e8;
char MEM[MAX_MEM];
int MEM_POS = 0;
inline void* operator new(size_t x)
{
    auto ret = MEM + MEM_POS;
    MEM_POS += x;
    assert(MEM_POS < MAX_MEM);
    return ret;
}
inline void operator delete(void*) {}
*/

template<class T> istream& operator>> (istream &in, vector <T> &a)
{
    for (auto &i : a)
        in >> i;
    return in;
}
template<class T> ostream& operator<< (ostream &out, vector <T> a)
{
    for (auto &i : a)
        out << i << " ";
    return out;
}
template<class T, class U> istream& operator>> (istream &in, pair <T, U> &a)
{
    in >> a.first >> a.second;
    return in;
}
template<class T, class U> ostream& operator<< (ostream &out, pair <T, U> a)
{
    out << a.first << " " << a.second;
    return out;
}

inline void Start()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
}

struct node
{
    int val, mini;
    int vl, vr;
    node *l = 0, *r = 0;
    node() {}
    node(int tl, int tr)
    {
        vl = tl, vr = tr;
        if (vr - vl == 1)
        {
            val = -1;
            return;
        }
        l = new node(vl, vl + vr >> 1), r = new node(vl + vr >> 1, vr);
        val = max(l->val, r->val);
        mini = min(l->mini, r->mini);
    }
    void update(int pos, int x)
    {
        if (vr - vl == 1)
        {
            val = x;
            mini = x;
            return;
        }
        int vm = vl + vr >> 1;
        if (pos < vm)
            l->update(pos, x);
        else
            r->update(pos, x);
        val = max(l->val, r->val), mini = min(l->mini, r->mini);
    }
    int get(int ql, int qr)
    {
        if (vl == ql && vr == qr)
            return val;
        int vm = vl + vr >> 1;
        if (qr <= vm)
            return l->get(ql, qr);
        if (ql >= vm)
            return r->get(ql, qr);
        return max(l->get(ql, vm), r->get(vm, qr));
    }
    int mget(int ql, int qr)
    {
        if (vl == ql && vr == qr)
            return mini;
        int vm = vl + vr >> 1;
        if (qr <= vm)
            return l->mget(ql, qr);
        if (ql >= vm)
            return r->mget(ql, qr);
        return min(l->mget(ql, vm), r->mget(vm, qr));
    }

};

signed main()
{
    Start();
    int n, m, q;
    cin >> n >> m >> q;
    vector <int> rr(n, -1), cc(m, -1);
    node *rt = new node(0, n), *ct = new node(0, m);
    for (int i = 0; i < q; ++i)
    {
        int ty;
        cin >> ty;
        if (ty == 1)
        {
            int j;
            cin >> j, --j;
            rr[j] = i;
            rt->update(j, i);
        }
        else if (ty == 2)
        {
            int j;
            cin >> j, --j;
            cc[j] = i;
            ct->update(j, i);
        }
        else
        {
            int r1, c1, r2, c2, k;
            cin >> r1 >> c1 >> r2 >> c2 >> k, --r1, --c1, --r2, --c2;
            k = i - k;
            //dbg(rr), dbg(cc), dbg(k);
            if (rr[r1] >= k && cc[c2] >= k)
            {
                cout << llabs(r2 - r1) + llabs(c2 - c1) << endl;
                continue;
            }
            if (cc[c1] >= k && rr[r2] >= k)
            {
                cout << llabs(r2 - r1) + llabs(c2 - c1) << endl;
                continue;
            }
            if (cc[c1] >= k && cc[c2] >= k)
            {
                //dbg("lol");
                if (ct->mget(min(c1, c2), max(c1, c2) + 1) >= k)
                {
                    cout << llabs(r2 - r1) + llabs(c2 - c1) << endl;
                    continue;
                }
                if (rt->get(min(r1, r2), max(r1, r2) + 1) >= k)
                {
                    cout << llabs(r2 - r1) + llabs(c2 - c1) << endl;
                    continue;
                }
                int ans = 1e9;
                int l = 0, r = min(r1, r2), cr = min(r1, r2);
                while (r - l > 1)
                {
                    int x = l + r >> 1;
                    int g = rt->get(x, cr);
                    if (g >= k)
                        l = x;
                    else
                        r = x;
                }
                if (rr[l] >= k)
                    ans = min(ans, llabs(c1 - c2) + llabs(r1 - l) + llabs(r2 - l));
                cr = max(r1, r2);
                l = cr, r = n - 1;
                while (r - l > 1)
                {
                    int x = l + r >> 1;
                    int g = rt->get(cr + 1, x + 1);
                    if (g >= k)
                        r = x;
                    else
                        l = x;
                }
                if (rr[r] >= k)
                    ans = min(ans, llabs(c1 - c2) + llabs(r1 - r) + llabs(r2 - r));
                if (ans != 1e9)
                    cout << ans << endl;
                else
                    cout << -1 << endl;
                continue;
            }
            if (rr[r1] >= k && rr[r2] >= k)
            {
                if (rt->mget(min(r1, r2), max(r1, r2) + 1) >= k)
                {
                    cout << llabs(r2 - r1) + llabs(c2 - c1) << endl;
                    continue;
                }
                if (ct->get(min(c1, c2), max(c1, c2) + 1) >= k)
                {
                    cout << llabs(r2 - r1) + llabs(c2 - c1) << endl;
                    continue;
                }
                int ans = 1e9;
                int l = 0, r = min(c1, c2), cr = min(c1, c2);
                while (r - l > 1)
                {
                    int x = l + r >> 1;
                    int g = ct->get(x, cr);
                    if (g >= k)
                        l = x;
                    else
                        r = x;
                }
                if (cc[l] >= k)
                    ans = min(ans, llabs(r1 - r2) + llabs(c1 - l) + llabs(c2 - l));
                cr = max(c1, c2);
                l = cr, r = m - 1;
                while (r - l > 1)
                {
                    int x = l + r >> 1;
                    int g = ct->get(cr + 1, x + 1);
                    if (g >= k)
                        r = x;
                    else
                        l = x;
                }
                if (cc[r] >= k)
                    ans = min(ans, llabs(r1 - r2) + llabs(c1 - r) + llabs(c2 - r));
                if (ans != 1e9)
                    cout << ans << endl;
                else
                    cout << -1 << endl;
                continue;
            } 
        cout << -1 << endl;
        }
    }
    return 0;
}

