#include <bits/stdc++.h>
 
using namespace std;
 
typedef long long ll;
 
int n, m, q;
 
vector <int> row, col;
 
const int N = 3e5 + 7;
const int Inf = 1e9 + 7;
int ans[N];
bool qr[N];
 
int dist(int x1, int y1, int x2, int y2) {
    return abs(x1 - x2) + abs(y1 - y2);
}
 
struct STmin {
    int n;
    vector <int> t;
    STmin(int nn) {
        n = nn;
        t.resize(2 * nn, -1);
    }
    void upd(int i, int val) {
        for (t[i += n] = val; i > 1; i >>= 1) {
            t[i >> 1] = min(t[i], t[i ^ 1]);
        }
    }
    int get(int l, int r) {
        ++r;
        int res = Inf;
        for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
            if (l & 1) res = min(res, t[l++]);
            if (r & 1) res = min(res, t[--r]);
        }
        return res;
    }
};
 
struct STmax {
    int n;
    vector <int> t;
    STmax(int nn) {
        n = nn;
        t.resize(2 * nn, -1);
    }
    void upd(int i, int val) {
        for (t[i += n] = val; i > 1; i >>= 1) {
            t[i >> 1] = max(t[i], t[i ^ 1]);
        }
    }
    int get(int l, int r) {
        ++r;
        int res = -1;
        for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
            if (l & 1) res = max(res, t[l++]);
            if (r & 1) res = max(res, t[--r]);
        }
        return res;
    }
};
 
signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.setf(ios::fixed); cout.precision(20);
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    #endif                                                                                  
    cin >> n >> m >> q;
    row.resize(n, -1); col.resize(m, -1);
    for (int i = 0; i < q; ++i) ans[i] = Inf;
    STmin rmn(n), cmn(m);
    STmax rmx(n), cmx(m);
    for (int i = 0; i < q; ++i) {
        int t;
        cin >> t;
        if (t == 1) {
            int r;
            cin >> r;
            --r;
            row[r] = i;
            rmn.upd(r, i);
            rmx.upd(r, i);
        }
        else if (t == 2) {
            int c;
            cin >> c;
            --c;
            col[c] = i;
            cmn.upd(c, i);
            cmx.upd(c, i);
        }
        else {
            qr[i] = 1;
            int x1, y1, x2, y2, k;
            cin >> x1 >> y1 >> x2 >> y2 >> k;
            --x1, --y1, --x2, --y2;
            int d = dist(x1, y1, x2, y2);
            auto okr = [&] (int x) {
                return i - row[x] <= k;
            };
            auto okc = [&] (int y) {
                return i - col[y] <= k;
            };
            int mny = min(y1, y2), mnx = min(x1, x2), mxx = max(x1, x2), mxy = max(y1, y2);
            if (i - cmn.get(mny, mxy) <= k || i - rmn.get(mnx, mxx) <= k) ans[i] = d;

            if (okc(y1) && okc(y2)) {
                if (i - rmx.get(mnx, mxx) <= k) ans[i] = d;
                int l = -1, r = mnx + 1;
                while (r - l > 1) {
                 	int mid = (l + r) >> 1;
                 	if (i - rmx.get(mid, mnx) <= k) l = mid;
                 	else r = mid;
                } 
                if (l >= 0) ans[i] = min(ans[i], d + 2 * (mnx - l));
                l = mxx - 1, r = n;
                while (r - l > 1) {
                 	int mid = (l + r) >> 1;
                 	if (i - rmx.get(mxx, mid) <= k) r = mid;
                 	else l = mid;
                }
                if (r < n) ans[i] = min(ans[i], d + 2 * (r - mxx));
            } 
            if (okr(x1) && okr(x2)) {
                if (i - cmx.get(mny, mxy) <= k) ans[i] = d;
                int l = -1, r = mny + 1;
                while (r - l > 1) {
                 	int mid = (l + r) >> 1;
                 	if (i - cmx.get(mid, mny) <= k) l = mid;
                 	else r = mid;
                } 
                if (l >= 0) ans[i] = min(ans[i], d + 2 * (mny - l));
                l = mxy - 1, r = m;
                while (r - l > 1) {
                 	int mid = (l + r) >> 1;
                 	if (i - cmx.get(mxy, mid) <= k) r = mid;
                 	else l = mid;
                }
                if (r < m) ans[i] = min(ans[i], d + 2 * (r - mxy));
 
            } 
             
            if (okr(x1) && okc(y2)) ans[i] = d;
            if (okr(x2) && okc(y1)) ans[i] = d;
        }
    }
 
    for (int i = 0; i < q; ++i) {
        if (!qr[i]) continue;
        if (ans[i] > Inf / 2) cout << "-1\n";
        else cout << ans[i] << '\n';
    }
}