#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx,mmx,tune=native,popcnt")
#pragma GCC optimize("fast-math,no-stack-protector,unroll-loops,unroll-all-loops,align-functions,aggressive-loop-optimizations")
#pragma GCC optimize("align-jumps,align-labels,align-loops,associative-math,asynchronous-unwind-tables,auto-inc-dec,branch-count-reg")
#pragma GCC optimize("branch-probabilities,branch-target-load-optimize,branch-target-load-optimize2,btr-bb-exclusive,caller-saves")
#pragma GCC optimize("combine-stack-adjustments,compare-elim,conserve-stack,cprop-registers,crossjumping,cse-follow-jumps")
#pragma GCC optimize("defer-pop,delayed-branch,delete-dead-exceptions,devirtualize,dse,early-inlining,expensive-optimizations")
#pragma GCC optimize("forward-propagate,function-cse,gcse,gcse-after-reload,gcse-las,gcse-lm,gcse-sm,graphite,graphite-identity")
#pragma GCC optimize("guess-branch-probability,indirect-inlining,inline")
#pragma GCC optimize("inline-atomics,inline-functions,inline-functions-called-once,inline-small-functions")
#pragma GCC optimize("ivopts,lifetime-dse,jump-tables,loop-nest-optimize,omit-frame-pointer,peel-loops,prefetch-loop-arrays")

#include <bits/stdc++.h>

using namespace std;

#define int long long

vector< vector< pair<int, int> > > adj;
vector< set<int> > dist;
vector<int> cnt_adjr;
vector<int> cnt_visited;

void dfs(int u) {
	cnt_visited[u]++;
	if(cnt_visited[u] < cnt_adjr[u]) {
		return;
	}

	for(auto p: adj[u]) {
		int v = p.first;
		int d = p.second;
		for(int d1: dist[u]) {
			if(dist[v].size() >= 1000) {
				auto it = dist[v].lower_bound(d1 + d);
				if(it != dist[v].end() && 1000 * (*it) / (d1 + d) < 300) {
					dist[v].erase(it);
				}
			}
			dist[v].insert(d1 + d);
		}
		dfs(v);
	}
}

signed main() {
	int t;
	cin >> t;
	while(t-- > 0) {
		int n, m, q, p;
		cin >> n >> m >> q >> p;

		adj.clear();
		adj.resize(n);
		cnt_adjr.clear();
		cnt_adjr.resize(n);

		for(int i = 0; i < m; i++) {
			int u, v, d;
			cin >> u >> v >> d;
			u--; v--;
			adj[u].emplace_back(v, d);
			cnt_adjr[v]++;
		}

		dist.clear();
		dist.resize(n);
		dist[0].insert(0);
		cnt_visited.clear();
		cnt_visited.resize(n);
		dfs(0);

		for(int i = 0; i < q; i++) {
			int f, r;
			cin >> f >> r;
			f--;

			auto it = dist[f].lower_bound(r);
			if(it != dist[f].end() && *it <= r * p / (p - 1)) {
				cout << "1";
			} else {
				cout << "0";
			}
		}
		cout << "\n";
	}

	return 0;
}
