#include "bits/stdc++.h"
#define ll long long
#define all(x) x.begin(), x.end()
#define ull unsigned long long
#define pb push_back


const ll inf = 1e18;


using namespace std;


template <class T>
istream& operator>>(istream &in, vector<T> &arr) {
    for (T &cnt : arr) {
        in >> cnt;
    }
    return in;
};


struct kek {
    ll pos, type, ind;
};


bool operator<(kek a, kek b) {
    return a.pos < b.pos;
}


struct ans {
    ll c, l, r;
};


struct stree {
    vector<ll> t, upd;

    void push(ll v, ll l, ll r) {
        if (upd[v] == -1) {
            return;
        }
        t[v] = upd[v];
        if (l != r) {
            upd[v * 2] = upd[v];
            upd[v * 2 + 1] = upd[v];
        }
        upd[v] = -1;
    }

    void query(ll v, ll l, ll r, ll ql, ll qr, ll val) {
        push(v, l, r);
        if (ql <= l and r <= qr) {
            upd[v] = val;
            return;
        }
        if (ql > r or qr < l) {
            return;
        }
        ll mid = (l + r) / 2;
        query(v * 2, l, mid, ql, qr, val);
        query(v * 2 + 1, mid + 1, r, ql, qr, val);
    }

    ll get(ll v, ll l, ll r, ll pos) {
        push(v, l, r);
        if (l == r) {
            return t[v];
        }
        ll mid = (l + r) / 2;
        if (pos <= mid) {
            return get(v * 2, l, mid, pos);
        } else {
            return get(v * 2 + 1, mid + 1, r, pos);
        }
    }
};


void solve() {
    ll m, n;
    cin >> m >> n;
    vector<ll> order(m);
    cin >> order;
    vector<pair<ll, ll>> segs(n, {inf, -inf});
    vector<kek> keks;
    for (ll i = 0; i < m; i++) {
        order[i]--;
        segs[order[i]].first = min(segs[order[i]].first, i);
        segs[order[i]].second = max(segs[order[i]].second, i);
    }
    for (int i = 0; i < n; i++) {
        if (segs[i].first != inf) {
            keks.pb({segs[i].first, 1, i});
            keks.pb({segs[i].second, -1, i});
        }
    }
    sort(all(keks));
    vector<ans> res;
    stree solver;
    solver.t.resize(4 * m);
    solver.upd.resize(4 * m, -1);
    for (auto cnt: keks) {
        if (cnt.type == 1) {
            res.pb({cnt.ind + 1, segs[cnt.ind].first + 1, segs[cnt.ind].second + 1});
            solver.query(1, 0, m - 1, segs[cnt.ind].first, segs[cnt.ind].second, cnt.ind);
        }
    }
    vector<ll> result(m);
    for (int i = 0; i < m; i++) {
        result[i] = solver.get(1, 0, m - 1, i);
    }
    if (result != order) {
        cout << -1;
        return;
    }
    cout << res.size() << "\n";
    for (auto x : res) {
        cout << x.c << " " << x.l << " " << x.r << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    srand(time(0));
    cout.precision(30);
    solve();
    return 0;
}