#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

using namespace std;

const ll maxn = (ll)3e5 + 10;

ll m, n;

ll used[maxn];
ll first[maxn];
ll last[maxn];

vector < ll > a;



struct segtree{
    ll n;
    vector < ll > t, p;
    segtree(){}
    segtree(ll n): n(n){
        t.resize(4 * n);
        p.resize(4 * n, -1);
    }

    inline void push(ll v, ll tl, ll tr){
        if(p[v] == -1)return;
        t[v] = p[v];
        if(tl != tr){
            p[v * 2 + 1] = p[v];
            p[v * 2 + 2] = p[v];
        }
        p[v] = -1;
    }
    inline void update(ll v, ll tl, ll tr, ll l, ll r, ll x){
        push(v, tl, tr);
        if(tl > r || tr < l)return;
        if(l <= tl && tr <= r){
            p[v] = x;
            push(v, tl, tr);
            return;
        }
        ll tm = (tl + tr) / 2;
        update(v * 2 + 1, tl, tm, l, r, x);
        update(v * 2 + 2, tm + 1, tr, l, r, x);
        t[v] = min(t[v * 2 + 1], t[v * 2 + 2]);
    }

    void get(ll v, ll tl, ll tr, vector < ll > &res){
        push(v, tl, tr);
        if(tl == tr){
            res.push_back(t[v]);
        } else {
            ll tm = (tl + tr) / 2;
            get(v * 2 + 1, tl, tm, res);
            get(v * 2 + 2, tm + 1, tr, res);
        }
    }
};







void solve(){
    fill(first, first + maxn, -1);
    cin >> m >> n;
    a.resize(m);
    for(ll i = 0; i < m; ++i){
        cin >> a[i];
    }
    for(ll i = 0; i < m; ++i){
        if(first[a[i]] == -1){
            first[a[i]] = i;
        }
    }
    for(ll i = m - 1; i >= 0; --i){
        last[a[i]] = max(last[a[i]], i);
    }
    vector < ll > res;
    vector < vector < ll > > ans;
    segtree tree = segtree(m);
    for(ll i = 0; i < m; ++i){
        if(used[a[i]])continue;
        used[a[i]] = 1;
        ans.push_back({a[i], i, last[a[i]]});
        tree.update(0, 0, m - 1, i, last[a[i]], a[i]);
    }
    tree.get(0, 0, m - 1, res);
    for(ll i = 0; i < m; ++i){
        if(res[i] != a[i]){
            cout << -1 << "\n";
            exit(0);
        }
    }
    cout << ans.size() << "\n";
    for(auto i: ans){
        cout << i[0] << " " << i[1] + 1 << " " << i[2] + 1 << "\n";
    }
    cout << "\n";
}


signed main(){
    ll t = 1;
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #else

    #endif
    while(t--){
        solve();
    }
}
