#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

using namespace std;

const ll maxn = (ll)11000 + 100;


ll n, m, q, p;

const ll inf = (ll)1e13;


struct ed{
    ll v, u, c;
    ed(){}
    ed(ll v, ll u, ll c): v(v), u(u), c(c){}
};

vector < vector < ll > > dp;
vector < vector < pair < ll, ll > > > g;
vector < ll > used;
vector < ed > e;


void dfs(ll v){
    used[v] = 1;
    for(auto u1: g[v]){
        ll u = u1.first;
        ll c = u1.second;
        if(!used[u]){
            dfs(u);
        }
        for(ll i = 0; i < maxn; ++i){
            if(i - c < 0){
                continue;
            }
            dp[v][i] |= dp[u][i - c];
        }
    }
    if(g[v].size() == 0){
        dp[v][0] = 1;
    }
}


void dfs0(ll v, vector < vector < ll > > &dp1){
    used[v] = 1;
    for(auto u1: g[v]){
        ll u = u1.first;
        ll c = u1.second;
        if(!used[u]){
            dfs0(u, dp1);
        }
        for(ll i = 0; i < dp1[u].size(); ++i){
            dp1[v].push_back(dp1[u][i] + c);
        }
    }
    if(g[v].size() == 0){
        dp1[v].push_back(0);
    }
}





void solve0(){
    string ans = "";
    vector < vector < ll > > dp1(n);
    for(ll i = 0; i < n; ++i){
        if(!used[i]){
            dfs0(i, dp1);
        }
    }
    for(ll i = 0; i < q; ++i){
        bool ok = 0;
        ll f, r;
        cin >> f >> r;
        --f;
        ll l1 = r;
        ll r1 = (p * r) / (p - 1);
        for(ll j = 0; j < dp1[f].size(); ++j){
            if(l1 <= dp1[f][j] && dp1[f][j] <= r1){
                ok = 1;
                break;
            }
        }
        if(ok){
            ans += '1';
        } else {
            ans += '0';
        }
    }
    cout << ans << "\n";
}




void solve(){
    e.clear();
    g.clear();
    used.clear();
    cin >> n >> m >> q >> p;
    string ans = "";
    e.resize(m);
    g.resize(n);
    used.resize(n);
    for(ll i = 0; i < m; ++i){
        ll v, u, c;
        cin >> v >> u >> c;
        --v, --u;
        g[u].push_back({v, c});
        e[i].v = v;
        e[i].u = u;
        e[i].c = c;
    }
    if(n <= 10 && m <= 10 && q <= 10){
        solve0();
        return;
    }
    dp.clear();
    dp.resize(n, vector < ll > (maxn));
    for(ll i = 0; i < n; ++i){
        if(used[i]){
            continue;
        }
        dfs(i);
    }

    for(ll i = 0; i < q; ++i){
        ll f, r;
        cin >> f >> r;
        --f;
        ll l1 = r;
        ll r1 = (p * r) / (p - 1);
        bool ok = 0;
        for(ll j = l1; j <= r1; ++j){
            if(dp[f][j] == 1){
                ok = 1;
                break;
            }
        }
        if(ok){
            ans += '1';
        } else {
            ans += '0';
        }
    }
    cout << ans << "\n";
}


signed main(){
    ll t = 1;
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #else

    #endif
    cin >> t;
    while(t--){
        solve();
    }
}
