#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <set>
#include <map>
#include <vector>
#include <algorithm>

using namespace std;

#define ll long long
#define ld long double
#define pi pair<int, int>
#define pll pair<ll, ll>
#define fs first
#define sc second
const int maxn = 2097152;
const int inf = 1000000000;

int zc[maxn];
int zr[maxn];

pair<pi, pi> dc[maxn];
pair<pi, pi> dr[maxn];

int timer = 0;

void updatec(int x)
{
	if (x * 2 >= maxn) return;
	if (zc[dc[x * 2].fs.fs] <= zc[dc[x * 2 + 1].fs.fs])
		dc[x].fs.fs = dc[x * 2].fs.fs;
	else
		dc[x].fs.fs = dc[x * 2 + 1].fs.fs;
	
	if (zc[dc[x * 2].fs.sc] < zc[dc[x * 2 + 1].fs.sc])
		dc[x].fs.sc = dc[x * 2].fs.sc;
	else
		dc[x].fs.sc = dc[x * 2 + 1].fs.sc;

	if (zc[dc[x * 2].sc.fs] >= zc[dc[x * 2 + 1].sc.fs])
		dc[x].sc.fs = dc[x * 2].sc.fs;
	else
		dc[x].sc.fs = dc[x * 2 + 1].sc.fs;

	if (zc[dc[x * 2].sc.sc] > zc[dc[x * 2 + 1].sc.sc])
		dc[x].sc.sc = dc[x * 2].sc.sc;
	else
		dc[x].sc.sc = dc[x * 2 + 1].sc.sc;

}

void updater(int x)
{
	if (x * 2 >= maxn) return;

	if (zr[dr[x * 2].fs.fs] <= zr[dr[x * 2 + 1].fs.fs])
		dr[x].fs.fs = dr[x * 2].fs.fs;
	else
		dr[x].fs.fs = dr[x * 2 + 1].fs.fs;

	if (zr[dr[x * 2].fs.sc] < zr[dr[x * 2 + 1].fs.sc])
		dr[x].fs.sc = dr[x * 2].fs.sc;
	else
		dr[x].fs.sc = dr[x * 2 + 1].fs.sc;

	if (zr[dr[x * 2].sc.fs] >= zr[dr[x * 2 + 1].sc.fs])
		dr[x].sc.fs = dr[x * 2].sc.fs;
	else
		dr[x].sc.fs = dr[x * 2 + 1].sc.fs;

	if (zr[dr[x * 2].sc.sc] > zr[dr[x * 2 + 1].sc.sc])
		dr[x].sc.sc = dr[x * 2].sc.sc;
	else
		dr[x].sc.sc = dr[x * 2 + 1].sc.sc;

}

void zeroc(int pos, int z)
{
	zc[pos] = z;
	int x = maxn / 2 + pos;
	
	while (x > 1)
	{
		x /= 2;
		updatec(x);
	}
}

void zeror(int pos, int z)
{
	zr[pos] = z;
	int x = maxn / 2 + pos;
	while (x > 1)
	{
		x /= 2;
		updater(x);
	}
}

int getVc(int l, int r, int x, int pl, int pr, bool isMin, bool isFirst)
{
	if (pl >= l && pr <= r)
	{
		if (isMin && isFirst)
			return dc[x].fs.fs;
		if (isMin && !isFirst)
			return dc[x].fs.sc;
		if (!isMin && isFirst)
			return dc[x].sc.fs;
		return dc[x].sc.sc;
	}
	if (r <= pl || l >= pr) return -1;

	int m = (pl + pr) / 2;
	int z1 = getVc(l, r, x * 2, pl, m, isMin, isFirst);
	int z2 = getVc(l, r, x * 2 + 1, m, pr, isMin, isFirst);
	if (z1 == -1) return z2;
	if (z2 == -1) return z1;
	if (isMin)
	{
		if (isFirst)
		{
			if (zc[z1] <= zc[z2])
				return z1;
			return z2;
		}
		if (zc[z1] < zc[z2])
			return z1;
		return z2;
	}
	if (isFirst)
	{
		if (zc[z1] >= zc[z2])
			return z1;
		return z2;
	}
	if (zc[z1] > zc[z2])
		return z1;
	return z2;
}

int getVr(int l, int r, int x, int pl, int pr, bool isMin, bool isFirst)
{
	if (pl >= l && pr <= r)
	{
		if (isMin && isFirst)
			return dr[x].fs.fs;
		if (isMin && !isFirst)
			return dr[x].fs.sc;
		if (!isMin && isFirst)
			return dr[x].sc.fs;
		return dr[x].sc.sc;
	}
	if (r <= pl || l >= pr) return -1;

	int m = (pl + pr) / 2;
	int z1 = getVr(l, r, x * 2, pl, m, isMin, isFirst);
	int z2 = getVr(l, r, x * 2 + 1, m, pr, isMin, isFirst);
	if (z1 == -1) return z2;
	if (z2 == -1) return z1;
	if (isMin)
	{
		if (isFirst)
		{
			if (zr[z1] <= zr[z2])
				return z1;
			return z2;
		}
		if (zr[z1] < zr[z2])
			return z1;
		return z2;
	}
	if (isFirst)
	{
		if (zr[z1] >= zr[z2])
			return z1;
		return z2;
	}
	if (zr[z1] > zr[z2])
		return z1;
	return z2;
}

bool checkc(int pos, int k)
{
	if (timer - zc[pos] <= k)
		return true;
	return false;
}

bool checkr(int pos, int k)
{
	if (timer - zr[pos] <= k)
		return true;
	return false;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	#ifdef LOCAL
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif
	
	for (int i = maxn / 2; i < maxn; i++)
	{
		int pos = i - maxn / 2;
		dc[i] = { {pos, pos}, {pos, pos} };
		dr[i] = { {pos, pos}, {pos, pos} };
	}
	for (int i = maxn / 2 - 1; i > 0; i--)
	{
		updatec(i);
		updater(i);
	}

	int n, m, q;
	cin >> n >> m >> q;

	for (int i = 0; i < q; i++)
	{
		timer++;
		int type;
		cin >> type;
		if (type == 1)
		{
			int r;
			cin >> r;
			zeror(r, timer);
		}
		if (type == 2)
		{
			int c;
			cin >> c;
			zeroc(c, timer);
		}
		if (type == 3)
		{
			int r1, c1, r2, c2, k;
			int ans = inf;
			cin >> r1 >> c1 >> r2 >> c2 >> k;

			if (((checkc(c1, k) || checkr(r1, k)) && (checkc(c2, k) || checkr(r2, k))) == false)
			{
				cout << "-1\n";
				continue;
			}

			if (r1 > r2)
			{
				swap(r1, r2);
				swap(c1, c2);
			}
			for (int d1 = -1; d1 <= 1; d1++)
			{
				if (checkc(c1+d1, k))
				{
					for (int d2 = -1; d2 <= 1; d2++)
					{
						if (checkr(r2 + d2, k))
						{
							ans = min(ans, abs((c1+d1) - c2) + abs(r1 - (r2+d2)) + abs(d2) + abs(d1));
						}
					}
					for (int d2 = -1; d2 <= 1; d2++)
					{
						if (checkc(c2 + d2, k))
						{
							int zr1 = getVr(1, r2 + 1, 1, 0, maxn/2, false, false);
							int zr2 = getVr(r1, n + 1, 1, 0, maxn/2, false, true);
							if (checkr(zr1, k))
								ans = min(ans, abs(d1) + abs(r1 - zr1) + abs((c1 + d1) - (c2 + d2)) + abs(r2 - zr1) + abs(d2));
							if (checkr(zr2, k))
								ans = min(ans, abs(d1) + abs(r1 - zr2) + abs((c1 + d1) - (c2 + d2)) + abs(r2 - zr2) + abs(d2));
							if (i == 8)
								cout << "";
							int zc1 = getVc(min(c1 + d1, c2 + d2), max(c1 + d1, c2 + d2), 1, 0, maxn/2, true, false);
							
							if (checkc(zc1, k))
								ans = min(ans, abs(d1) + abs((c1 + d1) - (c2 + d2)) + abs(d2) + abs(r1 - r2));
						}
					}
				}
			}
			for (int d1 = -1; d1 <= 1; d1++)
			{
				if (checkr(r1 + d1, k))
				{
					for (int d2 = -1; d2 <= 1; d2++)
					{
						if (checkc(c2 + d2, k))
						{
							ans = min(ans, abs((r1 + d1) - r2) + abs(c1 - (c2 + d2)) + abs(d2) + abs(d1));
						}
					}
					for (int d2 = -1; d2 <= 1; d2++)
					{
						if (checkr(r2 + d2, k))
						{
							int zc1 = getVc(1, max(c2, c1) + 1, 1, 0, maxn/2, false, false);
							int zc2 = getVc(min(c1, c2), m + 1, 1, 0, maxn/2, false, true);
							if (checkc(zc1, k))
								ans = min(ans, abs(d1) + abs(c1 - zc1) + abs((r1 + d1) - (r2 + d2)) + abs(c2 - zc1) + abs(d2));
							if (checkc(zc2, k))
								ans = min(ans, abs(d1) + abs(c1 - zc2) + abs((r1 + d1) - (r2 + d2)) + abs(c2 - zc2) + abs(d2));
							int zr1 = getVc(min(r1 + d1, r2 + d2), max(r1 + d1, r2 + d2), 1, 0, maxn/2, true, false);
							if (checkr(zr1, k))
								ans = min(ans, abs(d1) + abs((r1 + d1) - (r2 + d2)) + abs(d2) + abs(c1 - c2));
						}
					}
				}
			}

			if (ans == inf)
				cout << "-1\n";
			else
				cout << ans << "\n";

		}
	}

}