#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <set>
#include <map>
#include <vector>
#include <algorithm>
#include <random>
#include <ctime>
#include <queue>

using namespace std;

#define ll long long
#define ld long double
#define pi pair<int, int>
#define pll pair<ll, ll>
#define fs first
#define sc second
const int maxn = 2097152;
const int inf = 1000000000;

mt19937 rnd(1077927);

int zc[maxn];
int zr[maxn];

pair<pi, pi> dc[maxn];
pair<pi, pi> dr[maxn];

int timer = 0;
int n, m, q;

void updatec(int x)
{
	if (x * 2 >= maxn) return;
	if (zc[dc[x * 2].fs.fs] <= zc[dc[x * 2 + 1].fs.fs])
		dc[x].fs.fs = dc[x * 2].fs.fs;
	else
		dc[x].fs.fs = dc[x * 2 + 1].fs.fs;
	
	if (zc[dc[x * 2].fs.sc] < zc[dc[x * 2 + 1].fs.sc])
		dc[x].fs.sc = dc[x * 2].fs.sc;
	else
		dc[x].fs.sc = dc[x * 2 + 1].fs.sc;

	if (zc[dc[x * 2].sc.fs] >= zc[dc[x * 2 + 1].sc.fs])
		dc[x].sc.fs = dc[x * 2].sc.fs;
	else
		dc[x].sc.fs = dc[x * 2 + 1].sc.fs;

	if (zc[dc[x * 2].sc.sc] > zc[dc[x * 2 + 1].sc.sc])
		dc[x].sc.sc = dc[x * 2].sc.sc;
	else
		dc[x].sc.sc = dc[x * 2 + 1].sc.sc;

}

void updater(int x)
{
	if (x * 2 >= maxn) return;

	if (zr[dr[x * 2].fs.fs] <= zr[dr[x * 2 + 1].fs.fs])
		dr[x].fs.fs = dr[x * 2].fs.fs;
	else
		dr[x].fs.fs = dr[x * 2 + 1].fs.fs;

	if (zr[dr[x * 2].fs.sc] < zr[dr[x * 2 + 1].fs.sc])
		dr[x].fs.sc = dr[x * 2].fs.sc;
	else
		dr[x].fs.sc = dr[x * 2 + 1].fs.sc;

	if (zr[dr[x * 2].sc.fs] >= zr[dr[x * 2 + 1].sc.fs])
		dr[x].sc.fs = dr[x * 2].sc.fs;
	else
		dr[x].sc.fs = dr[x * 2 + 1].sc.fs;

	if (zr[dr[x * 2].sc.sc] > zr[dr[x * 2 + 1].sc.sc])
		dr[x].sc.sc = dr[x * 2].sc.sc;
	else
		dr[x].sc.sc = dr[x * 2 + 1].sc.sc;

}

void zeroc(int pos, int z)
{
	zc[pos] = z;
	int x = maxn / 2 + pos;
	
	while (x > 1)
	{
		x /= 2;
		updatec(x);
	}
}

void zeror(int pos, int z)
{
	zr[pos] = z;
	int x = maxn / 2 + pos;
	while (x > 1)
	{
		x /= 2;
		updater(x);
	}
}

int getVc(int l, int r, int x, int pl, int pr, bool isMin, bool isFirst)
{
	if (pl >= l && pr <= r)
	{
		if (isMin && isFirst)
			return dc[x].fs.fs;
		if (isMin && !isFirst)
			return dc[x].fs.sc;
		if (!isMin && isFirst)
			return dc[x].sc.fs;
		return dc[x].sc.sc;
	}
	if (r <= pl || l >= pr) return -1;

	int m = (pl + pr) / 2;
	int z1 = getVc(l, r, x * 2, pl, m, isMin, isFirst);
	int z2 = getVc(l, r, x * 2 + 1, m, pr, isMin, isFirst);
	if (z1 == -1) return z2;
	if (z2 == -1) return z1;
	if (isMin)
	{
		if (isFirst)
		{
			if (zc[z1] <= zc[z2])
				return z1;
			return z2;
		}
		if (zc[z1] < zc[z2])
			return z1;
		return z2;
	}
	if (isFirst)
	{
		if (zc[z1] >= zc[z2])
			return z1;
		return z2;
	}
	if (zc[z1] > zc[z2])
		return z1;
	return z2;
}

int getVr(int l, int r, int x, int pl, int pr, bool isMin, bool isFirst)
{
	if (pl >= l && pr <= r)
	{
		if (isMin && isFirst)
			return dr[x].fs.fs;
		if (isMin && !isFirst)
			return dr[x].fs.sc;
		if (!isMin && isFirst)
			return dr[x].sc.fs;
		return dr[x].sc.sc;
	}
	if (r <= pl || l >= pr) return -1;

	int m = (pl + pr) / 2;
	int z1 = getVr(l, r, x * 2, pl, m, isMin, isFirst);
	int z2 = getVr(l, r, x * 2 + 1, m, pr, isMin, isFirst);
	if (z1 == -1) return z2;
	if (z2 == -1) return z1;
	if (isMin)
	{
		if (isFirst)
		{
			if (zr[z1] <= zr[z2])
				return z1;
			return z2;
		}
		if (zr[z1] < zr[z2])
			return z1;
		return z2;
	}
	if (isFirst)
	{
		if (zr[z1] >= zr[z2])
			return z1;
		return z2;
	}
	if (zr[z1] > zr[z2])
		return z1;
	return z2;
}

bool checkc(int pos, int k)
{
	if (timer - zc[pos] <= k)
		return true;
	return false;
}

bool checkr(int pos, int k)
{
	if (timer - zr[pos] <= k)
		return true;
	return false;
}

int solve(int r1, int c1, int r2, int c2, int k)
{
	int ans = inf;
	if (((checkc(c1, k) || checkr(r1, k)) && (checkc(c2, k) || checkr(r2, k))) == false)
	{
		return -1;
	}
	if (r1 == 5 && c1 == 9)
	{
		cout << "";
	}
	if (r1 > r2)
	{
		swap(r1, r2);
		swap(c1, c2);
	}
	for (int d1 = -1; d1 <= 1; d1++)
	{
		if (checkc(c1 + d1, k))
		{
			for (int d2 = -1; d2 <= 1; d2++)
			{
				if (checkr(r2 + d2, k))
				{
					ans = min(ans, abs((c1 + d1) - c2) + abs(r1 - (r2 + d2)) + abs(d2) + abs(d1));
				}
			}
			for (int d2 = -1; d2 <= 1; d2++)
			{
				if (checkc(c2 + d2, k))
				{
					int zr1 = getVr(1, r2 + 1, 1, 0, maxn / 2, false, false);
					int zr2 = getVr(r1, n + 1, 1, 0, maxn / 2, false, true);
					int next = getVr(zr1 + 1, max(r2, r1) + 1, 1, 0, maxn / 2, false, false);
					while (zr1 + 1 < max(r2, r1) + 1  &&checkr(next, k))
					{
						zr1 = next;
						next = getVr(zr1 + 1, max(r2, r1) + 1, 1, 0, maxn / 2, false, false);
					}
					next = getVr(min(r1, r2), zr2, 1, 0, maxn / 2, false, true);
					while (min(r1, r2) < zr2 && checkr(next, k))
					{
						zr2 = next;
						next = getVr(min(r1, r2), zr2, 1, 0, maxn / 2, false, true);
					}
					if (checkr(zr1, k))
						ans = min(ans, abs(d1) + abs(r1 - zr1) + abs((c1 + d1) - (c2 + d2)) + abs(r2 - zr1) + abs(d2));
					if (checkr(zr2, k))
						ans = min(ans, abs(d1) + abs(r1 - zr2) + abs((c1 + d1) - (c2 + d2)) + abs(r2 - zr2) + abs(d2));

					int zc1 = getVc(min(c1 + d1, c2 + d2), max(c1 + d1, c2 + d2) + 1, 1, 0, maxn / 2, true, false);

					if (checkc(zc1, k))
						ans = min(ans, abs(d1) + abs((c1 + d1) - (c2 + d2)) + abs(d2) + abs(r1 - r2));
				}
			}
		}
	}
	for (int d1 = -1; d1 <= 1; d1++)
	{
		if (checkr(r1 + d1, k))
		{
			for (int d2 = -1; d2 <= 1; d2++)
			{
				if (checkc(c2 + d2, k))
				{
					ans = min(ans, abs((r1 + d1) - r2) + abs(c1 - (c2 + d2)) + abs(d2) + abs(d1));
				}
			}
			for (int d2 = -1; d2 <= 1; d2++)
			{
				if (checkr(r2 + d2, k))
				{
					int zc1 = getVc(1, max(c2, c1) + 1, 1, 0, maxn / 2, false, false);
					int zc2 = getVc(min(c1, c2), m + 1, 1, 0, maxn / 2, false, true);
					int next = getVc(zc1 + 1, max(c2, c1) + 1, 1, 0, maxn / 2, false, false);
					while (zc1 + 1 < max(c2, c1) + 1 && checkc(next, k))
					{
						zc1 = next;
						next = getVc(zc1 + 1, max(c2, c1) + 1, 1, 0, maxn / 2, false, false);
					}
					next = getVc(min(c1, c2), zc2, 1, 0, maxn / 2, false, true);
					while (min(c1, c2) < zc2 && checkc(next, k))
					{
						zc2 = next;
						next = getVc(min(c1, c2), zc2, 1, 0, maxn / 2, false, true);
					}
					if (checkc(zc1, k))
						ans = min(ans, abs(d1) + abs(c1 - zc1) + abs((r1 + d1) - (r2 + d2)) + abs(c2 - zc1) + abs(d2));
					if (checkc(zc2, k))
						ans = min(ans, abs(d1) + abs(c1 - zc2) + abs((r1 + d1) - (r2 + d2)) + abs(c2 - zc2) + abs(d2));
					int zr1 = getVr(min(r1 + d1, r2 + d2), max(r1 + d1, r2 + d2) + 1, 1, 0, maxn / 2, true, false);
					if (checkr(zr1, k))
						ans = min(ans, abs(d1) + abs((r1 + d1) - (r2 + d2)) + abs(d2) + abs(c1 - c2));
				}
			}
		}
	}

	if (ans == inf)
		return -1;
	else
		return ans;
}

const int sn = 10;
const int sm = 10;
int zn[sn+2][sm+2];
int dist[sn + 2][sm + 2];
void stress()
{
	n = sn;
	m = sm;
	q = 1000;
	for (int i = 0; i < q; i++)
	{
		timer++;
		for (int r = 0; r < sn + 2; r++)
			for (int c  = 0; c < sm + 2; c++)
				zn[r][c] ++;
		int type = rnd() % 3 + 1;
		if (type == 1)
		{
			int r = rnd() % sn + 1;
			for (int c = 0; c < sm + 2; c++)
				zn[r][c] = 0;
			zeror(r, timer);
		}
		if (type == 2)
		{
			int c = rnd() % sm + 1;
			for (int r = 0; r < sn + 2; r++)
				zn[r][c] = 0;
			zeroc(c, timer);
		}
		if (type == 3)
		{
			int r1 = rnd() % sn + 1, c1 = rnd() % sm + 1, r2 = rnd() % sn + 1, c2 = rnd() % sm + 1, k = rnd() % 6 + 5;
			if (r1 == r2 && c1 == c2)
				continue;
			for (int r = 0; r < sn + 2; r++)
				for (int c = 0; c < sm + 2; c++)
					dist[r][c] = inf;
			dist[r1][c1] = 0;
			int z1 = solve(r1, c1, r2, c2, k);
			queue<pi> q;
			q.push({ r1,c1 });
			vector<pi> ways = { {0,-1}, {0,1}, {-1, 0}, {1, 0} };
			while (q.size() > 0)
			{
				pi e = q.front();
				q.pop();
				for (auto way : ways)
				{
					int nr = e.fs + way.fs;
					int nc = e.sc + way.sc;
					if (nr > 0 && nc > 0 && nr <= n && nc <= m && zn[nr][nc] <= k && zn[e.fs][e.sc] <= k && dist[nr][nc] > dist[e.fs][e.sc] + 1)
					{
						dist[nr][nc] = dist[e.fs][e.sc] + 1;
						q.push({ nr, nc });
					}
				}
			}
			int z2 = dist[r2][c2];
			if (z2 == inf)
				z2 = -1;
			if (z2 != z1)
			{
				for (int r = 1; r < sn + 1; r++)
				{
					for (int c = 1; c < sm + 1; c++)
						cout << zn[r][c] << ' ';
					cout << '\n';
				}

				cout << "\n\n";
				cout << r1 << ' ' << c1 << ' ' << r2 << ' ' << c2 << ' ' << k << '\n';
				cout << "smart = " << z1 << "\nstupid = " << z2;
				return;
			}
		}
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	#ifdef LOCAL
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif
	
	for (int i = maxn / 2; i < maxn; i++)
	{
		int pos = i - maxn / 2;
		dc[i] = { {pos, pos}, {pos, pos} };
		dr[i] = { {pos, pos}, {pos, pos} };
	}
	for (int i = maxn / 2 - 1; i > 0; i--)
	{
		updatec(i);
		updater(i);
	}
	//stress();
	//return 0;
	cin >> n >> m >> q;

	for (int i = 0; i < q; i++)
	{
		timer++;
		int type;
		cin >> type;
		if (type == 1)
		{
			int r;
			cin >> r;
			zeror(r, timer);
		}
		if (type == 2)
		{
			int c;
			cin >> c;
			zeroc(c, timer);
		}
		if (type == 3)
		{
			int r1, c1, r2, c2, k;
			
			cin >> r1 >> c1 >> r2 >> c2 >> k;

			cout << solve(r1, c1, r2, c2, k) << '\n';

			

		}
	}

}