#include <bits/stdc++.h>

using namespace std;

vector < int > r, c;

struct seg_tree {
    vector < int > mn, mx;
    vector < int > L, R;
    pair < int, int > build(int l, int r, int id, vector < int > &b) {
        if(l == r) {
            mn[id] = b[l];
            mx[id] = b[l];
            L[id] = l;
            R[id] = l;
            return {b[l], b[l]};
        }
        int m = (l + r) / 2;
        L[id] = l; R[id] = r;
        auto p1 = build(l, m, 2 * id + 1, b);
        auto p2 = build(m + 1, r, 2 * id + 2, b);
        return {min(p1.first, p2.first), max(p1.second, p2.second)};
    }
    seg_tree(int n, vector < int > &b) {
        mn.resize(5000000); mx.resize(5000000);
        L.resize(5000000); R.resize(5000000);
        build(1, n, 0, b);
    }
    void update(int p, int x, int id) {
        if(L[id] == R[id]) {
            mn[id] = mx[id] = x;
            return;
        }
        if(p > (L[id] + R[id]) / 2)
            update(p, x, 2 * id + 2);
        else
            update(p, x, 2 * id + 1);
        mn[id] = min(mn[2 * id + 1], mn[2 * id + 2]);
        mx[id] = max(mx[2 * id + 1], mx[2 * id + 2]);
        //cout << id << ' ' << mn[id] << ' ' << mx[id] << endl;
    }
    int seg_min(int l, int r, int id) {
        //cout << l << ' ' << r << ' ' << L[id] << ' ' << R[id] << ' ' << mn[id] << ' ' << id << endl;
        if(L[id] > r || R[id] < l)
            return 1e9;
        if(L[id] >= l && R[id] <= r)
            return mn[id];
        return min(seg_min(l, r, 2 * id + 1), seg_min(l, r, 2 * id + 2));
    }
    int seg_max(int l, int r, int id) {
        if(L[id] > r || R[id] < l)
            return 0;
        if(L[id] >= l && R[id] <= r)
            return mx[id];
        return max(seg_max(l, r, 2 * id + 1), seg_max(l, r, 2 * id + 2));
    }
};
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int n, m, q;
    cin >> n >> m >> q;
    r.resize(n + 1);
    c.resize(m + 1);
    seg_tree str = seg_tree(n, r);
    seg_tree stc = seg_tree(m, c);
    for(int i = 1; i <= q; i++) {
        int t; cin >> t;
        if(t == 1) {
            int cr; cin >> cr;
            str.update(cr, i, 0);
        } else if(t == 2) {
            int cc; cin >> cc;
            stc.update(cc, i, 0);
        } else {
            int r1, c1, r2, c2, k;
            cin >> r1 >> c1 >> r2 >> c2 >> k;
            k = i - k;
            if(str.seg_max(r1, r1, 0) >= k && stc.seg_max(c2, c2, 0) >= k || str.seg_max(r2, r2, 0) >= k && stc.seg_max(c1, c1, 0) >= k) {
                cout << abs(r2 - r1) + abs(c2 - c1) << '\n'; continue;
            } else if(str.seg_min(min(r1, r2), max(r1, r2), 0) >= k || stc.seg_min(min(c1, c2), max(c1, c2), 0) >= k){
                cout << abs(r2 - r1) + abs(c2 - c1) << '\n'; continue;
            }
            int R = 1e9;
            if(str.seg_max(r1, r1, 0) >= k && str.seg_max(r2, r2, 0) >= k) {
                int ll = 0, rr = max(c1, c2);
                while(rr - ll > 1) {
                    int mm = (rr + ll) / 2;
                    if(stc.seg_max(mm, rr, 0) >= k) {
                        ll = mm;
                    } else {
                        rr = mm;
                    }
                }
                swap(ll, rr);
                if(stc.seg_max(rr, rr, 0) >= k) {
                    R = abs(rr - c1) + abs(rr - c2) + abs(r1 - r2);
                }
                ll = min(c1, c2), rr = m + 1;
                while(rr - ll > 1) {
                    int mm = (rr + ll) / 2;
                    if(stc.seg_max(ll, mm, 0) >= k) {
                        rr = mm;
                    } else {
                        ll = mm;
                    }
                }
                if(stc.seg_max(ll, ll, 0) >= k) {
                    R = min(R, abs(ll - c1) + abs(ll - c2) + abs(r1 - r2));
                }
            }
            if(stc.seg_max(c1, c1, 0) >= k && stc.seg_max(c2, c2, 0) >= k) {
                int ll = 0, rr = max(r1, r2);
                while(rr - ll > 1) {
                    int mm = (rr + ll) / 2;
                    if(str.seg_max(mm, rr, 0) >= k) {
                        ll = mm;
                    } else {
                        rr = mm;
                    }
                }
                swap(ll, rr);
                if(str.seg_max(rr, rr, 0) >= k) {
                    R = min(R, abs(rr - r1) + abs(rr - r2) + abs(c1 - c2));
                }
                ll = min(r1, r2), rr = n + 1;
                while(rr - ll > 1) {
                    int mm = (rr + ll) / 2;
                    if(str.seg_max(ll, mm, 0) >= k) {
                        rr = mm;
                    } else {
                        ll = mm;
                    }
                }
                if(str.seg_max(ll, ll, 0) >= k) {
                    R = min(R, abs(ll - r1) + abs(ll - r2) + abs(c1 - c2));
                }
            }
            if(R < 1e9)
                cout << R << '\n';
            else
                cout << -1 << '\n';
        }
    }
}
