#include <cstdio>
#include <vector>
#include <queue>
#include <algorithm>

std::vector <int> topsort;
std::vector <bool> used;
void dfs(std::vector <std::vector<std::pair<int, long long>>> &g, int v) {
    used[v] = true;
    for (auto [u, d] : g[v]) {
        if (!used[u]) {
            dfs(g, u);
        }
    }
    topsort.push_back(v);
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    int t;
    scanf("%d", &t);
    for (;t;t--) {

        int n, m, q, p;
        scanf("%d%d%d%d", &n, &m, &q, &p);
        std::vector <std::vector<std::pair<int, long long>>> g(n + 1);
        std::vector <std::vector<long long>> dists(n + 1);

        for (int i = 0; i < m; i++) {
            int v, u;
            long long d;
            scanf("%d%d%lld", &v, &u, &d);
            g[v].emplace_back(u, d);
        }
        dists[1].push_back(0);
        used.clear();
        used.resize(n + 1);
        topsort.clear();
        dfs(g, 1);
        std::reverse(topsort.begin(), topsort.end());
//        for (auto v : topsort) {
//            printf("%d ", v);
//        }
//        printf("\n");
        for (auto v : topsort) {
            for (auto dist : dists[v]) {
                for (auto [u, d] : g[v]) {
                    dists[u].push_back(dist + d);
                }
            }
        }
        for (;q;q--) {
            int f;
            long long r;
            scanf("%d%lld", &f, &r);
            bool ok = false;
            for (auto dist : dists[f]) {
                double left = r;
                double right = r * (double)p / (p - 1);
                if (left <= dist && dist <= right) {
                    printf("1");
                    ok = true;
                    break;
                }
            }
            if (!ok) {
                printf("0");
            }
        }
        printf("\n");
    }
    return 0;
}
