#ifdef LCL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define vi vector<ll>
#define vvi vector<vi>
#define pll pair<ll, ll>
#define mp make_pair
#define pb push_back
#define all(v) v.begin(), v.end()
#define pas(v) cout << #v << ' ' << v << endl;
#define fi first
#define se second

struct stree {
	vi t;
	int k;
	stree (int n) {
		k = 1;
		while (k <= n) k *= 2;
		t.assign(2 * k, 0);
	};

	ll get(int l, int r) {
		ll res = 1e9;
		for (l += k, r += k; l <= r; l /= 2, r /= 2) {
			if (l % 2 == 1) res = min(res, t[l]), l++;
			if (r % 2 == 0) res = min(res, t[r]), r--;
		}
		return res;
	}

	void up(int pos, int val) {
		pos += k;
		t[pos] = val;
		pos /= 2;
		while (pos > 1) {
			t[pos] = min(t[2 * pos], t[2 * pos + 1]);
			pos /= 2;
		}
	}
};

void solve() {
	int n, m, q; cin >> n >> m >> q;
	vi hors(n, 1), vers(m, 1);
	stree sh(n), sv(m);
	stree shr(n), svr(m);
	for (int i = 0; i < n; i++) sh.up(i, 1), shr.up(i, -1);
	for (int i = 0; i < m; i++) sv.up(i, 1), svr.up(i, -1);

	auto dist = [&](ll x, ll y, ll x1, ll y1) {
		return abs(x - x1) + abs(y - y1);
	};

	for (int it = 0; it < q; it++) {
		// pas(it);
		int type; cin >> type;
		if (type == 1) {
			ll r; cin >> r; r--;
			hors[r] = -it;
			sh.up(r, -it);
			shr.up(r, it);
		} else if (type == 2) {
			ll c; cin >> c; c--;
			vers[c] = -it;
			sv.up(c, -it);
			svr.up(c, it);
		} else {
			ll r1, c1, r2, c2, k; cin >> r1 >> c1 >> r2 >> c2 >> k;
			r1--, r2--, c1--, c2--;
			k -= it;
			// pas(k);
			if (hors[r1] <= k && vers[c2] <= k) {
				cout << dist(r1, c1, r2, c2) << '\n';
			} else if (hors[r2] <= k && vers[c1] <= k) {
				cout << dist(r1, c1, r2, c2) << '\n';
			} else if (hors[r1] <= k && hors[r2] <= k) {
				if (-shr.get(min(r1, r2), max(r1, r2)) <= k) {
					cout << dist(r1, c1, r2, c2) << '\n';
					continue;
				}
				ll y1 = min(c1, c2), y2 = max(c1, c2);
				if (sv.get(y1, y2) <= k) {
					cout << dist(r1, c1, r2, c2) << '\n';
					continue;
				}

				int l = -1, r = y1;
				while (r - l > 1) {
					int mid = (l + r) / 2;
					if (sv.get(mid, y1) <= k) l = mid;
					else r = mid;
				}
				ll left_bord = l;
				l = y2, r = m;
				while (r - l > 1) {
					int mid = (l + r) / 2;
					if (sv.get(y2, mid) <= k) r = mid;
					else l = mid;
				}
				ll right_bord = r;

				if (left_bord == -1 && right_bord == m) {
					cout << -1 << '\n';
					continue;
				}
				if (left_bord == -1) left_bord = -1e9;
				if (right_bord == m) right_bord = 1e9;

				cout << dist(r1, c1, r2, c2) + min(y1 - left_bord, right_bord - y2) * 2 << '\n';	

			} else if (vers[c1] <= k && vers[c2] <= k) {
				if (-svr.get(min(c1, c2), max(c1, c2)) <= k) {
					cout << dist(r1, c1, r2, c2) << '\n';
					continue;
				}
				ll y1 = min(r1, r2), y2 = max(r1, r2);
				if (sh.get(y1, y2) <= k) {
					cout << dist(r1, c1, r2, c2) << '\n';
					continue;
				}
				int l = -1, r = y1;
				
				// cout << "YAY" << endl;
				while (r - l > 1) {
					int mid = (l + r) / 2;
					// pas(mid);
					// pas(sh.get(mid, y1));
					// pas(sh.t[mid + sh.k]);
					if (sh.get(mid, y1) <= k) l = mid;
					else r = mid;
				}
				ll left_bord = l;
				l = y2, r = n;
				while (r - l > 1) {
					int mid = (l + r) / 2;
					if (sh.get(y2, mid) <= k) r = mid;
					else l = mid;
				}
				ll right_bord = r;

				if (left_bord == -1 && right_bord == n) {
					cout << -1 << '\n';
					continue;
				}
				if (left_bord == -1) left_bord = -1e9;
				if (right_bord == n) right_bord = 1e9;

				cout << dist(r1, c1, r2, c2) + min(y1 - left_bord, right_bord - y2) * 2 << '\n';
			} else {
				cout << -1 << '\n';
			}
		}
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	solve();
	return 0;
}