#include <algorithm>
#include <iostream>
#include <vector>
#include <stack>

using ll = long long;

const int INF = 1e9;

struct Huy {
    int ind;
    int tin;
    int tout;
    Huy(): ind(0), tin(INF), tout(INF) {}
};

int n, m;
std::vector<int> a;
std::vector<Huy> gr;

int main() {
    std::ios::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);
    std::cout.precision(20);
//    freopen("input", "r", stdin);
    std::cin >> m >> n;
    a.resize(m);
    gr.resize(n);
    for (auto &i : a) {
        std::cin >> i;
        --i;
    }
    for (int i = 0; i < n; ++i) {
        gr[i].ind = i;
    }
    for (int i = 0; i < m; ++i) {
        if (gr[a[i]].tin == INF) {
            gr[a[i]].tin = i;
        }
        gr[a[i]].tout = i;
    }
    std::sort(gr.begin(), gr.end(), [&] (const Huy &a, const Huy &b) {
        return a.tin < b.tin;
    });
    while (gr.back().tin == INF) {
        gr.pop_back();
    }
//    std::stack<int> out;
//    for (int i = 0; i < gr.size(); ++i) {
//        if (out.empty()) {
//            out.push(gr[i].tout);
//            continue;
//        }
//        while (!out.empty() && gr[i].tout > out.top()) {
//            if (gr[i].tin < out.top()) {
//                std::cout << -1;
//                return 0;
//            }
//            out.pop();
//        }
//        out.push(gr[i].tout);
//    }
    std::stack<int> last;
    std::vector<int> start(n);
    for (int i = 0; i < m; ++i) {
        if (last.empty() || start[a[i]] == 0) {
            start[a[i]] += 1;
            last.push(a[i]);
            continue;
        }
        if (start[a[i]] >= 2) {
            std::cout << -1;
            return 0;
        }
        while (!last.empty() && last.top() != a[i]) {
            start[a[i]] += 1;
            last.pop();
        }
        if (last.empty()) {
            std::cout << -1;
            return 0;
        }
    }
    std::cout << gr.size() << '\n';
    for (auto i : gr) {
        std::cout << i.ind + 1 << ' ' << i.tin + 1 << ' ' << i.tout + 1 << '\n';
    }
    return 0;
}