#include <algorithm>
#include <iostream>
#include <vector>

using ll = long long;

const ll MAXD = 5264;

int n, m, q;
ll p;
std::vector<std::vector<std::pair<int, ll>>> graph;
std::vector<std::vector<char>> distance;

void dfs(int v, ll d) {
    if (d > MAXD) {
        return;
    }
    if (distance[v][d]) {
        return;
    }
    distance[v][d] = 1;
    for (auto to : graph[v]) {
        dfs(to.first, d + to.second);
    }
}

void solve() {
    graph.clear();
    distance.clear();
    std::cin >> n >> m >> q >> p;
    graph.resize(n);
    distance.resize(n, std::vector<char> (MAXD));
    for (int i = 0; i < m; ++i) {
        int u, v;
        ll d;
        std::cin >> u >> v >> d;
        --u;
        --v;
        graph[u].push_back({v, d});
    }
    dfs(0, 0);
    for (int i = 0; i < q; ++i) {
        bool fl = 1;
        int f;
        ll l;
        std::cin >> f >> l;
        --f;
        ll r = (l * p) / (p - 1);
        r = std::min(r, MAXD - 1);
        for (ll ind = l; ind <= r; ++ind) {
            if (distance[f][ind]) {
                fl = false;
                std::cout << 1;
                break;
            }
        }
        if (fl) {
            std::cout << 0;
        }
    }
    std::cout << '\n';
}

int main() {
    std::ios::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);
    std::cout.precision(20);
//    freopen("input", "r", stdin);
    int cntTests = 0;
    std::cin >> cntTests;
    while (cntTests--) {
        solve();
    }
    return 0;
}