#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <set>
#include <map>
#include <algorithm>
#include <stack>
#include <queue>
#include <iomanip>
#include <bitset>

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const ll INF_LL = 1e18;

//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("abm,mmx,avx,avx2,sse,sse2,ssse3,sse4,tune=native")

int main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	auto ti = clock();
#endif
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, m;
	cin >> n >> m;

	vector<int> v(n);
	for (int i = 0; i < n; i++) {
		cin >> v[i];
		v[i]--;
	}

	vector<int> first(m, -1);
	vector<int> last(m, -1);
	vector<int> prev(m, -1);
	vector<int> next(n, -1);

	for (int i = 0; i < n; i++) {
		if (first[v[i]] == -1)
			first[v[i]] = i;
	}
	for (int i = n - 1; i >= 0; i--) {
		if (last[v[i]] == -1)
			last[v[i]] = i;
	}

	for (int i = n - 1; i >= 0; i--) {
		next[i] = prev[v[i]];
		prev[v[i]] = i;
	}
	
	set<int> st;
	vector<int> ans;

	for (int i = 0; i < n; i++) {
		st.erase(i);
		if (i == first[v[i]]) {
			if (!st.empty() && *st.begin() < last[v[i]]) {
				cout << -1 << endl;
				return 0;
			}
		}
		if (i == last[v[i]]) {
			ans.push_back(v[i]);
		}

		if (next[i] != -1)
			st.insert(next[i]);
	}

	reverse(ans.begin(), ans.end());

	cout << ans.size() << endl;
	for (int i : ans)
		cout << i + 1 << ' ' << first[i] + 1 << ' ' << last[i] + 1 << endl;

#ifdef LOCAL
	cout << "\nExecuted in "
		<< fixed << setprecision(5) << (ld)(clock() - ti) / (ld)CLOCKS_PER_SEC << " seconds" << endl;
#endif
	return 0;
}