#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <set>
#include <map>
#include <algorithm>
#include <stack>
#include <queue>
#include <iomanip>
#include <bitset>
#include <cmath>

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const ll INF_LL = 1e18;
const int MAX_R = 10010;

const int dx[] = { 1, -1, 0, 0 };
const int dy[] = {0, 0, 1, -1};

//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("abm,mmx,avx,avx2,sse,sse2,ssse3,sse4,tune=native")

int main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	auto ti = clock();
#endif
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, m, q;
	cin >> n >> m >> q;

	vector<vector<int>> f(n, vector<int>(m, 0));

	while (q--) {
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++)
				f[i][j]++;
		}

		int t;
		cin >> t;
		if (t == 1) {
			int r;
			cin >> r;
			r--;
			for (int i = 0; i < m; i++)
				f[r][i] = 0;
		}
		else if (t == 2) {
			int c;
			cin >> c;
			c--;
			for (int i = 0; i < n; i++)
				f[i][c] = 0;
		}
		else {
			int r1, c1, r2, c2, k;
			cin >> r1 >> c1 >> r2 >> c2 >> k;

			r1--, r2--, c1--, c2--;

			if (f[r2][c2] > k) {
				cout << -1 << endl;
				continue;
			}

			vector<vector<int>> dist(n, vector<int>(m, INF));
			queue<pair<int, int>> qu;
			qu.push({r1, c1});
			dist[r1][c1] = 0;
			while (!qu.empty()) {
				auto v = qu.front();
				qu.pop();
				//cout << "! " << v.first << ' ' << v.second << endl;
				if (f[v.first][v.second] > k)
					continue;

				for (int i = 0; i < 4; i++) {
					int a = v.first + dx[i], b = v.second + dy[i];
					if (a < 0 || b < 0)
						continue;
					if (a >= n || b >= m)
						continue;

					if (dist[a][b] > dist[v.first][v.second] + 1) {
						dist[a][b] = dist[v.first][v.second] + 1;
						qu.push({a, b});
					}
				}
			}

			if (dist[r2][c2] != INF)
				cout << dist[r2][c2] << '\n';
			else
				cout << -1 << "\n";

			//cout << "-------------\n";
		}
	}

#ifdef LOCAL
	cout << "\nExecuted in "
		<< fixed << setprecision(5) << (ld)(clock() - ti) / (ld)CLOCKS_PER_SEC << " seconds" << endl;
#endif
	return 0;
}