// #pragma GCC optimize("I_l_N_M")
//#pragma GCC optimize("Ofast,unroll-loops")

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair <int, int> pii;

#define f first
#define s second
#define add push_back
#define sz(x) (int)(x).size()

const ll INF = (ll)1e9 + 2019;

const int N = 1e6 + 10;
int rr[N], cc[N];

int dist(int r1, int c1, int r2, int c2) {
	return abs(r1 - r2) + abs(c1 - c2);
}

bool checkC(int c1, int c2, int v) {
	int mn = INF;
	for (int i = min(c1, c2); i <= max(c1, c2); i++) {
		mn = min(mn, cc[i]);
	}
	return mn >= v;
}

bool checkR(int r1, int r2, int v) {
	int mn = INF;
	for (int i = min(r1, r2); i <= max(r1, r2); i++) {
		mn = min(mn, rr[i]);
	}
	return mn >= v;
}

bool betwC(int c1, int c2, int v) {
	int mx = -INF;
	for (int i = min(c1, c2); i <= max(c1, c2); i++) {
		mx = max(mx, cc[i]);
	}
	return mx >= v;
}

bool betwR(int r1, int r2, int v) {
	int mx = -INF;
	for (int i = min(r1, r2); i <= max(r1, r2); i++) {
		mx = max(mx, rr[i]);
	}
	return mx >= v;
}

int getLC(int c, int m, int v) {
	for (int i = c; i > 0; i--) {
		if (cc[i] >= v) {
			return i;
		}
	}
	return -INF;
}

int getRC(int c, int m, int v) {
	for (int i = c; i <= m; i++) {
		if (cc[i] >= v) {
			return i;
		}
	}
	return INF;
}

int getUR(int r, int n, int v) {
	for (int i = r; i > 0; i--) {
		if (rr[i] >= v) {
			return i;
		}
	}
	return -INF;
}

int getDR(int r, int n, int v) {
	for (int i = r; i <= n; i++) {
		if (rr[i] >= v) {
			return i;
		}
	}
	return INF;
}

int query(int n, int m, int r1, int c1, int r2, int c2, int k, int tt) {
	int v = tt - k;
	if ((rr[r1] < v && cc[c1] < v) || (rr[r2] < v && cc[c2] < v)) {
		return -1;
	}
	if (checkR(r1, r2, v) || checkC(c1, c2, v)) {
		return dist(r1, c1, r2, c2);
	}
	int ans = INF;
	if (rr[r1] >= v || rr[r2] >= v) {
		if (betwC(c1, c2, v)) {
			ans = min(ans, dist(r1, c1, r2, c2));
		} else {
			int l = getLC(min(c1, c2), m, v), r = getRC(max(c1, c2), m, v);
			ans = min(ans, abs(r1 - r2) + abs(c1 - l) + abs(c2 - l));
			ans = min(ans, abs(r1 - r2) + abs(c1 - r) + abs(c2 - r));
		}
	}
	if (cc[c1] >= v || cc[c2] >= v) {
		if (betwR(r1, r2, v)) {
			ans = min(ans, dist(r1, c1, r2, c2));
		} else {
			int u = getUR(min(r1, r2), n, v), d = getDR(max(r1, r2), n, v);
			ans = min(ans, abs(c1 - c2) + abs(r1 - u) + abs(r2 - u));
			ans = min(ans, abs(c1 - c2) + abs(r1 - d) + abs(r2 - d));
		}
	}
	if (ans == INF) {
		ans = -1;
	}
	return ans;
}

void mane() {
	int n, m, q;
	cin >> n >> m >> q;
	for (int i = 1; i <= q; i++) {
		int t;
		cin >> t;
		if (t == 1) {
			int r;
			cin >> r;
			rr[r] = i;
		}
		if (t == 2) {
			int c;
			cin >> c;
			cc[c] = i;
		}
		if (t == 3) {
			int r1, c1, r2, c2, k;
			cin >> r1 >> c1 >> r2 >> c2 >> k;
			cout << query(n, m, r1, c1, r2, c2, k, i) << "\n";
		}
	}
}

int main() {
	ios::sync_with_stdio(0);
#ifdef osss
	freopen("input.txt", "r", stdin);
#endif
	mane();
}
