#include <bits/stdc++.h>

using namespace std;

#define int long long

const int bl = 10;
const int cnt = 10;

int a2[cnt][bl];
int b2[cnt][bl];

vector<int> a(bl * cnt);
vector<int> b(bl * cnt);

int a_get_max(int l, int r) {
    int res = -1e9;
    while (l <= r && l % bl != 0)
        res = max(res, a[l++]);
    while ((r + 1) % bl != 0 && l <= r)
        res = max(res, a[r--]);
    if (l > r) return res;
    l /= bl;
    r /= bl;
    for (int i = l; i <= r; ++i)
        res = max(res, a2[i][bl - 1]);
    return res;
}

int b_get_max(int l, int r) {
    int res = -1e9;
    while (l <= r && l % bl != 0)
        res = max(res, b[l++]);
    while ((r + 1) % bl != 0 && l <= r)
        res = max(res, b[r--]);
    if (l > r) return res;
    l /= bl;
    r /= bl;
    for (int i = l; i <= r; ++i)
        res = max(res, b2[i][bl - 1]);
    return res;
}

int a_get_min(int l, int r) {
    int res = 1e9;
    while (l <= r && l % bl != 0)
        res = min(res, a[l++]);
    while ((r + 1) % bl != 0 && l <= r)
        res = min(res, a[r--]);
    if (l > r) return res;
    l /= bl;
    r /= bl;
    for (int i = l; i <= r; ++i)
        res = min(res, a2[i][0]);
    return res;
}

int b_get_min(int l, int r) {
    int res = 1e9;
    while (l <= r && l % bl != 0)
        res = min(res, b[l++]);
    while ((r + 1) % bl != 0 && l <= r)
        res = min(res, b[r--]);
    if (l > r) return res;
    l /= bl;
    r /= bl;
    for (int i = l; i <= r; ++i)
        res = min(res, b2[i][0]);
    return res;
}

void a_relax(int x) {
    for (int i = 0; i < bl; ++i)
        a2[x][i] = a[x * bl + i];
    sort(a2[x], a2[x] + bl);
}

void b_relax(int x) {
    for (int i = 0; i < bl; ++i)
        b2[x][i] = b[x * bl + i];
    sort(b2[x], b2[x] + bl);
}

int a_get_right(int r, int k) {
    int l = 0;
    while ((r + 1) % bl != 0)
        if (a[r] <= k) return r;
        else --r;
    r /= bl;
    for (int i = r; i >= l; --i)
        if (a2[i][0] <= k)
        {
            for (int j = (i + 1) * bl - 1; j >= i * bl; --j)
                if (a[j] <= k) return j;
        }
    return -1;
}

int a_get_left(int l, int k) {
    int r = cnt - 1;
    while (l % bl != 0)
        if (a[l] <= k) return l;
        else ++l;
    l /= bl;
    for (int i = l; i <= r; ++i)
        if (a2[i][0] <= k)
        {
            for (int j = i * bl; j <= (i + 1) * bl - 1; ++j)
                if (a[j] <= k) return j;
        }
    return -1;
}


int b_get_right(int r, int k) {
    int l = 0;
    while ((r + 1) % bl != 0 && l <= r)
        if (b[r] <= k) return r;
        else --r;
    if (r == -1) return -1;
    r /= bl;
    for (int i = r; i >= l; --i)
        if (b2[i][0] <= k)
        {
            for (int j = (i + 1) * bl - 1; j >= i * bl; --j)
            {
                if (b[j] <= k) return j;
            }
        }
    return -1;
}


int b_get_left(int l, int k) {
    int r = cnt - 1;
    while (l % bl != 0)
        if (b[l] <= k) return l;
        else ++l;
    l /= bl;
    for (int i = l; i <= r; ++i)
        if (b2[i][0] <= k)
        {
            for (int j = i * bl; j <= (i + 1) * bl - 1; ++j)
                if (b[j] <= k) return j;
        }
    return -1;
}

signed main() // bl -> 10000
{
    for (int i = 0; i < cnt; ++i)
    for (int j = 0; j < bl; ++j)
    {
        a2[i][j] = 0;
        b2[i][j] = 0;
    }
    int n, m, q;
    cin >> n >> m >> q;
    for (int i = 0; i < q; ++i)
    {
        int type;
        cin >> type;
        if (type == 1)
        {
            int x;
            cin >> x;
            --x;
            a[x] = - i - 1;
            a_relax(x / bl);
        }
        else if (type == 2)
        {
            int x;
            cin >> x;
            --x;
            b[x] = - i - 1;
            b_relax(x / bl);
        }
        else
        {
            int x1, y1, x2, y2, k;
            cin >> x1 >> y1 >> x2 >> y2 >> k;
            --x1;
            --x2;
            --y1;
            --y2;
            k -= i + 1;
            bool flag = true;
            if (x1 > x2)
            {
                swap(x1, x2);
                swap(y1, y2);
            }
            if (a_get_max(x1, x2) > k) flag = false;
            if (flag)
            {
                cout << abs(x2 - x1) + abs(y2 - y1) << endl;
                continue;
            }
            flag = true;
            if (y1 > y2)
            {
                swap(x1, x2);
                swap(y1, y2);
            }
            if (b_get_max(y1, y2) > k) flag = false;
            if (flag)
            {
                cout << abs(x2 - x1) + abs(y2 - y1) << endl;
                continue;
            }
            if (a[x1] <= k && b[y2] <= k)
            {
                cout << abs(x2 - x1) + abs(y2 - y1) << endl;
                continue;
            }
            if (a[x2] <= k && b[y1] <= k)
            {
                cout << abs(x2 - x1) + abs(y2 - y1) << endl;
                continue;
            }
            if (y1 > y2)
            {
                swap(x1, x2);
                swap(y1, y2);
            }

            int ans = 1e9;
            if (a[x1] <= k && a[x2] <= k)
            {
                int f1 = b_get_right(y1, k);
                int f2 = b_get_left(y2, k);
                if (b_get_min(y1, y2) <= k) ans = min(ans, abs(x1 - x2) + abs(y1 - y2));
                if (f1 != -1) ans = min(ans, abs(x1 - x2) + y1 + y2 - 2 * f1);
                if (f2 != -1) ans = min(ans, abs(x1 - x2) + 2 * f1 - y1 - y2);
                for (int j = 0; j < m; ++j)
                {
                    if (b[j] <= k)
                    {
                        if (j <= y1) ans = min(ans, abs(x1 - x2) + y1 + y2 - 2 * j);
                        //if (y2 <= j) ans = min(ans, j * 2 - y1 - y2 + abs(x1 - x2));
                        //if (y1 <= j && j <= y2) ans = min(ans, abs(x1 - x2) + abs(y1 - y2));
                    }
                }
            }

            if (x1 > x2)
            {
                swap(x1, x2);
                swap(y1, y2);
            }

            if (b[y1] <= k && b[y2] <= k)
            {
                for (int j = 0; j < n; ++j)
                    if (a[j] <= k)
                        ans = min(ans, abs(x1 - j) + abs(x2 - j) + abs(y1 - y2));
            }
            if (ans == 1e9) ans = -1;
            cout << ans << endl;
        }
    }
}
