#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <queue>
#include <set>
#include <map>
#include <stack>
#include <bitset>
#include <algorithm>
#include <cmath>
#include <ctime>
#include <cstring>
#include <chrono>
#include <random>

using namespace std;

#define int long long
#define sz(a) (int)(a.size())
#define pb emplace_back

void fast_io() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
}

const int MAXN = 5e3 + 228;
vector<pair<int, int>> graph[MAXN];
int p;
bitset<10000> can[MAXN];
int inside[MAXN];

void bfs() {
	queue<int> q;
	q.push(0);
	can[0][0] = 1;
	while (sz(q)) {
		int v = q.front();
		q.pop();
		for (auto u : graph[v]) {
			can[u.first] |= (can[v] << u.second);
			inside[u.first]--;
			if (!inside[u.first]) {
				q.push(u.first);
			}
		}
	}
}


signed main() {
	fast_io();
	int test;
	cin >> test;
	for (int t = 0; t < test; t++) {
		fill(graph, graph + MAXN, vector<pair<int, int>>(0));
		memset(can, 0, sizeof can);
		string ans;
		int n, m, q;
		cin >> n >> m >> q >> p;
		for (int i = 0; i < m; i++) {
			int u, v, d;
			cin >> u >> v >> d;
			u--;
			v--;
			if (u > v) swap(u, v);
			graph[u].pb(make_pair(v, d));
			inside[v]++;
		}
		bfs();
		for (int i = 0; i < q; i++) {
			int f, r;
			cin >> f >> r;
			f--;
			bool fl = 0;
			for (int j = r; j * (p - 1) <= (p * r); j++) {
				if (can[f][j]) {
					fl = 1;
					break;
				}
			}
			ans += ('0' + fl);
		}
		cout << ans << '\n';
	}
	return 0;
}