#include <bits/stdc++.h>

using namespace std;

#define f first
#define s second

const long long INF = 1e18 + 1;

void Dijkstra(vector<long long> &dist,  vector<vector<pair<int, long long>>> &graph){
    int n = graph.size();
    vector<bool> used(n);
    priority_queue<pair<long long, int>> q;
    q.push({0, 0});
    dist[0] = 0;
    int curr;
    long long d;
    while(!q.empty()){
        d = -q.top().f; curr = q.top().s;
        q.pop();
        if (used[curr])
            continue;
        used[curr] = true;
        for (auto edge : graph[curr]){
            if (dist[edge.f] > d + edge.s){
                dist[edge.f] = d + edge.s;
                q.push({-dist[edge.f], edge.f});
            }
        }
    }
}

void solution(){
    int n, m, q, p;
    cin >> n >> m >> q >> p;
    vector<vector<pair<int, long long>>> graph(n);
    int a, b, w;
    for (int i = 0; i < m; i++){
        cin >> a >> b >> w;
        a--; b--;
        graph[a].push_back({b, w});
    }
    vector<long long> dist(n, INF);
    Dijkstra(dist, graph);
    string str;
    int to;
    long long r, curr;
    for (int i = 0; i < q; i++){
        cin >> to >> r;
        to--;
        curr = dist[to];
        //cout << "---- " << i << ": " << to << " " << r << endl;
        if (r <= curr && curr * (p - 1) <= p * r)
            str += '1';
        else
            str += '0';
    }
//    cout << "dist:\n";
//    for (long long el : dist)
//        cout << el << " ";
//    cout << "\nans: \n";
    cout << str << "\n";
}

int main(){
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    freopen("in2.txt", "r", stdin);
    int tests;
    cin >> tests;
    for (int i = 0; i < tests; i++)
        solution();
    return 0;
}