#include <iostream>
#include <vector>
#include <algorithm>
#include <assert.h>
#include <cassert>

using namespace std;

struct go
{
	int c, l, r;
};

const int sz = 3e5 + 5;
int tree[4 * sz], mod[4 * sz];

void push(int v, int l, int r)
{
	if (l + 1 == r)
	{
		if (mod[v])
			tree[v] = mod[v];
		mod[v] = 0;
		return;
	}
	if (mod[v])
	{
		mod[2 * v] = mod[v];
		mod[2 * v + 1] = mod[v];
	}
	tree[v] = mod[v];
	mod[v] = 0;
}

int get(int v, int l, int r, int pl)
{
	push(v, l, r);
	if (l + 1 == r)
	{
		return tree[v];
	}
	int m = (l + r) / 2;
	if (pl < m)
		return get(2 * v, l, m, pl);
	else
		return get(2 * v + 1, m, r, pl);
}

void upd(int v, int l, int r, int L, int R, int col)
{
	push(v, l, r);
	if (L <= l && r <= R)
	{
		mod[v] = col;
		return;
	}
	else if (l >= R || r <= L)
		return;
	else
	{
		//push(v, l, r);
		int m = (l + r) / 2;
		upd(2 * v, l, m, L, R, col);
		upd(2 * v + 1, m, r, L, R, col);
	}
}

signed main()
{
	for (int i = 0; i < 4 * sz; i++)
		tree[i] = 0, mod[i] = 0;
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int m, n;
	cin >> m >> n;
	vector<int> a(m);
	for (int& i : a)
		cin >> i;
	vector<int> arr(n + 1, -1);
	for (int i = 0; i < m; i++)
	{
		arr[a[i]] = i;
	}
	vector<bool> used(n + 1, false);
	int col = 0, last = -1;
	for (int i = 0; i < m; i++)
	{
		int col = get(1, 0, sz, i);
		if (used[a[i]] && col != a[i])
		{
			cout << -1;
			return 0;
		}
		used[a[i]] = true;
		upd(1, 0, sz, i, arr[a[i]] + 1, a[i]);
		
	}
	vector<go> ans;
	used.assign(n + 1, false);
	for (int i = 0; i < m; i++)
	{
		if (!used[a[i]])
		{
			ans.push_back({ a[i], i + 1, arr[a[i]] + 1 });
			used[a[i]] = true;
		}
	}
	cout << ans.size() << '\n';
	for (go i : ans)
	{
		cout << i.c << " " << i.l << " " << i.r << '\n';
	}
	return 0;
}