#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#define int long long 

using namespace std;

struct go
{
	int to, w;
};

vector<vector<go>> g, r_g;
vector<vector<int>> dp;
vector<int> top;
vector<bool> used;

void dfs(int v)
{
	used[v] = true;
	for (go e : g[v])
	{
		if (!used[e.to])
			dfs(e.to);
	}
	top.push_back(v);
}

void solve()
{
	int n, m, q, p;
	cin >> n >> m >> q >> p;
	dp.clear();
	dp.resize(n);
	g.clear();
	g.resize(n);
	r_g.clear();
	r_g.resize(n);
	top.clear();
	used.clear();
	used.resize(n, false);
	for (int i = 0; i < m; i++)
	{
		int u, v, w;
		cin >> u >> v >> w;
		g[--u].push_back({ --v, w });
		r_g[v].push_back({ u, w });
	}
	dfs(0);
	dp[0].push_back(0);
	reverse(top.begin(), top.end());
	for (int i = 0; i < n; i++)
	{
		for (go e : r_g[i])
		{
			for (int ws : dp[e.to])
				dp[i].push_back(ws + e.w);
		}
	}
	string ans;
	for (int i = 0; i < q; i++)
	{
		int f, r;
		cin >> f >> r;
		--f;
		bool can = false;
		for (int i : dp[f])
		{
			if (r <= i && i * (p - 1) <= p * r)
				can = true;
		}
		if (can)
			ans += '1';
		else
			ans += '0';
	}
	cout << ans << '\n';
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int t;
	cin >> t;
	for (int i = 0; i < t; i++)
	{
		solve();
	}
	return 0;
}