#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>
#include <queue>
#include <set>
#include <cmath>

//#define DEBUG

using namespace std;

vector <int> tree;

const int INF = 1e9;

int get_min(int v, int vL, int vR, int L, int R) {
	if (L <= vL && vR <= R) return tree[v];
	if (R <= vL || vR <= L) return INF;
	int vM = (vL + vR) / 2;
	return min(get_min(2 * v, vL, vM, L, R), get_min(2 * v + 1, vM, vR, L, R));
}

void update(int v, int vL, int vR, int ind, int x) {
	if (ind < vL || vR <= ind) return;
	if (vL + 1 >= vR) {
		tree[v] = x;
		return;
	}
	int vM = (vL + vR) / 2;
	update(2 * v, vL, vM, ind, x);
	update(2 * v + 1, vM, vR, ind, x);
	tree[v] = min(tree[2 * v], tree[2 * v + 1]);
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, m, q;
	cin >> n >> m >> q;
	tree.resize(4 * n, -1);
	for (int i = 0; i < q; i++) {
		int type;
		cin >> type;
		if (type == 1) {
			int r;
			cin >> r;
			update(1, 0, n, r - 1, i);
		}
		if (type == 3) {
			int x1, x2, y1, y2, k;
			cin >> x1 >> y1 >> x2 >> y2 >> k;
			x1--, x2--, y1--, y2--;
			if (get_min(1, 0, n, min(x1, x2), max(x1, x2) + 1) + k >= i) {
				cout << abs(x1 - x2) + abs(y1 - y2) << '\n';
			}
			else {
				cout << -1 << '\n';
			}
		}
	}

#ifdef DEBUG
	system("Pause");
#endif // DEBUG
}