#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <queue>

using namespace std;

void init(){
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
}

#define vi vector<int>
#define vvi vector<vi>
#define pb push_back
#define printvi(arr) for (int x: arr) cout << x << " "; cout << endl;
#define myreverse(arr) reverse(arr.begin(), arr.end())
#define pii pair<int, int>
#define vpii vector<pii>
#define vb vector<bool>
#define vvb vector<vb>
#define F first
#define S second

const int maxn = 1024 * 1024;
const int inf = 2 * 1024 * 1024 * 1023 - 1;

int n, m;
int r1, c1, r2, c2, k;


int main() {
    init();
    int q;
    cin >> n >> m >> q;
    int k = 0;
    vvi Q(q);
    for (int i = 0; i < q; ++i){
        int z;
        cin >> z;
        Q[i].pb(z);
        if (z == 1 || z == 2){
            cin >> z;
            Q[i].pb(z);
        } else {
            for (int j = 0; j < 5; ++j){
                int y;
                cin >> y;
                y--;
                Q[i].pb(y);
            }
            k = Q[i].back() + 1;
        }
    }
    vb usedr(n), usedc(m);
    set<int> ir, ic;
    for (int i = 0; i < q; ++i){
        if (i > k){
            int j = i - k - 1;
            if (Q[j][0] == 1){
                usedr[Q[j][1]] = 0;
                ir.erase(Q[j][1]);
            }
            if (Q[j][0] == 2){
                usedc[Q[j][1]] = 0;
                ic.erase(Q[j][1]);
            }
        }
        if (Q[i][0] == 1){
            usedr[Q[i][1]] = 1;
            ir.insert(Q[i][1]);
        }
        if (Q[i][0] == 2){
            usedc[Q[i][1]] = 1;
            ic.insert(Q[i][1]);
        }
        if (Q[i][0] == 3){
            r1 = Q[i][1], c1 = Q[i][2], r2 = Q[i][3], c2 = Q[i][4];
            if (k >= i){
                cout << abs(r1 - r2) + abs(c1 - c2) << endl;
                continue;
            }
            if (r1 == r2 && usedr[r1]){
                cout << abs(c1 - c2) << endl;
                continue;
            }
            if (c1 == c2 && usedc[c1]){
                cout << abs(r1 - r2) << endl;
                continue;
            }
            if ((usedr[r1] && usedc[c2]) || (usedr[r2] && usedc[c1])){
                cout << abs(r1 - r2) + abs(c1 - c2) << endl;
                continue;
            }
            bool flag1 = 1, flag2 = 1;
            for (int j = min(r1, r2); j <= max(r1, r2); ++j){
                if (!usedr[j]){
                    flag1 = 0;
                    break;
                }
            }
            for (int j = min(c1, c2); j <= max(c1, c2); ++j){
                if (!usedc[j]){
                    flag2 = 0;
                    break;
                }
            }
            if (flag1 || flag2){
                cout << abs(r1 - r2) + abs(c1 - c2) << endl;
                continue;
            }
            if (usedr[r1] && usedr[r2]){
                int ans = inf;
                for (int c: ic){
                    int d = abs(r1 - r2) + abs(c1 - c) + abs(c2 - c);
                    ans = min(ans, d);
                }
                if (ans != inf) {
                    cout << ans << endl;
                    continue;
                }
            }
            if (usedc[c1] && usedc[c2]){
                int ans = inf;
                for (int r: ir){
                    int d = abs(c1 - c2) + abs(r1 - r) + abs(r2 - r);
                    ans = min(ans, d);
                }
                if (ans != inf) {
                    cout << ans << endl;
                    continue;
                }
            }
            cout << -1 << endl;
        }
    }
    return 0;
}
