#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <queue>

using namespace std;

void init(){
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
}

#define vi vector<int>
#define vvi vector<vi>
#define pb push_back
#define printvi(arr) for (int x: arr) cout << x << " "; cout << endl;
#define myreverse(arr) reverse(arr.begin(), arr.end())
#define pii pair<int, int>
#define vpii vector<pii>
#define vb vector<bool>
#define vvb vector<vb>
#define F first
#define S second
#define ll long long
#define pll pair<ll, ll>
#define vpll vector<pll>
#define vvpll vector<vpll>
#define vll vector<ll>
#define vvll vector<vll>

const int maxn = 3e5 + 2;
const int inf = 2 * 1024 * 1024 * 1023 - 1;
const ll inf1 = inf;
const ll INF = inf1 * inf1;

void solve(){
    int n, m, q;
    ll p;
    cin >> n >> m >> q >> p;
    vvpll g(n);
    vvll e(m, vll(3));
    for (int i = 0; i < m; ++i){
        int v, u;
        ll d;
        cin >> v >> u >> d;
        v--, u--;
        e[i][0] = v, e[i][1] = u, e[i][2] = d;
        g[v].pb({u, d});
        g[u].pb({v, d});
    }
    sort(e.begin(), e.end());
    cout << endl;
    if (n <= 10){
        vi pw(12);
        pw[0] = 1;
        for (int i = 1; i < 12; ++i) pw[i] = 2 * pw[i - 1];
        string ans = "";
        for (int i = 0; i < q; ++i){
            int to;
            ll D;
            cin >> to >> D;
            ll D1 = D * p / (p - 1);
            to--;
            bool flag = 0;
            for (int mask = 0; mask < (1 << m); ++mask){
                vi idx;
                for (int j = 0; j < 12; ++j){
                    if ((mask & pw[j]) > 0){
                        idx.pb(j);
                    }
                }
                if (idx.empty()) continue;
                if (e[idx[0]][0] != 0) continue;
                if (e[idx.back()][1] != to) continue;
                ll sum = e[idx[0]][2];
                for (int j = 1; j < idx.size(); ++j){
                    if (e[idx[j]][0] != e[idx[j - 1]][1]){
                        sum = -1;
                        break;
                    }
                    sum += e[idx[j]][2];
                    if (e[idx[j]][2] == to) break;
                }
                if (sum == -1) continue;
                if (D <= sum && sum <= D1){
                    ans += "1";
                    flag = 1;
                    break;
                }
            }
            if (!flag) ans += "0";
        }
        cout << ans << endl;
        return;
    }
}

int main() {
    init();
    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) solve();
    return 0;
}
/*
 2
 3 3 5 20
 1 2 20
 2 3 1
 1 3 10
 2 19
 2 20
 3 20
 3 21
 3 9
 7 10 5 5
 1 2 15
 1 3 10
 2 4 21
 3 4 30
 2 5 14
 3 5 31
 4 6 3
 5 6 14
 1 7 39
 5 7 13
 7 42
 7 43
 7 44
 5 39
 6 44
 */
