#include <bits/stdc++.h>

using namespace std;

#define len(x) (int)x.size()
#define pb push_back()
#define all(x) x.begin(), x.end()

const int MAXN = 1e6 + 100, inf = 1e9;

int a[MAXN], b[MAXN], sz = (1 << 20);

pair <int, int> treex[MAXN * 4], treey[MAXN * 4];

void updX(int v)
{
    if (v >= sz)
        return;
    treex[v].first = max(treex[v*2].first, treex[v*2+1].first);
    treex[v].second = min(treex[v*2].second, treex[v*2+1].second);
}

void updY(int v)
{

    if (v >= sz)
        return;
    treey[v].first = max(treey[v*2].first, treey[v*2+1].first);
    treey[v].second = min(treey[v*2].second, treey[v*2+1].second);
}

void addX(int v, int x)
{
    v += sz - 1;
    treex[v] = {x, x};
    v /= 2;
    while (v)
    {
        updX(v);
        v /= 2;
    }
}

void addY(int v, int x)
{
    v += sz - 1;
    treey[v] = {x, x};
    v /= 2;
    while (v)
    {
        updY(v);
        v /= 2;
    }
}

pair <int, int> getY(int v, int tl, int tr, int l, int r)
{
    if (r < tl || l > tr)
        return {0, 1e9};
    if (tl == l && tr == r)
    {
        return treey[v];
    }
    int tm = (tl + tr) / 2;
    pair <int, int> a = getY(v*2, tl, tm, l, min(r, tm)), b = getY(v*2+1, tm+1, tr, max(tm+1, l), r);
    return {max(a.first, b.first), min(a.second, b.second)};
}

pair <int, int> getX(int v, int tl, int tr, int l, int r)
{
    if (r < tl || l > tr)
        return {0, 1e9};
    if (tl == l && tr == r)
    {
        return treex[v];
    }
    int tm = (tl + tr) / 2;
    pair <int, int> a = getX(v*2, tl, tm, l, min(r, tm)), b = getX(v*2+1, tm+1, tr, max(tm+1, l), r);
    return {max(a.first, b.first), min(a.second, b.second)};
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "r", stdout);
    int n, m, q;
    cin >> n >> m >> q;
    for (int e = 1; e <= q; e++)
    {
        int k;
        cin >> k;
        if (k == 1)
        {
            int x;
            cin >> x;
            addX(x, e);
            a[x] = e;
        }
        if (k == 2)
        {
            int x;
            cin >> x;
            addY(x, e);
            b[x] = e;
        }
        if (k == 3) {
            int x0, y0, x, y;
            cin >> x0 >> y0 >> x >> y >> k;
            int f = 1e9, g = 1e9, mnx = abs(x - x0) + abs(y - y0);
            f = getX(1, 1, sz, min(x, x0), max(x, x0)).second;
            g = getY(1, 1, sz, min(y, y0), max(y, y0)).second;
            // до на минимум
            if ((e - f) <= k || (e - g) <= k) {
                cout << mnx << endl;
                continue;
            }
            if ((e - a[x0]) <= k && (e - b[y]) <= k)
            {
                cout << mnx << endl;
                continue;
            }
            if ((e - b[y0]) <= k && (e - a[x]) <= k)
            {
                cout << mnx << endl;
                continue;
            }

            int ans = inf;

            if (e - b[y] <= k && e - b[y0] <= k)
            {

                /*for (int i = x0; i <= n; i++) {
                    int flex = abs(x0 - i) + abs(x - i) + abs(y - y0);
                    if ((e - a[i]) <= k) {
                        ans = min(ans, flex);
                    }
                }

                for (int i = x0; i >= 1; i--) {
                    int flex = abs(x0 - i) + abs(x - i) + abs(y - y0);
                    if ((e - a[i]) <= k) {
                        ans = min(ans, flex);
                    }
                }*/
                int l = x0+1, r = n;
                while (l <= r)
                {
                    int mid = (l + r) /2;
                    int t = getX(1, 1, sz, l, mid).first;
                    if (e - t <= k)
                    {
                        r = mid - 1;
                        ans = min(ans, abs(x0 - mid) + abs(x - mid) + abs(y0 - y));
                    } else
                        l = mid + 1;
                }
                l = 1, r = x0 - 1;
                while (l <= r) {
                    int mid = (l + r) / 2;
                    int t = getX(1, 1, sz, l, mid).first;
                    if (e - t <= k)
                    {
                        l = mid + 1;
                        ans = min(ans, abs(x0 - mid) + abs(x - mid) + abs(y - y0));
                    } else
                    {
                        r = mid - 1;
                    }
                }
            }
            if (e - a[x] <= k && e - a[x0] <= k)
            {
                for (int i = y0; i <= m; i++) {
                    int flex = abs(y0 - i) + abs(i - y) + abs(x - x0);
                    if ((e - b[i]) <= k) {
                        ans = min(ans, flex);
                    }
                }
                for (int i = y0; i >= 1; i--) {
                    int flex = abs(y0 - i) + abs(i - y) + abs(x - x0);
                    if ((e - b[i]) <= k) {
                        ans = min(ans, flex);
                    }
                }
            }
            if (ans == inf)
                cout << -1 << endl;
            else
                cout << ans << endl;
        }
    }
    return 0;
}