#pragma GCC optimize("Ofast")

#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES

#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <fstream>
#include <iomanip>
#include <bitset>
#include <random>

using namespace std;

#define X first
#define Y second
#define mp make_pair
#define all(x) x.begin(), x.end()
#define all_(x) x.rbegin(), x.rend()
#define multi_test 0

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;

const ll INF = 1e9 + 9;
const ll MAXN = 3e5 + 7;
const ll MAXN1 = 1 << 11;
const ll MAXN2 = 1e6 + 7;
const ll MOD = 1e9 + 7;
const ll PW = 239;
const ll BLOCK = 316;

void solve();
mt19937 mt(1e9 + 7);

signed main() {
	srand('a' + 'l' + 'e' + 'x' + 'X' + '5' + '1' + '2');
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
#define MAXN 5000
#define MAXN2 10000
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int q = 1;
	if (multi_test) cin >> q;
	while (q--) solve();
}

/*-----------------------------------------------------------------------------------------------------------------------------*/

struct Fv {
	set<int> fv[MAXN + 1];
	void build(int n) {
		for (int i = MAXN; i <= MAXN; ++i) {
			for (int j = 1; j <= n; ++j) {
				fv[i].emplace(j);
			}
		}
	}
	void add(int x, int t) {
		for (; x <= MAXN; x |= x + 1) {
			fv[x].emplace(t);
		}
	}
	void del(int x, int t) {
		for (; x <= MAXN; x |= x + 1) {
			fv[x].erase(t);
		}
	}
	pair<int, pii> get(int x, int l, int r) {
		if (l > r) swap(l, r);
		int left = -1, mid = -1, right = -1;
		for (; x >= 0; x &= x + 1, --x) {
			auto p = fv[x].lower_bound(l);
			if (p != fv[x].end() && *p >= l && *p <= r) mid = *p;
			if (p != fv[x].begin()) {
				--p;
				if (left == -1 || left < *p) left = *p;
			}
			p = fv[x].lower_bound(r);
			if (p != fv[x].end() && (right == -1 || right > *p));
		}
		return mp(left, mp(mid, right));
	}
};

struct Segment_tree {
	int v[4 * MAXN2];
	Segment_tree() {
		fill(v, v + 4 * MAXN, MAXN);
	}
	void upd(int vert, int tl, int tr, int ind, int t) {
		if (tl == tr) {
			v[vert] = t;
			return;
		}
		int tm = (tl + tr) >> 1;
		if (ind <= tm) upd(vert << 1, tl, tm, ind, t);
		else upd(vert << 1 | 1, tm + 1, tr, ind, t);
		v[vert] = max(v[vert << 1], v[vert << 1 | 1]);
	}
	int get(int vert, int tl, int tr, int l, int r) {
		if (l > r) swap(l, r);
		if (tl == l && tr == r) return v[vert];
		int tm = (tl + tr) >> 1;
		if (r <= tm) return get(vert << 1, tl, tm, l, r);
		else if (l > tm) return get(vert << 1 | 1, tm + 1, tr, l, r);
		return max(get(vert << 1, tl, tm, l, tm), get(vert << 1 | 1, tm + 1, tr, tm + 1, r));
	}
};

int tst[MAXN2], tstr[MAXN2];

void solve() {
	int n, m, q;
	cin >> n >> m >> q;
	Fv st, str;
	Segment_tree sst, sstr;
	st.build(m);
	str.build(n);
	for (int i = 1; i <= q; ++i) {
		int t, r1;
		cin >> t >> r1;
		if (t == 1) {
			str.del(MAXN - tstr[r1], r1);
			tstr[r1] = i;
			sstr.upd(1, 0, MAXN2 - 1, r1, MAXN - tstr[r1]);
			str.add(MAXN - tstr[r1], r1);
		}
		else if (t == 2) {
			st.del(MAXN - tst[r1], r1);
			tst[r1] = i;
			sst.upd(1, 0, MAXN2 - 1, r1, MAXN - tst[r1]);
			st.add(MAXN - tst[r1], r1);
		}
		else {
			int ans = INF, c1, r2, c2, k;
			cin >> c1 >> r2 >> c2 >> k;
			k = MAXN + (k - i);
			if (sst.get(1, 0, MAXN2 - 1, c1, c2) <= k || sstr.get(1, 0, MAXN2 - 1, r1, r2) <= k)
				ans = abs(c1 - c2) + abs(r1 - r2);
			if (MAXN - tst[c1] <= k && MAXN - tst[c2] <= k) {
				auto p = str.get(k, r1, r2);
				if (p.Y.X != -1) ans = abs(c1 - c2) + abs(r1 - r2);
				if (p.X != -1) ans = min(ans, abs(c1 - c2) + abs(r1 - p.X) + abs(r2 - p.X));
				if (p.Y.Y != -1) ans = min(ans, abs(c1 - c2) + abs(r1 - p.Y.Y) + abs(r2 - p.Y.Y));
			}
			if (MAXN - tstr[r1] <= k && MAXN - tstr[r2] <= k) {
				auto p = st.get(k, c1, c2);
				if (p.Y.X != -1) ans = abs(c1 - c2) + abs(r1 - r2);
				if (p.X != -1) ans = min(ans, abs(r1 - r2) + abs(c1 - p.X) + abs(c2 - p.X));
				if (p.Y.Y != -1) ans = min(ans, abs(r1 - r2) + abs(c1 - p.Y.Y) + abs(c2 - p.Y.Y));
			}
			if (ans == INF) ans = -1;
			cout << ans << "\n";
		}
	}
}