#include <iostream>
#include <stack>
#include <vector>
#include <algorithm>

#define ll long long
#define pii pair<int, int>

using namespace std;

const int NMAX = 1111111;
const ll inf = 2e9;

int r[NMAX];
int c[NMAX];

int lastr = 0;
int lastc = 0;

int mx[2][NMAX * 4];
int mn[2][NMAX * 4];

void update(int w, int v, int tl, int tr, int pos, int data)
{
	if (tl == tr - 1)
	{
		mx[w][v] = data;
		mn[w][v] = data;
		return;
	}
	int m = (tl + tr) / 2;
	if (pos < m)
		update(w, 2 * v, tl, m, pos, data);
	else
		update(w, 2 * v + 1, m, tr, pos, data);
	mn[w][v] = min(mn[w][2 * v], mn[w][2 * v + 1]);
	mx[w][v] = max(mx[w][2 * v], mx[w][2 * v + 1]);
	return;
}

int getmin(int w, int v, int tl, int tr, int l, int r)
{
	if (r <= l || r <= tl || tr <= l)
		return inf;
	if (l <= tl && tr <= r)
		return mn[w][v];
	int m = (tl + tr) / 2;
	return min(getmin(w, 2 * v, tl, m, l, r), getmin(w, 2 * v + 1, m, tr, l, r));
}

int getmax(int w, int v, int tl, int tr, int l, int r)
{
	if (r <= l || r <= tl || tr <= l)
		return 0;
	if (l <= tl && tr <= r)
		return mx[w][v];
	int m = (tl + tr) / 2;
	return max(getmax(w, 2 * v, tl, m, l, r), getmax(w, 2 * v + 1, m, tr, l, r));
}

int main()
{
	cout.sync_with_stdio(0);
	cin.sync_with_stdio(0);
	cout.tie(0);
	cin.tie(0);
	int n, m;
	cin >> n >> m; 
	int q;
	cin >> q;
	int t = 0;
	for (int i = 1; i <= q; i++)
	{
		t++;
		int type;
		cin >> type;
		if (type == 1)
		{
			int k;
			cin >> k;
			r[k] = t;
			update(0, 1, 1, n + 1, k, t);
			lastr = t;
		}
		else if (type == 2)
		{
			int k;
			cin >> k;
			update(1, 1, 1, m + 1, k, t);
			c[k] = t;
			lastc = t;
		}
		else
		{
			int r1, c1, r2, c2, k;
			cin >> r1 >> c1 >> r2 >> c2 >> k;
			if (r[r1] + k < t && c[c1] + k < t || r[r2] + k < t && c[c2] + k < t)
			{
				cout << -1 << endl;
				continue;
			}
			if (r[r1] + k < t && r[r2] + k < t)
			{
				if (c1 > c2)
					swap(c1, c2);
				if (r1 > r2)
					swap(r1, r2);
				if (getmin(1, 1, 1, m + 1, c1, c2 + 1) + k >= t || getmax(0, 1, 1, n + 1, r1, r2 + 1) + k >= t)
				{
					cout << abs(r1 - r2) + abs(c1 - c2) << endl;
					continue;
				}
				int l = 0;
				int r = n + 1;
				while (r - l > 1)
				{
					int m = (l + r) / 2;
					int x = max(1, r1 - m);
					int y = min(r2 + m, n);
					if (getmax(0, 1, 1, n + 1, x, y + 1) + k >= t)
					{
						r = m;
					}
					else
						l = m;
				}
				if (r == n + 1)
				{
					cout << -1 << endl;
				}
				else
				{
					cout << abs(r1 - r2) + 2 * r + abs(c1 - c2) << endl;
				}
				continue;
			}
			if (c[c1] + k < t && c[c2] + k < t)
			{
				if (c1 > c2)
					swap(c1, c2);
				if (r1 > r2)
					swap(r1, r2);
				if (getmin(0, 1, 1, n + 1, r1, r2 + 1) + k >= t || getmax(1, 1, 1, m + 1, c1, c2 + 1) + k >= t)
				{
					cout << abs(r1 - r2) + abs(c1 - c2) << endl;
					continue;
				}
				int l = 0;
				int r = m + 1;
				while (r - l > 1)
				{
					int mid = (l + r) / 2;
					int x = max(1, c1 - mid);
					int y = min(c2 + mid, n);
					if (getmax(1, 1, 1, m + 1, x, y + 1) + k >= t)
					{
						r = mid;
					}
					else
						l = mid;
				}
				if (r == m + 1)
				{
					cout << -1 << endl;
				}
				else
				{
					cout << abs(r1 - r2) + 2 * r + abs(c1 - c2) << endl;
				}
				continue;
			}
			cout << abs(r1 - r2) + abs(c1 - c2) << endl;
		}
	}
	return 0;
}