#include <iostream>
#include <stack>
#include <vector>
#include <algorithm>
#include <bitset>

#define ll long long
#define pii pair<ll, ll>

using namespace std;

const ll NMAX = 111;
const ll inf = 2e9;

int dp[NMAX][NMAX][NMAX][NMAX];
int used[NMAX][NMAX][NMAX][NMAX];

int DP(int l, int x, int y, int r)
{
	if (used[l][x][y][r])
	{
		return dp[l][x][y][r];
	}
	used[l][x][y][r] = 1;
	dp[l][x][y][r] = inf;
	if (l + 1 == r)
	{
		dp[l][x][y][r] = 0;
	}
	else
	{
		for (int m = l + 1; m < r; m++)
		{
			int mn1, mn2, mx1, mx2;
			int res = 0;

			mn1 = y;
			mn2 = r;
			if (m >= x)
			{
				mx1 = m;
				mx2 = x;
			}
			else
			{
				mx1 = x;
				mx2 = m;
			}

			res = max(res, DP(mx2, mx1, mn1, mn2));

			mx1 = x;
			mx2 = l;
			if (m <= y)
			{
				mn1 = m;
				mn2 = y;
			}
			else
			{
				mn2 = y;
				mn1 = m;
			}
			res = max(res, DP(mx2, mx1, mn1, mn2));

			dp[l][x][y][r] = min(dp[l][x][y][r], res + 1);
		}
	}
	return dp[l][x][y][r];
}

signed main()
{
	cout.sync_with_stdio(0);
	cin.sync_with_stdio(0);
	cout.tie(0);
	cin.tie(0);
	int n;
	cin >> n;

	int l = 1, r = n + 1, x = 1, y = n + 1;

	while (r - l > 1)
	{
		int ansm = inf;
		int resm = 0;
		for (int m = l + 1; m < r; m++)
		{
			int mn1, mn2, mx1, mx2;
			int res = 0;

			mn1 = y;
			mn2 = r;
			if (m >= x)
			{
				mx1 = m;
				mx2 = x;
			}
			else
			{
				mx1 = x;
				mx2 = m;
			}

			res = max(res, DP(mx2, mx1, mn1, mn2));

			mx1 = x;
			mx2 = l;
			if (m <= y)
			{
				mn1 = m;
				mn2 = y;
			}
			else
			{
				mn2 = y;
				mn1 = m;
			}
			res = max(res, DP(mx2, mx1, mn1, mn2));


			if (ansm > res + 1)
			{
				ansm = res + 1;
				resm = m;
			}
		}
		cout << '?' << ' ' << resm << endl;
		string s;
		cin >> s;
		if (s[0] == 'Y')
		{
			if (resm >= x)
			{
				l = x;
				x = resm;
			}
			else
			{
				l = resm;
			}
		}
		else
		{
			if (resm <= y)
			{
				r = y;
				y = resm;
			}
			else
			{
				y = resm;
			}
		}
	}
	cout << '!' << ' ' << l << endl;

	return 0;
}