#include <iostream>
#include <map>
#include <set>
#include <vector>
#include <cmath>
#include <iomanip>
#include <algorithm>

using namespace std;

typedef long long ll;

const int SZ = 1e6 + 100;
const int INF = 1e8;

int stolb[SZ] = {};
int strok[SZ] = {};
int n, m, q;
int k;

int dist(int x1, int y1, int x2, int y2)
{
    return abs(x1 - x2) + abs(y1 - y2);
}

int peres(int x1, int y1, int x2, int y2)
{
    if (strok[y1] > k || stolb[x2] > k) return INF;
    return dist(x1, y1, x2, y2);
}

int get_strok(int x1, int y1, int x2, int y2)
{
    if (strok[y1] > k || strok[y2] > k) return INF;
    int can = -INF;
    for (int i = min(y1, y2); i <= max(y1, y2); i++)
    {
        can = max(can, strok[i]);
    }
    if (can <= k) return dist(x1, y1, x2, y2);
    int val;
    val = INF;
    for (int i = 0; i < m; i++)
    {
        if (stolb[i] <= k)
        {
            val = min(val, abs(x1 - i) + abs(y2 - y1) + abs(x2 - i));
        }
    }
    return val;
}

int get_stolb(int x1, int y1, int x2, int y2)
{
    if (stolb[x1] > k || stolb[x2] > k) return INF;
    int can = -INF;
    for (int i = min(x1, x2); i <= max(x1, x2); i++)
    {
        can = max(can, stolb[i]);
    }
    if (can <= k) return dist(x1, y1, x2, y2);
    int val;
    val = INF;
    for (int i = 0; i < n; i++)
    {
        if (strok[i] <= k)
        {
            val = min(val, abs(y1 - i) + abs(x2 - x1) + abs(y2 - i));
        }
    }
    return val;
}


int main()
{
    ios::sync_with_stdio(false);

    cin >> n >> m >> q;
    int sim;
    int x1, x2, y1, y2;
    for (int i = 1; i <= q; i++)
    {
        cin >> sim;
        if (sim == 1)
        {
            cin >> y1;
            y1--;
            strok[y1] = -i;
            continue;
        }
        if (sim == 2)
        {
            cin >> x1;
            x1--;
            stolb[x1] = -i;
            continue;
        }
        if (sim == 3)
        {
            cin >> y1 >> x1 >> y2 >> x2 >> k;
            k -= i;
            x1--;
            y1--;
            x2--;
            y2--;
            bool fl1, fl2;
            fl1 = false;
            fl2 = false;
            if (strok[y1] == 0 && stolb[x1] == 0) fl1 = true;
            if (strok[y2] == 0 && stolb[x2] == 0) fl2 = true;
            if (fl1 || fl2)
            {
                if (k >= 0) cout << dist(x1, y1, x2, y2) << "\n";
                else cout << -1 << "\n";
                continue;
            }

            int ans = INF;
            int zn = max(min(strok[y1], stolb[x1]),
                         min(strok[y2], stolb[x2]));
            if (zn > k)
            {
                cout << -1 << "\n";
                continue;
            }

            if (strok[y1] < 0 && stolb[x2] < 0)
            {
                ans = min(ans, peres(x1, y1, x2, y2));
            }
            if (strok[y2] < 0 && stolb[x1] < 0)
            {
                ans = min(ans, peres(x2, y2, x1, y1));
            }
            if (strok[y1] < 0 && strok[y2] < 0)
            {
                ans = min(ans, get_strok(x1, y1, x2, y2));
            }
            if (stolb[x1] < 0 && stolb[x2] < 0)
            {
                ans = min(ans, get_stolb(x1, y1, x2, y2));
            }

            if (ans < INF) cout << ans << "\n";
            else cout << -1 << "\n";

            continue;
        }
    }

    return 0;
}
