#include <iostream>
#include <map>
#include <set>
#include <vector>
#include <cmath>
#include <iomanip>
#include <algorithm>
#include <iterator>

using namespace std;

typedef long long ll;

const int SZ = 1e6 + 100;
const int INF = 1e8;

int n, m, q;
ll p;

void slow_solve()
{
    int x, y;
    ll d;
    vector< pair<int, ll> > v[20];
    set<ll> dp[20];
    dp[0].insert(0);

    for (int i = 0; i < m; i++)
    {
        cin >> x >> y >> d;
        x--;
        y--;
        v[y].push_back({x, d});
    }

    int from;
    ll cost;
    set<ll>::iterator it;
    for (int i = 1; i < n; i++)
    {
        for (int j = 0; j < v[i].size(); j++)
        {
            from = v[i][j].first;
            cost = v[i][j].second;
            for (it = dp[from].begin(); it != dp[from].end(); it++)
            {
                dp[i].insert(cost + *it);
            }
        }
    }

    for (int i = 0; i < q; i++)
    {
        cin >> x >> d;
        x--;

        it = dp[x].lower_bound(d);
        if (it == dp[x].end())
        {
            cout << 0;
            continue;
        }
        cost = *it;
        if (cost * (p - 1ll) <= p * d) cout << 1;
        else cout << 0;
    }
}

int main()
{
    ios::sync_with_stdio(false);

    int t;
    cin >> t;
    for (int i = 0; i < t; i++)
    {
        cin >> n >> m >> q >> p;
        if (n <= 10 && m <= 10)
        {
            slow_solve();
            cout << "\n";
            continue;
        }
    }


    return 0;
}
