#include <iostream>
#include <map>
#include <set>
#include <vector>
#include <cmath>
#include <iomanip>
#include <algorithm>
#include <iterator>

using namespace std;

typedef long long ll;

const int SZ = 5e4 + 100;
const ll INF = 5e17;

int n, m, q;
ll p;

void slow_solve()
{
    int x, y;
    ll d;
    vector< pair<int, ll> > v[SZ];
    set<ll> dp[SZ];
    dp[0].insert(0);

    for (int i = 0; i < m; i++)
    {
        cin >> x >> y >> d;
        x--;
        y--;
        v[y].push_back({x, d});
    }

    int from;
    ll cost;
    set<ll>::iterator it;
    for (int i = 1; i < n; i++)
    {
        for (int j = 0; j < v[i].size(); j++)
        {
            from = v[i][j].first;
            cost = v[i][j].second;
            for (it = dp[from].begin(); it != dp[from].end(); it++)
            {
                dp[i].insert(cost + *it);
            }
        }
    }

    for (int i = 0; i < q; i++)
    {
        cin >> x >> d;
        x--;

        it = dp[x].lower_bound(d);
        if (it == dp[x].end())
        {
            cout << 0;
            continue;
        }
        cost = *it;
        if (cost * (p - 1ll) <= p * d) cout << 1;
        else cout << 0;
    }
}

void two_solve()
{
    int x, y;
    ll d;

    ll down[SZ];
    ll up[SZ];

    for (int i = 0; i < n; i++)
    {
        down[i] = INF;
        up[i] = 0;
    }

    for (int i = 0; i < m; i++)
    {
        cin >> x >> y >> d;
        x--;
        y--;
        down[y] = min(down[y], d);
        up[y] = max(up[y], d);
    }

    ll p[SZ];
    p[0] = 0;
    for (int i = 1; i < n; i++)
    {
        p[i] = p[i - 1] + down[i];
    }


    for (int i = 0; i < q; i++)
    {
        cin >> x >> d;
        x--;

    }
}

int main()
{
    ios::sync_with_stdio(false);

    int t;
    cin >> t;
    for (int i = 0; i < t; i++)
    {
        cin >> n >> m >> q >> p;
        //if (n <= 10 && m <= 10)
       // {
            slow_solve();
            cout << "\n";
            continue;
       // }
        if (m == (2 * n - 2))
        {
            two_solve();
            cout << "\n";
            continue;
        }
    }


    return 0;
}
