#pragma GCC optimize("O3")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx")

#include <iostream>
#include <map>
#include <set>
#include <vector>
#include <cmath>
#include <iomanip>
#include <algorithm>
#include <iterator>

using namespace std;

typedef long long ll;

const int SZ = 5000 + 10;
const ll INF = 5e17;

int n, m, q;
ll p;
bool dp[SZ][SZ];

void slow_solve()
{
    int x, y;
    ll d;
    vector< pair<int, ll> > v[SZ];

    for (int i = 0; i < m; i++)
    {
        cin >> x >> y >> d;
        x--;
        y--;
        v[y].push_back({x, d});
    }

    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < SZ; j++)
        {
            dp[i][j] = false;
        }
    }
    dp[0][0] = true;

    int from;
    ll cost;
    for (int i = 1; i < n; i++)
    {
        for (int j = 0; j < v[i].size(); j++)
        {
            from = v[i][j].first;
            cost = v[i][j].second;
            for (int pos = 0; pos < SZ; pos++)
            {
                if (!dp[from][pos]) continue;
                if ((pos + cost) >= SZ) break;
                dp[i][pos + cost] = true;
            }
        }
    }

    for (int i = 0; i < q; i++)
    {
        cin >> x >> d;
        x--;

        int ind;
        ind = d;

        bool used = false;
        while (true)
        {
            if (ind >= SZ) break;
            if ((p - 1) * ind > p * d) break;
            if (dp[x][ind])
            {
                used = true;
                break;
            }
            ind++;
        }

        if (used) cout << 1;
        else cout << 0;
    }
}

int main()
{
    ios::sync_with_stdio(false);

    int t;
    cin >> t;
    for (int i = 0; i < t; i++)
    {
        cin >> n >> m >> q >> p;

            slow_solve();
            cout << "\n";
            continue;

    }


    return 0;
}
