#include <iostream>
#include <vector>
#include <algorithm>
#define x first
#define y second
#define mp make_pair
using namespace std;
const int N = 3e5;

int p[N];
static bool c[N];

vector<int> g[N];
vector<pair<int,pair<int,int>>> ans;

void dfs(int v, int p, int* fe, int* le)
{
    if (fe[v] + 1)
        ans.emplace_back(v, mp(fe[v], le[v]));
    for (int u: g[v])
        if (u - p)
            dfs(u, v, fe, le);
}

int tree[4*N], nv[4*N], m = 1;
static bool upd[4*N];

void build_tree(int n)
{
    while (m < n)
        m *= 2;
}

void push(int id)
{
    if (!upd[id])
        return;
    if (id >= m)
    {
        tree[id] = nv[id], upd[id] = false;
        return;
    }
    upd[2*id] = upd[2*id+1] = true, nv[2*id] = nv[2*id+1] = nv[id], upd[id] = false;
}

void update(int id, int val, int l, int r, int tl, int tr)
{
    push(id);
    if (l == tl && r == tr)
    {
        nv[id] = val, upd[id] = true;
        return;
    }
    int tm = (tl + tr) / 2;
    if (r <= tm)
        return update(2*id, val, l, r, tl, tm);
    if (l >= tm)
        return update(2*id+1, val, l, r, tm, tr);
    update(2*id, val, l, tm, tl, tm), update(2*id+1, val, tm, r, tm, tr);
}

vector<int> arr;

void dfs(int id, int n, int tl, int tr)
{
    push(id);
    if (id >= m)
    {
        if (id - m < n)
            arr.push_back(tree[id]);
        return;
    }
    int tm = (tl + tr) / 2;
    dfs(2*id, n, tl, tm), dfs(2*id+1, n, tm, tr);
}

bool check(int n, int* a)
{
    build_tree(n);
    for (auto x: ans)
        update(1, x.x, x.y.x, x.y.y + 1, 0, m);
    dfs(1, n, 0, m);
    bool ok = true;
    for (int i = 0; i < n; ++i)
        ok &= arr[i] == a[i];
    return ok;
}

int main()
{
    int n, m;
    cin >> n >> m;
    int a[n];
    for (int i = 0; i < n; ++i)
        cin >> a[i], --a[i];
    int fe[m], le[m];
    fill(fe, fe + m, -1);
    for (int i = 0; i < n; ++i)
        fe[a[i]] = fe[a[i]] == -1 ? i : fe[a[i]], le[a[i]] = i;
    fill(p, p + m, -1);
    vector<int> last = {-1};
    bool ok = true;
    for (int i = 0; i < n; ++i)
    {
        if (fe[a[i]] == i)
            p[a[i]] = last.back(), last.push_back(a[i]);
        if (le[a[i]] == i)
            last.pop_back();
    }
    for (int i = 0; i < m; ++i)
        if (p[i] + 1)
            ok &= fe[p[i]] < fe[i] && le[i] < le[p[i]];
    if (!ok)
    {
        cout << -1;
        return 0;
    }
    for (int i = 0; i < m; ++i)
        if (p[i] != -1)
            g[i].push_back(p[i]), g[p[i]].push_back(i);
    for (int i = 0; i < m; ++i)
        if (p[i] == -1)
            dfs(i, -1, fe, le);
    if (!check(n, a))
    {
        cout << -1;
        return 0;
    }
    cout << ans.size() << '\n';
    for (auto x: ans)
        cout << x.first + 1 << ' ' << x.second.first + 1 << ' ' << x.second.second + 1 << '\n';
    return 0;
}
