#include <bits/stdc++.h>

using namespace std;

typedef int ll;
typedef vector<ll> lvec;
typedef pair<ll, ll> lpair;

const ll INF = 1e9;

struct Node {
    Node *l = nullptr, *r = nullptr;
    ll left, right;
    ll value = 0, value2 = 0;

    Node(ll left, ll right) : left(left), right(right) {
        if (right - left == 1) return;
        ll m = (left + right) / 2;
        l = new Node(left, m);
        r = new Node(m, right);
    }

    void Update(ll i, ll x) {
        if (right - left == 1) {
            if (left == i)value = value2 = x;
            return;
        }
        l->Update(i, x);
        r->Update(i, x);
        value = max(l->value, r->value);
        value2 = min(l->value2, r->value2);
    }

    ll GetMax(ll rl, ll rr) {
        if (rr <= left || right <= rl) return -1;
        if (rl <= left &&  right <= rr) return value;
        return max(l->GetMax(rl, rr), r->GetMax(rl, rr));
    }

    ll GetMin(ll rl, ll rr) {
        if (rr <= left || right <= rl) return INF;
        if (rl <= left &&  right <= rr) return value2;
        return min(l->GetMin(rl, rr), r->GetMin(rl, rr));
    }

    ll LeftRange(ll x, ll i, ll j) {
        if (j <= left || right <= i) return INF;
        if (i <= left && right <= j) {
                if(value >= x) return LeftAtLeast(x);
                return INF;
            }
        ll ans = INF;
        if (l->value >= x) ans = min(ans, l->LeftRange(x, i, j));
        if (r->value >= x) ans = min(ans, r->LeftRange(x, i, j));
        return ans;
    }

    ll RightRange(ll x, ll i, ll j) {
        if (j <= left || right <= i) return -1;
        if (i <= left && right <= j) {
            if(value >= x) return RightAtLeast(x);
            return -1;
        }
        ll ans = -1;
        if (l->value >= x) ans = max(ans, l->RightRange(x, i, j));
        if (r->value >= x) ans = max(ans, r->RightRange(x, i, j));
        return ans;
    }

    ll LeftAtLeast(ll x) {
        if (right - left == 1) return left;
        if (l->value >= x) return l->LeftAtLeast(x);
        return r->LeftAtLeast(x);
    }

    ll RightAtLeast(ll x) {
        if (right - left == 1) return left;
        if (r->value >= x) return r->RightAtLeast(x);
        return l->RightAtLeast(x);
    }

};


int main() {
    ll n, m, q;
    cin >> n >> m >> q;
    Node *v = new Node(0, n), *u = new Node(0, m);
    for (ll time = 1; time <= q; time++) {
        ll mode;
        cin >> mode;
        if (mode == 1) {
            ll r;
            cin >> r;
            v->Update(--r, time);
            continue;
        }
        if (mode == 2) {
            ll c;
            cin >> c;
            u->Update(--c, time);
            continue;
        }
        ll r1, c1, r2, c2, k;
        cin >> r1 >> c1 >> r2 >> c2 >> k;
        r1--;
        r2--;
        c1--;
        c2--;
        ll MinTime = time - k;
        if(v->GetMin(min(r1,r2), max(r1,r2)+1) >= MinTime) {
            cout << abs(r2 - r1) + abs(c2 - c1) << "\n";
            continue;
        }
        if(u->GetMin(min(c1,c2), max(c1,c2)+1) >= MinTime) {
            cout << abs(r2 - r1) + abs(c2 - c1) << "\n";
            continue;
        }
        bool StartHor = true, StartVer = true;
        if (v->GetMax(r1, r1 + 1) < MinTime) StartHor = false;
        if (u->GetMax(c1, c1 + 1) < MinTime) StartVer = false;
        bool FinishHor = true, FinishVer = true;
        if (v->GetMax(r2, r2 + 1) < MinTime) FinishHor = false;
        if (u->GetMax(c2, c2 + 1) < MinTime) FinishVer = false;
        if (!StartHor && !StartVer) {
            cout << "-1\n";
            continue;
        }
        if (!FinishHor && !FinishVer) {
            cout << "-1\n";
            continue;
        }
        if ((StartHor && FinishVer) || (StartVer && FinishHor)) {
            cout << abs(r2 - r1) + abs(c2 - c1) << "\n";
            continue;
        }
        if (StartHor) {
            if (u->GetMax(min(c1, c2), max(c1, c2) + 1) >= MinTime) {
                cout << abs(r1 - r2) + abs(c1 - c2);
                continue;
            }
            ll ans = INF;
            if(u->GetMax(max(c1, c2) + 1, m + 1) >= MinTime) {
                ll x = u->LeftRange(MinTime,max(c1, c2) + 1, m + 1 );
                if(x == INF) exit(1);
                ans = min(ans, abs(2 * x - c1 - c2) + abs(r1 - r2));
            }
            if(u->GetMax(0, min(c1,c2))>= MinTime) {
                ll x = u->RightRange(MinTime,0, min(c1,c2));
                if(x == -1) exit(1);
                ans = min(ans, abs(c1 + c2 - 2 * x) + abs(r1 - r2));
            }
            if(ans == INF) cout <<"-1\n";
            else cout << ans <<"\n";
            continue;
        }
            if (v->GetMax(min(r1, r2), max(r1, r2) + 1) >= MinTime) {
                cout << abs(r1 - r2) + abs(c1 - c2);
                continue;
            }
            ll ans = INF;
            if(v->GetMax(max(r1, r2) + 1, n + 1) >= MinTime) {
                ll x = v->LeftRange(MinTime,max(r1, r2) + 1, m + 1 );
                if(x == INF) exit(1);
                ans = min(ans, 2 * x - r1 - r2 + abs(c1 - c2));
            }
            if(v->GetMax(0, min(r1,r2))>= MinTime) {
                ll x = v->RightRange(MinTime,0, min(r1,r2));
                if(x == -1) exit(1);
                ans = min(ans, r1 + r2 - 2 * x + abs(c1 - c2));
            }
            if(ans == INF) cout <<"-1\n";
            else cout << ans <<"\n";
    }
    return 0;
}