#include <bits/stdc++.h>
using namespace std;

const int max_size = 1e2;
int tree[2*max_size] = {0};
int n, m, q;

void modify(int x, int v) {
	x += n;
	tree[x] = v;
	for ( ; x > 0; x >>= 1 ) tree[x<<1] = max(tree[x], tree[x^1]);
}

int query(int l, int r) {
	int ans = 0;
	l += n; r += n;
	for ( ; l < r; l >>= 1, r >>= 1 ) {
		if ( l & 1 )
			ans = max(ans, tree[l++]);
		if ( r & 1 )
			ans = max(ans, tree[--r]);
	}
	return ans;
}

int get_dist(pair<int, int> p1, pair<int, int> p2, int k) {
	if ( p1.first > p2.first )
		swap(p1, p2);
	int mx = query(p1.first, p2.first+1);
	if ( mx <= k )
		return abs(p1.first - p2.first) + abs(p2.second - p1.second);
	else
		return -1;
}

int main() {
	cin >> n >> m >> q;
	int seconds = 1;
	for ( int i = 0; i < q; ++i ) {
		int type;
		cin >> type;
		if ( type == 1 ) {
			int row;
			cin >> row;
			row--;
			modify(row, -seconds);
		} else {
			int x, y, x1, y1, k;
			cin >> x >> y >> x1 >> y1 >> k;
			x--; y--; x1--; y1--;
			cout << get_dist({x, y}, {x1, y1}, k-seconds) << endl;
		}

		seconds++;
	}
	return 0;
}