#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <stack>
#include <assert.h>

using namespace std;
const int maxn = static_cast<const int>(3e5 + 5);
int a[maxn];
int b[maxn];

struct elem {
    int minpos, maxpos;
    int id;
};
elem elems[maxn];

struct event {
    int id;
    int time;
    int type; // 0 -- add   1 -- erase
};

event add_events[maxn];
event rem_events[maxn];
/*
struct comp {
    bool operator() (const event& e1, const event& e2) {
        return e1.time < e2.time;
    }
};
set<event, comp> q;*/
stack<int> st;

int main() {
    for (int i = 0; i < maxn; i++) {
        elems[i].minpos = 1e9;
        elems[i].id = i;
    }
    ios_base::sync_with_stdio(false);
    int m, n;
    cin >> m >> n;
    for (int i = 0; i < m; i++) {
        cin >> a[i];
        a[i]--;
        elems[a[i]].minpos = min(elems[a[i]].minpos, i);
        elems[a[i]].maxpos = max(elems[a[i]].maxpos, i);
    }
    sort(elems, elems + n, [](const elem& e1, const elem& e2) {
        return e1.maxpos - e1.minpos > e2.maxpos - e2.minpos;
    });
    for (int i = 0; i < m; i++) {
        add_events[i] = {-1, -1, -1};
        rem_events[i] = {-1, -1, -1};
    }
    int cnt = 0;
    for (int i = 0; i < n; i++) {
        if (elems[i].minpos != 1e9) {
            add_events[elems[i].minpos] = {elems[i].id, i, 0};
            rem_events[elems[i].maxpos] = {elems[i].id, i, 1};
            cnt++;
        }
    }
    for (int i = 0; i < m; i++) {
        if (add_events[i].type == 0) {
            st.push(add_events[i].id);
        }
        assert(!st.empty());
        b[i] = st.top();
        if (rem_events[i].type == 1) {
            if (st.top() != rem_events[i].id) {
                cout << -1;
                return 0;
            }
            st.pop();
        }
    }
    for (int i = 0 ; i < m; i++) {
        assert(a[i] == b[i]);
    }
    cout << cnt << endl;
    for (int i = 0; i < cnt; i++) {
        cout << elems[i].id + 1 << " " << elems[i].minpos + 1 << " " << elems[i].maxpos + 1 << "\n";
    }
    return 0;
}