#include <iostream>
#include "assert.h"
#include "queue"
using namespace std;
const int maxn = 1e4 + 4;
int a[maxn][maxn];

bool checked[maxn][maxn];

struct elem{
    int x, y, dist;
};
int n, m, kq;
int k;

queue<elem> q;

void try_add(int x, int y, int dist) {
    if (x < 0 || y < 0 || x >= n || y >= m || checked[x][y] || a[x][y] > k) return;
    checked[x][y] = true;
    q.push({x, y, dist});
}

int main() {
    cin >> n >> m >> kq;
    for (int it = 0; it < kq; it++) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                a[i][j]++;
                checked[i][j] = false;
            }
        }

        int req_type;
        cin >> req_type;
        if (req_type == 1) {
            int val;
            cin >> val; val--;
            for (int j = 0; j < m; j++) {
                a[val][j] = 0;
            }
        } else if (req_type == 2) {
            int val;
            cin >> val; val--;
            for (int i = 0; i < n; i++) {
                a[i][val] = 0;
            }
        } else {
            int x1, y1, x2, y2;
            cin >> x1 >> y1 >> x2 >> y2 >> k; x1--; x2--; y1--; y2--;
            q = queue<elem>();
            if (a[x1][y1] <= k)
                q.push({x1, y1, 0});
            int res = -1;
            while (!q.empty()) {
                elem e = q.front();
                q.pop();
                if (e.x == x2 && e.y == y2) {
                    res = e.dist;
                    break;
                }
                try_add(e.x + 1, e.y, e.dist + 1);
                try_add(e.x - 1, e.y, e.dist + 1);
                try_add(e.x, e.y + 1, e.dist + 1);
                try_add(e.x, e.y - 1, e.dist + 1);
            }
            cout << res << "\n";
        }
    }
}