#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <queue>

using namespace std;

typedef long long ll;
typedef double dl;

ll inf = 1e9;

vector<vector<ll>> g;
vector<ll> used;

vector<ll> ord;

void dfs(ll v)
{
	used[v] = 1;
	for (ll to : g[v])
	{
		if (!used[to])
		{
			dfs(to);
		}
	}

	ord.push_back(v);
}

int main()
{
	//freopen("input.txt", "r", stdin);

	ll m, n;

	cin >> m >> n;

	vector<ll> a(m);


	g.resize(n);
	used.resize(n, 0);

	for (int i = 0; i < m; ++i)
	{
		cin >> a[i];
		--a[i];
	}

	vector<ll> l(n, inf), r(n, inf);

	for (int c = 0; c < n; ++c)
	{
		for (int i = 0; i < m; ++i)
		{
			if (a[i] == c)
			{
				l[c] = i;
				break;
			}
		}

		for (int i = m - 1; i >= 0; --i)
		{
			if (a[i] == c)
			{
				r[c] = i;
				break;
			}
		}
	}

	for (int color = 0; color < n; ++color)
	{
		for (int i = l[color]; i <= min(m - 1, r[color]); ++i)
		{
			g[color].push_back(a[i]);
		}
	}

	for (int i = 0; i < used.size(); ++i)
	{
		if (!used[i])
		{
			dfs(i);
		}
	}

	reverse(ord.begin(), ord.end());

	vector<ll> res(m, -1);
	vector<pair<ll, ll>> ans;

	for (ll in : ord)
	{
		for (int i = l[in]; i <= min(m - 1, r[in]); ++i)
		{
			res[i] = in;
		}

		if (l[in] != inf)
			ans.push_back(make_pair(l[in], r[in]));
	}

	bool can = 1;

	for (int i = 0; i < m; ++i)
	{
		if (a[i] != res[i])
		{
			can = 0;
		}
	}

	if (can)
	{
		cout << ans.size() << endl;
		for (int i = 0; i < ans.size(); ++i)
		{
			cout << ans[i].first + 1 << " " << ans[i].second + 1 << endl;
		}
	}
	else
	{
		puts("-1");
	}

	return 0;
}

/*
7 10
10 5 5 10 4 2 4

*/