#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <queue>

using namespace std;

typedef long long ll;
typedef double dl;

ll inf = 1e9;

vector<vector<ll>> g;
vector<ll> used;
vector<ll> l, r;
vector<ll> ord;

void dfs(ll v)
{
	used[v] = 1;
	for (ll to : g[v])
	{
		if (!used[to])
		{
			dfs(to);
		}
	}

	ord.push_back(v);
}

bool comp(ll i1, ll i2)
{
	return r[i1] < r[i2];
}

int main()
{
	//freopen("input.txt", "r", stdin);

	ll m, n;

	cin >> m >> n;

	vector<ll> a(m);


	g.resize(n);
	used.resize(n, 0);

	for (int i = 0; i < m; ++i)
	{
		cin >> a[i];
		--a[i];
	}

	l.resize(n, inf);
	r.resize(n, inf);

	for (int i = 0; i < m; ++i)
	{
		if (l[a[i]] == inf)
			l[a[i]] = i;

		r[a[i]] = i;
	}
	

	for (int color = 0; color < n; ++color)
	{
		for (int i = l[color]; i <= min(m - 1, r[color]); ++i)
		{
			g[color].push_back(a[i]);
		}
	}

	/*for (int i = 0; i < used.size(); ++i)
	{
		if (!used[i])
		{
			dfs(i);
		}
	}*/

	for (int i = 0; i < n; ++i)
		ord.push_back(i);

	sort(ord.begin(), ord.end(), comp);

	reverse(ord.begin(), ord.end());

	vector<ll> res(m, -1);
	vector<pair<ll, pair<ll, ll>>> ans;

	for (ll in : ord)
	{
		for (int i = l[in]; i <= min(m - 1, r[in]); ++i)
		{
			res[i] = in;
		}

		if (l[in] != inf)
			ans.push_back({ in, { l[in], r[in] } });
	}

	bool can = 1;

	for (int i = 0; i < m; ++i)
	{
		if (a[i] != res[i])
		{
			can = 0;
		}
	}

	if (can)
	{
		cout << ans.size() << endl;
		for (int i = 0; i < ans.size(); ++i)
		{
			cout << ans[i].first + 1 << " " << ans[i].second.first + 1 << " " << ans[i].second.second + 1 << endl;
		}
	}
	else
	{
		puts("-1");
	}

	return 0;
}

/*
7 10
10 5 5 10 4 2 4

*/