#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <queue>

using namespace std;

typedef long long ll;
typedef double dl;

ll inf = 1e9;
ll n, m;

vector<pair<ll, ll>> step = { {1, 0}, {-1, 0}, {0, 1}, {0, -1} };

vector<vector<ll>> mx;

void prnt(vector<vector<ll>> vec)
{
	for (int i = 0; i < vec.size(); ++i)
	{
		for (int j = 0; j < vec[i].size(); ++j)
		{
			cout << vec[i][j] << " ";
		}
		puts("");
	}

	puts("");
	puts("");
}

void pls()
{
	for (int i = 0; i < mx.size(); ++i)
	{
		for (int j = 0; j < mx[i].size(); ++j)
		{
			mx[i][j] += 1;
		}
	}
}

void doi(ll ii)
{
	for (int j = 0; j < mx[ii].size(); ++j)
		mx[ii][j] = 0;
}

void doj(ll jj)
{
	for (int i = 0; i < mx.size(); ++i)
		mx[i][jj] = 0;
}

ll get(ll ii, ll jj, ll iii, ll jjj,ll k)
{
	vector<vector<ll>> d(n, vector<ll>(m, inf));

	queue<pair<ll, ll>> q;

	q.push({ ii, jj });

	d[ii][jj] = 0;


	while (!q.empty())
	{
		pair<ll, ll> p = q.front();
		q.pop();

		ll  i = p.first;
		ll j = p.second;

		if (mx[i][j] > k)
		{
			d[i][j] = inf;
			continue;
		}

		for (pair<ll, ll> del : step)
		{
			ll toi = i + del.first;
			ll toj = j + del.second;

			if (toi >= 0 && toi < n && toj >= 0 && toj < m &&
				d[i][j] + 1 < d[toi][toj])
			{
				d[toi][toj] = d[i][j] + 1;
				q.push({ toi, toj });
			}
		}
	}

	return d[iii][jjj] == inf ? -1 : d[iii][jjj];
}

int main()
{
	//freopen("input.txt", "r", stdin);

	ll  q;

	cin >> n >> m >> q;

	mx.resize(n, vector<ll>(m, 0));

	for (int i = 0; i < q; ++i)
	{
		pls();

		ll type;

		cin >> type;

		if (type == 1)
		{
			ll ii;
			cin >> ii;
			--ii;

			doi(ii);
		}
		else if (type == 2)
		{
			ll jj;

			cin >> jj;
			--jj;

			doj(jj);
		}
		else
		{
			ll i1, j1, i2, j2, k;

			cin >> i1 >> j1 >> i2 >> j2 >> k;
			--i1;
			--j1;
			--i2;
			--j2;

			ll ans = get(i1, j1, i2, j2, k);

			cout << ans << endl;
		}

	}

	return 0;
}

/*
7 10
10 5 5 10 4 2 4

*/