#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <set>
#include <vector>
#include <algorithm>
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-mast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,abm,mmx,popcnt,tune=native")
using namespace std;
#define fs first
#define sc second
typedef long long ll;
typedef long double ld;
const int maxn = 1e6 + 100;
const int inf = 2e9 + 100;
const int mod = 1e9 + 7;

int r[maxn], c[maxn];

struct minsegtree {
	int t[maxn * 4];

	void build(int x) {
		for (int i = 0; i < maxn * 4; ++i) t[i] = x;
	}

	void upd(int v, int tl, int tr, int pos, int nv) {
		if (tl == tr) t[v] = nv;
		else {
			int tm = (tl + tr) / 2;
			if (pos <= tm) upd(v * 2, tl, tm, pos, nv);
			else upd(v * 2 + 1, tm + 1, tr, pos, nv);
			t[v] = min(t[v * 2], t[v * 2 + 1]);
		}
	}

	void upd(int pos, int nv) {
		upd(1, 0, maxn - 1, pos, nv);
	}

	int mn(int v, int tl, int tr, int l, int r) {
		if (l > r) return inf;
		if (tl == l && tr == r) return t[v];
		int tm = (tl + tr) / 2;
		return min(mn(v * 2, tl, tm, l, min(r, tm)), mn(v * 2 + 1, tm + 1, tr, max(tm + 1, l), r));
	}

	int mn(int l, int r) {
		return mn(1, 0, maxn - 1, l, r);
	}
} rt, ct;

int n, m, q;

inline int get(int r0, int c0, int time) {
	return time - max(r[r0], c[c0]);
}

const int dx[5] = { 0, 0, 0, 1, -1 };
const int dy[5] = { 0, 1, -1, 0, 0 };

int get1(int r1, int c1, int r2, int c2, int time, int k) {
	int mnans = inf;
	for (int i = 0; i < 5; ++i) {
		for (int j = 0; j < 5; ++j) {
			int lr1 = r1 + dx[i];
			int lc1 = c1 + dy[i];
			int lr2 = r2 + dx[j];
			int lc2 = c2 + dy[j];
			if (lr1 < 0 || lr1 >= n || lc1 < 0 || lc1 >= m) continue;
			if (lr2 < 0 || lr2 >= n || lc2 < 0 || lc2 >= m) continue;
			int ans = abs(r1 - lr1) + abs(c1 - lc1) + abs(lr1 - lr2) + abs(lc1 - lc2) + abs(lr2 - r2) + abs(lc2 - c2);
			if (time - r[lr1] <= k && time - c[lc2] <= k) mnans = min(mnans, ans);
			else if (time - r[lr2] <= k && time - c[lc1] <= k) mnans = min(mnans, ans);
		}
	}
	return mnans;
}

int get2(int r1, int c1, int r2, int c2, int time, int k) {
	int ans = abs(r1 - r2) + abs(c1 - c2);
	int L = min(c1, c2) + 1;
	int R = max(c1, c2) - 1;
	if (L > R) {
		if (time - c[c1] <= k) return ans;
		if (time - c[c2] <= k) return ans;
	}
	else if (time - ct.mn(L, R) <= k) return ans;
	L = min(r1, r2) + 1;
	R = max(r1, r2) - 1;
	if (L > R) {
		if (time - r[r1] <= k) return ans;
		if (time - r[r2] <= k) return ans;
	}
	else if (time - rt.mn(L, R) <= k) return ans;
	return inf;
}



int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	cin >> n >> m >> q;
	for (int i = 0; i < n; ++i) r[i] = -1;
	for (int i = 0; i < m; ++i) c[i] = -1;
	ct.build(-1);
	rt.build(-1);
	for (int i = 0; i < q; ++i) {
		int t;
		cin >> t;
		if (t == 1) {
			int x;
			cin >> x;
			r[--x] = i;
			rt.upd(x, i);
		}
		else if (t == 2) {
			int x;
			cin >> x;
			c[--x] = i;
			ct.upd(x, i);
		}
		else {
			int r1, c1, r2, c2, k;
			cin >> r1 >> c1 >> r2 >> c2 >> k;
			r1--; c1--; r2--; c2--;
			int ans = inf;
			if (get(r1,c1,i) <= k && get(r2,c2,i) <= k) 
				ans = min(get1(r1,c1,r2,c2,i,k), get2(r1,c1,r2,c2,i,k));
			if (ans == inf) ans = -1;
			cout << ans << "\n";
		}
	}

}