#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <deque>
#include <iomanip>
#include <cstdio>
#include <climits>
#include <cmath>
std::vector<std::vector<int>> snow;
struct state
{
	int x, y, dist;
};
int main(int argc, char*argv[])
{
	int n, m, q; std::cin >> n >> m >> q;
	snow.resize(n, std::vector<int>(m));
	for(int _ = 0; _ < q; _++)
	{
		int type; 
		std::cin >> type;
		for(int i = 0; i < n; i++) for(int j = 0; j < m; j++) snow[i][j]++;
		if(type == 1)
		{
			int row; std::cin >> row; row--;
			for(int i = 0; i < m; i++)
				snow[row][i] = 0;
		}
		if(type == 2)
		{
			int col; std::cin >> col; col--;
			for(int i = 0; i < n; i++)
				snow[i][col] = 0;
		}
		if(type == 3)
		{
			int fx, fy, tx, ty, k;
			std::cin >> fy >> fx >> ty >> tx >> k;
			fx--; fy--; tx--; ty--;
			//for(int i = 0; i < n; i++)
			//{
			//	for(int j = 0; j < m; j++) std::cout << snow[i][j];
			//	std::cout << '\n';
			//}
			if(snow[fy][fx] > k)
			{
				std::cout << "-1\n";
				continue;
			}
			std::queue<state> q;
			std::map<std::pair<int,int>, bool> marks;
			q.push({fx, fy, 0});
			marks[{fx,fy}] = 1;
			bool done = false;
			while(!q.empty())
			{
				state cur = q.front();
				//printf("state: x=%d y=%d d=%d\n", cur.x, cur.y, cur.dist);
				if(cur.x == tx && cur.y == ty)
				{
					std::cout << cur.dist << '\n';
					done = true;
					break;
				}
				q.pop();
				int cx = cur.x, cy = cur.y;
				int dx[4] = {0, 0, 1, -1};
				int dy[4] = {1, -1, 0, 0};
				for(int i = 0; i < 4; i++)
				{
					int nx = cx + dx[i];
					if(nx >= m || nx < 0) continue;
					int ny = cy + dy[i];
					if(ny >= n || ny < 0) continue;
					if(snow[ny][nx] > k) continue;
					if(marks[{nx,ny}]) continue;
					marks[{nx,ny}] = 1;
					q.push({nx,ny, cur.dist + 1});
				}
			}
			if(!done) std::cout << -1 << '\n';
		}
	}
	return 0;	
}
