#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <deque>
#include <queue>
#include <iomanip>
#include <functional>
#include <string>
#include <algorithm>
#include <cstring>
#include <cassert>
#include <random>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(T &x, ostream &out = cerr) {
	output(all(x), out);
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

struct segment {
	int l, r, clr;
};

bool operator < (segment a, segment b) {
	return (a.r - a.l) < (b.r - b.l);
}

const int mx = 3e5 + 228;
int m, n, a[mx], b[mx], l[mx], r[mx];

int main() {
	fast_io();
	cin >> m >> n;
	for (int i = 0; i < n; ++i) {
		l[i] = m;
		r[i] = -1;
	}
	for (int i = 0; i < m; ++i) {
		cin >> a[i];
		a[i]--;
		chkmin(l[a[i]], i);
		chkmax(r[a[i]], i);
	}
	vector<segment> seg;
	for (int i = 0; i < n; ++i) {
		if (l[i] <= r[i]) {
			seg.push_back({l[i], r[i], i});
		}
	}

	sort(rall(seg));
	fill(b, b + m, -1);
	for (int i = 0; i < seg.size(); ++i) {
		for (int j = seg[i].l; j <= seg[i].r; ++j) {
			b[j] = seg[i].clr;
		}
	}

	int not_ok = 0;
	for (int i = 0; i < m; ++i) {
		if (a[i] != b[i]) {
			not_ok = 1;
		}
	}

	if (not_ok) {
		cout << -1 << endl;
	}
	else {
		cout << seg.size() << endl;
		for (int i = 0; i < seg.size(); ++i) {
			cout << seg[i].clr + 1 << " " << seg[i].l + 1 << " " << seg[i].r + 1 << endl;
		}
	}
}