#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <deque>
#include <queue>
#include <iomanip>
#include <functional>
#include <string>
#include <algorithm>
#include <cstring>
#include <cassert>
#include <random>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(T &x, ostream &out = cerr) {
	output(all(x), out);
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int INF = 1e9;
const int mx = 1e6 + 228;
int n, m, q, f_row[mx], f_col[mx], mod;

int chkrow(int r, int k) {
	return (mod - f_row[r] <= k);
}

int chkcol(int c, int k) {
	return (mod - f_col[c] <= k);
}

int get(int r1, int c1, int r2, int c2, int k) {
	/*cerr << "get " << r1 << " " << c1 << " " << r2 << " " << c2 << " " << k << endl;
	cerr << "row" << endl;
	for (int i = 0; i < n; ++i) {
		cout << chkrow(i, k) << " ";
	}
	cout << endl;
	cerr << "col" << endl;
	for (int i = 0; i < m; ++i) {
		cout << chkcol(i, k) << " ";
	}
	cout << endl;*/
	int dist0 = abs(r1 - r2) + abs(c1 - c2);
	int r_min = min(r1, r2), r_max = max(r1, r2);
	int c_min = min(c1, c2), c_max = max(c1, c2);
	int ok = 1;
	for (int i = r_min; i <= r_max; ++i) {
		if (chkrow(i, k) == 0) {
			ok = 0;
			break;
		}
	}
	if (ok) {
		return dist0;
	}
	ok = 1;
	for (int i = c_min; i <= c_max; ++i) {
		if (chkcol(i, k) == 0) {
			ok = 0;
			break;
		}
	}
	if (ok) {
		return dist0;
	}
	if (chkrow(r1, k) && chkcol(c2, k)) {
		return dist0;
	}
	if (chkcol(c1, k) && chkrow(r2, k)) {
		return dist0;
	}
	int best = INF;
	if (chkrow(r1, k) && chkrow(r2, k)) {
		for (int i = c_min; i <= c_max; ++i) {
			if (chkcol(i, k)) {
				best = 0;
				break;
			}
		}
		for (int i = c_min - 1; i >= 0; --i) {
			if (chkcol(i, k)) {
				chkmin(best, c_min - i);
			}
		}
		for (int i = c_max + 1; i < m; ++i) {
			if (chkcol(i, k)) {
				chkmin(best, i - c_max);
			}
		}
	}
	if (chkcol(c1, k) && chkcol(c2, k)) {
		for (int i = r_min; i <= r_max; ++i) {
			if (chkrow(i, k)) {
				best = 0;
				break;
			}
		}
		for (int i = r_min - 1; i >= 0; --i) {
			if (chkrow(i, k)) {
				chkmin(best, r_min - i);
			}
		}
		for (int i = r_max + 1; i < n; ++i) {
			if (chkrow(i, k)) {
				chkmin(best, i - r_max);
			}
		}
	}
	if (best == INF) {
		return -1;
	}
	else {
		return dist0 + 2 * best;
	}
}

int main() {
	fast_io();
	cin >> n >> m >> q;
	for (int i = 0; i < q; ++i) {
		mod++;
		int type, pos;
		cin >> type;
		if (type == 1) {
			cin >> pos;
			pos--;
			f_row[pos] = mod;
		}
		if (type == 2) {
			cin >> pos;
			pos--;
			f_col[pos] = mod;
		}
		if (type == 3) {
			int r1, c1, r2, c2, k;
			cin >> r1 >> c1 >> r2 >> c2 >> k;
			int res = get(r1 - 1, c1 - 1, r2 - 1, c2 - 1, k);
			cout << res << "\n";
		}
	}
}