#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <deque>
#include <queue>
#include <iomanip>
#include <functional>
#include <string>
#include <algorithm>
#include <cstring>
#include <cassert>
#include <random>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(T &x, ostream &out = cerr) {
	output(all(x), out);
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

struct node {
	int val, l, r;
	node (int _val, int _l, int _r): val(_val), l(_l), r(_r) {}
};

struct pst {
	vector<node> t;
	int n;
	vector<int> versions;

	int new_node(int val, int l, int r) {
		t.emplace_back(val, l, r);
		return (int)t.size() - 1;
	}

	int build(int tl, int tr) {
		if (tl == tr) {
			return new_node(0, -1, -1);
		}
		else {
			int tm = (tl + tr) >> 1;
			int l = build(tl, tm);
			int r = build(tm + 1, tr);
			return new_node(0, l, r);
		}
	}

	pst() {}

	void init(int _n) {
		n = _n;
		int root = build(0, n - 1);
		versions.push_back(root);
	}

	int update(int pos, int val, int v, int tl, int tr) {
		if (tl == tr) {
			return new_node(t[v].val + 1, -1, -1);
		}
		else {
			int tm = (tl + tr) >> 1, l = t[v].l, r = t[v].r;
			if (pos <= tm) {
				l = update(pos, val, l, tl, tm);
			}
			else {
				r = update(pos, val, r, tm + 1, tr);
			}
			return new_node(t[l].val + t[r].val, l, r);
		}
	}

	void update(int pos) {
		int new_root = update(pos, 1, versions.back(), 0, n - 1);
		versions.push_back(new_root);
	}

	void copy() {
		versions.push_back(versions.back());
	}

	int get(int l, int r, int v, int tl, int tr) {
		if (l > r) {
			return 0;
		}
		if (l == tl && r == tr) {
			return t[v].val;
		}
		int tm = (tl + tr) >> 1;
		int res_l = get(l, min(r, tm), t[v].l, tl, tm);
		int res_r = get(max(l, tm + 1), r, t[v].r, tm + 1, tr);
		return res_l + res_r;
	}

	int get(int sl, int sr, int l, int r) {
		int rbig = get(l, r, versions[sr + 1], 0, n - 1), rsmall = get(l, r, versions[sl], 0, n - 1);
		return rbig - rsmall;
	}

	int bigger(int pos, int v1, int v2, int tl, int tr) {
		if (tl == tr) {
			if (t[v1].val < t[v2].val) {
				return tl;
			}
			else {
				return tl + 1;
			}
		}
		int tm = (tl + tr) >> 1;
		if (pos <= tm && t[t[v1].l].val < t[t[v2].l].val) {
			int res_l = bigger(pos, t[v1].l, t[v2].l, tl, tm);
			if (res_l <= tm) {
				return res_l;
			}
		}
		int res_r = bigger(pos, t[v1].r, t[v2].r, tm + 1, tr);
		return res_r;
	}

	int bigger(int v1, int v2, int pos) {
		int res = bigger(pos, versions[v1], versions[v2 + 1], 0, n - 1);
		return res;
	}

	int smaller(int pos, int v1, int v2, int tl, int tr) {
		if (tl == tr) {
			if (t[v1].val < t[v2].val) {
				return tl;
			}
			else {
				return tl - 1;
			}
		}
		int tm = (tl + tr) >> 1;
		if (pos >= tm + 1 && t[t[v1].r].val < t[t[v2].r].val) {
			int res_r = smaller(pos, t[v1].r, t[v2].r, tm + 1, tr);
			if (res_r >= tm + 1) {
				return res_r;
			}
		}
		int res_l = smaller(pos, t[v1].l, t[v2].l, tl, tm);
		return res_l;
	}

	int smaller(int v1, int v2, int pos) {
		int res = smaller(pos, versions[v1], versions[v2 + 1], 0, n - 1);
		return res;
	}
};

const int INF = 1e9;

struct rmq {
	vector<int> t;
	int n;

	rmq() {}

	void init(int _n) {
		n = _n;
		t.resize(4 * n, -1);
	}

	void update(int pos, int val, int v, int tl, int tr) {
		if (tl == tr) {
			t[v] = val;
		}
		else {
			int tm = (tl + tr) >> 1;
			if (pos <= tm) {
				update(pos, val, v * 2, tl, tm);
			}
			else {
				update(pos, val, v * 2 + 1, tm + 1, tr);
			}
			t[v] = min(t[v * 2], t[v * 2 + 1]);
		}
	}

	int get(int l, int r, int v, int tl, int tr) {
		if (l > r) {
			return INF;
		}
		if (l == tl && r == tr) {
			return t[v];
		}
		int tm = (tl + tr) >> 1;
		int res_l = get(l, min(r, tm), v * 2, tl, tm);
		int res_r = get(max(l, tm + 1), r, v * 2 + 1, tm + 1, tr);
		return min(res_l, res_r);
	}

	void update(int pos, int val) {
		update(pos, val, 1, 0, n - 1);
	}

	int get(int l, int r) {
		int res = get(l, r, 1, 0, n - 1);
		return res;
	}
};

const int mx = 1e6 + 228;
int n, m, q;

pst t1, t2;
rmq R1, R2;

int get(int r1, int c1, int r2, int c2, int k, int id) {
	/*cerr << "get " << r1 << " " << c1 << " " << r2 << " " << c2 << " " << k << endl;
	cerr << "row" << endl;
	for (int i = 0; i < n; ++i) {
		cout << chkrow(i, k) << " ";
	}
	cout << endl;
	cerr << "col" << endl;
	for (int i = 0; i < m; ++i) {
		cout << chkcol(i, k) << " ";
	}
	cout << endl;*/
	int dist0 = abs(r1 - r2) + abs(c1 - c2);
	int r_min = min(r1, r2), r_max = max(r1, r2);
	int c_min = min(c1, c2), c_max = max(c1, c2);
	int L = id - k, R = id;
	if (L < 0) {
		return dist0;
	}
	int sum_r = t1.get(L, R, r_min, r_max);
	int sum_c = t2.get(L, R, c_min, c_max);
	int mr = R1.get(r_min, r_max);
	int mc = R2.get(c_min, c_max);
	if (mr >= L || mc >= L) {
		return dist0;
	}
	int is_r1 = t1.get(L, R, r1, r1);
	int is_r2 = t1.get(L, R, r2, r2);
	int is_c1 = t2.get(L, R, c1, c1);
	int is_c2 = t2.get(L, R, c2, c2);
	if (is_r1 && is_c2) {
		return dist0;
	}
	if (is_c1 && is_r2) {
		return dist0;
	}
	int best = INF;
	if (is_r1 && is_r2) {
		if (sum_c) {
			best = 0;
		}
		else {
			int lpos = t2.smaller(L, R, c_min);
			int rpos = t2.bigger(L, R, c_max);
			if (lpos > -1) {
				chkmin(best, c_min - lpos);
			}
			if (rpos < m) {
				chkmin(best, rpos - c_max);
			}
		}
	}
	if (is_c1 && is_c2) {
		if (sum_r) {
			best = 0;
		}
		else {
			int lpos = t1.smaller(L, R, r_min);
			int rpos = t1.bigger(L, R, r_max);
			if (lpos > -1) {
				chkmin(best, r_min - lpos);
			}
			if (rpos < n) {
				chkmin(best, rpos - r_max);
			}
		}
	}
	if (best == INF) {
		return -1;
	}
	else {
		return dist0 + 2 * best;
	}
}

int main() {
	fast_io();
	cin >> n >> m >> q;
	t1.init(n);
	t2.init(m);
	R1.init(n);
	R2.init(m);
	for (int i = 0; i < q; ++i) {
		int type, pos;
		cin >> type;
		if (type == 1) {
			cin >> pos;
			pos--;
			t1.update(pos);
			R1.update(pos, i);
			t2.copy();
		}
		if (type == 2) {
			cin >> pos;
			pos--;
			t2.update(pos);
			R2.update(pos, i);
			t1.copy();
		}
		if (type == 3) {
			int r1, c1, r2, c2, k;
			cin >> r1 >> c1 >> r2 >> c2 >> k;
			t1.copy();
			t2.copy();
			int res = get(r1 - 1, c1 - 1, r2 - 1, c2 - 1, k, i);
			cout << res << "\n";
		}
	}
}
