#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <deque>
#include <queue>
#include <iomanip>
#include <functional>
#include <string>
#include <algorithm>
#include <cstring>
#include <cassert>
#include <random>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(T &x, ostream &out = cerr) {
	output(all(x), out);
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int mx = 20;
int n, m, q;
ll p;
vector<vector<pair<int, ll> > > g;

int dfs(int v, int t, int r, ll sum) {
	if (v == t && sum >= r && sum * (p - 1) <= p * r) {
		return 1;
	}
	for (auto pp : g[v]) {
		if (dfs(pp.first, t, r, sum + pp.second)) {
			return 1;
		}
	}
	return 0;
}

void solve() {
	cin >> n >> m >> q >> p;
	if (n > 10 || m > 10 || q > 10) {
		return;
	}
	g.resize(n);
	for (int i = 0; i < n; ++i) {
		g[i].clear();
	}
	for (int i = 0; i < m; ++i) {
		int u, v, cost;
		cin >> u >> v >> cost;
		u--;
		v--;
		if (u > v) {
			swap(u, v);
		}
		g[u].push_back({v, cost});
	}
	for (int i = 0; i < q; ++i) {
		int t, r;
		cin >> t >> r;
		t--;
		int res = dfs(0, t, r, 0);
		cout << res;
	}
	cout << endl;
}

int main() {
	fast_io();
	int T;
	cin >> T;
	for (int i = 0; i < T; ++i) {
		solve();
	}
}
