#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <deque>
#include <queue>
#include <iomanip>
#include <functional>
#include <string>
#include <algorithm>
#include <cstring>
#include <cassert>
#include <random>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(T &x, ostream &out = cerr) {
	output(all(x), out);
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int mx = 5e3 + 228;
const int C = 1e4 + 228;
int n, m, q;
char dp[mx][C];
ll p;
vector<vector<pair<int, ll> > > g;

int dfs(int v, int t, ll r, ll sum) {
	if (v == t && sum >= r && sum * (p - 1) <= p * r) {
		return 1;
	}
	for (auto pp : g[v]) {
		if (dfs(pp.first, t, r, sum + pp.second)) {
			return 1;
		}
	}
	return 0;
}

vector<ll> s, d;

int get(int v, ll l) {
	ll r = 2 * l;
	for (int i = 0; i < v; ++i) {
		l -= s[i];
		r -= s[i];
	}
	if (r < 0) {
		return 0;
	}
	ll sum = 0;
	for (int i = 0; i < v; ++i) {
		if (d[i] <= r) {
			sum += d[i];
		}
	}
	return (sum >= l);
}

void solve() {
	cin >> n >> m >> q >> p;
	g.resize(n);
	for (int i = 0; i < n; ++i) {
		g[i].clear();
	}
	for (int i = 0; i < m; ++i) {
		int u, v;
		ll cost;
		cin >> u >> v >> cost;
		u--;
		v--;
		if (u > v) {
			swap(u, v);
		}
		g[u].push_back({v, cost});
	}
	s.clear();
	d.clear();
	for (int i = 0; i < n - 1; ++i) {
		ll low = min(g[i][0].second, g[i][1].second);
		ll high = max(g[i][0].second, g[i][1].second);
		s.push_back(low);
		d.push_back(high - low);
	}
	for (int i = 0; i < q; ++i) {
		int v;
		ll l;
		cin >> v >> l;
		v--;
		int res = get(v, l);
		cout << res;
	}
	cout << endl;
}

signed main() {
	fast_io();
	int T;
	cin >> T;
	for (int i = 0; i < T; ++i) {
		solve();
	}
}
