#include <bits/stdc++.h>
#define ll long long

using namespace std;

struct edge{
    int to;
    ll w;

    edge(int to, ll w){
        this->to = to;
        this->w = w;
    }
};

int dfs(vector<vector<edge> >& a, int from, int to, ll l, ll r1, ll r2){
    if (from == to){
        return (r1 <= l && r2 >= l ? 1 : 0);
    }
    if (l > r2){
        return 0;
    }
    for (auto e: a[from]){
        int res = dfs(a, e.to, to, l + e.w, r1, r2);
        if (res == 1){
            return 1;
        }
    }
    return 0;
}

void solve_group1(int n, int m, int q, int p){
    int v, u;
    ll w, r;
    vector<vector<edge> > a(n);
    for (int i = 0; i < m; ++i){
        cin >> v >> u >> w;
        a[v - 1].push_back({u - 1, w});
    }
    for (int i = 0; i < q; ++i){
        cin >> v >> r;
        cout << dfs(a, 0, v - 1, 0, r, r + r / (p - 1));
    }
    cout << "\n";
}

void dfs2(vector<vector<edge> >& a, vector<vector<bool> >& ok, int v, int l){
    ok[v][l] = true;
    for (auto e: a[v]){
        if (l + e.w <= 10000 && !ok[e.to][l + e.w]){
            dfs2(a, ok, e.to, l + e.w);
        }
    }
}

void solve(){
    int n, m, q, p, v, u;
    ll w, r;
    cin >> n >> m >> q >> p;
    if (n <= 10){
        solve_group1(n, m, q, p);
        return;
    }
    vector<vector<edge> > a(n);
    for (int i = 0; i < m; ++i){
        cin >> v >> u >> w;
        a[v - 1].push_back({u - 1, w});
    }
    vector<vector<bool> > ok(n, vector<bool>(10001, false));
    dfs2(a, ok, 0, 0);
    for (int i = 0; i < q; ++i){
        cin >> v >> r;
        --v;
        bool found = false;
        for (int j = r; j <= r + r / (p - 1); ++j){
            if (ok[v][j]){
                found = true;
                break;
            }
        }
        cout << found ? 1 : 0;
    }
    cout << "\n";
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    int t;
    cin >> t;
    for (int i = 0; i < t; ++i){
        solve();
    }
    return 0;
}

/*
2
3 3 5 20
1 2 20
2 3 1
1 3 10
2 19
2 20
3 20
3 21
3 9
7 10 5 5
1 2 15
1 3 10
2 4 21
3 4 30
2 5 14
3 5 31
4 6 3
5 6 14
1 7 39
5 7 13
7 42
7 43
7 44
5 39
6 44
*/
/*
1
4 6 5 2
1 2 1
2 3 1
3 4 1
1 2 70
2 3 120
3 4 4
4 90
4 2
4 10
4 37
2 34
*/
