#include <bits/stdc++.h>

using namespace std;

#define int long long

const int INF = 1e9 + 239;

vector<vector<pair<int, int>>> g;

int dfs(int cur, int to, int limit) {
	if (0 > limit) {
		return -INF;
	}
	int ans = -INF;                              
	if (cur == to) {
		ans = max(ans, (int)0);	
	}
	for (auto t : g[cur]) {
		int cand = dfs(t.first, to, limit - t.second);
		if (cand != -INF) {
			ans = max(ans, cand + t.second);
		}
	}
	return ans;
}

void solve1(int n, int m, int q, int p) {
	//cout << "solve1" << endl;
	g.clear();
	g.resize(n);
	for (int i = 0; i < m; i++) {
		int u, v, d;
		cin >> u >> v >> d;
		u--;
		v--;
		g[u].push_back({v, d});
	}
	while (q--) {
		int f, r;
		cin >> f >> r;
		f--;
		int limit = (p * r) / (p - 1);
		int sl = dfs(0, f, limit);
		if (r <= sl && sl <= limit) {
        	cout << 1;
        } else {
        	cout << 0;
        }
	}
	cout << endl;
}
   
const int MAXN = 5003;
const int MAXR = 10002;

int can[MAXR][MAXR];

int timer = 1;
	
void dfs2(int cur, int cur_dist) {
	if (cur_dist >= MAXR) return;
	if (can[cur][cur_dist] != timer) {
     	can[cur][cur_dist] = timer;
     	for (auto t : g[cur]) {
     		dfs2(t.first, cur_dist + t.second);
     	}  
	}	
}

void solve2(int n, int m, int q, int p) {
	timer++;
	g.clear();
	g.resize(n);
	for (int i = 0; i < m; i++) {
		int u, v, d;
		cin >> u >> v >> d;
		u--;
		v--;
		g[u].push_back({v, d});
	}
	dfs2(0, 0);
	while (q--) {
    	int f, r;
    	cin >> f >> r;
    	f--;
    	int sl = -1;
    	int limit = (p * r) / (p - 1);
    	for (int i = 0; i <= limit; i++) {
    		if (can[f][i] == timer) sl = i;
    	}
    	if (r <= sl && sl <= limit) {
        	cout << 1;
        } else {
        	cout << 0;
        }
    }           
    cout << endl;
}

void solve() {
	int n, m, q, p;
	cin >> n >> m >> q >> p;
	if (n <= 10 && m <= 10 && q <= 10) {
		solve1(n, m, q, p);
	} else {
		solve2(n, m, q, p);
	}
}    	
signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	#endif
	
	 int t;
	 cin >> t;
	 while (t--) {
	 	solve();
	 }
}