#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <math.h>
#include <queue>
#include <random>

using namespace std;

typedef long long ll;
typedef long double ld;
#define np nullptr

pair<int, int> sr[2500000];
pair<int, int> st[2500000];
int srz[1000010];
int stz[1000010];

void set1(int v, int l, int r, int pos, int val) {
	if (r - l == 1) {
		sr[v] = { val, val };
		return;
	}
	int m = (r + l) / 2;
	if (pos < m) {
		set1(v * 2, l, m, pos, val);
	}
	else {
		set1(v * 2 + 1, m, r, pos, val);
	}
	sr[v].first = max(sr[v * 2].first, sr[v * 2 + 1].first);
	sr[v].second = min(sr[v * 2].second, sr[v * 2 + 1].second);
}

void set2(int v, int l, int r, int pos, int val) {
	if (r - l == 1) {
		st[v] = { val, val };
		return;
	}
	int m = (r + l) / 2;
	if (pos < m) {
		set2(v * 2, l, m, pos, val);
	}
	else {
		set2(v * 2 + 1, m, r, pos, val);
	}
	st[v].first = max(st[v * 2].first, st[v * 2 + 1].first);
	st[v].second = min(st[v * 2].second, st[v * 2 + 1].second);
}

pair<int, int> getInf1(int v, int tl, int tr, int l, int r) {
	if (tl >= l && tr <= r) {
		return sr[v];
	}
	if (tl >= r || tr <= l) {
		return { -1e9, 1e9 };
	}
	int m = (tr + tl) / 2;
	pair<int, int> ans1 = getInf1(v * 2, tl, m, l, r), ans2 = getInf1(v * 2 + 1, m, tr, l, r);
	return { max(ans1.first, ans2.first), min(ans1.second, ans2.second) };
}

pair<int, int> getInf2(int v, int tl, int tr, int l, int r) {
	if (tl >= l && tr <= r) {
		return st[v];
	}
	if (tl >= r || tr <= l) {
		return { -1e9, 1e9 };
	}
	int m = (tr + tl) / 2;
	pair<int, int> ans1 = getInf2(v * 2, tl, m, l, r), ans2 = getInf2(v * 2 + 1, m, tr, l, r);
	return { max(ans1.first, ans2.first), min(ans1.second, ans2.second) };
}

int main() {
#ifdef LOCAL 
	freopen("In.txt", "r", stdin);
	freopen("Out.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int n, m, q, x, x1, y1, x2, y2, k;
	cin >> n >> m >> q;
	pair<int, int> a, b;
	pair<int, int> res;
	int gr = 0;
	for (int i = 1; i <= q; i++) {
		cin >> x;
		if (x == 1) {
			cin >> k;
			k--;
			set1(1, 0, n, k, i);
			srz[k] = i;
		}
		if (x == 2) {
			cin >> k;
			k--;
			set2(1, 0, m, k, i);
			stz[k] = i;
		}
		if (x == 3) {
			cin >> x1 >> y1 >> x2 >> y2 >> k;
			x1--;
			y1--;
			x2--;
			y2--;
			a = { srz[x1], stz[y1] };
			b = { srz[x2], stz[y2] };
			gr = i - k;
			if (a.first < gr && a.second < gr || b.first < gr && b.second < gr) {
				cout << -1 << "\n";
				continue;
			}
			if (a.first >= gr && b.second >= gr || a.second >= gr && b.first >= gr) {
				cout << abs(x1 - x2) + abs(y1 - y2) << "\n";
				continue;
			}
			if (x1 > x2) {
				swap(x1, x2);
			}
			if (y1 > y2) {
				swap(y1, y2);
			}
			if (a.first >= gr) {
				res = getInf1(1, 0, n, x1, x2);
				if (res.second >= gr) {
					cout << abs(x1 - x2) + abs(y1 - y2) << "\n";
					continue;
				}
				res = getInf2(1, 0, m, y1, y2 + 1);
				if (res.first >= gr) {
					cout << abs(x1 - x2) + abs(y1 - y2) << "\n";
					continue;
				}
				int l = -1;
				int r = y1;
				int med;
				while (r - l > 1) {
					med = (r + l) / 2;
					res = getInf2(1, 0, m, med, y1);
					if (res.first >= gr) {
						l = med;
					}
					else {
						r = med;
					}
				}
				int ans = 1e9;
				if (l != -1) {
					ans = abs(x1 - x2) + abs(y1 - y2) + (y1 - l) * 2;
				}
				l = y2, r = m;
				while (r - l > 1) {
					med = (r + l) / 2;
					res = getInf2(1, 0, m, y2 + 1, med + 1);
					if (res.first >= gr) {
						r = med;
					}
					else {
						l = med;
					}
				}
				if (r != m) {
					ans = min(ans, abs(x1 - x2) + abs(y1 - y2) + (r - y2) * 2);
				}
				if (ans == 1e9) {
					cout << -1 << "\n";
				}
				else {
					cout << ans << "\n";
				}
			} 
			else {
				res = getInf2(1, 0, m, y1, y2);
				if (res.second >= gr) {
					cout << abs(x1 - x2) + abs(y1 - y2) << "\n";
					continue;
				}
				res = getInf1(1, 0, n, x1, x2 + 1);
				if (res.first >= gr) {
					cout << abs(x1 - x2) + abs(y1 - y2) << "\n";
					continue;
				}
				int l = -1;
				int r = x1;
				int med;
				while (r - l > 1) {
					med = (r + l) / 2;
					res = getInf1(1, 0, n, med, x1);
					if (res.first >= gr) {
						l = med;
					}
					else {
						r = med;
					}
				}
				int ans = 1e9;
				if (l != -1) {
					ans = abs(x1 - x2) + abs(y1 - y2) + (x1 - l) * 2;
				}
				l = x2, r = n;
				while (r - l > 1) {
					med = (r + l) / 2;
					res = getInf1(1, 0, n, x2 + 1, med + 1);
					if (res.first >= gr) {
						r = med;
					}
					else {
						l = med;
					}
				}
				if (r != n) {
					ans = min(ans, abs(x1 - x2) + abs(y1 - y2) + (r - x2) * 2);
				}
				if (ans == 1e9) {
					cout << -1 << "\n";
				}
				else {
					cout << ans << "\n";
				}
			}
		}
	}
	return 0;
}