#include <bits/stdc++.h>

#define __LOCAL

#ifdef __LOCAL
#define DBG(X) cerr << #X << "=" << (X) << endl;
#else
#define DBG(X) 42;
#endif

using namespace std;

#define endl '\n'

using ll = long long int;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

struct Edge
{
	int w;
	ll cost;

	Edge(int _w, ll _c): w(_w), cost(_c)
	{
	}
};

void fastio()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}

const int MAX_N = (int)5e5 + 777;
vector<Edge> g[MAX_N];
int n, m, q;
ll p;
vector<ll> dp[MAX_N];
bool met[MAX_N];

string answ;

bool dfs(int v)
{
	met[v] = true;

	for(auto edge: g[v])
	{
		if(!met[edge.w])
			dfs(edge.w);

		for(auto el: dp[edge.w])
			dp[v].push_back(el + edge.cost);
	}
}

void solve()
{
	answ.clear();
	cin >> n >> m >> q >> p;

	for(int v = 0; v < n; ++v)
	{
		g[v].clear();
		dp[v].clear();
	}

	memset(met, 0, sizeof(met));

	dp[0].push_back(0LL);

	for(int i = 0; i < m; ++i)
	{
		int v, u;
		ll cost;

		cin >> v >> u >> cost;
		--v, --u;

		g[u].emplace_back(v, cost);
	}

	for(int i = 0; i < q; ++i)
	{
		int f;
		ll r;
		cin >> f >> r;
		--f;

		if(!met[f])
			dfs(f);

		bool fl = false;

		for(auto el: dp[f])
			fl |= ((p - 1) * r <= (p - 1) * el && (p - 1) * el <= p * r);

		answ.push_back('0' + fl);
	}

	cout << answ << "\n";
}

int main()
{
	fastio();
	int t;
	cin >> t;

	for(; t > 0; --t)
		solve();

	return 0;
}