//#pragma GCC optimize("O2")
#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

int n, m, q;
int ADDED;
short a[10001][10001];
short last_op[10001][10001];
int HR[10001];
int HC[10001];

inline int ans(int v)
{
    if (v > 0) return v;
    else return -v;
}
inline int dist(int x1, int y1, int x2, int y2, int k)
{
    int up1 = x1;
    int down1 = x1;
    while (up1 - 1 >= 1 && a[up1 - 1][y1] + ADDED <= k)
        up1--;
    while (down1 + 1 <= n && a[down1 + 1][y1] + ADDED <= k)
        down1++;
    int left1 = y1;
    int right1 = y1;
    while (left1 - 1 >= 1 && a[x1][left1 - 1] + ADDED <= k)
        left1--;
    while (right1 + 1 <= m && a[x1][right1 + 1] + ADDED <= k)
        right1++;

    int up2 = x2;
    int down2 = x2;
    while (up2 - 1 >= 1 && a[up2 - 1][y2] + ADDED <= k)
        up2--;
    while (down2 + 1 <= n && a[down2 + 1][y2] + ADDED <= k)
        down2++;
    int left2 = y2;
    int right2 = y2;
    while (left2 - 1 >= 1 && a[x2][left2 - 1] + ADDED <= k)
        left2--;
    while (right2 + 1 <= m && a[x2][right2 + 1] + ADDED <= k)
        right2++;

    int ans = 1e9;
    for (int i = 1; i <= m; i++)
    {
        if (HC[i] <= k)
        {
            if (left1 <= i && i <= right1 && left2 <= i && i <= right2)
            {
                ans = min(ans, abs(x1 - x2) + abs(i - y1) + abs(i - y2));
            }
        }
    }
    for (int i = 1; i <= n; i++)
    {
        if (HR[i] <= k)
        {
            if (up1 <= i && i <= down1 && up2 <= i && i <= down2)
            {
                ans = min(ans, abs(y1 - y2) + abs(i - x1) + abs(i - x2));
            }
        }
    }
    if (a[x1][y1] + ADDED > k || a[x2][y2] + ADDED > k)
        return -1;
    if (ans == 1e9) return -1;
    return ans;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m >> q;
    for (int i = 1; i <= q; i++)
    {
        int t = 0;
        cin >> t;
        ADDED++;
        for (int i = 1; i <= n; i++)
            HR[i]++;
        for (int i = 1; i <= m; i++)
            HC[i]++;
        if (t == 1)
        {
            int x;
            cin >> x;
            for (int j = 1; j <= m; j++)
            {
                a[x][j] -= (i - last_op[x][j]);
                last_op[x][j] = i;
            }
            HR[x] = 0;
        }
        if (t == 2)
        {
            int x;
            cin >> x;
            for (int j = 1; j <= n; j++)
            {
                a[j][x] -= (i - last_op[j][x]);
                last_op[j][x] = i;
            }
            HC[x] = 0;
        }
        if (t == 3)
        {
            int x1, y1, x2, y2, k;
            cin >> x1 >> y1 >> x2 >> y2 >> k;
            cout << dist(x1, y1, x2, y2, k) << " ";
        }
    }
}
