#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef pair < int, int > pii;
typedef double db;

#define F first
#define S second
#define pb push_back
#define mp make_pair
#define all(x) x.begin(), x.end()
#define sz(x) int(x.size())
#ifndef MY
    #define endl '\n'
#endif // MY

const int inf = 1e9;
const int N = 1e6 + 6;
const int M = 1e3 + 1;
int lst[2][N];
int mx[2][M];
int mn[2][M];
int fn[2];
int T = 0;

void update(int t, int in) {
    int k = in / M;
    mx[t][k] = T;
    if (lst[t][in] == mn[2][k]) {
        lst[t][in] = T;
        mn[t][k] = inf;
        for (int i = k * M; i < min(fn[t], k * M + M); i++)
            mn[t][k] = min(mn[t][k], lst[t][i]);
    }
    lst[t][in] = T;
}

int get_max(int t, int l, int r) {
    int a = l / M, b = r / M;
    int res = 0;
    if (a == b) {
        for (int i = l; i <= r; i++)
            res = max(lst[t][i], res);
        return res;
    }
    for (int i = l; i < a * M + M; i++)
        res = max(res, lst[t][i]);
    for (int i = a + 1; i < b; i++)
        res = max(res, mx[t][i]);
    for (int i = b * M; i <= r; i++)
        res = max(res, lst[t][i]);
    return res;
}

int get_min(int t, int l, int r) {
    int a = l / M, b = r / M;
    int res = inf;
    if (a == b) {
        for (int i = l; i <= r; i++)
            res = min(lst[t][i], res);
        return res;
    }
    for (int i = l; i < a * M + M; i++)
        res = min(res, lst[t][i]);
    for (int i = a + 1; i < b; i++)
        res = min(res, mx[t][i]);
    for (int i = b * M; i <= r; i++)
        res = min(res, lst[t][i]);
    return res;
}

int get_rgh(int t, int l, int r, int k) {
    k = T - k;
    int a = l / M, b = r / M;
    if (a == b) {
        for (int i = l; i <= r; i++) {
            if (lst[t][i] >= k)
                return i;
        }
        return -1;
    }
    for (int i = l; i < a * M + M; i++) {
        if (lst[t][i] >= k)
            return i;
    }
    for (int i = a + 1; i < b; i++) {
        if (mx[t][i] >= k) {
            for (int j = i * M; j < i * M + M; j++) {
                if (lst[t][j] >= k)
                    return j;
            }
        }
    }
    for (int i = b * M; i <= r; i++) {
        if (lst[t][i] >= k)
            return i;
    }
    return -1;
}

int get_lft(int t, int l, int r, int k) {
    k = T - k;
    int a = l / M, b = r / M;
    if (a == b) {
        for (int i = r; i >= l; i--) {
            if (lst[t][i] >= k)
                return i;
        }
        return -1;
    }
    for (int i = r; i >= b * M; i--) {
        if (lst[t][i] >= k)
            return i;
    }

    for (int i = b - 1; i > a; i--) {
        if (mx[t][i] >= k) {
            for (int j = i * M + M - 1; j >= i * M; j--) {
                if (lst[t][j] >= k)
                    return j;
            }
        }
    }
    for (int i = a * M + M - 1; i >= l; i--) {
        if (lst[t][i] >= k)
            return i;
    }
    return -1;
}

bool ok_r(int x, int k) {
    return T - lst[0][x] <= k;
}

bool ok_c(int x, int k) {
    return T - lst[1][x] <= k;
}

int main() {
#ifdef MY
    freopen("f.in", "r", stdin);
    //freopen("f.in", "w", stdout);
#endif // MY
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, m, q;
    cin >> n >> m >> q;
    fn[0] = n, fn[1] = m;
    //build(0, n);
    //build(1, m);
    while (q--) {
        T++;
        int t;
        cin >> t;
        if (t != 3) {
            int x;
            cin >> x;
            update(t - 1, x - 1);
            continue;
        }
        pii x, y;
        int k;
        cin >> x.F >> x.S >> y.F >> y.S >> k;
        x.F--, x.S--, y.F--, y.S--;
        bool a = ok_r(x.F, k), b = ok_c(x.S, k);
        bool c = ok_r(y.F, k), d = ok_c(y.S, k);
        int dist = abs(x.F - y.F) + abs(x.S - y.S);
        if ((a && d) || (b && c)) {
            cout << dist << endl;
            continue;
        }
        if (!(a && c) && !(b && d)) {
            cout << -1 << endl;
            continue;
        }
        int res = inf;
        if (a && c) {
            int l =  min(x.S, y.S), r =  max(x.S, y.S);
            int pc = get_max(1, l, r);
            int pr = get_min(0, min(x.F, y.F), max(x.F, y.F));
            if (T - pc <= k || T - pr <= k) {
                cout << dist << endl;
                continue;
            }
            int lf = get_lft(1, 0, l, k);
            int rg = get_rgh(1, r, fn[1], k);
            if (lf != -1)
                res = min(res, abs(x.F - y.F) + abs(lf - x.S) + abs(lf - y.S));
            if (rg != -1)
                res = min(res, abs(x.F - y.F) + abs(rg - x.S) + abs(rg - y.S));
        }
        if (b && d) {
            int l =  min(x.F, y.F), r =  max(x.F, y.F);
            int pr = get_max(0, l, r);
            int pc = get_min(1, min(x.S, y.S), max(x.S, y.S));
            if (T - pc <= k || T - pr <= k) {
                cout << dist << endl;
                continue;
            }
            int lf = get_lft(0, 0, l, k);
            int rg = get_rgh(0, r, fn[0], k);
            if (lf != -1)
                res = min(res, abs(x.S - y.S) + abs(lf - x.F) + abs(lf - y.F));
            if (rg != -1)
                res = min(res, abs(x.S - y.S) + abs(rg - x.F) + abs(rg - y.F));
        }
        if (res == inf)
            res = -1;
        cout << res << endl;
    }
    return 0;
}
