#include <bits/stdc++.h>

using namespace std;

#define INF 4e6

struct DO {
    vector<pair<int, int>> t;
    int n;

    pair<int, int> merge(pair<int, int> a, pair<int, int> b) {
        return {min(a.first, b.first), max(a.second, b.second)};
    }

    DO() {

    }

    DO(int n) : n(n) {
        t.resize(n * 4, {0, 0});
    }

    void update(int pos, int val) {
        update(1, 0, n, pos, val);
    }

    void update(int v, int l, int r, int pos, int val) {
        if (pos < l || pos >= r) {
            return;
        }
        if (l == r - 1) {
            t[v] = {val, val};
            return;
        }
        int m = (r + l) / 2;
        update(v * 2, l, m, pos, val);
        update(v * 2 + 1, m, r, pos, val);
        t[v] = merge(t[v * 2], t[v * 2 + 1]);
    }

    pair<int, int> get(int l, int r) {
        return get(1, 0, n, l, r);
    }

    pair<int, int> get(int v, int tl, int tr, int l, int r) {
        if (r <= tl || l >= tr) {
            return {INF, -INF};
        }
        if (l <= tl && tr <= r) {
            return t[v];
        }
        int m = (tr + tl) / 2;
        return merge(get(v * 2, tl, m, l, r), get(v * 2 + 1, m, tr, l, r));
    }
};


int dist(int x1, int y1, int x2, int y2) {
    return abs(x1 - x2) + abs(y1 - y2);
}

bool check(int x1, int x2, DO &cur, int k) {
    x1--;
    x2--;
    if (x1 > x2) {
        swap(x1, x2);
    }
    return (cur.get(x1, x2 + 1).second > k);
}

signed main() {
    bool flag = false;
    int n, m, q;
    cin >> n >> m >> q;
    DO cur(n);
    for (int step = 1; step <= q; ++step) {
        int cmd;
        cin >> cmd;
        if (cmd == 1) {
            int x;
            cin >> x;
            x--;
            cur.update(x, -step);
        } else if (cmd == 2) {
            return 1;
        } else {
            int x1, y1, x2, y2, k;
            cin >> x1 >> y1 >> x2 >> y2 >> k;
            k -= step;
            if (check(x1, x2, cur, k)) {
                cout << -1;
            } else {
                cout << dist(x1, y1, x2, y2);
            }
            cout << "\n";
        }
    }
    return 0;
}