#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

struct STR {
    int x, xx, c;
    STR() {}
    STR(int x1, int xx1, int cc) {
        x = x1;
        xx = xx1;
        c = cc;
    }
};

bool cmp(STR a, STR b) {
    if (a.x != b.x) {
        return a.x < b.x;
    }
    return a.xx <= b.xx;
}

vector<int> tr;

void upd(int v, int l, int r, int L, int R, int c) {
    if (L <= l && r <= R) {
        tr[v] = c;
        return;
    }
    if (r <= L || R <= l) {
        return;
    }
    int m = (l + r) / 2;
    if (tr[v] != 0) {
        tr[2 * v + 1] = tr[v];
        tr[2 * v + 2] = tr[v];
        tr[v] = 0;
    }
    upd(2 * v + 1, l, m, L, R, c);
    upd(2 * v + 2, m, r, L, R, c);
    return;
}

int query(int v, int l, int r, int pos) {
    if (l + 1 == r) {
        return tr[v];
    }
    int m = (l + r) / 2;
    if (tr[v] != 0) {
        tr[2 * v + 1] = tr[v];
        tr[2 * v + 2] = tr[v];
        tr[v] = 0;
    }
    if (pos < m) {
        return query(2 * v + 1, l, m, pos);
    } else {
        return query(2 * v + 2, m, r, pos);
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    // freopen("input.txt", "r", stdin);
    int m, n;
    cin >> m >> n;
    vector<int> a(m), l(n + 1, m), r(n + 1, 0);
    vector<STR> tmp;
    for (int i = 0; i < m; i++) {
        cin >> a[i];
        l[a[i]] = min(l[a[i]], i);
        r[a[i]] = max(r[a[i]], i);
    }
    for (int i = 1; i <= n; i++) {
        if (l[i] != m) {
            tmp.push_back(STR(l[i], r[i], i));
        }
    }
    stable_sort(tmp.begin(), tmp.end(), cmp);
    vector<int> used(n + 1);
    tr.resize(4 * m + 1);
    int sz = tmp.size();
    for (int i = 0; i < sz; i++) {
        upd(0, 0, m, tmp[i].x, tmp[i].xx + 1, tmp[i].c);
    }
    bool flag = true;
    for (int i = 0; i < m; i++) {
        if (a[i] != query(0, 0, m, i)) {
            flag = false;
            break;
        }
    }
    if (!flag) {
        cout << -1;
        return 0;
    }
    cout << sz << '\n';
    for (int i = 0; i < sz; i++) {
        cout << tmp[i].c << ' ' << tmp[i].x + 1 << ' ' << tmp[i].xx + 1 << '\n';
    }
    return 0;
}
