#include <algorithm>
#include <iostream>
#include <fstream>
#include <vector>
#include <string>

using namespace std;

int count(vector<int>& a, int left, int right, int k) {
	int result = 0;
	for (int i = left; i <= right; ++i) {
		if (a[i] <= k) {
			++result;
		}
	}
	return result;
}

int main() {
#ifdef _DEBUG
	ifstream cin("input.txt");
	ofstream cout("output.txt");
#else
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
#endif

	int n, m, q;
	cin >> n >> m >> q;
	vector<int> x(n);
	vector<int> y(m);
	for (int time = 1; time <= q; ++time) {
		int type;
		cin >> type;
		if (type == 1) {
			int xx;
			cin >> xx;
			x[xx - 1] = -time;
		}
		if (type == 2) {
			int yy;
			cin >> yy;
			y[yy - 1] = -time;
		}
		if (type == 3) {
			int x1, x2, y1, y2, k;
			cin >> x1 >> y1 >> x2 >> y2 >> k;
			--x1;
			--x2;
			--y1;
			--y2;
			k = time - k;
			if (x[x1] + k > 0 && y[y1] + k > 0) {
				cout << -1 << "\n";
				continue;
			}
			if (x[x2] + k > 0 && y[y2] + k > 0) {
				cout << -1 << "\n";
				continue;
			}
			if (x[x1] + k <= 0 && y[y2] + k <= 0) {
				cout << (abs(x1 - x2) + abs(y1 - y2)) << "\n";
				continue;
			}
			if (x[x2] + k <= 0 && y[y1] + k <= 0) {
				cout << (abs(x1 - x2) + abs(y1 - y2)) << "\n";
				continue;
			}
			if (x[x1] + k <= 0 && x[x2] + k <= 0) {
				if (count(x, min(x1, x2), max(x1, x2), -k) == abs(x1 - x2) + 1) {
					cout << (abs(x1 - x2) + abs(y1 - y2)) << "\n";
					continue;
				}
				if (count(y, min(y1, y2), max(y1, y2), -k) > 0) {
					cout << (abs(x1 - x2) + abs(y1 - y2)) << "\n";
					continue;
				}
				bool f = false;
				for (int i = 1; i < m; ++i) {
					if (min(y1, y2) - i >= 0) {
						if (y[min(y1, y2) - i] + k <= 0) {
							cout << (abs(x1 - x2) + abs(y1 - y2)) + 2 * i << "\n";
							f = true;
							break;
						}
					}
					if (max(y1, y2) + i < m) {
						if (y[max(y1, y2) + i] + k <= 0) {
							cout << (abs(x1 - x2) + abs(y1 - y2)) + 2 * i << "\n";
							f = true;
							break;
						}
					}
				}
				if (f) {
					continue;
				}
			}
			if (y[y1] + k <= 0 && y[y2] + k <= 0) {
				if (count(y, min(y1, y2), max(y1, y2), -k) == abs(y1 - y2) + 1) {
					cout << (abs(x1 - x2) + abs(y1 - y2)) << "\n";
					continue;
				}
				if (count(x, min(x1, x2), max(x1, x2), -k) > 0) {
					cout << (abs(x1 - x2) + abs(y1 - y2)) << "\n";
					continue;
				}
				bool f = false;
				for (int i = 1; i <= n; ++i) {
					if (min(x1, x2) - i >= 0) {
						if (x[min(x1, x2) - i] + k <= 0) {
							cout << (abs(x1 - x2) + abs(y1 - y2)) + 2 * i << "\n";
							f = true;
							break;
						}
					}
					if (max(x1, x2) + i <= n) {
						if (x[max(x1, x2) + i] + k <= 0) {
							cout << (abs(x1 - x2) + abs(y1 - y2)) + 2 * i << "\n";
							f = true;
							break;
						}
					}
				}
				if (f) {
					continue;
				}
			}
			cout << -1 << "\n";
		}
	}
	return 0;
}
