#pragma GCC optimaze("Ofast, no-stack-protectors");
#pragma GCC optimaze("unroll-loops");
//#pragma GCC target("sse,sse2,sse3,sse4,sse4.2,abm,mmx,popcnt,tune=native");
#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<queue>
#include<random>
#include<chrono>

using namespace std;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

const int maxn = 1e6 + 113;

struct de1 {
	vector<int> ms;
	int n;
	de1(int n)
	{
		ms.resize(4 * n, 0);
		this->n = n;
	}
	void upd(int root, int l, int r, int x, int y)
	{
		if (l > x || r < x)
			return;
		if (l == r)
		{
			ms[root] = y;
			return;
		}
		int m = (l + r) / 2;
		upd(root * 2, l, m, x, y);
		upd(root * 2 + 1, m + 1, r, x, y);
		ms[root] = max(ms[root * 2], ms[root * 2 + 1]);
	}
	void upd(int x, int y)
	{
		upd(1, 1, n, x, y);
	}
	int mx(int root, int l, int r, int l1, int r1)
	{
		if (l1 > r1 || l > r1 || r < l1)
			return 0;
		if (l == l1 && r == r1)
			return ms[root];
		int m = (l + r) / 2;
		return max(mx(root * 2, l, m, l1, min(m, r1)), mx(root * 2 + 1, m + 1, r, max(m + 1, l1), r1));
	}
	int mx(int l, int r)
	{
		return mx(1, 1, n, l, r);
	}
};


struct de2 {
	vector<int> ms;
	int n;
	de2(int n)
	{
		ms.resize(4 * n, 0);
		this->n = n;
	}
	void upd(int root, int l, int r, int x, int y)
	{
		if (l > r || l > x || r < x)
			return;
		if (l == r)
		{
			ms[root] = y;
			return;
		}
		int m = (l + r) / 2;
		upd(root * 2, l, m, x, y);
		upd(root * 2 + 1, m + 1, r, x, y);
		ms[root] = min(ms[root * 2], ms[root * 2 + 1]);
	}
	void upd(int x, int y)
	{
		upd(1, 1, n, x, y);
	}
	int mx(int root, int l, int r, int l1, int r1)
	{
		if (l1 > r1 || l > r1 || r < l1)
			return 1e9;
		if (l == l1 && r == r1)
			return ms[root];
		int m = (l + r) / 2;
		return min(mx(root * 2, l, m, l1, min(m, r1)), mx(root * 2 + 1, m + 1, r, max(m + 1, l1), r1));
	}
	int mx(int l, int r)
	{
		return mx(1, 1, n, l, r);
	}
};

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr), cout.tie(nullptr);
	cout.setf(ios::fixed);
	cout.precision(12);
	int n, m, q;
	cin >> n >> m >> q;
	de1 str1(n);
	de2 str2(n);
	de1 stb1(m);
	de2 stb2(m);
	for (int i = 1; i <= q; i++)
	{
		int a;
		cin >> a;
		if (a == 1)
		{
			int x;
			cin >> x;
			str1.upd(x, i);
			str2.upd(x, i);
		}
		if (a == 2)
		{
			int y;
			cin >> y;
			stb1.upd(y, i);
			stb2.upd(y, i);
		}
		if (a == 3)
		{
			int x1, y1, x2, y2, k;
			cin >> x1 >> y1 >> x2 >> y2 >> k;
			bool tr1 = (str1.mx(x1, x1) >= i - k);
			bool tr2 = (stb1.mx(y1, y1) >= i - k);
			bool tr3 = (str1.mx(x2, x2) >= i - k);
			bool tr4 = (stb1.mx(y2, y2) >= i - k);
			if ((!tr1 && !tr2) || (!tr3 && !tr4))
			{
				cout << "-1\n";
				continue;
			}
			if ((tr1 && tr4) || (tr2 && tr3))
			{
				cout << abs(x1 - x2) + abs(y1 - y2) << "\n";
				continue;
			}
			if (tr1 && tr3)
			{
				int ans = 1e9;
				if (str2.mx(min(x1, x2), max(x1, x2)) >= i - k || stb1.mx(min(y1, y2), max(y1, y2) >= i - k))
					ans = abs(y1 - y2) + abs(x1 - x2);
				else
				{
					if (y1 > y2)
						swap(y1, y2);
					int l = 0, r = y1;
					while (l + 1 < r)
					{
						int m2 = (l + r) / 2;
						if (stb1.mx(m2, y1) >= i - k)
							l = m2;
						else
							r = m2;
					}
					if (l != 0)
						ans = min(ans, abs(x1 - x2) + abs(y1 - l) + abs(y2 - l));
					l = y2, r = m + 1;
					while (l + 1 < r)
					{
						int m2 = (l + r) / 2;
						if (stb1.mx(y2, m2) >= i - k)
							r = m2;
						else
							l = m2;
					}
					if (r != m + 1)
						ans = min(ans, abs(x1 - x2) + abs(y1 - r) + abs(y2 - r));
				}

				if (ans != 1e9)
					cout << ans << "\n";
				else
					cout << "-1\n";
			}
			else
			{
				int ans = 1e9;
				if (stb2.mx(min(y1, y2), max(y1, y2)) >= i - k || str1.mx(min(x1, x2), max(x1, x2)) >= i - k)
					ans = abs(y1 - y2) + abs(x1 - x2);
				else
				{
					if (x1 > x2)
						swap(x1, x2);
					int l = 0, r = x1;
					while (l + 1 < r)
					{
						int m2 = (l + r) / 2;
						if (str1.mx(m2, x1) >= i - k)
							l = m2;
						else
							r = m2;
					}
					if (l != 0)
						ans = min(ans, abs(y1 - y2) + abs(x1 - l) + abs(x2 - l));
					l = x2, r = n + 1;
					while (l + 1 < r)
					{
						int m2 = (l + r) / 2;
						if (str1.mx(x2, m2) >= i - k)
							r = m2;
						else
							l = m2;
					}
					if (r != n + 1)
						ans = min(ans, abs(y1 - y2) + abs(x1 - r) + abs(x2 - r));
				}
				if (ans != 1e9)
					cout << ans << "\n";
				else
					cout << "-1\n";
			}
		}
	}
	//system("pause");
}