#include <iostream>
#include <vector>
#include <algorithm>

#define ll long long

using namespace std;

const int M = (int)2e5;
const ll INF = (ll)1e18;

int get_dif(int h, pair<int, int> d) {
	if (h > d.second)
		return h - d.second;
	if (h < d.first)
		return d.first - h;
	return 0;
}

bool is_inside(pair<int, int> s1, pair<int, int> s2) {
	return s2.first >= s1.first && s2.second <= s1.second;
}

int m, n, k;
vector<int> h[M];
vector<pair<int, int>> d, tmp;
vector<ll> ans;
ll sum;

void solve(int l, int r, int kl, int kr) {
	if (r - l < 1)
		return;

	int c = (l + r) / 2, kc, l_pos, r_pos;
	ll cur, l_sum, r_sum;
	vector<int> p;

	l_pos = -1;
	r_pos = 0;
	l_sum = 0;
	r_sum = 0;
	for (int i = 0; i < m; i++) {
		p.push_back(h[i][2 * c]);
		p.push_back(h[i][2 * c + 1]);
	}
	sort(p.begin(), p.end());
	for (int i = 0; i < 2 * m; i++)
		r_sum += (ll)p[i];

	ans[c] = INF;
	for (int i = kl; i < kr; i++) {
		while (l_pos < 2 * m - 1 && p[l_pos + 1] < d[i].first) {
			l_pos++;
			l_sum += (ll)p[l_pos];
		}
		while (r_pos < 2 * m && p[r_pos] <= d[i].second) {
			r_sum -= (ll)p[r_pos];
			r_pos++;
		}
		cur = (ll)d[i].first * (ll)(l_pos + 1) - l_sum + r_sum - (ll)d[i].second * (ll)(2 * m - r_pos);
		if (ans[c] > cur) {
			ans[c] = cur;
			kc = i;
		}
	}

	if (r - l == 1)
		return;
	solve(l, c, kl, kc + 1);
	solve(c + 1, r, kc, kr);
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> m >> n >> k;
	tmp.resize(k);
	for (int i = 0; i < k; i++)
		cin >> tmp[i].first >> tmp[i].second;
	for (int i = 0; i < m; i++)
		h[i].resize(2 * n);
	for (int i = 0; i < m; i++)
		for (int j = 0; j < 2 * n; j++)
			cin >> h[i][j];

	for (int i = 0; i < m; i++)
		sort(h[i].begin(), h[i].end());

	sort(tmp.begin(), tmp.end(), [](auto p1, auto p2) {
		if (p1.first != p2.first)
			return p1.first < p2.first;
		return p1.second > p2.second;
	});
	d.push_back(tmp[0]);
	for (int i = 1; i < k; i++)
		if (!is_inside(d.back(), tmp[i]))
			d.push_back(tmp[i]);
	k = (int)d.size();

	ans.resize(n);
	solve(0, n, 0, k);

	sum = 0;
	for (ll i : ans)
		sum += i;
	cout << sum << endl;

	//system("pause");
	return 0;
}