#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>

using namespace std;

#define all(v) v.begin(), v.end()

struct Seg {
	int left, right;
	Seg() {}
	pair<int, int> mp() { return { left, right }; }
	bool have(int i) { return left <= i && i <= right; }
};
istream& operator>>(istream &in, Seg &s) { return in >> s.left >> s.right; }
bool operator<(Seg s1, Seg s2) { return s1.mp() < s2.mp(); }

int f(Seg s, int x) {
	if (s.have(x)) return 0;
	return min(abs(x - s.left), abs(x - s.right));
}

int f(vector<Seg> &p, int a, int b) {
	int i = 0;
	for (int j = 0; j < p.size(); ++j) {
		if (f(p[i], a) + f(p[i], b) > f(p[j], a) + f(p[j], b)) {
			i = j;
		}
	}
	return f(p[i], a) + f(p[i], b);
}

int main() {
	int m, n, k;
	cin >> m >> n >> k;
	vector<Seg> p(n);
	for (int i = 0; i < n; ++i) cin >> p[i];
	sort(all(p));
	vector<vector<int>> arr(m, vector<int>(2 * n));
	for (int i = 0; i < m; ++i) {
		for (int j = 0; j < 2 * n; ++j) cin >> arr[i][j];
		sort(all(arr[i]));
	}
	long long d = 0;
	for (int i = 0; i < n; ++i) {
		d += f(p, arr[0][2 * i], arr[0][2 * i + 1]);
	}
	cout << d << endl;
	system("pause");
	return 0;
}