#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <cassert>

using namespace std;

#define all(v) v.begin(), v.end()

struct Seg {
	int left, right;
	Seg() {}
	pair<int, int> mp() { return { left, right }; }
	bool have(int i) { return left <= i && i <= right; }
	bool inside(Seg s) { return s.have(left) && s.have(right); }
};
istream& operator>>(istream &in, Seg &s) { return in >> s.left >> s.right; }
bool operator<(Seg s1, Seg s2) { return s1.mp() < s2.mp(); }

int f(Seg s, int x) {
	if (x < s.left) return s.left - x;
	if (x > s.right) return x - s.right;
	return 0;
}

long long f(vector<vector<int>> &arr, Seg s, int j) {
	long long res = 0;
	for (int i = 0; i < arr.size(); ++i) {
		res += f(s, arr[i][2 * j]) + f(s, arr[i][2 * j + 1]);
	}
	return res;
}

bool check(vector<long long> &arr) {
	int i = 0;
	while (i < arr.size() - 1 && arr[i] > arr[i + 1]) {
		++i;
	}
	while (i < arr.size()) {
		if (arr[i] > arr[i + 1]) return false;
		++i;
	}
	return true;
}

int main() {
	ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
	int m, n, k;
	cin >> m >> n >> k;
	vector<Seg> p(k);
	for (int i = 0; i < k; ++i) cin >> p[i];
	sort(all(p));
	vector<Seg> _p;
	_p.push_back(p[0]);
	for (int i = 1; i < k; ++i) {
		if (!p[i].inside(p[i - 1])) _p.push_back(p[i]);
	}
	p = _p; k = p.size();
	vector<vector<int>> arr(m, vector<int>(2 * n));
	for (int i = 0; i < m; ++i) {
		for (int j = 0; j < 2 * n; ++j) cin >> arr[i][j];
		sort(all(arr[i]));
	}
	long long sd = 0;
	for (int i = 0; i < n; ++i) {
		long long d = 1e18;
		vector<long long> tmp;
		for (int j = 0; j < k; ++j) {
			d = min(d, f(arr, p[j], i));
			tmp.push_back(f(arr, p[j], i));
		}
		assert(check(tmp));
		sd += d;
	}
	cout << sd << endl;
	system("pause");
	return 0;
}