#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <cassert>

using namespace std;

#define all(v) v.begin(), v.end()

struct Seg {
	int left, right;
	Seg() {}
	pair<int, int> mp() { return { left, right }; }
};
istream& operator>>(istream &in, Seg &s) { return in >> s.left >> s.right; }
bool operator<(Seg s1, Seg s2) { return s1.mp() < s2.mp(); }

int f(Seg s, int x) {
	if (x < s.left) return s.left - x;
	if (x > s.right) return x - s.right;
	return 0;
}

long long f(vector<vector<int>> &arr, Seg s) {
	long long res = 0;
	for (int i = 0; i < arr.size(); ++i) {
		res += f(s, arr[i][0]) + f(s, arr[i][1]);
	}
	return res;
}

int main() {
	int m, n, k;
	cin >> m >> n >> k;
	vector<Seg> p(k);
	for (int i = 0; i < k; ++i) cin >> p[i];
	sort(all(p));
	vector<vector<int>> arr(m, vector<int>(2 * n));
	for (int i = 0; i < m; ++i) {
		for (int j = 0; j < 2 * n; ++j) cin >> arr[i][j];
		sort(all(arr[i]));
	}
	long long d = 1e18;
	for (int i = 0; i < k; ++i) {
		d = min(d, f(arr, p[i]));
	}
	cout << d << endl;
	system("pause");
	return 0;
}