#include <iostream>
#include <algorithm>
#include <vector>
#include <map>

using namespace std;

#define all(v) v.begin(), v.end()

const int MOD = 998244353;

struct Item {
	int r, c, v;
	pair<int, int> mp() { return { r, c }; }
};
istream& operator>>(istream &in, Item &it) { return in >> it.r >> it.c >> it.v; }
bool operator<(Item a, Item b) { return a.mp() < b.mp(); }

const int N = 1007;
const int INF = 1e9 + 7;
int n, m, dp[N][N][2];

int rec(int i, int j, bool flag) {
	int &res = dp[i][j][flag];
	if (res != INF) return res;
	if (flag) res = max(rec(i + 1, j, !flag), rec(i, j + 1, !flag));
	else res = min(rec(i + 1, j, !flag), rec(i, j + 1, !flag));
	return res;
}

int main() {
	int k;
	cin >> n >> m >> k;
	vector<Item> lov(k);
	for (int i = 0; i < k; ++i) cin >> lov[i];
	sort(all(lov));
	for (int i = 1; i <= n; ++i) for (int j = 1; j <= m; ++j) dp[i][j][0] = dp[i][j][1] = INF;
	for (auto l : lov) dp[l.r][l.c][0] = dp[l.r][l.c][1] = l.v;
	cout << endl;
	int ans = 0;
	for (int i = 1; i <= n; ++i) {
		for (int j = 1; j <= m; ++j) {
			ans = (ans + rec(i, j, false)) % MOD;
			//cout << rec(i, j, false) << " ";
			/*for (int a = 1; a <= n; ++a) {
				for (int b = 1; b <= m; ++b) {
					cout << dp[a][b][0] << " ";
				}
				cout << endl;
			}
			cout << endl;*/
		}
		//cout << endl;
	}
	cout << (ans + MOD) % MOD << endl;
	system("pause");
	return 0;
}
/*
3 3 3
2 3 -2
3 1 3
1 2 1
*/