#include <iostream>
#include <vector>
#include <algorithm>

const long long INF = 1e18;

void SortParts(std::vector <long long> &L, std::vector <long long> &R, int start, int end);

int main(void) {
    long long m = 0, n = 0, k = 0;
    std::cin >> m >> n >> k;
    std::vector <long long> L(k), R(k);
    for (long long i = 0; i < k; i++)
        std::cin >> L[i] >> R[i];
    long long **group = new long long *[m];
    for (long long i = 0; i < m; i++) {
        group[i] = new long long[2 * n];
        std::vector <long long> mGroup(2 * n);
        for (long long j = 0; j < 2 * n; j++)
            std::cin >> mGroup[j];
        std::sort(mGroup.begin(), mGroup.end());
        for (long long j = 0; j < 2 * n; j++)
            group[i][j] = mGroup[j];
    }

    long long cost = 0, bestCost = INF;
    SortParts(L, R, 0, k - 1);

    long long **dp = new long long *[2 * n + 1];
    for (int i = 0; i <= 2 * n; i++) {
        dp[i] = new long long [k];
        for (int j = 0; j < k; j++)
            dp[i][j] = 0;
    }

    for (int kId = 0; kId < k; kId++) {
        for (int i = 1; i <= 2 * n; i++) {
            if (i > 1)
                dp[i][kId] = dp[i - 1][kId];
            for (int mId = 0; mId < m; mId++) {
                dp[i][kId] += std::max(std::max(L[kId] - group[mId][i - 1], group[mId][i - 1] - R[kId]), 0LL);
                //std::cout << dp[i][kId] << "_" << L[kId] - group[mId][i - 1] << " " << group[mId][i] - R[kId] << "|";
            }
        }
    }

    /*for (int i = 1; i <= n; i++) {
        for (int kId = 0; kId < k; kId++) {
            std::cout << dp[i][kId] << " ";
        }
        std::cout << std::endl;
    }*/

    for (long long num1 = 0; num1 <= n; num1++) {
        if (k == 3) {
            for (long long num2 = 0; num2 <= n - num1; num2++) {
                cost = dp[num1 * 2][0] + (dp[(num2 + num1) * 2][1] - dp[num1 * 2][1]) + (dp[n * 2][2] - dp[(num2 + num1) * 2][2]);
                /*for (long long groupId = 0; groupId < m; groupId++) {
                    for (long long i = 0; i < 2 * n; i++) {
                        if (i < num1 * 2)
                            cost += std::max(std::max(L[0] - group[groupId][i], group[groupId][i] - R[0]), 0LL);
                        else if (i < (num1 + num2) * 2)
                            cost += std::max(std::max(L[1] - group[groupId][i], group[groupId][i] - R[1]), 0LL);
                        else
                            cost += std::max(std::max(L[2] - group[groupId][i], group[groupId][i] - R[2]), 0LL);
                    }
                }*/
                if (cost < bestCost) {
                    bestCost = cost;
                    //std::cout << num1 << " " << num2 << " " << cost << std::endl;
                }
            }
        }
        else {
            cost = 0;
            for (long long groupId = 0; groupId < m; groupId++) {
                for (long long i = 0; i < 2 * n; i++) {
                    if (i < num1 * 2)
                        cost += std::max(std::max(L[0] - group[groupId][i], group[groupId][i] - R[0]), 0LL);
                    else
                        cost += std::max(std::max(L[1] - group[groupId][i], group[groupId][i] - R[1]), 0LL);
                }
            }
            if (cost < bestCost) {
                bestCost = cost;
                //std::cout << num1 << " " << num2 << " " << cost << std::endl;
            }
        }
    }
    std::cout << bestCost << std::endl;
    return 0;
}

void SortParts(std::vector <long long> &L, std::vector <long long> &R, int start, int end) {
    if (start == end)
        return;
    SortParts(L, R, start, (start + end) / 2);
    SortParts(L, R, (start + end) / 2 + 1, end);
    std::vector <int> LTemp, RTemp;
    int i = 0, j = (start + end) / 2 + 1;
    while (i <= (start + end) / 2 && j <= end) {
        if (L[i] < L[j] || (L[i] == L[j] && R[i] < R[j])) {
            LTemp.push_back(L[i]);
            RTemp.push_back(R[i]);
            i++;
        }
        else {
            LTemp.push_back(L[j]);
            RTemp.push_back(R[j]);
            j++;
        }
    }
    while (i <= (start + end) / 2) {
        LTemp.push_back(L[i]);
        RTemp.push_back(R[i]);
        i++;
    }
    while (j <= end) {
        LTemp.push_back(L[j]);
        RTemp.push_back(R[j]);
        j++;
    }
    for (int t = 0; t <= end - start; t++) {
        L[start + t] = LTemp[t];
        R[start + t] = RTemp[t];
    }
}
