#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cstring>
#include <iomanip>
#include <fstream>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <random>
#include <ctime>
#include <cassert>

using namespace std;
typedef long long ll;
typedef unsigned long long ull;

#ifdef DEBUG
	const int MAXN = 10;
	const int MAXLOG = 4;
	const int MAXSQRT = 4;
#else
	const int MAXN = 3e5;
	const int MAXLOG = 20;
	const int MAXSQRT = 400;
	#define cerr if (false) cerr
#endif
const int INF = 1e9;
const int MOD = 1e9 + 7;
mt19937 rng(time(0));
int n, m, k;

vector<vector<int>> h;
vector<vector<pair<int, int>>> hehe;
vector<pair<int, int>> seg;
ll ans[MAXN];

void init() {
	h.assign(m, vector<int>(2 * n));
	for (int i = 0; i < MAXN; i++) {
		ans[i] = 1ll * INF * INF;
	}
}

inline int cost(int x, int l, int r) {
	if (x <= l) {
		return l - x; 
	}
	if (x >= r) {
		return x - r;
	}
	return 0;
}

inline ll calc(int i, int j) {
	ll kek = 0;
	for (int t = 0; t < m; t++) {
		kek += cost(hehe[i][t].first, seg[j].first, seg[j].second);
		kek += cost(hehe[i][t].second, seg[j].first, seg[j].second);
	}
	return kek;
}

inline bool check(int i, int j) {
	ll kek = calc(i, j);
	if (kek < ans[i]) {
		ans[i] = kek;
		return 1;
	}
	return 0;
}

inline void solve(int l, int r, int tl, int tr) {
	if (l > r) {
		return;
	}
	int mid = (l + r) >> 1;
	int opt = tl;
	for (int i = tl; i <= tr; i++) {
		check(i, mid);
	}
	for (int i = tl + 1; i <= tr; i++) {
		int cnt_a = 0;
		int cnt_b = 0;
		for (int j = 0; j < m; j++) {
			if (hehe[i][j].first < seg[mid].first) {
				cnt_a++;
			}
			if (hehe[i][j].first > seg[mid].second) {
				cnt_b++;
			}
			if (hehe[i][j].second < seg[mid].first) {
				cnt_a++;
			}
			if (hehe[i][j].second > seg[mid].second) {
				cnt_b++;
			}
		}
		if (cnt_b < cnt_a) {
			opt = i;
			break;
		}
	}
	solve(l, mid - 1, tl, opt);
	solve(mid + 1, r, opt, tr);
}

void solve() {
	init();
	seg.resize(k);
	for (int i = 0; i < k; i++) {
		cin >> seg[i].first >> seg[i].second;
		seg[i].second *= -1;
	}
	sort(seg.begin(), seg.end());
	for (int i = 0; i < k; i++) {
		seg[i].second *= -1;
	}
	int maxr = 0;
	vector<int> bl(k);
	for (int i = 0; i < k; i++) {
		if (seg[i].second <= maxr) {
			bl[i] = 1;
		}
		maxr = max(maxr, seg[i].second);
	}
	vector<pair<int, int>> nx;
	for (int i = 0; i < k; i++) {
		if (bl[i] == 0) {
			nx.push_back(seg[i]);
		}
	}
	seg.swap(nx);
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < 2 * n; j++) {
			cin >> h[i][j];
		}
		sort(h[i].begin(), h[i].end());
	}
	hehe.assign(n, vector<pair<int, int>> (m));
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < n; j++) {
			hehe[j][i].first = h[i][j * 2];
			hehe[j][i].second = h[i][j * 2 + 1];
		}
	}
	k = seg.size();
	solve(0, k - 1, 0, n - 1);
	ll res = 0;
	for (int i = 0; i < n; i++) {
		res += ans[i];
	}
	cout << res << '\n';
}

signed main() {
	#ifdef DEBUG
		freopen("B.in", "r", stdin);
		freopen("B.out", "w", stdout);
	#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	while (cin >> m >> n >> k) {
		solve();
	}
	return 0;
}


