#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cstring>
#include <iomanip>
#include <fstream>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <random>
#include <ctime>
#include <cassert>

using namespace std;
typedef long long ll;
typedef unsigned long long ull;

#ifdef DEBUG
	const int MAXN = 10;
	const int MAXLOG = 4;
	const int MAXSQRT = 4;
#else
	const int MAXN = 3e5;
	const int MAXLOG = 20;
	const int MAXSQRT = 400;
	#define cerr if (false) cerr
#endif
const int INF = 1e9;
const int MOD = 1e9 + 7;
mt19937 rng(time(0));
#define int ll
int n, m, k;

vector<vector<int>> h;
vector<pair<int, int>> seg;

void init() {
	h.assign(m, vector<int>(2 * n));
}

int cost(int x, int l, int r) {
	if (x <= l) {
		return l - x; 
	}
	if (x >= r) {
		return x - r;
	}
	return 0;
}

ll calc(int i, int j) {
	ll kek = 0;
	for (int t = 0; t < m; t++) {
		kek += cost(h[t][2 * i], seg[j].first, seg[j].second);
		kek += cost(h[t][2 * i + 1], seg[j].first, seg[j].second);
	}
	return kek;
}

void solve() {
	init();
	seg.resize(k);
	for (int i = 0; i < k; i++) {
		cin >> seg[i].first >> seg[i].second;
		seg[i].second *= -1;
	}
	sort(seg.begin(), seg.end());
	for (int i = 0; i < k; i++) {
		seg[i].second *= -1;
	}
	int maxr = 0;
	vector<int> bl(k);
	for (int i = 0; i < k; i++) {
		if (seg[i].second <= maxr) {
			bl[i] = 1;
		}
		maxr = max(maxr, seg[i].second);
	}
	vector<pair<int, int>> nx;
	for (int i = 0; i < k; i++) {
		if (bl[i] == 0) {
			nx.push_back(seg[i]);
		}
	}
	seg.swap(nx);
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < 2 * n; j++) {
			cin >> h[i][j];
		}
		sort(h[i].begin(), h[i].end());
	}
	k = seg.size();
	ll ans = 0;
	int ptr = 0;
	for (int i = 0; i < n; i++) {
		while (ptr + 1 < k && calc(i, ptr + 1) <= calc(i, ptr)) {
			ptr++;
		}
		int opt = ptr;
		for (int j = max(0, ptr - 10); j <= min(k - 1, ptr + 10); j++) {
			if (calc(i, j) < calc(i, opt)) {
				opt = j;
			}
		}
		ans += calc(i, opt);
		ptr = opt;
	}
	cout << ans << '\n';
}

signed main() {
	#ifdef DEBUG
		freopen("B.in", "r", stdin);
		freopen("B.out", "w", stdout);
	#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	while (cin >> m >> n >> k) {
		solve();
	}
	return 0;
}


