#include <iostream>
#include <string>
#include <algorithm>
#include <vector>

using namespace std;

typedef long long ll;

#define rand() (rand() | (rand() << 15))

const ll N = 500010;
const ll INF = 1000000000000;

pair < ll, ll > SL[N];
ll h[N];
ll m, n, k;

ll d(ll a, pair < ll, ll > b) {
	if (a >= b.first && a <= b.second)
		return 0;
	return min(abs(a - b.first), abs(a - b.second));
}

bool cmp(pair < ll, ll > a, pair < ll, ll > b) {
	if (a.first == b.first)
		return a.second > b.second;
	else
		return a.first < b.first;
}

ll check(ll l, ll i) {
	ll sum = 0;
	for (ll j = 0; j < m; ++j) {
		ll ind = (2 * i + j * 2 * n) + 1;
		sum += d(h[ind], SL[l]) + d(h[ind + 1], SL[l]);
	}
	return sum;
}

ll tern(ll l, ll r, ll i) {
	while (r - l > 1) {
		ll mid = (l + r) >> 1;
		if (mid <= 1 || mid >= k)
			break;
		ll res = check(mid, i);
		if (check(mid + 1, i) - res >= res - check(mid - 1, i))
			r = mid;
		else
			l = mid;
	}
	return min({ check(l, i), check(r, i), check(1, i), check(k, i) });
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	cin >> m >> n >> k;
	for (ll i = 1; i <= k; ++i)
		cin >> SL[i].first >> SL[i].second;
	sort(SL + 1, SL + (k + 1), cmp);
	ll P = 0;
	for (ll i = 1; i <= 2 * n * m; ++i)
		cin >> h[i];
	for (ll j = 0; j < m; ++j) {
		sort(h + 2 * n * j + 1, h + 2 * n * (j + 1) + 1);
	}
	for (ll i = 0; i < n; ++i) {
		ll Min = tern(1, k, i);
		for (int iter = 0; iter <= 10; ++iter) {
			ll l = rand() % k + 1, r = rand() % k + 1;
			if (r < l)
				swap(l, r);
			Min = min(Min, tern(l, r, i));
		}
		P += Min;
	}
	cout << P;
}