#include <iostream>
#include <string>
#include <algorithm>
#include <vector>

using namespace std;

typedef long long ll;

const ll N = 500010;
const ll INF = 1000000000000;

pair < ll, ll > SL[N];
ll v[N];
ll h[N];
ll m, n, k;

ll d(ll a, pair < ll, ll > b) {
	if (a >= b.first && a <= b.second)
		return 0;
	return min(abs(a - b.first), abs(a - b.second));
}

bool cmp(pair < ll, ll > a, pair < ll, ll > b) {
	if (a.first == b.first)
		return a.second > b.second;
	else
		return a.first < b.first;
}

bool operator<(pair < ll, ll > a, pair < ll, ll > b) {
	return cmp(a, b);
}

bool vcmp(ll a1, ll b1) {
	pair < ll, ll > a = SL[a1], b = SL[b1];
	if (a.second - a.first == b.second - b.first) {
		if (a.first == b.first)
			return a.second > b.second;
		else
			return a.first < b.first;
	}
	else {
		return a.second - a.first > b.second - b.first;
	}
}

ll check(ll l, ll i) {
	ll sum = 0;
	for (ll j = 0; j < m; ++j) {
		ll ind = (2 * i + j * 2 * n) + 1;
		sum += d(h[ind], SL[l]) + d(h[ind + 1], SL[l]);
	}
	return sum;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	cin >> m >> n >> k;
	for (ll i = 1; i <= k; ++i)
		cin >> SL[i].first >> SL[i].second;
	for (ll i = 1; i <= k; ++i)
		v[i] = i;
	sort(SL + 1, SL + (k + 1), cmp);
	sort(v + 1, v + (k + 1), vcmp);
	ll P = 0;
	for (ll i = 1; i <= 2 * n * m; ++i)
		cin >> h[i];
	for (ll j = 0; j < m; ++j) {
		sort(h + 2 * n * j + 1, h + 2 * n * (j + 1) + 1);
	}
	ll last = 1;
	for (ll i = 0; i < n; ++i) {
		ll Min = INF;
		for (ll j = 0; j < m; ++j) {
			ll ind = (2 * i + j * 2 * n) + 1;
			ll pind = lower_bound(SL + 1, SL + (k + 1), make_pair(h[ind], -INF)) - SL, i);
			Min = min(Min, check(pind, i));
			--pind;
			if (pind >= 1)
				Min = min(Min, check(pind, i));
			pind = lower_bound(SL + 1, SL + (k + 1), make_pair(h[ind + 1], -INF)) - SL;
			Min = min(Min, check(pind, i));
			--pind;
			if (pind >= 1)
				Min = min(Min, check(pind, i));
		}
		P += Min;
	}
	cout << P;
}