#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <cassert>

using namespace std;

typedef long long ll;

const ll N = 10100;
const ll INF = 1000000000000;
const ll MOD = 998244353;

ll dp1[N][N], dp2[N][N];
ll v[N][N];

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	ll n, m, k;
	cin >> n >> m >> k;
	for (int i = 0; i < N; ++i)
		for (int j = 0; j < N; ++j)
			v[i][j] = INF;
	for (ll i = 0; i < k; ++i) {
		ll r, c, cost;
		cin >> r >> c >> cost;
		v[r][c] = cost;
	}
	ll sum = 0;
	for (ll i = n; i >= 1; --i) {
		for (ll j = m; j >= 1; --j) {
			if (v[i][j] != INF) {
				dp1[i][j] = v[i][j], dp2[i][j] = v[i][j];
			}
			else {
				dp1[i][j] = min(dp2[i + 1][j], dp2[i][j + 1]);
				dp2[i][j] = max(dp1[i + 1][j], dp1[i][j + 1]);
			}
			dp1[i][j] %= MOD, dp2[i][j] %= MOD;
			sum += dp1[i][j];
			sum %= MOD;
		}
	}
	cout << (sum + MOD) % MOD;
}