#include <iostream>
#include <vector>
#include <algorithm>
#include <tuple>
#include <random>
#define ll long long
#define pb push_back
#define pii pair<ll, ll>
#define ft first
#define sd second

using namespace std;

mt19937 rnd;

struct Node {
    ll x;
    ll y;
    ll sum;
    ll am;
    Node* left;
    Node* right;
    Node (int _x) {
        x = _x;
        y = rnd();
        sum = _x;
        am = 1;
        left = NULL;
        right = NULL;
    }
};

ll s(Node *t) {
    if (t == NULL) return 0;
    return t->sum;
}
ll amm(Node *t) {
    if (t == NULL) return 0;
    return t->am;
}

void update(Node* t) {
    if (t == NULL) return;
    t->sum = s(t->left) + s(t->right) + t->x;
    t->am = amm(t->left) + amm(t->right) + 1;

}

Node* merge_tree(Node *t1, Node *t2) {
    if (t1 == NULL) return t2;
    if (t2 == NULL) return t1;
    if (t1->y < t2->y) {
        t1->right = merge_tree(t1->right, t2);
        update(t1);
        return t1;
    } else {
        t2->left = merge_tree(t1, t2->left);
        update(t2);
        return t2;
    }
}

pair<Node*, Node*> split_tree(Node *t, int k) {
    if (t == NULL) return {NULL, NULL};
    if (t->x <= k) {
        pair<Node*, Node*> p = split_tree(t->right, k);
        t->right = p.first;
        update(t);
        return {t, p.second};
    } else {
        pair<Node*, Node*> p = split_tree(t->left, k);
        t->left = p.second;
        update(t);
        return {p.first, t};
    }
}

vector<int> v[200005];
int main() {
    int m, n, k;
    cin >> m >> n >> k;
    vector<pii> p;
    for (int i = 0; i < k; ++i) {
        int a, b;
        cin >> a >> b;
        p.pb({a, b});
    }
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < 2 * n; ++j) {
            int a;
            cin >> a;
            v[i].pb(a);
        }
        sort(v[i].begin(), v[i].end());
    }

    ll fin = 0;
    for (int i = 0; i < 2 * n; i += 2) {
        Node* t = new Node(v[0][i]);
        Node* t5 = new Node(v[0][i + 1]);
        t = merge_tree(t, t5);
        for (int j = 1; j < m; ++j) {
            Node* t1 = new Node(v[j][i]);
            Node* t2 = new Node(v[j][i + 1]);
            t = merge_tree(t, merge_tree(t1, t2));
        }
        ll ans = 1e18;
        for (int j = 0; j < k; ++j) {
            int l = p[j].ft, r = p[j].sd;
            Node *t1, *t2, *t3;
            tie(t1, t2) = split_tree(t, l - 1);
            tie(t2, t3) = split_tree(t2, r);
            ll d1 = amm(t1) * l - s(t1);
            ll d2 = s(t3) - amm(t3) * r;
            ans = min(ans, d1 + d2);
            t = merge_tree(merge_tree(t1, t2), t3);
        }
        fin += ans;
    }
    cout << fin;


    /*ll fin = 0;
    for (int i = 0; i < 2 * n; i += 2) {
        ll ans = 1e18;
        for (int j = 0; j < k; ++j) {
            ll res = 0;
            for (int y = 0; y < m; ++y) {
                if (v[y][i] < p[j].first) res += p[j].first - v[y][i];
                if (v[y][i] > p[j].second) res += v[y][i] - p[j].second;
                if (v[y][i + 1] < p[j].first) res += p[j].first - v[y][i + 1];
                if (v[y][i + 1] > p[j].second) res += v[y][i + 1] - p[j].second;
            }
            ans = min(res, ans);
        }
        fin += ans;
    }
    cout << fin;*/
    return 0;
}

