#include <iostream>
#include <vector>
#include <algorithm>
#include <tuple>
#include <random>
#include <cassert>
#define ll long long
#define pb push_back
#define pii pair<ll, ll>
#define ft first
#define sd second

using namespace std;

mt19937 rnd;

struct Node {
    ll x;
    ll y;
    ll sum;
    ll am;
    ll e;
    Node* left;
    Node* right;
    Node (ll _x) {
        x = _x;
        y = rnd();
        sum = _x;
        am = 1;
        e = 1;
        left = NULL;
        right = NULL;
    }
};

ll xx(Node *t) {
    if (t == NULL) return -1;
    return t->x;
}

ll s(Node *t) {
    if (t == NULL) return 0;
    return t->sum;
}
ll amm(Node *t) {
    if (t == NULL) return 0;
    return t->am;
}

void update(Node* t) {
    if (t == NULL) return;
    t->sum = s(t->left) + s(t->right) + (t->x * t->e);
    t->am = amm(t->left) + amm(t->right) + t->e;

}

Node* merge_tree(Node *t1, Node *t2) {
    if (t1 == NULL) return t2;
    if (t2 == NULL) return t1;
    if (t1->y < t2->y) {
        t1->right = merge_tree(t1->right, t2);
        update(t1);
        return t1;
    } else {
        t2->left = merge_tree(t1, t2->left);
        update(t2);
        return t2;
    }
}

pair<Node*, Node*> split_tree(Node *t, ll k) {
    if (t == NULL) return {NULL, NULL};
    if (t->x <= k) {
        pair<Node*, Node*> p = split_tree(t->right, k);
        t->right = p.first;
        update(t);
        return {t, p.second};
    } else {
        pair<Node*, Node*> p = split_tree(t->left, k);
        t->left = p.second;
        update(t);
        return {p.first, t};
    }
}

void dfs(Node* t) {
    if (t == NULL) return;
    //cout << xx(t) << " " << xx(t->left) << " " << xx(t->right) << " " << t->e << "\n";
    dfs(t->left);
    dfs(t->right);
}

Node* rr(Node* t) {
    if (t == NULL) return NULL;
    if (t->right == NULL) return t;
    return rr(t->right);
}

void pl(Node *t) {
    if (t == NULL) return;
    t->am += 1;
    pl(t->right);
}


vector<ll> v[200005];
int main() {
    int m, n, k;
    cin >> m >> n >> k;
    vector<pii> p;
    for (int i = 0; i < k; ++i) {
        int a, b;
        cin >> a >> b;
        p.pb({a, b});
    }
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < 2 * n; ++j) {
            int a;
            cin >> a;
            v[i].pb(a);
        }
        sort(v[i].begin(), v[i].end());
    }

    ll fin = 0;
    for (int i = 0; i < 2 * n; i += 2) {
        Node* t = new Node(v[0][i]);
        Node* t10 = new Node(v[0][i + 1]);
        if (t->x == t10->x) {
            ++t->am;
            ++t->e;
        } else if (t->x < t10->x) {
            t = merge_tree(t, t10);
        } else {
            t = merge_tree(t10, t);
        }
        for (int j = 1; j < m; ++j) {
            Node* t5 = new Node(v[j][i]);
            Node* t6 = new Node(v[j][i + 1]);
            Node*t1, *t2;

            tie(t1, t2) = split_tree(t, t5->x);
            Node* curr = rr(t1);
            if (xx(curr) == t5->x) {
                curr->e += 1;
                pl(t1);
                t = merge_tree(t1, t2);
            } else {
                t = merge_tree(t1, merge_tree(t5, t2));
            }

            //cout << "\n\n";
            //dfs(t);
            //cout << "\n\n";

            tie(t1, t2) = split_tree(t, t6->x);
            curr = rr(t1);
            if (xx(curr) == t6->x) {
                curr->e += 1;
                pl(t1);
                t = merge_tree(t1, t2);
            } else {
                t = merge_tree(t1, merge_tree(t6, t2));
            }

            //cout << "\n\n";
            //dfs(t);
            //cout << "\n\n";
        }
        ll ans = 1e18;
        for (int j = 0; j < k; ++j) {
            int l = p[j].ft, r = p[j].sd;
            Node *t1, *t2, *t3;
            tie(t1, t2) = split_tree(t, l - 1);
            tie(t2, t3) = split_tree(t2, r);
            ll d1 = amm(t1) * l - s(t1);
            ll d2 = s(t3) - amm(t3) * r;
            /*cout << "\nl r: " << l << " " << r << "\n";
            cout << "am: " << amm(t1) << " " << amm(t2) << " " << amm(t3) << "\n";
            cout << "s: " << s(t1) << " " << s(t2) << " " << s(t3) << "\n";
            cout << "x: " << xx(t1) << " " << xx(t2) << " " << xx(t3) << "\n";
            cout << d1 << " " << d2 << "\n";*/
            ans = min(ans, d1 + d2);
            t = merge_tree(merge_tree(t1, t2), t3);

            /*ll res = 0;
            for (int y = 0; y < m; ++y) {
                if (v[y][i] < p[j].first) res += p[j].first - v[y][i];
                if (v[y][i] > p[j].second) res += v[y][i] - p[j].second;
                if (v[y][i + 1] < p[j].first) res += p[j].first - v[y][i + 1];
                if (v[y][i + 1] > p[j].second) res += v[y][i + 1] - p[j].second;
            }
            cout << i << " " << j << "   " << d1 << " " << d2 << " " << res << "\n";
            assert(d1 + d2 == res);*/
        }
        //cout << "\n";
        fin += ans;
    }
    cout << fin;


    /*ll fin = 0;
    for (int i = 0; i < 2 * n; i += 2) {
        ll ans = 1e18;
        for (int j = 0; j < k; ++j) {
            ll res = 0;
            for (int y = 0; y < m; ++y) {
                if (v[y][i] < p[j].first) res += p[j].first - v[y][i];
                if (v[y][i] > p[j].second) res += v[y][i] - p[j].second;
                if (v[y][i + 1] < p[j].first) res += p[j].first - v[y][i + 1];
                if (v[y][i + 1] > p[j].second) res += v[y][i + 1] - p[j].second;
            }
            ans = min(res, ans);
        }
        fin += ans;
    }
    cout << fin;*/
    return 0;
}

/*
2 3 3
200 400
300 500
100 600
300 330 440 40 30 300
150 250 350 450 550 300
*/

/*
1 2 2
5 25
50 90
60 5 10 40

*/

/*
5 3 3
200 400
300 500
100 600
300 330 440 40 30 300
150 250 350 450 550 300
400 1000 250 200 50 50
300 350 600 700 800 900
400 400 200 100 100 100
*/

