#include <iostream>
#include <fstream>

#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <functional>
#include <string>

#include <cstring>
#include <cstdio>
#include <climits>
using namespace std;
//#define DEBUG
#ifdef DEBUG
ifstream input("input.txt");
ofstream output("output.txt");
#define cin input
#define cout output
#endif
#define endl '\n'

int kmp(string s, string t) {
	int res = 0;
	int *p = new int[t.size() + 1];
	p[0] = p[1] = 0;
	for (int i = 1; i <= t.size(); i++) {
		int perf = p[i];
		while (t[perf] != t[i] && perf)perf = p[perf];
		p[i + 1] = perf = (t[perf] == t[i] ? (perf + 1) : 0);
	}

	for (int i = 0, j = 0; i < s.size(); i++) {
		while (s[i] != t[j] && j)j = p[j];
		if (s[i] == t[j])j++;
		if (j == t.size()) {
			res++;
			j = p[j];
		}
	}

	return res;
}

int main() {
	int m, n; cin >> m >> n;
	string p; cin >> p;
	string res = "";
	for (int i = 0; i < n; i++) {
		int t; cin >> t;
		if (t == 1) {
			string suf; cin >> suf;
			res += suf;
		}
		if (t == 2) {
			int a, b;
			cin >> a >> b;
			a--;
			for (int j = 0; j < b; j++) {
				res += res[j + a];
			}
		}
	}

	cout << kmp(res, p);
	return 0;
}