#include <iostream>
#include <string>
#include <bitset>
#include <set>
#include <vector>
#include <deque>
#include <algorithm>
#include <ctime>

#define kekek ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
using namespace std;

int m, n, k;
vector<pair<int, int>> p;
vector<vector<int>> g;

long long check(int f, int s, pair<int, int> a) {
	long long pnow = 0;

	if (f < a.first) {
		pnow += a.first - f;
	}
	else if (f > a.second) {
		pnow += f - a.second;
	}

	if (s < a.first) {
		pnow += a.first - s;
	}
	else if (s > a.second) {
		pnow += s - a.second;
	}
	return pnow;
}

void solve1() {
	long long mnp = 1e15;
	for (auto a : p) {
		long long pnow = 0;
		for (int i = 0; i < m; i++) {
			int f = min(g[i][0], g[i][1]), s = max(g[i][0], g[i][1]);
			pnow += check(f, s, a);
		}
		mnp = min(mnp, pnow);
	}
	cout << mnp;
}

void solve2() {
	sort(g[0].begin(), g[0].end());
	sort(p.begin(), p.end());

	long long ans = 0;
	for (int i = 0; i < 2 * n; i+=2) {
		long long pmn = 1e15;
		for (int j = 0; j < k; j++) {
			pmn = min(pmn, check(g[0][i], g[0][i + 1], p[j]));
		}
		ans += pmn;
	}

	cout << ans;
}

signed main() {
	kekek;

	cin >> m >> n >> k;
	p.resize(k);
	g.resize(m);

	for (auto &i : p) {
		cin >> i.first >> i.second;
	}
	for (auto &i : g) {
		i.resize(2 * n);
		for (auto &j : i) {
			cin >> j;
		}
	}

	if (m <= 100 && n == 1 && k <= 50) {
		solve1();
	}
	else if (m == 1) {
		solve2();
	}

	//system("pause");
	return 0;
}