#include <iostream>
#include <vector>
#include <set>

using namespace std;

vector<int> nx;
vector<int> pr;
vector<int> sz;

set<pair<int, int> > s;
int cnt = 0;

void del(int i){
    if (nx[i] != -1){
        pr[nx[i]] = pr[i];
    }
    if (pr[i] != -1){
        nx[pr[i]] = nx[i];
    }
}

void next(int i){
    s.erase({sz[i], i});
    s.erase({sz[nx[i]], nx[i]});
    sz[i] += sz[nx[i]];
    del(nx[i]);
    s.insert({sz[i], i});
}

void prev(int i){
    s.erase({sz[i], i});
    s.erase({sz[pr[i]], pr[i]});
    sz[i] += sz[pr[i]];
    del(pr[i]);
    s.insert({sz[i], i});
}

void merge(int i){
    cnt--;
    if (pr[i] != -1 && nx[i] != -1){
        if (sz[pr[i]] > sz[nx[i]]){
            next(i);
        }else{
            prev(i);
        }
    }else if (pr[i] != -1){
        prev(i);
    }else{
        next(i);
    }
}

int get_ans(){
    int mn = (s.begin() -> first);
    int res = (cnt + 1) * mn + cnt;
    return res;
}


int main()
{
    //freopen("input.txt", "r", stdin);
    int n;
    cin >> n;
    int last = 0;
    for (int i = 0; i < n; i++){
        char c;
        cin >> c;
        if (c == '1'){
            sz.push_back(last);
            last = 0;
        }else{
            last++;
        }
    }
    sz.push_back(last);
    cnt = sz.size();
    nx.resize(cnt);
    pr.resize(cnt);
    for (int i = 0; i < cnt; i++){
        pr[i] = i - 1;
        nx[i] = i + 1;
        s.insert({sz[i], i});
    }
    nx[cnt - 1] = -1;
    cnt--;
    int ans = 0;
    int ansc = 0;
    for (; cnt >= 1; ){
        int now = get_ans();
        if (now > ans){
            ans = now;
            ansc = cnt;
        }
        int mn = s.begin() -> second;
        merge(mn);
    }
    cout << ans << endl;
    int r = (ans - ansc) / (ansc + 1);
    string t = "";
    for (int i = 0; i < r; i++){
        t += '0';
    }
    for (int i = 0; i < ansc; i++){
        cout << t << "1";
    }
    cout << t << endl;
    return 0;
}
