#include <iostream>
#include <vector>

#define int long long

using namespace std;

const int p = 57;
const int MOD = 2286661337;

struct hashs{
    vector<int> h;
    vector<int> pw;
    int n;

    void init(string &s){
        n = s.size();
        h.resize(n + 1);
        pw.resize(n + 1);
        pw[0] = 1;
        for (int i = 0; i < n; i++){
            pw[i + 1] = (pw[i] * p) % MOD;
            h[i + 1] = (h[i] * p + s[i]) % MOD;
        }
    }

    int gethash(int l, int r){
        int all = h[r];
        int mn = h[l] * pw[r - l] % MOD;
        int ans = (all - mn + MOD) % MOD;
        return ans;
    }

};

signed main()
{
    //freopen("input.txt", "r", stdin);
    int m, n;
    cin >> m >> n;
    string p;
    cin >> p;
    string t = "";
    for (int i = 0; i < n; i++){
        int type;
        cin >> type;
        if (type == 1){
            string add;
            cin >> add;
            t += add;
        }else{
            int pos, len;
            cin >> pos >> len;
            pos--;
            for (int j = 0; j < len; j++){
                t += t[pos + j];
            }
        }
        //cout << t << endl;
    }
    hashs h1, h2;
    h1.init(p);
    h2.init(t);
    int ans = 0;
    for (int i = 0; i + p.size() <= t.size(); i++){
        if (h1.gethash(0, p.size()) == h2.gethash(i, i + p.size())){
            ans++;
        }
    }
    //cout << endl;
    cout << ans << endl;
    return 0;
}
