#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif

#define $ if (DEV)

#include <bits/stdc++.h>
using namespace std;
void entry(int test_id);

int main() {
    int test_cnt = 1;
    if (DEV) {
        freopen("input.txt", "r", stdin);
        test_cnt = 179;
    }
    for (int t = 0; t < test_cnt; ++t) {
        if (feof(stdin)) break;
        $ printf("--- TEST CASE %d ---\n", t);
        entry(t);
    }
}

template<typename T>
bool relmax(T& lhs, const T rhs) {
    if (lhs < rhs) {
        lhs = rhs;
        return true;
    }
    return false;
}using ll = long long;

vector<int> calc_pi(string s) {
    int n = s.size();
    vector<int> out(n);
    out[0] = 0;
    for (int i = 1; i < n; ++i) {
        int j = out[i-1];
        while (j > 0 && s[i] != s[j]) {
            j = out[j-1];
        }
        if (s[i] == s[j]) {
            ++j;
        }
        out[i] = j;
    }
    return out;
}

struct PushQ {
    char* s;
};

struct RepQ {
    int pos;
    int len;
};

union QueryUn {
    PushQ push;
    RepQ rep;
};

enum QueryTy {
    PUSH,
    REP,
};

struct Query {
    QueryTy ty;
    QueryUn un;
};

struct Input {
    char* p;
    int p_len;
    int n;
    vector<Query> q;
} I;

struct Output {
    ll ans;
} O;

void read() {
    char* rbuf = new char[200'001];
    int m, n;
    scanf("%d %d", &m, &n);
    I.n = n;
    I.p_len = m;
    char* sp;
    {
        sp = new char[m+1];
        scanf("%s", sp);
    }
    I.p = sp;

    for (int _i = 0; _i < n; ++_i) {
        int type;
        scanf("%d", &type);
        Query q;
        if (type == 1) {
            scanf("%s", rbuf);
            int s = strlen(rbuf);
            char* bf = new char[s+1];
            strcpy(bf, rbuf);
            q.ty = PUSH;
            q.un.push.s = bf;
        } else {
            int pos, len;
            scanf("%d %d", &pos, &len);
            --pos;
            q.ty=REP;
            q.un.rep.pos = pos;
            q.un.rep.len = len;
        }
        I.q.push_back(q);
    }
    delete[] rbuf;
    O.ans = 0;
}

void write() {
    printf("%lld\n", O.ans);
    delete[] I.p;
    for (auto q : I.q) {
        if (q.ty == PUSH) {
            delete[] q.un.push.s;
        }
    }
    I.q.clear();
}

void solve_silly() {
    string buf;
    for (auto q : I.q) {
        if (q.ty == PUSH) {
            buf += string(q.un.push.s);
        } else {
            for (int j = 0; j < q.un.rep.len; ++j) {
                char c = buf[q.un.rep.pos + j];
                buf.push_back(c);
            }
        }
    }
    string big(I.p);
    big += '|';
    big += buf;
    auto v = calc_pi(big);
    for (int x : v) {
        if (x == I.p_len) ++O.ans;
    }
}

int period(const string& s) {
    auto pi = calc_pi(s);
    return s.size()-pi.back();
}

void solve_div(int test_id) {
    ll cnt = 1;
    for (auto q : I.q) {
        if (q.ty == REP) {
            cnt += q.un.rep.len / strlen(I.q[0].un.push.s);
        }
    }
    string block(I.q[0].un.push.s);
    int block_per = period(block);
    string needle(I.p);
    int needle_per = period(needle);
    int num_blocks = 0;
    while (num_blocks * block.size() <= 2*needle.size()) ++num_blocks;
    {
        string big(needle);
        big += '|';
        for (int k = 0; k < num_blocks; ++k) {
            big += block;
        }
        auto p = calc_pi(big);
        for (int i = 0; i < block.size(); ++i) {
            int j = 2* needle.size() + i;
            if (p[j] != needle.size()) continue;
            int end_block_id = (i+needle.size())/block.size();
            ll num_good_blocks = (cnt-1) - (end_block_id)+1;
            O.ans += num_good_blocks;
        }
    }
}

void entry(int test_id) {
    read();
    bool should_use_div = false;
    if (DEV && test_id == 2) should_use_div = true;
    if (!DEV && I.n > 1) should_use_div = true;
    if (should_use_div) {
        solve_div(test_id);
    } else {
        solve_silly();
    }
    write();
}