#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

int get(int n, vector<bool> &v, int mid) {
    int rest = mid;
    int k = 0;
    for (int i = 0; i < n; ++i) {
        if (!v[i]) {
            rest--;
        }
        else {
            if (rest <= 0) {
                k++;
                rest = mid;
            }
        }
    }
    if (rest <= 0) {
        return k;
    }
    else {
        return max(0, k - 1);
    }
}

int f(int k, int mid) {
    if (k == 0) {
        return 0;
    }
    else {
        return (k + 1) * mid + k;
    }
}

void print(int k, int r) {
    cout << f(k, r) << endl;
    for (int i = 0; i < k + 1; ++i) {
        if (i > 0) {
            cout << 1;
        }
        for (int j = 0; j < r; ++j) {
            cout << 0;
        }
    }
    cout << endl;
}

int main() {
    int n;
    cin >> n;
    vector<bool> v(n);
    for (int i = 0; i < n; ++i) {
        char c;
        cin >> c;
        v[i] = (c == '1');
    }

    int l = -1, r = n + 1;
    while (l + 3 < r) {
        int mid1 = l + (r - l) / 3;
        int mid2 = mid1 + max(1, (r - l) / 3);
        int res1 = get(n, v, mid1);
        int res2 = get(n, v, mid2);
        if (f(res1, mid1) >= f(res2, mid2)) {
            r = mid2;
        }
        else {
            l = mid1;
        }
    }

    l++;
    r--;
    int res1 = get(n, v, l);
    int res2 = get(n, v, r);
    if (f(res1, l) > f(res2, r)) {
        print(res1, l);
    }
    else {
        print(res2, r);
    }
}