#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

ll f(pair<ll, ll> t, ll x) {
    if (t.first <= x && x <= t.second) {
        return 0;
    }
    return min(abs(t.first - x), abs(t.second - x));
}

int main() {
    int m, n, k;
    cin >> m >> n >> k;
    vector<pair<ll, ll>> t(k);
    for (int i = 0; i < k; ++i) {
        cin >> t[i].first >> t[i].second;
    }
    sort(t.begin(), t.end());
    vector<vector<ll>> v(m, vector<ll>(2 * n));
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < 2 * n; ++j) {
            cin >> v[i][j];
        }
        sort(v[i].begin(), v[i].end());
    }

    vector<vector<ll>> dp(n + 1, vector<ll>(k + 1, 1e18));
    for (int i = 0; i <= k; ++i) {
        dp[0][i] = 0;
    }
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= k; ++j) {
            ll x = 0;
            for (int l = 0; l < m; ++l) {
                x += f(t[j - 1], v[l][i * 2 - 2]);
                x += f(t[j - 1], v[l][i * 2 - 1]);
            }
            for (int l = 0; l <= k; ++l) {
                dp[i][j] = min(dp[i][j], dp[i - 1][l] + x);
            }
        }
    }
    ll ans = 1e18;
    for (int i = 0; i < k; ++i) {
        ans = min(ans, dp[n][i + 1]);
    }
    cout << ans << endl;
}