#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <map>
#include <string>
#include <assert.h>
#include <numeric>
#include <algorithm>
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

#define x first
#define y second
#define all(x) (x).begin(), (x).end()
#define pb push_back
#define size(x) (int)x.size()

const int mod = 998244353;
const int INF = 1e9;

inline int add(int a, int b) {
	return ((a + b) % mod + mod) % mod;
}

void solve() {
	int n, m, k;
	cin >> n >> m >> k;
	vector<vector<int>> dp[2];

	dp[0].resize(n + 1, vector<int>(m + 1, INF));
	dp[1].resize(n + 1, vector<int>(m + 1, INF));
	for (int i = 0; i < n; i++) {
		dp[0][i][m] = dp[1][i][m] = 0;
	}
	for (int i = 0; i < m; i++) {
		dp[0][n][i] = dp[1][n][i] = 0;
	}
	ll res = 0;
	for (int i = 0; i < k; i++) {
		int x, y, c;
		cin >> x >> y >> c;
		res = add(res, c);
		--x; --y;
		dp[0][x][y] = dp[1][x][y] = c;
	}
	for (int i = n - 1; i >= 0; i--) {
		for (int j = m - 1; j >= 0; j--) {
			if (dp[0][i][j] != INF) continue;
			dp[0][i][j] = min(dp[1][i + 1][j], dp[1][i][j + 1]);
			dp[1][i][j] = max(dp[0][i + 1][j], dp[0][i][j + 1]);
			res = add(res, dp[0][i][j]);
		}
	}
	cout << res;
}

signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios::sync_with_stdio(false);
	cin.tie(NULL);
	solve();
}