#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define F first
#define S second

typedef unsigned long long ull;

const ull N = 4e5 + 228, inf = (ull)4e18;
vector<ull> a[N];
pair<ull, ull> b[N];
ull pref[N];

ull f(ull ind, ull now)
{
    if (now < b[ind].F)
        return b[ind].F - now;
    else if (now > b[ind].S)
        return now - b[ind].S;
    return 0;
}

ull g(ull ind, vector<ull>& now)
{
    ull res = 0;
    if (now[0] < b[ind].F)
    {
        ull l = 0, r = (ull)now.size(), m;
        while (r - l > 1)
        {
            m = (l + r) / 2;
            if (now[m] < b[ind].F)
                l = m;
            else
                r = m;
        }
        res = b[ind].F * (l + 1) - pref[l];
    }
    if (now.back() > b[ind].S)
    {
        ull l = -1, r = (ull)now.size() - 1, m;
        while (r - l > 1)
        {
            m = (l + r) / 2;
            if (now[m] > b[ind].S)
                r = m;
            else
                l = m;
        }
        res = res + pref[(ull)now.size() - 1] - ((ull)now.size() - r) * b[ind].S;
        if (r)
            res -= pref[r - 1];
    }
    return res;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    bool eq = true;
    ull m, n, k, now, P = 0;
    cin >> m >> n >> k;
    for (ull i = 0; i < k; i++)
    {
        cin >> b[i].F >> b[i].S;
        if (b[i].F != b[i].S)
            eq = false;
    }
    for (ull i = 0; i < m; i++)
    {
        for (ull j = 0; j < 2 * n; j++)
        {
            cin >> now;
            a[i].push_back(now);
        }
        sort(a[i].begin(), a[i].end());
    }
    if (n <= 100)
    {
        vector<ull> now;
        for (ull i = 0; i < 2 * n; i += 2)
        {
            now.clear();
            for (ull j = 0; j < m; j++)
            {
                now.push_back(a[j][i]);
                now.push_back(a[j][i + 1]);
            }
            sort(now.begin(), now.end());
            pref[0] = now[0];
            for (ull j = 1; j < (ull)now.size(); j++)
                pref[j] = now[j] + pref[j - 1];
            ull mb = inf;
            for (ull j = 0; j < k; j++)
                mb = min(mb, g(j, now));
            P += mb;
        }
        cout << P;
        return 0;
    }
    for (ull i = 0; i < 2 * n; i += 2)
    {
        ull q = inf;
        for (ull z = 0; z < k; z++)
        {
            ull d = 0;
            for (ull j = 0; j < m; j++)
                d += f(z, a[j][i]) + f(z, a[j][i + 1]);
            q = min(q, d);
        }
        P += q;
    }
    cout << P;
    return 0;
}


/*
1 2 2
5 25
50 90
60 5 10 40
ans = 10

2 3 3
200 400
300 500
100 600
300 330 440 40 30 300
150 250 350 450 550 300
ans = 130

1 3 4
10 100
200 200
10 100
300 1000
5 10 20 15 200 90
ans = 105
*/
