// B.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <cassert>

using namespace std;
using ll = long long;

const int S = 500;

ll dist(int i, int l, int r) {
	if (i >= l && i <= r) return 0;
	if (i < l) return l - i;
	if (i > r) return i - r;
	return 1e9;
}

bool cmp(pair<int, int> a, pair<int, int> b) {
	return make_pair(a.first, -a.second) < make_pair(b.first, -b.second);
}

int main()
{
	ios::sync_with_stdio(0);
	//ifstream cin("input.txt");
	int m, n, k;
	cin >> m >> n >> k;
	vector<pair<int, int> > seg(k);
	for (int i = 0; i < k; i++) {
		cin >> seg[i].first >> seg[i].second;
	}
	sort(seg.begin(), seg.end(), cmp);
	vector<pair<int, int> > seg1;
	for (int i = 0; i < k; i++) {
		if (seg1.empty() || seg1.back().second < seg[i].second) {
			seg1.push_back(seg[i]);
		}
	}
	k = (int)seg1.size();
	vector<vector<pair<int, int> > > pairs(n, vector<pair<int, int> >(m));
	for (int i = 0; i < m; i++) {
		vector<int> cur(2 * n);
		for (int j = 0; j < 2 * n; j++) {
			cin >> cur[j];
		}
		sort(cur.begin(), cur.end());
		for (int j = 0; j < n; j++) {
			pairs[j][i] = { cur[2 * j], cur[2 * j + 1] };
		}
	}
	vector<vector<int> > cht;
	for (int i = 0; i < k; i++) {
		if (i % S == 0) {
			cht.push_back({i});
		}
		else {
			while (cht.back().size() > 1) {
				auto p1 = seg1[cht.back()[cht.back().size() - 2]], p2 = seg1[cht.back().back()];
				ll x1 = p2.first - p1.first, y1 = p2.second - p1.second;
				ll x2 = seg1[i].first - p2.first, y2 = seg1[i].second - p2.second;
				if (x1 * y2 - x2 * y1 >= 0) {
					cht.back().pop_back();
				}
				else {
					break;
				}
			}
			cht.back().push_back(i);
		}
	}
	ll ans = 0;
	for (int i = 0; i < n; i++) {
		vector<int> all;
		for (int j = 0; j < m; j++) {
			all.push_back(pairs[i][j].first);
			all.push_back(pairs[i][j].second);
		}
		sort(all.begin(), all.end());
		int sz = (int)all.size();
		vector<ll> pref(sz + 1), suf(sz + 1);
		for (int j = 0; j < sz; j++) {
			pref[j + 1] = pref[j] + all[j];
		}
		for (int j = sz - 1; j >= 0; j--) {
			suf[j] = suf[j + 1] + all[j];
		}
		ll mn = 1e18;
		int j = 0;
		while (j < k) {
			int l1 = lower_bound(all.begin(), all.end(), seg1[j].first) - all.begin();
			int r1 = upper_bound(all.begin(), all.end(), seg1[j].second) - all.begin();
			int l = j, r = k;
			while (r - l > 1) {
				int m1 = (l + r) / 2;
				int l2 = lower_bound(all.begin(), all.end(), seg1[m1].first) - all.begin();
				int r2 = upper_bound(all.begin(), all.end(), seg1[m1].second) - all.begin();
				if (l1 == l2 && r1 == r2) {
					l = m1;
				}
				else {
					r = m1;
				}
			}
			int b1 = (j + S - 1) / S, b2 = r / S;
			//cout << j << ' ' << r << ' ' << b1 << ' ' << b2 << endl;
			for (int j1 = j; j1 < min(r, b1 * S); j1++) {
				mn = min(mn, -pref[l1] + suf[r1] + (ll)l1 * seg1[j1].first - (ll)(all.size() - r1) * seg1[j1].second);
			}
			for (int j1 = max(j, b2 * S); j1 < r; j1++) {
				mn = min(mn, -pref[l1] + suf[r1] + (ll)l1 * seg1[j1].first - (ll)(all.size() - r1) * seg1[j1].second);
			}
			for (int b = b1; b < b2; b++) {
				int l = 0, r = (int)cht[b].size() - 1;
				while (l < r) {
					int m1 = (l + r) / 2, m2 = (l + r) / 2 + 1;
					int ind1 = cht[b][m1], ind2 = cht[b][m2];
					ll val1 = (ll)l1 * seg1[ind1].first - (ll)(all.size() - r1) * seg1[ind1].second;
					ll val2 = (ll)l1 * seg1[ind2].first - (ll)(all.size() - r1) * seg1[ind2].second;
					if (val1 < val2) {
						r = m1;
					}
					else {
						l = m2;
					}
				}
				int ind = cht[b][l];
				mn = min(mn, -pref[l1] + suf[r1] + (ll)l1 * seg1[ind].first - (ll)(all.size() - r1) * seg1[ind].second);
			}
			/*for (int j1 = j; j1 < r; j1++) {
				mn = min(mn, -pref[l1] + suf[r1] + (ll)l1 * seg1[j1].first - (ll)(all.size() - r1) * seg1[j1].second);
			}*/
			j = r;
		}
		/*for (int j = 0; j < k; j++) {
			int l = lower_bound(all.begin(), all.end(), seg1[j].first) - all.begin();
			int r = upper_bound(all.begin(), all.end(), seg1[j].second) - all.begin();
			mn = min(mn, -pref[l] + suf[r] + (ll)l * seg1[j].first - (ll)(all.size() - r) * seg1[j].second);
		}*/
		ans += mn;
	}
	cout << ans << endl;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
