// B.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <cassert>

using namespace std;
using ll = long long;

ll dist(int i, int l, int r) {
	if (i >= l && i <= r) return 0;
	if (i < l) return l - i;
	if (i > r) return i - r;
	return 1e9;
}

bool cmp(pair<int, int> a, pair<int, int> b) {
	return make_pair(a.first, -a.second) < make_pair(b.first, -b.second);
}

int main()
{
	ios::sync_with_stdio(0);
	//ifstream cin("input.txt");
	int m, n, k;
	cin >> m >> n >> k;
	vector<pair<int, int> > seg(k);
	for (int i = 0; i < k; i++) {
		cin >> seg[i].first >> seg[i].second;
	}
	sort(seg.begin(), seg.end(), cmp);
	vector<pair<int, int> > seg1;
	for (int i = 0; i < k; i++) {
		if (seg1.empty() || seg1.back().second < seg[i].second) {
			seg1.push_back(seg[i]);
		}
	}
	vector<vector<pair<int, int> > > pairs(n, vector<pair<int, int> >(m));
	for (int i = 0; i < m; i++) {
		vector<int> cur(2 * n);
		for (int j = 0; j < 2 * n; j++) {
			cin >> cur[j];
		}
		sort(cur.begin(), cur.end());
		for (int j = 0; j < n; j++) {
			pairs[j][i] = { cur[2 * j], cur[2 * j + 1] };
		}
	}
	ll ans = 0;
	for (int i = 0; i < n; i++) {
		int l = 0, r = (int)seg1.size() - 1;
		while (r - l > 1500) {
			int m1 = (l + r) / 2, m2 = m1 + 1;
			ll t1 = 0, t2 = 0;
			for (int j = 0; j < m; j++) {
				int x1 = pairs[i][j].first, x2 = pairs[i][j].second;
				t1 += dist(x1, seg1[m1].first, seg1[m1].second) + dist(x2, seg1[m1].first, seg1[m1].second);
				t2 += dist(x1, seg1[m2].first, seg1[m2].second) + dist(x2, seg1[m2].first, seg1[m2].second);
			}
			if (t1 < t2) {
				r = m1;
			}
			else {
				l = m2;
			}
		}
		ll mn = 1e18;
		for (int m1 = l; m1 <= r; m1++) {
			ll t = 0;
			for (int j = 0; j < m; j++) {
				int x1 = pairs[i][j].first, x2 = pairs[i][j].second;
				t += dist(x1, seg1[m1].first, seg1[m1].second) + dist(x2, seg1[m1].first, seg1[m1].second);
			}
			mn = min(mn, t);
		}
		//cout << t << endl;
		ans += mn;
	}
	cout << ans << endl;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
