// D.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;
using ll = long long;

const int maxn = 2000000;
const ll p1 = 10007, mod = 1000000007;
ll pw[maxn];

vector<ll> get_h(string s) {
	int n = (int)s.size();
	vector<ll> h(n + 1);
	for (int i = 0; i < n; i++) {
		h[i + 1] = (h[i] * p1 + s[i]) % mod;
	}
	return h;
}

ll h_seg(vector<ll>& h, int l, int r) {
	return ((h[r + 1] - h[l] * pw[r - l + 1]) % mod + mod) % mod;
}

int main()
{
	pw[0] = 1;
	for (int i = 1; i < maxn; i++) pw[i] = pw[i - 1] * p1 % mod;
	ios::sync_with_stdio(0);
	int m, n;
	cin >> m >> n;
	string p;
	cin >> p;
	string s;
	ll it = 0;
	int l0 = 0;
	for (int i = 0; i < n; i++) {
		int tp;
		cin >> tp;
		if (tp == 1) {
			string t;
			cin >> t;
			s += t;
			l0 = (int)s.size();
			it += l0;
		}
		else {
			ll pos, len;
			cin >> pos >> len;
			pos--;
			it += len;
		}
	}
	//cout << s << endl;
	ll ans = 0;
	for (int i = 0; i < l0; i++) {
		bool ok = 1;
		for (int j = 0; j < m; j++) {
			if (s[(i + j) % l0] != p[j]) {
				ok = 0;
				break;
			}
		}
		if (ok) {
			int l = i, r = i + m;
			if (r <= it) ans += (it - r) / l0 + 1;
		}
	}
	cout << ans << endl;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
