#include <iostream>
#include <string>
#include <cassert>
using namespace std;

long long h_s[(int)1e6 + 1];
//long long h_p[(int)1e5 + 1];
long long xp[(int)1e6 + 2];

const int prime = 239;
const int mod = 1e9 + 7;

long long get_hash(long long h[], int a, int b){  /// [a, b], 1-indexation
    long long ans = h[b] - h[a - 1] * xp[b - a + 1];
    ans %= mod;
    if(ans < 0)
        ans += mod;
    return ans;
}
int main(){
    int m, n;
    cin >> m >> n;
    string p;
    cin >> p;
    string s;
    long long repeats = 1;
    int start_len;
    for(int i=0; i<n; i++){
        int type;
        cin >> type;
        if(type == 1){
            string w;
            cin >> w;
            s += w;
            start_len = s.size();
        }
        else{
            int pos, len;
            cin >> pos >> len;
            repeats += len / start_len;
        }
    }
    if(((long long) repeats) * s.size() < p.size()){
        cout << 0;
        return 0;
    }
    int block_size = s.size();
    long long old_size = ((long long) s.size()) * repeats;
    string old_s = s;
    while(s.size() < p.size())
        s += old_s;
    int loop_size = s.size();
    s += s;
    h_s[0] = 0;
    for(int i=1; i<=s.size(); i++)
        h_s[i] = (h_s[i - 1] * prime + (s[i - 1] - 'a' + 1)) % mod;

    long long h_p = 0;
    for(int i=0; i<p.size(); i++)
        h_p = (h_p * prime + (p[i] - 'a' + 1)) % mod;

    xp[0] = 1;
    for(int i=1; i<(int)1e6 + 2; i++){
        xp[i] = (xp[i - 1] * prime) % mod;
    }
    long long ans = 0;
    int loop_count = old_size / loop_size - 1;
    int loop_ans = 0;
    for(int i=0; i<loop_size; i++){
        int ii = i % block_size;
        if(get_hash(h_s, ii + 1, ii + p.size()) == h_p){
            loop_ans++;
        }
    }
    ans += ((long long) loop_count) * loop_ans;
    long long cur_index = ((long long) loop_count) * loop_size;
    for(long long i=cur_index; i<old_size; i++){
        int ii = i % block_size;
        if(get_hash(h_s, ii + 1, ii + p.size()) == h_p){
            ans++;
        }
    }
    cout << ans;
    return 0;
}
