#include <iostream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <map>
#define int long long

using namespace std;

const int M = 998244353, INF = 1e18, MAX_N = 1e6 + 7;
int n, m, k;
bool bad[7][MAX_N];
int val[7][MAX_N];

struct query{
	int x, y, v;
	query() {}
	query(int x, int y, int v) {
		this->x = x;
		this->y = y;
		this->v = v;
	}
};

bool ok(int x, int y) {
	return (x < n && y < m);
}

int calc(int n, int m) {
	int dp1[n][m], dp2[n][m];
	for (int i = n - 1; i >= 0; i--) {
		for (int j = m - 1; j >= 0; j--) {
			dp1[i][j] = INF;
			dp2[i][j] = -INF;
			if (bad[i][j]) {
				dp1[i][j] = dp2[i][j] = val[i][j];
				continue;
			}
			if (i == n - 1 || j == m - 1) {
				dp1[i][j] = min(dp1[i][j], 0ll);
				dp2[i][j] = max(dp2[i][j], 0ll);
			}
			if (i != n - 1) {
				dp1[i][j] = min(dp1[i][j], dp2[i + 1][j]);
				dp2[i][j] = max(dp2[i][j], dp1[i + 1][j]);
			}
			if (j != m - 1) {
				dp1[i][j] = min(dp1[i][j], dp2[i][j + 1]);
				dp2[i][j] = max(dp2[i][j], dp1[i][j + 1]);
			}
		}
	}
	int ans = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			ans += dp1[i][j];
		}
	}
	ans %= M;
	if (ans < 0) ans += M;
	return ans;
}

bool cmp(query a, query b) {
	return (a.y < b.y);
}

signed main() {
	//freopen("Desktop/input.txt", "r", stdin);
	ios_base :: sync_with_stdio(0);
	cin.tie(0);
	cin >> n >> m >> k;
	vector <query> kek;
	for (int i = 0; i < k; i++) {
		int x, y, t;
		cin >> x >> y >> t;
		x--;
		y--;
		kek.push_back(query(x, y, t));
	}
	int ans = 0;
	sort(kek.begin(), kek.end(), cmp);
	for (int i = 0; i < kek.size();) {
		int l = i + 1;
		while (l < kek.size() && kek[l].y - kek[l - 1].y <= 10) l++;
		int lleft = max(0ll, kek[i].y - 7);
		int rright = kek[l - 1].y;
		int t = rright - lleft + 1;
		for (int xx = 0; xx < n; xx++) {
			for (int yy = 0; yy < t; yy++) {
				bad[xx][yy] = 0;
			}
		}
		for (int j = i; j < l; j++) {
			bad[kek[j].x][kek[j].y - lleft] = 1;
			val[kek[j].x][kek[j].y - lleft] = kek[j].v;
		}
		ans = (ans + calc(5, t)) % M;
		i = l;
	}
	cout << ans << endl;
	return 0;
}
