#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <algorithm>
#include <math.h>
#include <iomanip>

#define ll long long
#define ld long double
#define ep emplace_back
#define F first
#define S second

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

using namespace std;

const ll inf = 998244353;

int n, m;
map<pair<int, int>, ll > mp, used[2];
map<pair<int, int>, bool> e;

bool in_f(int x, int y){
	return (0 <= x && x < n && 0 <= y && y < m);
}

bool Empty(int x, int y){
	if (e.count({x, y}))
		return e[{x, y}];

	for (int i = 0; i <= 5; i++){
		for (int j = 0; j <= 5; j++){
			if (in_f(x + i, y + j) && mp.count({x + i, y + j})){
				e[{x, y}] = false;
				return false;
			}
		}
	}

	e[{x, y}] = true;
	return true;
}

ll calc(int x, int y, int t = 0){
	if (!in_f(x, y))
		return 0;
	if (used[t].count({x, y}))
		return used[t][{x, y}];

	if (mp.count({x, y})){
		ll tmp = mp[{x, y}];
		used[t][{x, y}] = tmp;
		return tmp;
	}

	if (Empty(x, y))
		used[t][{x, y}] = 0;
	else if (t == 1)
		used[t][{x, y}] = max(calc(x + 1, y, 0), calc(x, y + 1, 0));
	else
		used[t][{x, y}] = min(calc(x + 1, y, 1), calc(x, y + 1, 1));
	return used[t][{x, y}];
}

int main(){
	ios::sync_with_stdio(0), cin.tie(0);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int k;
	cin >> n >> m >> k;
	while (k--){
		int v, u, ci;
		cin >> v >> u >> ci;
		mp[{v - 1, u - 1}] = ci;
	}
	
	int i, j;
	ll ans = 0;
	set<pair<int, int> > calced;
	for (auto &it : mp){
		int x = it.F.F;
		int y = it.F.S;
		for (i = -5; i <= 0; i++){
			for (j = -5; j <= 0; j++){
				if (in_f(x + i, y + j) && !calced.count({x + i, y + j})){
					ans = (ans + calc(x + i, y + j) + 10 * inf) % inf;
					calced.insert({x + i, y + j});
				}
			}
		}
	}

	cout << ans;
}