﻿#include <iostream>
#include <algorithm>
#include <iomanip>
#include <vector>
#include <string>
#include <cmath>
#include <map>
#include <set>

using namespace std;

typedef long long ll;
typedef long double ld;

#define all(x) x.begin(), x.end()
#define int ll
const int INF = 1e18;

int getComf(int f, pair<int, int> prt)
{
	if (f < prt.first)
		return prt.first - f;
	if (f > prt.second)
		return f - prt.second;
	return 0;
}

signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int m, n, k;
	cin >> m >> n >> k;
	vector <pair<int, int>> table(k);
	for (int i = 0; i < k; i++)
	{
		cin >> table[i].first >> table[i].second;
	}
	vector <vector <int>> a(m, vector <int>(n * 2));
	for (int i = 0; i < m; i++)
	{
		for (int j = 0; j < 2 * n; j++)
		{
			cin >> a[i][j];
		}
		sort(all(a[i]));
	}

	int ans = 0;
	for (int j = 0; j < 2 * n; j += 2)
	{
		int bestRes = INF;
		for (int p = 0; p < k; p++)
		{
			int res = 0;
			for (int i = 0; i < m; i++)
			{
				int f = a[i][j];
				int s = a[i][j + 1];
				res += getComf(f, table[p]);
				res += getComf(s, table[p]);
			}
			bestRes = min(bestRes, res);
		}
		ans += bestRes;
	}
	cout << ans;
	return 0;

}