﻿/*#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,sse3,tune=native")*/

#include <iostream>
#include <algorithm>
#include <iomanip>
#include <vector>
#include <string>
#include <cmath>
#include <map>
#include <set>

using namespace std;

typedef long long ll;
typedef long double ld;

#define all(x) x.begin(), x.end()
#define int ll
const int INF = 1e18;
const int MOD = 998244353;

int getComf(int f, const pair<int, int> &prt)
{
	if (f < prt.first)
		return prt.first - f;
	if (f > prt.second)
		return f - prt.second;
	return 0;
}

bool comp(pair<int, int> a, pair<int, int> b)
{
	if (a.first != b.first)
		return a.first < b.first;
	return  a.second > b.second;
}

int getResult(const vector <int> &persons, const pair<int, int> &table)
{
	int res = 0;
	for (int i = 0; i < persons.size(); i++)
	{
		res += getComf(persons[i], table);
	}
	return res;
}

signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, m, k;
	cin >> n >> m >> k;

	map<int, int> a;
	for (int i = 0; i < k; i++)
	{
		int x, y, z;
		cin >> x >> y >> z;
		a[x - y] = max(x, a[x - y]);
	}
	int ans = 0; 
	for (auto it = a.begin(); it != a.end(); it++)
	{
		int maxX = it->second;
		int maxY = it->second - it->first;
		ans += min(maxX, maxY);
	}
	cout << ans;
	return 0;

}