#define _CRT_SECURE_NO_WARNINGS

#include <set>
#include <string>
#include <vector>
#include <iostream>
#include <algorithm>

using namespace std;

const int N = (int)2e6 + 7;
const int INF = (int)1e9 + 7;
long long MOD = 998244353;

#define mp make_pair

////////////////////////////////////////////

int m, n;
string p, w;

vector <int> z_func(const string &s) {
	vector <int> z(s.size());
	int l = 0, r = 0, n = s.size();
	for (int i = 1; i < n; i++) {
		if (i <= r)
			z[i] = min(z[i - l], r - i);
		while (i + z[i] < n && s[z[i]] == s[i + z[i]])
			z[i]++;
		if (i + z[i] > r)
			l = i, r = i + z[i] - 1;
	}
	return z;
}

int main() {
#ifdef _DEBUG 
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	cin.tie(0), cout.tie(0);
	ios_base::sync_with_stdio(0);
#endif
	cin >> m >> n >> p;
	string st = "";
	cin >> w >> w;
	int cnt = 0, x = n;
	while ((int)st.size() < m && x > 0) {
		st += w, x--, cnt++;
	}
	if ((int)st.size() < m) {
		cout << 0;
		return 0;
	}
	long long full = 1LL * n * w.size() / st.size() - 1;
	string s1 = p + '$' + st + st;
	auto z = z_func(s1);
	int in = 0;
	for (int i = 0; i < (int)s1.size(); i++) {
		if (i <= m + (int)st.size() && z[i] >= m)
			in++;
	}
	long long ans = full * in;
	long long use = full * st.size();
	string s2 = p + '$';
	while (use != 1LL * n * w.size())
		s2 += w, use += w.size();
	z = z_func(s2);
	for (int i = 0; i < (int)s2.size(); i++) {
		if (z[i] >= m)
			ans++;
	}
	cout << ans;
}