#include <bits/stdc++.h>
 
#define f first
#define s second
#define pb push_back
#define mp make_pair
using namespace std;
 
typedef long long ll;
typedef long double ld;
 
template<typename T1, typename T2> inline void chkmin(T1 & x, T2 y) {if (x > y) x = y;}
template<typename T1, typename T2> inline void chkmax(T1 & x, T2 y) {if (x < y) x = y;}
 
const int MAXN = 2e5 + 1;
vector<int> a[MAXN];
 
const ll INF = 1e18;
 
int get(pair<int, int> a, int h) {
    if (a.f <= h && h <= a.s) return 0;
    return min(abs(a.f - h), abs(a.s - h));
}

struct node {
	node *l, *r;
	ll x, sum;
	int y, cnt, str_cnt;
	node(int _x, int _cnt = 1) {
		x = _x;
		str_cnt = cnt = _cnt;
		sum = x * cnt;
		l = r = nullptr;
		y = (rand() << 16) + rand();
	}
};

int get_cnt(node *a) {
	if (!a) return 0;
	return a->str_cnt;
}

ll get_sum(node *a) {
	if (!a) return 0;
	return a->sum;
}

void upd(node *a) {
	if (!a) return;
	a->sum = a->x * a->cnt + get_sum(a->l) + get_sum(a->r);
	a->str_cnt = a->cnt + get_cnt(a->l) + get_cnt(a->r);
}

pair<node*, node*> split(node *a, int x) {
	if (!a) return {nullptr, nullptr};
	if (a->x <= x) {
		auto tmp = split(a->r, x);
		a->r = tmp.f;
		upd(a);
		return {a, tmp.s};
	}
	else {
		auto tmp = split(a->l, x);
		a->l = tmp.s;
		upd(a);
		return {tmp.f, a};
	}
}

node *merge(node *a, node *b) {
	if (!a) return b;
	if (!b) return a;
	if (a->y > b->y) {
		a->r = merge(a->r, b);
		upd(a);
		return a;
	}
	else {
		b->l = merge(a, b->l);
		upd(b);
		return b;
	}
}

ll get_res(pair<int, int> j, node *t) {
    auto tmp1 = split(t, j.f - 1);
    ll res = 1ll * j.f * get_cnt(tmp1.f) - get_sum(tmp1.f);
    auto tmp2 = split(tmp1.s, j.s);
    res += get_sum(tmp2.s) - 1ll * j.s * get_cnt(tmp2.s);
    t = merge(tmp1.f, merge(tmp2.f, tmp2.s));
    return res;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    // freopen("input.txt", "r", stdin);
    int n, m, k;
    cin >> m >> n >> k;
    map<int, int> d;
    for (int i = 0; i < k; ++i) {
        int l, r;
        cin >> l >> r;
        chkmax(d[l], r);
    }
    vector<pair<int, int>> dsk;
    dsk.reserve(d.size());
    for (auto i : d)
        dsk.pb(i);
    sort(dsk.begin(), dsk.end());
    for (int i = 0; i < m; ++i) {
        a[i].resize(2 * n);
        for (int j = 0; j < 2 * n; ++j)
            cin >> a[i][j];
        sort(a[i].begin(), a[i].end());
    }
    ll ans = 0;
    int pdesk = 0;
    for (int i = 0; i < n; ++i) {
        int ci = 2 * i;
        ll cur_ans = INF;
        map<int, int> cnt;
        for (int cl = 0; cl < m; ++cl) {
        	++cnt[a[cl][ci]];
        	++cnt[a[cl][ci + 1]];
        }
        node *t = nullptr;
        for (auto j : cnt)
        	t = merge(t, new node(j.f, j.s));

        ll pres = get_res(dsk[pdesk], t);
        while (pdesk < dsk.size()) {
            auto j = dsk[pdesk + 1];
            ll res = get_res(j, t);
            if (res < pres) {
                pres = res;
                ++pdesk;
            }
            else break;
        }
        ans += pres;
    }
    cout << ans;
    return 0;
}