#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>

using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")

typedef long long ll;
typedef long double ld;

#define int long long

const int inf = 1e18 + 7;
const ld eps = 1e-9;

struct Table
{
	int l;
	int r;
};

int unc(int l, int r, int h)
{
	if (h < l)
		return l - h;
	if (h > r)
		return h - r;
	return 0;
}

signed main()
{
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	int m, n, k;
	cin >> m >> n >> k;

	vector<Table> tab(k);
	for (int i = 0; i < k; i++)
	{
		cin >> tab[i].l >> tab[i].r;
	}

	vector<vector<int>> gr(m, vector<int>(2 * n));
	for (int i = 0; i < m; i++)
	{
		for (int j = 0; j < 2 * n; j++)
		{
			cin >> gr[i][j];
		}
	}

	for (int i = 0; i < m; i++)
	{
		sort(gr[i].begin(), gr[i].end());
	}

	int uncomf = 0;
	for (int j = 0; j < 2 * n; j += 2)
	{
		vector<int> h;
		for (int i = 0; i < m; i++)
		{
			h.push_back(gr[i][j]);
			h.push_back(gr[i][j + 1]);
		}
		sort(h.begin(), h.end());

		vector<int> pref(2 * m + 1, 0);
		for (int i = 0; i < 2 * m; i++)
		{
			pref[i + 1] = pref[i] + h[i];
		}

		int ans = inf;
		for (int i = 0; i < k; i++)
		{
			auto l = lower_bound(h.begin(), h.end(), tab[i].l);
			auto r = upper_bound(h.begin(), h.end(), tab[i].r);
			int preans = 0;
			if (l != h.begin())
			{
				int lind = l - h.begin() - 1;
				preans += tab[i].l * (lind + 1) - pref[lind + 1];
			}
			int rind = r - h.begin();
			preans += (pref[2 * m] - pref[rind]) - (tab[i].r * (2 * m - rind));

			ans = min(ans, preans);
		}
		uncomf += ans;
	}

	cout << uncomf << endl;

	

	//system("pause");
	return 0;
}