#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>

using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")

typedef long long ll;
typedef long double ld;

#define int long long

const int inf = 1e18 + 7;
const ld eps = 1e-9;

struct Table
{
	int l;
	int r;

	bool operator < (Table b) const
	{
		if (l == b.l)
			return r < b.r;
		return l < b.l;
	}
};

int unc(int lb, int rb, vector<int>& h, vector<int>& pref)
{
	int m = h.size() / 2;
	auto l = lower_bound(h.begin(), h.end(), lb);
	auto r = upper_bound(h.begin(), h.end(), rb);
	int preans = 0;
	if (l != h.begin())
	{
		int lind = l - h.begin() - 1;
		preans += lb * (lind + 1) - pref[lind + 1];
	}
	int rind = r - h.begin();
	preans += (pref[2 * m] - pref[rind]) - (rb * (2 * m - rind));
	return preans;
}

signed main()
{
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	int m, n, k;
	cin >> m >> n >> k;

	bool leqr = true;
	vector<Table> tab(k);
	for (int i = 0; i < k; i++)
	{
		int l, r;
		cin >> l >> r;
		tab[i] = { l, r };

		if (l != r)
			leqr = false;
	}
	sort(tab.begin(), tab.end());

	vector<vector<int>> gr(m, vector<int>(2 * n));
	for (int i = 0; i < m; i++)
	{
		for (int j = 0; j < 2 * n; j++)
		{
			cin >> gr[i][j];
		}
	}

	for (int i = 0; i < m; i++)
	{
		sort(gr[i].begin(), gr[i].end());
	}

	int uncomf = 0;
	for (int j = 0; j < 2 * n; j += 2)
	{
		vector<int> h;
		for (int i = 0; i < m; i++)
		{
			h.push_back(gr[i][j]);
			h.push_back(gr[i][j + 1]);
		}
		sort(h.begin(), h.end());

		vector<int> pref(2 * m + 1, 0);
		for (int i = 0; i < 2 * m; i++)
		{
			pref[i + 1] = pref[i] + h[i];
		}

		if (false)
		{
			int ans = inf;
			int ind = m - 1;
			Table tb = { h[ind], h[ind] };
			auto it = lower_bound(tab.begin(), tab.end(), tb);
			if (it != tab.end())
			{
				int preans = unc(it->l, it->r, h, pref);
				ans = min(ans, preans);
			}
			if (it != tab.begin())
			{
				it--;
				int preans = unc(it->l, it->r, h, pref);
				ans = min(ans, preans);
			}
			continue;
		}

		int ans = inf;
		for (int i = 0; i < k; i++)
		{
			int preans = unc(tab[i].l, tab[i].r, h, pref);
			ans = min(ans, preans);
		}
		uncomf += ans;
	}

	cout << uncomf << endl;

	

	//system("pause");
	return 0;
}