#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>

using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")

typedef long long ll;
typedef long double ld;

#define int long long

const int inf = 1e18 + 7;
const ld eps = 1e-9;

const int M = 998244353;

int mod(int a, int b)
{
	int ans = a % b;
	if (ans < 0)
		ans += b;
	return ans;
}


signed main()
{
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	int n, m, k;
	cin >> n >> m >> k;

	vector<vector<int>> fst(n + 1, vector<int>(m + 1, -1));
	vector<vector<int>> snd(n + 1, vector<int>(m + 1, -1));
	for (int i = 0; i <= n; i++)
	{
		fst[i][m] = 0;
		snd[i][m] = 0;
	}
	for (int j = 0; j <= m; j++)
	{
		fst[n][j] = 0;
		snd[n][j] = 0;
	}

	for (int i = 0; i < k; i++)
	{
		int x, y, c;
		cin >> x >> y >> c;
		x--; y--;

		fst[x][y] = c;
		snd[x][y] = c;
	}

	for (int i = n - 1; i >= 0; i--)
	{
		for (int j = m - 1; j >= 0; j--)
		{
			if (fst[i][j] == -1)
			{
				fst[i][j] = min(snd[i + 1][j], snd[i][j + 1]);
				snd[i][j] = max(fst[i + 1][j], fst[i][j + 1]);
			}
		}
	}

	int sum = 0;
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < m; j++)
		{
			sum += fst[i][j];
			sum = mod(sum, M);
		}
	}
	
	cout << sum << endl;

	//system("pause");
	return 0;
}