#include <iostream>
#include <vector>
#include <algorithm>
#define ll long long

using namespace std;

const int fr = 1e9 + 1;
const ll mod = 998244353;

struct cat {
	int r;
	int c;
	int v;
	cat(int r1, int c1, int v1) {
		r = r1;
		c = c1;
		v = v1;
	}
	cat(){}
};

bool cmp(cat A, cat B) {
	return A.c < B.c;
}

int main() {
	int n, m, k;
	cin >> n >> m >> k;
	vector<cat> arr(k);
	for (int i = 0; i < k; i++) {
		int r, c;
		int v;
		cin >> r >> c >> v;
		r--;
		c--;
		arr[i] = { r, c, v };
	}
	sort(arr.begin(), arr.end(), cmp);
	int last = 0;
	int len = 0;
	for (int i = 0; i < k; i++) {
		int x = arr[i].c;
		int help = x;
		if (x - last > 12) {
			x = len + 12;
			len = x;
			last = help;
			arr[i].c = x;
		}
		else {
			x = len + (x - last);
			len = x;
			last = help;
			arr[i].c = x;
		}
	}
	//for (auto elem : arr) cout << elem.r << " " << elem.c << endl;
	vector<vector<int> > bomb(6);
	vector<vector<int> > g1(6);
	vector<vector<int> > g2(6);
	for (int i = 0; i < 6; i++) bomb[i].resize(len + 2);
	for (int i = 0; i < 6; i++) g1[i].resize(len + 2);
	for (int i = 0; i < 6; i++) g2[i].resize(len + 2);
	m = len + 1;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) bomb[i][j] = fr;
	}
	for (int i = 0; i <= n; i++) {
		bomb[i][m] = 0;
		g1[i][m] = 0;
		g2[i][m] = 0;
	}
	for (int j = 0; j <= m; j++) {
		bomb[n][j] = 0;
		g1[n][j] = 0;
		g2[n][j] = 0;
	}
	for (auto elem : arr) {
		bomb[elem.r][elem.c] = elem.v;
	}
	for (int i = n - 1; i >= 0; i--) {
		for (int j = m - 1; j >= 0; j--) {
			//g1
			if (bomb[i][j] != fr) g1[i][j] = bomb[i][j];
			else {
				g1[i][j] = min(g2[i + 1][j], g2[i][j + 1]);
			}

			//g2
			if (bomb[i][j] != fr) g2[i][j] = bomb[i][j];
			else {
				g2[i][j] = max(g1[i + 1][j], g1[i][j + 1]);
			}
		}
	}
	ll ans = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			ans += g1[i][j];
			ans = (ans % mod + mod) % mod;
		}
	}
	cout << ans << endl;
	//cin >> ans;
}