#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

#define ll long long

using namespace std;

ll mod = 1791791791;
ll x = 137;

ll fastpow(ll need) {
	if (need == 0) return 1;
	if (need == 1) return x;
	if (need % 2 == 0) {
		ll res = fastpow(need / 2);
		return res * res % mod;
	}
	if (need % 2 == 1) {
		ll res = fastpow(need - 1);
		return res * x % mod;
	}
}

ll fasthash(ll h, ll len, ll need) {
	if (need == 0) return 0;
	if (need == 1) return h;
	if (need % 2 == 1) {
		ll res = fasthash(h, len, need - 1);
		ll ans = (res * fastpow(len) % mod + h) % mod;
		return ans;
	}
	if (need % 2 == 0){
		ll res = fasthash(h, len, need / 2);
		ll ans = (res * fastpow(len * need / 2) % mod + res) % mod;
		return res;
	}
}

ll geth(int L, int R, vector<ll> &h) {
	if (R < L) return 0;
	ll hr = h[R + 1];
	ll hl = h[L] * fastpow(R - L + 1) % mod;
	return ((hr - hl) % mod + mod) % mod;
}

int main() {
	ll m, n;
	cin >> m >> n;
	string p;
	cin >> p;
	ll H = 0;
	for (int i = 0; i < m; i++) {
		H = (H * x + (p[i] - 'a') + 1) % mod;
	}
	int t;
	cin >> t;
	string a;
	cin >> a;
	int cnt = 1;
	for (int i = 1; i < n; i++) {
		cin >> t;
		ll L;
		ll R;
		cin >> L >> R;
		ll len = R / a.size();
		cnt += len;
	}
	//cout << cnt << endl;
	// string a, cnt times
	n = p.size();
	m = a.size();
	vector<ll> h(m + 1);
	h[0] = 0;
	for (int i = 1; i <= m; i++) {
		h[i] = ((h[i - 1] * x) % mod + (a[i - 1] - 'a') + 1) % mod;
	}
	//cout << "here" << endl;
	vector<bool> ans(m);
	for (int i = 0; i < m; i++) ans[i] = 0;
	for (int i = 0; i < m; i++) {
		ll left = n;
		ll pref = min(left, m - i);
		left -= pref;
		ll coun = left / m;
		ll suff = left % m;
		//cout << i << ": " << pref << " " << coun << " " << suff << endl;
		ll hash1 = geth(i, i + pref - 1, h);
		ll hash2 = fasthash(h[m], m, coun);
		ll hash3 = geth(0, suff - 1, h);
		//cout << hash1 << " " << hash2 << " " << hash3 << endl;
		ll H2 = hash1 * fastpow(m * coun + suff) % mod;
		H2 += hash2 * fastpow(suff) % mod;
		H2 %= mod;
		H2 += hash3;
		H2 %= mod;
		//cout << H << " " << H2 << endl;
		if (H == H2) ans[i] = 1;
	}
	ll answer = 0;
	for (int i = 0; i < m; i++) {
		if (ans[i] == 0) {
			continue;
		}
		ll L = -1;
		ll R = cnt + 1;
		while (R - L > 1) {
			ll M = (L + R) / 2;
			if (M * m + i + n <= m * cnt) L = M;
			else R = M;
		}
		answer += (L + 1);
	}
	cout << answer << endl;
	//cin >> answer;
}