#include <bits/stdc++.h>
#define x first
#define y second
#define pb push_back
using namespace std;

template<typename T1, typename T2> 
inline void chkmax(T1 &x, const T2 &y) {
	if (x < y) x = y;
}

template<typename T1, typename T2> 
inline void chkmin(T1 &x, const T2 &y) {
	if (x > y) x = y;
}

typedef pair<int, int> point;

const int SZ = 2e7 + 1;

unsigned long long p1 = 998244353, p2 = 1e9 + 7;
unsigned long long w1 = 48428, w2 = 732737;

unsigned long long my_rand() {
	auto w3 = w1 * p1 + w2 * p2;
	w2 = w1;
	return w1 = w3;
}

struct node {
	int L = 0, R = 0;
	long long sum = 0;
	char mysum = 0;
	short int s = 0;
	bool mod = false;
	char c = ' ';

	node() {}
} a[SZ];

int it = 1;

inline int new_node(char c) {
	a[it].c = c;
	a[it].s = 1;
	return it++;
}

inline int clone(int i) {
	a[it] = a[i];
	return it++;
}

void print(int A) {
	if (A == 0) return;
	print(a[A].L);
	cout << char(a[A].c + 'a');
	print(a[A].R);
}

void print(int A, bool mod) {
	if (A == 0) return;
	mod |= a[A].mod;
	print(a[A].L, mod);
	cout << (mod ? 0 : a[A].mysum);
	print(a[A].R, mod);
}



int setv(int i) {
	if (!a[i].mod && a[i].sum) {
		i = clone(i);
		a[i].mod = true;
	} 
	return i;
}


int push(int j) {
	// int i = clone(j);
	int i = j;
	if (a[i].mod) {
		a[i].sum = a[i].mysum = a[i].mod = 0;
		a[i].L = setv(a[i].L);
		a[i].R = setv(a[i].R);
	}
	return i;
}

inline long long get(int i) {
	return a[i].mod ? 0 : a[i].sum;
}
void rebuild(int i) {
	a[i].s = a[a[i].L].s + 1 + a[a[i].R].s;
	a[i].sum = get(a[i].L) + a[i].mysum + get(a[i].R);
}

int merge(int L, int R) {
	if (L == 0) return R;
	if (R == 0) return L;
	auto v = my_rand() % (a[L].s + a[R].s);
	if (v < a[L].s) {
		L = clone(push(L));
		a[L].R = merge(a[L].R, R);
		rebuild(L);
		return L;
	} else {
		R = clone(push(R));
		a[R].L = merge(L, a[R].L);
		rebuild(R);
		return R;
	}
}

void split(int A, long long x, int &L, int &R) {
	if (A == 0) {
		L = R = 0;
		return;
	}
	A = clone(push(A));
	if (a[a[A].L].s < x) {
		x -= a[a[A].L].s + 1;
		split(a[A].R, x, L, R);
		a[A].R = L;
		L = A;
	} else {
		split(a[A].L, x, L, R);
		a[A].L = R;
		R = A;
	}
	rebuild(A);
}

string cur = "";

void get_string(int A) {
	if (A == 0) return;
	// cout << A << endl;
	get_string(a[A].L);
	cur += a[A].c;
	get_string(a[A].R);
}

void split_stringR(int A, int x) {
	if (A == 0) return;
	if (a[a[A].R].s + 1 <= x) {
		x -= a[a[A].R].s + 1;
		split_stringR(a[A].L, x);
		cur += a[A].c;
		get_string(a[A].R);
	} else {
		split_stringR(a[A].R, x);
	}
}

void split_stringL(int A, int x) {
	if (A == 0) return;
	if (a[a[A].L].s + 1 <= x) {
		x -= a[a[A].L].s + 1;
		get_string(a[A].L);
		cur += a[A].c;
		split_stringL(a[A].R, x);
	} else {
		split_stringL(a[A].L, x);
	}
}

int add(int A, long long x) {
	assert(A != 0);
	// cout << A << endl;
	A = clone(push(A));
	if (a[a[A].L].s < x) {
		x -= a[a[A].L].s + 1;
		a[A].R = add(a[A].R, x);
	} else if (a[a[A].L].s > x) {
		a[A].L = add(a[A].L, x);
	} else {
		++a[A].mysum;
	}
	++a[A].sum;
	return A;
}

int root = 0;
int n, m;
string s;

const int N = 10005;

int lst = 1, cur_root = 0;
int go[N * 2][26];
int suf[N * 2], len[N * 2];

void add(char c) {
	int cur = lst++;
	len[cur] = len[cur_root] + 1;
	if (len[cur] == 1) {
		suf[cur] = 0;
	} else {
		suf[cur] = 0;
		int r = cur_root;
		while (r >= 0) {
			if (go[r][c]) {
				suf[cur] = go[r][c];
				break;
			} else {
				r = suf[r];
			}	
		}
	}
	go[cur_root][c] = cur;
	cur_root = cur;
	// cout << cur << ' ' << suf[cur] << endl;
}

bool used[N * 2][26];

int solve(int i, char c) {
	if (used[i][c] || go[i][c]) return go[i][c];
	used[i][c] = true;
	if (i == 0) return 0;
	return go[i][c] = solve(suf[i], c);
}

int resetR(int v) {
	if (a[v].s < s.size()) {
		v = setv(v);
	} else {
		int L, R;
		split(v, a[v].s - s.size() + 1, L, R);
		setv(R);
		v = merge(L, R);
	}
	return v;
}

int connect(int L, int R) {
	L = resetR(L); 
	R = resetR(R);
	cur.clear();
	split_stringR(L, s.size() - 1);
	split_stringL(R, s.size() - 1);
	int M = merge(L, R);	
	int v = 0;
	long long Lc = 0;
	if (a[L].s >= s.size() - 1) {
		Lc = a[L].s - (s.size() - 1);
	}
	for (int i = 0; i < cur.size(); ++i) {
		v = go[v][cur[i]];
		if (len[v] == n) {
			M = add(M, Lc + i - s.size() + 1);
		}
	}
	return M;
}	

string val;

int main() {
	ios::sync_with_stdio(false);
	a[0].mod = true;
	suf[0] = -1;
	cin >> n >> m;
	cin >> s;
	for (auto &c : s) c -= 'a';
	for (auto c : s) add(c);
	for (int i = 0; i <= s.size(); ++i) {
		for (int j = 0; j < 26; ++j) {
			solve(i, j);
		}
	}
	for (int i = 0; i < m; ++i) {
		int t;
		cin >> t;
		if (t == 1) {
			string ns;
			cin >> ns;
			for (auto &c : ns) c -= 'a';
			int cur_root = 0;
			for (auto c : ns) {
				int v = new_node(c);
				if (s.size() == 1 && c == s[0]) {
					a[v].mysum = 1;
					a[v].sum = 1;
				}
				cur_root = connect(cur_root, v);
			} 
			val += ns;
			root = connect(root, cur_root);
		} else {
			long long L, sz;
			cin >> L >> sz;
			--L;
			while (sz) {
				// int M1, M2, M3;
				// long long csz = min(a[root].s - L, sz);
				// split(root, L + csz, M2, M3);
				// split(M2, L, M1, M2);
				// vector<int> w;
				// long long need = sz / csz;
				// w.pb(M2);
				// for (int i = 1; (need >> i); ++i) {
				// 	w.pb(connect(w.back(), w.back()));
				// }
				// int cur_root = 0;
				// for (int i = 0; i < w.size(); ++i) {
				// 	if ((need >> i) & 1) {
				// 		cur_root = connect(cur_root, w[i]);
				// 	}
				// }
				// root = connect(root, cur_root);
				// L += csz * need;
				// sz -= need * csz;

				int v = new_node(val[L]);
				val += val[L];
				++L, --sz;
				if (s.size() == 1 && val[L] == s[0]) {
					a[v].mysum = 1;
					a[v].sum = 1;
				}
				cur_root = connect(cur_root, v);
			}
			root = connect(root, cur_root);
		}	
	}
	cout << get(root) << '\n';
}
	