#pragma GCC optimize("Ofast", "unroll-loops")
#pragma GCC target("sse,sse2,sse3")

#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;
 
#define sz(x) ((int)(x).size())
#define pii pair<int, int>
#define MAXN 100005
#define MOD 998244353
#define LLINF 1000000000000000000LL
 
int n, m, k;

int idx[6*MAXN];
long long dp[7][7*MAXN];
char used[7][7*MAXN];
int t_sz = 1;

int find_idx(int x) {
    int l = 1, r = t_sz;
    while(l < r) {
        int sr = (l + r) / 2;
        if(x > idx[sr])
            l = sr + 1;
        else if(x < idx[sr])
            r = sr - 1;
        else
            return sr;
    }
    return r;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> m >> k;
    
    set<int> w;
    vector< pair<pii, int> > u(k);

    for(int i = 0; i < k; ++i) {
        int x, y, v;
        cin >> x >> y >> v;
        for(int i = max(1, y - 10); i < y + 10; ++i)
            w.insert(i);
        u[i] = {{x, y}, v};
    }

    for(auto p = w.begin(); p != w.end(); ++p)
        idx[t_sz++] = (*p);

    for(int i = 0; i < k; ++i) {
        int x = u[i].first.first;
        int y = find_idx(u[i].first.second);
        int v = u[i].second;
        used[x][y] = true;
        dp[x][y] = v;
    }

    for(int i = n; i > 0; --i) {
        for(int j = t_sz; j > 0; --j) {
            if(used[i][j])
                continue;
            if(used[i + 1][j])
                dp[i][j] = dp[i + 1][j];
            else
                dp[i][j] = max(dp[i + 2][j], (idx[j + 1] - idx[j] == 1 ? dp[i + 1][j + 1] : 0));
 
            if(idx[j + 1] - idx[j] == 1) {
                if(used[i][j + 1])
                    dp[i][j] = min(dp[i][j], dp[i][j + 1]);
                else
                    dp[i][j] = min(dp[i][j], max(dp[i][j + 2], dp[i + 1][j + 1]));
            }
            else
                dp[i][j] = 0;
        }
    }

    long long sum = 0;
 
    for(int i = 1; i <= n; ++i) {
        for(int j = 1; j <= t_sz; ++j) {
            sum += dp[i][j];
            while(sum < 0)
                sum += MOD;
            while(sum >= MOD)
                sum -= MOD;
        }
    }
 
    cout << sum << endl;

    return 0;
}