#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

const int64_t inf = 2e18;

int comfort(const int& x, const pair<int, int>& seg) {
	if ((seg.first <= x) && (x <= seg.second))
		return 0;
	return min(abs(x - seg.first), abs(x - seg.second));
}

int main() {
	int m, n, k;
	cin >> m >> n >> k;
	vector<pair<int, int>> place(k);
	for (int i = 0; i < k; ++i)
		cin >> place[i].first >> place[i].second;
	vector<vector<int>> height(m, vector<int>(2 * n));
	for (int i = 0; i < m; ++i)
		for (int j = 0; j < 2 * n; ++j)
			cin >> height[i][j];

	for (int i = 0; i < m; ++i)
		sort(height[i].begin(), height[i].end());

	int64_t ans = 0;
	for (int i = 0; i < 2 * n; i += 2) {
		int64_t best = inf;
		for (int j = 0; j < k; ++j) {
			int64_t now = 0;
			for (int s = 0; s < m; ++s) {
				now += comfort(height[s][i], place[j]);
				now += comfort(height[s][i + 1], place[j]);
			}
			best = min(best, now);
		}
		ans += best;
	}
	cout << ans;
}
