#include <stdio.h>
#include <algorithm>

const int MAX = 1e6;

int count_z(char *s, int *z, int n, int m) {
	int in = 0, cnt = 0;
	z[0] = 0;
	for (int i = 1; i < n; i++) {
		z[i] = 0;
		if (i <= z[in] + in) {
			z[i] = z[i - in];
			if (i + z[i] > in + z[in]) {
				z[i] = in + z[in] - i;
			}
		}
		while (i + z[i] < n && s[i + z[i]] == s[z[i]]) {
			z[i]++;
		}
		if (in + z[in] < i + z[i]) {
			in = i;
		}
		if (i > m && z[i] >= m) {
			cnt++;
		}
	}
	return cnt;
}

char s[MAX + (int)1e7 + 1];
int z[MAX + (int)1e7];

int main() {
	int m, n;
	scanf("%d%d", &m, &n);
	char w[MAX];
	scanf("\n%s", s);
	int ind = 0;
	for (int i = 0; i < n; i++) {
		int t;
		scanf("%d", &t);
		if (t == 1) {
			scanf("%s", w);
			for (int j = 0; w[j]; j++) {
				s[m + 1 + ind++] = w[j];
			}
		} else {
			long long pos, len;
			scanf("%lld%lld", &pos, &len);
			pos = ind - 1;
			for (long long j = 0; j < len && j <= 2 * m + 1; j++) {
				s[m + 1 + ind++] = s[m + pos + j + 1];
			}
		}
	}
	printf("%d", count_z(s, z, m + ind + 1, m));
	return 0;
}
