#include "bits/stdc++.h"

#define ll long long
#define pb push_back
#define all(x) x.begin(), x.end()


const ll inf = 1e18;
const ll mod = 998244353;


using namespace std;


struct state {
    ll i, j, turn;
};


bool operator<(state a, state b) {
    if (a.j < b.j) {
        return true;
    }
    if (a.j > b.j) {
        return false;
    }
    if (a.i < b.i) {
        return true;
    }
    if (a.i > b.i) {
        return false;
    }
    return a.turn < b.turn;
}


void solve() {
    ll n, m, k;
    cin >> n >> m >> k;
    set<pair<ll, ll>> need_watch;
    map<state, ll> dp;
    ll answer = 0;
    vector<pair<ll, ll>> bad;
    for (int t = 0; t < k; t++) {
        ll r, c, v;
        cin >> r >> c >> v;
        bad.pb({r - 1, c - 1});
        dp[{r - 1, c - 1, 0}] = v;
        dp[{r - 1, c - 1, 1}] = v;
        answer += v;
        for (int i = max(0LL, r - 6); i < r; i++) {
            for (int j = max(0LL, c - 6); j < c; j++) {
                need_watch.insert({i, j});
            }
        }
    }
    for (auto p : bad) {
        need_watch.erase(p);
    }
    vector<pair<ll, ll>> order;
    for (auto cnt : need_watch) {
        order.pb(cnt);
    }
    while (!order.empty()) {
        ll i = order.back().first, j = order.back().second;
        order.pop_back();
        dp[{i, j, 0}] = min(dp[{i + 1, j, 1}], dp[{i, j + 1, 1}]);
        answer += dp[{i, j, 0}];
        dp[{i, j, 1}] = max(dp[{i + 1, j, 0}], dp[{i, j + 1, 0}]);
    }
    cout << (answer % mod + mod) % mod;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    srand(time(0));
    solve();
    return 0;
}