#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <string>

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;

int get_ans(vector<int> v, int b, int &cnt) {
	int ans = 0;
	int last = 0;
	cnt = 0;

	if (b > 0) {
		while (v.back() == 0) {
			ans++;
			v.pop_back();
		}
	}

	for (int i = 0; i < v.size(); i++) {
		last += v[i];
		if (last >= b) {
			ans += last - b;
			last = 0;
			cnt++;
		}
		else
			ans++;
	}
	if (cnt == 1)
		return INF;
	if (last == 0)
		return ans;
	if (last >= b) {
		ans += last - b;
		cnt++;
	}
	else
		ans += 1 + last;
	return ans;
}

int main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;

	string s;
	cin >> s;

	int cur = 0;
	vector<int> v;
	for (int i = 0; i < n; i++) {
		if (s[i] == '0')
			cur++;
		else {
			v.push_back(cur);
			cur = 0;
		}
	}
	v.push_back(cur);

	vector<bool> r(n + 1, 0);
	for (int i : v)
		r[i] = 1;

	int ans = INF;
	int ans_sz = -1;

	int sz = 0;
	//cur = get_ans(v, 0, sz);
	for (int b = 0; b <= n; b++) {
		cur = get_ans(v, b, sz);
		if (cur < ans) {
			ans = cur;
			ans_sz = b;
		}
	}

	string str;
	int count = (n - ans - ans_sz) / (ans_sz + 1);
	for (int i = 0; i < count; i++) {
		for (int j = 0; j < ans_sz; j++)
			str += '0';
		str += '1';
	}
	for (int j = 0; j < ans_sz; j++)
		str += '0';

	cout << str.size() << endl << str << endl;

	return 0;
}