#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <string>

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;

struct Dsu {
	int n;
	int *p;
	int *r;
	int count;
	int *sum;
	int *first;

	Dsu(int n_ = 0) {
		n = n_;
		p = new int[n];
		r = new int[n];
		first = new int[n];
		sum = new int[n];
		count = n;
		for (int i = 0; i < n; i++) {
			p[i] = i;
			r[i] = 1;
			first[i] = i;
		}
	}

	int find(int a) {
		if (p[a] == a)
			return a;
		p[a] = find(p[a]);
		return p[a];
	}

	int get_sum(int a) {
		return sum[find(a)];
	}

	int get_first(int a) {
		return first[find(a)];
	}

	void unite(int a, int b) {
		a = find(a);
		b = find(b);
		if (a == b)
			return;
		count--;
		if (r[a] < r[b])
			swap(a, b);
		p[b] = a;
		r[a] += r[b];
		sum[a] += sum[b];
		first[a] = max(first[a], first[b]);
	}
};

int main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;

	string s;
	cin >> s;

	int cur = 0;
	vector<int> v;
	for (int i = 0; i < n; i++) {
		if (s[i] == '0')
			cur++;
		else {
			v.push_back(cur);
			cur = 0;
		}
	}
	v.push_back(cur);

	int v_sum = 0;
	for (int i : v)
		v_sum += i;

	int ans = INF;
	int ans_sz = -1;

	int sz = v.size();
	Dsu dsu(sz);

	for (int i = 0; i < sz; i++)
		dsu.sum[i] = v[i];

	set<pair<int, int>> st;
	for (int i = 0; i < v.size(); i++)
		st.insert({v[i], i});

	for (int b = 0; b <= n; b++) {
		while (!st.empty() && st.begin()->first < b) {
			int val = st.begin()->first;
			int ind = st.begin()->second;
			st.erase(st.begin());
			if (dsu.find(ind) == dsu.find(sz - 1)) {
				continue;
			}

			st.erase({ dsu.get_sum(dsu.get_first(ind) + 1), dsu.find(dsu.get_first(ind) + 1) });
			dsu.unite(ind, dsu.get_first(ind) + 1);
			st.insert({dsu.get_sum(ind), dsu.find(ind)});
		}

		int cur = dsu.count;
		if (dsu.get_sum(sz - 1) < b)
			cur--;
		if (cur <= 1)
			continue;

		int cur_ans = (v_sum - b * cur) + (int)v.size() - cur;
		if (cur_ans < ans) {
			ans = cur_ans;
			ans_sz = b;
		}
	}

	string str;
	int count = (n - ans - ans_sz) / (ans_sz + 1);
	for (int i = 0; i < count; i++) {
		for (int j = 0; j < ans_sz; j++)
			str += '0';
		str += '1';
	}
	for (int j = 0; j < ans_sz; j++)
		str += '0';

	cout << str.size() << endl << str << endl;

	return 0;
}