#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <string>

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const ll INF_LL = 1e18;
const int M = 998244353;


int main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	srand(time(NULL));
	
	int n, m, k;
	cin >> n >> m >> k;

	vector<vector<pair<int, int>>> dp(n + 1, vector<pair<int, int>>(m + 1, { INF, -INF }));
	vector<vector<bool>> x(n, vector<bool>(m, 0));

	for (int i = 0; i <= n; i++)
		dp[i][m] = { 0, 0 };
	for (int i = 0; i <= m; i++)
		dp[n][i] = { 0, 0 };

	for (int i = 0; i < k; i++) {
		int r, c, v;
		cin >> r >> c >> v;
		r--, c--;
		dp[r][c] = { v, v };
		x[r][c] = 1;
	}

	ll ans = 0;
	for (int i = n - 1; i >= 0; i--) {
		for (int j = m - 1; j >= 0; j--) {
			if (x[i][j]) {
				ans += dp[i][j].first;
				continue;
			}
			dp[i][j].first = min(dp[i + 1][j].second, dp[i][j + 1].second);
			dp[i][j].second = max(dp[i + 1][j].first, dp[i][j + 1].first);
			ans += dp[i][j].first;
		}
	}

	/*for (int i = 0; i <= n; i++) {
		for (int j = 0; j <= m; j++) {
			cout << "(" << dp[i][j].first << " " << dp[i][j].second << ") ";
		}
		cout << endl;
	}*/

	cout << ((ans % M) + M) % M << endl;

	return 0;
}