#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <string>

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const ll INF_LL = 1e18;

int get(int l, int r, int a) {
	if (l <= a && a <= r)
		return 0;
	return min(abs(l - a), abs(r - a));
}

int main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	srand(time(NULL));
	
	int m, n;
	cin >> n >> m;

	string s, t;
	cin >> t;

	while (m--) {
		int t;
		cin >> t;
		if (t == 1) {
			string w;
			cin >> w;
			s += w;
		}
		else {
			int pos, len;
			cin >> pos >> len;
			pos--;
			for (int i = 0; i < len; i++)
				s += s[pos + i];
		}
	}

	string str = t + "#" + s;
	
	int sz = str.size();
	vector<int> z(sz, 0);
	int l = 0, r = 0;
	for (int i = 1; i < sz; i++) {
		z[i] = max(0, min(z[i - l], r - i));
		while (i + z[i] < sz && str[z[i]] == str[i + z[i]])
			z[i]++;
		if (i + z[i] > r) {
			r = i + z[i];
			l = i;
		}
	}

	int ans = 0;
	for (int i = n; i < sz; i++) {
		if (z[i] >= n)
			ans++;
	}
	cout << ans << endl;

	return 0;
}