#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <bitset>
#include <queue>
#include <algorithm>
#include <cmath>
#include <ctime>
#include <cstring>

using namespace std;

#define int long long
#define sz(a) (int)(a.size())
#define pb emplace_back

void fast_io() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
}

const int MAXN = 5e5 + 228;
int g[MAXN];
int n;

int getv1(int T) {
	int ans = 0;
	int i = 0;
	int cur_c = 0;
	while (i < n) {
		if (g[i] == 0 && cur_c < T) {
			cur_c++;
		}
		if (g[i] == 1 && cur_c == T) {
			cur_c = 0;
			ans += (T + 1);
		}
		i++;
	}
	if (cur_c >= T) {
		ans += T;
	}
	else {
		ans--;
	}
	return ans;
}

int getv2(int T) {
	int ans = 0;
	int i = n - 1;
	int cur_c = 0;
	while (i >= 0) {
		if (g[i] == 0 && cur_c < T) {
			cur_c++;
		}
		if (g[i] == 1 && cur_c == T) {
			cur_c = 0;
			ans += (T + 1);
		}
		i--;
	}
	if (cur_c >= T) {
		ans += T;
	}
	else {
		ans--;
	}
	return ans;
}

int check(int T, bool mode) {
	int ans = max(getv1(T), getv2(T));
	if (mode) {
		return ans / (T + 1);
	}
	if (!mode) {
		return ans;
	}
}

int get_ans(int l, int r, int i) {
	while (r - l > 1) {
		int m = (l + r) / 2;
		if (check(m, 1) >= i) {
			l = m;
		}
		else {
			r = m;
		}
	}
	return (l + 1) * i + l;
}

string get_s(int mask) {
	string s;
	for (int i = 0; i < n; i++) {
		if ((mask | (1 << i)) == mask) {
			s += g[i] + '0';
		}
	}
	return s;
}

bool correct(string s) {
	int ans = -1;
	int l = 0;
	for (int i = 0; i < sz(s); i++) {
		if (s[i] == '1') {
			if (ans == -1) {
				ans = i;
			}
			else {
				if (i - l - 1 != ans) return false; 
			}
			l = i;
		}
	}
	return sz(s) - l - 1 == ans;
}

signed main() {
	fast_io();
	cin >> n;
	int l = 0, r = 0;
	string g_s;
	cin >> g_s;
	for (int i = 0; i < n; i++) {
		g[i] = g_s[i] - '0';
		if (!g[i]) {
			r++;
		}
	}
	string ans = "";
	for (int mask = 0; mask < (1 << n); mask++) {
		string s = get_s(mask);
		if (s == "01010") {
			int kek = 228;
		}
		if (correct(s) & sz(s) > sz(ans)) {
			ans = s;
		}
	}
	cout << sz(ans) << '\n';
	cout << ans;
	//int ans = n - r, flags = n - r;
	//for (int i = 1; i < n - r; i++) {
	//	int cur = get_ans(l, r, i);
	//	if (cur >= ans) {
	//		ans = cur;
	//		flags = i;
	//	}
	//}
	//cout << ans << '\n';
	//int T = (ans - flags) / (flags + 1);
	//for (int i = 0; i < flags; i++) {
	//	for (int j = 0; j < T; j++) {
	//		cout << 0;
	//	}
	//	cout << 1;
	//}
	//for (int j = 0; j < T; j++) {
	//	cout << 0;
	//}
	return 0;
}