#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <bitset>
#include <queue>
#include <algorithm>
#include <cmath>
#include <ctime>
#include <cstring>

using namespace std;

#define int long long
#define sz(a) (int)(a.size())
#define pb emplace_back

void fast_io() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
}

const int MAXN = 50;
const int MAXM = 100 + 3;
pair<int, int> sl[MAXN];
vector<int> groups[MAXM];
int m, n, k;

int check(int x) {
	int cur_p = 0;
	for (int j = 0; j < m; j++) {
		double cur_sl = 0;
		int l = sl[0].first, r = sl[0].second;
		for (int it = 0; it < 2 * n; it++) {
			if (cur_sl == x) {
				l = sl[1].first, r = sl[1].second;
			}
			cur_p += (l <= groups[j][it] && groups[j][it] <= r ? 0 :
				min(abs(groups[j][it] - l), abs(groups[j][it] - r)));
			cur_sl += 0.5;
		}
	}
	return cur_p;
}

signed main() {
	fast_io();
	cin >> m >> n >> k;
	fill(groups, groups + m, vector<int>(2 * n));
	for (int i = 0; i < k; i++) {
		int l, r;
		cin >> l >> r;
		sl[i] = { l, r };
	}
	sort(sl, sl + k);
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < 2 * n; j++) {
			cin >> groups[i][j];
		}
		sort(groups[i].begin(), groups[i].end());
	}
	int ans = 0;
	for (int i = 0; i < 2 * n; i += 2) {
		int l_i = groups[0][i], r_i = groups[0][i + 1];
		int cur_ans = 1e18;
		for (int j = 0; j < k; j++) {
			int l = sl[j].first, r = sl[j].second;
			cur_ans = min(cur_ans, (l <= l_i && l_i <= r ? 0 :	min(abs(l_i - l), abs(l_i - r))) +
				(l <= r_i && r_i <= r ? 0 : min(abs(r_i - l), abs(r_i - r))));
		}
		ans += cur_ans;
	}
	cout << ans;
	return 0;
}