#include <bits/stdc++.h>

using namespace std;

long long x = 257;
long long p = 1e9 + 7;
vector<long long> hs;
vector<long long> xp;

void build_hs(string &s){
    int n = s.size();
    hs.resize(n + 1);
    xp.resize(n + 1);
    hs[0] = 0;
    xp[0] = 1;
    for (int i = 0; i < n; i++){
        hs[i + 1] = (hs[i] * x + s[i]) % p;
        xp[i + 1] = xp[i] * x % p;
    }
}

long long get_hash(int a, int b){
    return ((hs[b] - hs[a] * xp[b - a]) % p + p) % p;
}

long long get_hash_t(string &s){
    long long curr = 0;
    for (char el : s)
        curr = (curr * x + el) % p;
    return curr;
}

int ans(string &s, string &t){
    build_hs(s);
    long long h = get_hash_t(t);
    int n = s.size(), m = t.size();
    int ans = 0;
    for (int i = 0; i + m <= n; i++){
        if (get_hash(i, i + m) == h)
            ans++;
    }
    return ans;
}

int main(){
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    //freopen("in.txt", "r", stdin);
    int m, n;
    cin >> m >> n;
    string s, curr;
    cin >> s;
    int action, pos, len;
    string temp;
    for (int i = 0; i < n; i++){
        cin >> action;
        if (action == 1){
            cin >> temp;
            curr += temp;
        }
        else{
            cin >> pos >> len;
            for (int indx = pos - 1, cnt = 0; cnt < len; indx++, cnt++)
                curr += curr[indx];
        }
    }
    //cout << curr << "\n" << s;
    cout << ans(curr, s);
    return 0;
}