#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

//#define DEBUG

using namespace std;

typedef int64_t ll;

const ll INF = 1e18;

ll f(ll x, ll l, ll r) {
	if (l <= x && x <= r) return 0;
	if (x < l) return l - x;
	return x - r;
}

ll my_pow(int x, int p) {
	if (p == 0) return 1;
	auto tmp = my_pow(x, p / 2);
	if (p % 2) return tmp * tmp * x;
	return tmp * tmp;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll n, m, k;
	cin >> m >> n >> k;
	vector <pair <ll, ll>> type(k);
	for (int i = 0; i < k; i++) {
		cin >> type[i].first >> type[i].second;
	}
	vector <vector <ll>> h(m, vector <ll>(2 * n));
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < n; j++) {
			cin >> h[i][2 * j] >> h[i][2 * j + 1];
		}
	}
	if (k == 2) {
		vector <vector <pair <ll, ll>>> dif(m);
		for (int i = 0; i < m; i++) {
			for (int j = 0; j < 2 * n; j++) {
				dif[i].emplace_back(f(h[i][j], type[0].first, type[0].second) - f(h[i][j], type[1].first, type[1].second), h[i][j]);
			}
			sort(dif[i].begin(), dif[i].end());
		}
		ll ans = INF;
		for (int cnt = 0; cnt <= n; cnt++) {
			ll sum = 0;
			for (int i = 0; i < m; i++) {
				for (int j = 0; j < 2 * cnt; j++) {
					sum += f(dif[i][j].second, type[0].first, type[0].second);
				}
				for (int j = 2 * cnt; j < 2 * n; j++) {
					sum += f(dif[i][j].second, type[1].first, type[1].second);
				}
			}
			ans = min(sum, ans);
		}
		cout << ans;
		return 0;
	}
	auto init = vector <vector <vector <ll>>>(n + 1, vector <vector <ll>>(n + 1, vector <ll>(n + 1, INF)));
	vector <vector <vector <vector <ll>>>> cost(m, init);
	for (int i = 0; i < m; i++) {
		int tmp = pow(3, 2 * n);
		for (int mask = 0; mask < tmp; mask++) {
			vector <int> cnt(3);
			int tmp = mask, ind = 0;
			ll sum = 0;
			while (ind < 2 * n) {
				cnt[tmp % 3]++;
				sum += f(h[i][ind], type[tmp % 3].first, type[tmp % 3].second);
				tmp /= 3;
				ind++;
			}
			if (cnt[0] % 2 == 0 && cnt[1] % 2 == 0 && cnt[2] % 2 == 0) {
				cost[i][cnt[0] / 2][cnt[1] / 2][cnt[2] / 2] = min(cost[i][cnt[0] / 2][cnt[1] / 2][cnt[2] / 2], sum);
			}
		}
	}
	ll ans = INF;
	for (int i = 0; i <= n; i++) {
		for (int j = 0; j + i <= n; j++) {
			int  c = n - i - j;
			ll sum = 0;
			for (int tmp = 0; tmp < m; tmp++) {
				sum += cost[tmp][i][j][c];
			}
			ans = min(ans, sum);
		}
	}
	cout << ans;
#ifdef DEBUG
	system("Pause");
#endif // DEBUG
}