#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

//#define DEBUG

using namespace std;

int get_max(int x, int y, vector <vector <int>> &g, vector <vector <int>> &trap) {
	if (trap[x][y]) return g[x][y];
	int d = (x == g.size() - 1 ? 0 : g[x + 1][y]);
	int r = (y == g[0].size() - 1 ? 0 : g[x][y + 1]);
	return max(r, d);
}

int get_min(int x, int y, vector <vector <int>> &g, vector <vector <int>> &trap) {
	int d = (x == g.size() - 1 ? 0 : get_max(x + 1, y, g, trap));
	int r = (y == g[0].size() - 1 ? 0 : get_max(x, y + 1, g, trap));
	return min(r, d);
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, m, k;
	cin >> n >> m >> k;
	vector <vector <int>> a(n, vector <int>(m));
	vector <vector <int>> trap(n, vector <int>(m, 0));
	for (int i = 0; i < k; i++) {
		int x, y, v;
		cin >> x >> y >> v;
		x--, y--;
		a[x][y] = v;
		trap[x][y] = 1;
	}
	vector <vector <int>> g = a;
	for (int i = n - 1; i > -1; i--) {
		for (int j = m - 1; j > -1; j--) {
			if (g[i][j]) continue;
			g[i][j] = get_min(i, j, g, trap);
		}
	}
	long long sum = 0;
	const long long Q = 998244353;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			sum += g[i][j];
			sum %= Q;
		}
	}
	sum = (sum + Q) % Q;
	cout << sum;
#ifdef DEBUG
	system("Pause");
#endif // DEBUG
}