#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

//#define DEBUG

using namespace std;

typedef int64_t ll;

ll get_max(ll x, ll y, vector <vector <ll>> &g, vector <vector <ll>> &trap) {
	if (trap[x][y]) return g[x][y];
	ll d = (x == g.size() - 1 ? 0 : g[x + 1][y]);
	ll r = (y == g[0].size() - 1 ? 0 : g[x][y + 1]);
	return max(r, d);
}

ll get_min(ll x, ll y, vector <vector <ll>> &g, vector <vector <ll>> &trap) {
	if (trap[x][y]) return g[x][y];
	ll d = (x == g.size() - 1 ? 0 : get_max(x + 1, y, g, trap));
	ll r = (y == g[0].size() - 1 ? 0 : get_max(x, y + 1, g, trap));
	return min(r, d);
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, m, k;
	cin >> n >> m >> k;
	vector <vector<ll>> tmp;
	vector <ll> all_y;
	for (int i = 0; i < k; i++) {
		int x, y, v;
		cin >> x >> y >> v;
		vector <ll> t = { x - 1, y - 1, v };
		tmp.emplace_back(t);
		for (int j = max(0, y - n - 2); j < y; j++) {
			all_y.emplace_back(j);
		}
	}
	sort(all_y.begin(), all_y.end());
	all_y.resize(unique(all_y.begin(), all_y.end()) - all_y.begin());
	vector <vector <ll>> a(n, vector <ll>(all_y.size()));
	vector <vector <ll>> trap(n, vector <ll>(all_y.size(), 0));
	for (ll i = 0; i < k; i++) {
		int tmp_y = lower_bound(all_y.begin(), all_y.end(), tmp[i][1]) - all_y.begin();
		a[tmp[i][0]][tmp_y] = tmp[i][2];
		trap[tmp[i][0]][tmp_y] = 1;
	}
	vector <vector <ll>> g = a;
	m = all_y.size();
	for (ll i = n - 1; i > -1; i--) {
		for (ll j = m - 1; j > -1; j--) {
			g[i][j] = get_min(i, j, g, trap);
		}
	}
	long long sum = 0;
	const long long Q = 998244353;
	for (ll i = 0; i < n; i++) {
		for (ll j = 0; j < m; j++) {
			g[i][j] %= Q;
			sum += Q + g[i][j];
			sum %= Q;
		}
	}
	cout << sum;
#ifdef DEBUG
	system("Pause");
#endif // DEBUG
}