#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

//#define DEBUG

using namespace std;

typedef int64_t ll;

ll get_max(ll x, ll y, vector <vector <ll>> &g, vector <vector <ll>> &trap) {
	if (trap[x][y]) return g[x][y];
	ll d = (x == g.size() - 1 ? 0 : g[x + 1][y]);
	ll r = (y == g[0].size() - 1 ? 0 : g[x][y + 1]);
	return max(r, d);
}

ll get_min(ll x, ll y, vector <vector <ll>> &g, vector <vector <ll>> &trap) {
	if (trap[x][y]) return g[x][y];
	ll d = (x == g.size() - 1 ? 0 : get_max(x + 1, y, g, trap));
	ll r = (y == g[0].size() - 1 ? 0 : get_max(x, y + 1, g, trap));
	return min(r, d);
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll n, m, k;
	cin >> n >> m >> k;
	vector <vector <ll>> a(n, vector <ll>(m));
	vector <vector <ll>> trap(n, vector <ll>(m, 0));
	for (ll i = 0; i < k; i++) {
		ll x, y, v;
		cin >> x >> y >> v;
		x--, y--;
		a[x][y] = v;
		trap[x][y] = 1;
	}
	vector <vector <ll>> g = a;
	for (ll i = n - 1; i > -1; i--) {
		for (ll j = m - 1; j > -1; j--) {
			g[i][j] = get_min(i, j, g, trap);
		}
	}
	long long sum = 0;
	const long long Q = 998244353;
	for (ll i = 0; i < n; i++) {
		for (ll j = 0; j < m; j++) {
			g[i][j] %= Q;
			sum += Q + g[i][j];
			sum %= Q;
		}
	}
	cout << sum;
#ifdef DEBUG
	system("Pause");
#endif // DEBUG
}