#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

//#define DEBUG

typedef int64_t ll;

using namespace std;

struct my_str {
	vector <ll> pows_p, hash;
	ll p, Q, n;
	my_str(string tmp = "a") : n(tmp.size()), p(239), Q(1e9 + 21) {
		if (n > 0) {
			pows_p.resize(n);
			hash.resize(n);
			pows_p[0] = 1;
			for (int i = 1; i < n; i++) {
				pows_p[i] = pows_p[i - 1] * p % Q;
			}
			hash[0] = tmp[0];
			for (int i = 1; i < n; i++) {
				hash[i] = (hash[i - 1] * p + tmp[i]) % Q;
			}
		}
	}
	ll get_hash(int beg, int len) {
		ll ans =  hash[beg + len - 1] - (beg == 0 ? 0 : hash[beg - 1] * pows_p[len] % Q);
		if (ans < 0) ans += Q;
		return ans;
	}
	ll get_hash(string &tmp) {
		ll ans = 0;
		for (int i = 0; i < tmp.size(); i++) {
			ans = (ans * p + tmp[i]) % Q;
		}
		return ans;
	}
};

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, m;
	cin >> m >> n;
	string a;
	cin >> a;
	string tmp;
	for (int i = 0; i < n; i++) {
		int type;
		cin >> type;
		if (type == 1) {
			string str;
			cin >> str;
			tmp += str;
		}
		else {
			int b, len;
			cin >> b >> len;
			b--;
			for (int j = 0; j < len; j++) {
				tmp += tmp[b + j];
			}
		}
	}
	my_str s(tmp);
	ll hash_str = s.get_hash(a);
	int ans = 0;
	for (int i = 0; i + m <= s.n; i++) {
		if (hash_str == s.get_hash(i, m)) {
			ans++;
		}
	}
	cout << ans;
#ifdef DEBUG
	system("Pause");
#endif // DEBUG
}