#pragma GCC optimaze ("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4")

#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>

using namespace std;
typedef long long ll;

const ll INF = 1e18;
const ll mod = 998244353;

bool comp56(pair<pair<ll, ll>, ll> a, pair<pair<ll, ll>, ll > b) {
	return a.first.second - a.first.first < b.first.second - b.first.first;
}

int main() {
	ios_base::sync_with_stdio(false);
	ll n, m, k;
	ll ans = 0;
	cin >> n >> m >> k;

	if (n * m <= 1000000) {
		vector<vector<ll> > dp1(n + 1, vector<ll>(m + 1)), dp2, cd(n + 1, vector<ll>(m + 1, -INF));
		dp2 = dp1;
		for (int i = 0, x, y, z; i < k; ++i) {
			cin >> x >> y >> z;
			--x, --y;
			cd[x][y] = z;
		}
		for (int s = (n + m - 2); s >= 0; --s) {
			for (int i = 0; i < n; ++i) {
				int j = s - i;
				if (j >= m)
					continue;
				if (j < 0)
					break;
				if (cd[i][j] == -INF) {
					dp1[i][j] = min(dp2[i + 1][j], dp2[i][j + 1]);
					dp2[i][j] = max(dp1[i + 1][j], dp1[i][j + 1]);
				}
				else {
					dp1[i][j] = dp2[i][j] = cd[i][j];
				}
				ans = ((ans + dp1[i][j]) % mod + mod) % mod;
			}
		}
		cout << ans;
	}


	bool fl56 = true;
	vector<pair<pair<ll, ll>, ll> > cd(k);
	for (int i = 0; i < k; ++i) {
		cin >> cd[i].first.first >> cd[i].first.second >> cd[i].second;
		--cd[i].first.first, --cd[i].first.second;
		fl56 &= cd[i].second == 1;
	}

	map<ll, ll> cp;
	if (fl56) {
		sort(cd.begin(), cd.end(), comp56);

		ll di, dj;
		for (int i = 0; i < k; ++i) {
			ll xi = cd[i].first.first, yi = cd[i].first.second, xj, yj;
			di = yi - xi;
			cp[xi + yi] = max(cp[xi + yi], min(xi, yi) + ll(1));
			for (int j = i + 1; j < k; ++j) {
				xj = cd[j].first.first, yj = cd[j].first.second;
				dj = yj - xj;
				if (di + 4 < dj)
					break;
				if (di + 2 == dj && abs(xi - xj) == 1 && abs(yi - yj) == 1) {
					cp[xi + yi - 1] = max(cp[xi + yi - 1], min(xi - 1, yi) + ll(1));
				}
				if (di + 4 == dj) {
					cp[xi + yi - 2] = max(cp[xi + yi - 2], min(min(xi - 2, yi), min(xj, yj - 2)) + 1);
				}
				if (di + 3 == dj) {
					if (xi + yi < xj + yj) {
						cp[xi + yi - 1] = max(cp[xi + yi - 1], min(xi - 1, yi) + ll(1));
					}
					else {
						cp[xj + yj - 1] = max(cp[xj + yj - 1], min(xj, yj - 1) + ll(1));
					}
				}
			}
		}
		for (auto to : cp) {
			ans = (ans + to.second) % mod;
		}
		cout << ans;
	}

	return 0;
}


/*
3 3 3
2 3 -2
3 1 3
1 2 1

2 4 3
1 2 2
2 4 -3
2 1 1
*/