#include <iostream>
#include <vector>
#include <set>
#include <map>

using namespace std;

#define vi vector<int>
#define pb push_back
#define printvi(arr) for(int x: arr) cout << x << " "; cout << endl;
#define pii pair<int, int>
#define F first
#define S second
#define vpii vector<pii>

void init() {
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
}

bool check(vi &a, int x, int k){
    int cnt = 0;
    int sum = 0;
    for (int i = 0; i < a.size(); ++i){
        sum += a[i];
        if (sum >= x){
            sum = 0;
            cnt++;
        }
    }
    return (cnt >= k);
}

int ans = 0;
int opt = 0;

map<int, pii> mem;

pii fun(vi &a, int i){
    if (mem.find(i) != mem.end())
        return mem[i];
    int j = i + 1;
    int l = 0, r = 100005;
    while (l != r){
        int md = (l + r + 1) / 2;
        if (check(a, md, j)) l = md; else r = md - 1;
    }
    int x = j * l + i;
    mem.insert({i, {x, l}});
    return {x, l};
}

int main() {
    init();
    int n;
    string str;
    cin >> n >> str;
    int m = 0;
    set<int> idx1;
    for (int i = 0; i < n; ++i){
        if (str[i] == '1'){
            m++;
            idx1.insert(i);
        }
    }
    vpii a0;
    for (int i: idx1){
        a0.pb({0, 0});
        int j1 = i, j2 = i;
        while (j1 > 0){
            j1--;
            if (str[j1] == '1') break;
        }
        if (str[j1] == '1') j1++;
        a0.back().F = max(0, i - j1);
        while (j2 + 1 < n){
            j2++;
            if (str[j2] == '1') break;
        }
        if (str[j2] == '1') j2--;
        a0.back().S = max(0, j2 - i);
    }
    vi a;
    for (auto p: a0) a.pb(p.F);
    a.pb(a0.back().S);
    int l = 1, r = m;
    while (r - l > 1000){
        int x1 = (2 * l + r) / 3, x2 = (l + 2 * r) / 3;
        pii p1 = fun(a, x1), p2 = fun(a, x2);
        if (p1.F == p2.F){
            l = x1, r = x2;
        }
        if (p1.F > p2.F) r = x2; else l = x1;
    }
    for (int i = l; i <= r; ++i){
        pii p = fun(a, i);
        if (p.F > ans){
            ans = p.F;
            opt = p.S;
        }
    }
    cout << ans << endl;
    string ANS = "";
    for (int i = 0; i < opt; ++i) ANS += "0";
    while (ANS.length() < ans){
        ANS += "1";
        for (int i = 0; i < opt; ++i) ANS += "0";
    }
    cout << ANS << endl;
    return 0;
}
