#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <random>


using namespace std;


mt19937 rgen(57);


vector<int> a;
vector<int> psum;


int f(int x) {
    if (x == 0) {
        return a.size() - 1;
    }

    int cnt = 0;
    int i = 0;
    while (i < a.size() && psum[a.size()] - psum[i] >= x) {
        int low = i - 1, high = a.size();
        while (high - low > 1) {
            int mid = (low + high + 1) >> 1;

            if (psum[mid] - psum[i] >= x) {
                high = mid;
            } else {
                low = mid;
            }
        }

        i = high;

        ++cnt;
    }

    if (cnt < 2) {
        return -1;
    }

    return cnt * x + cnt - 1;
}


string build(int x) {
    int cnt = 0;
    int left = x;
    for (int c : a) {
        if (c >= left) {
            left = x;
            ++cnt;
        } else {
            left -= c;
        }
    }

    string res;
    for (int i = 0; i < cnt - 1; ++i) {
        for (int j = 0; j < x; ++j) {
            res += '0';
        }

        res += '1';
    }

    for (int j = 0; j < x; ++j) {
        res += '0';
    }

    return res;
}


const bool TEST = false;


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    string s;

    if (TEST) {
        for (int i = 0; i < n; ++i) {
            s += '0' + rgen() % 2;
        }

        cout << s << '\n';
    } else {
        cin >> s;
    }

    int cnt = 0;
    for (char c : s) {
        if (c == '0') {
            ++cnt;
        } else {
            a.push_back(cnt);
            cnt = 0;
        }
    }

    a.push_back(cnt);

    psum.resize(a.size() + 1);
    for (int i = 0; i < a.size(); ++i) {
        psum[i + 1] = psum[i] + a[i];
    }

    int answ = 0;
    int res = 0;
    for (int i = 0; i <= n / 2; ++i) {
        int cur = f(i);

        if (cur > res) {
            answ = i;
            res = cur;
        }
    }

    cout << res << '\n' << build(answ);

    return 0;
}


/*

10
0100100000

3
111

7
0100101

*/