#include <iostream>
#include <vector>
#include <algorithm>
#include <string>


using namespace std;


#define int long long


const int MAXN = (int)1e6 + 5;


const int M = (int)1e9 + 7;
const int P = 57;

int PPOW[MAXN];


int mod(int x) {
    x %= M;

    if (x < 0) {
        return x + M;
    }

    return x;
}


class HS {
    vector<int> ph;

public:
    HS(string s) {
        int n = s.length();

        ph.resize(n + 1);
        for (int i = 0; i < n; ++i) {
            ph[i + 1] = mod(ph[i] * P + s[i]);
        }
    }

    int get(int i, int j) {
        return mod(ph[j] - ph[i] * PPOW[j - i]);
    }
};


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    PPOW[0] = 1;
    for (int i = 1; i < MAXN; ++i) {
        PPOW[i] = mod(PPOW[i - 1] * P);
    }

    int n, m;
    cin >> n >> m;

    string p;
    cin >> p;

    string s;

    int t, pos, len;
    string w;

    for (int i = 0; i < m; ++i) {
        cin >> t;

        if (t == 1) {
            cin >> w;

            s += w;
        } else {
            cin >> pos >> len;

            --pos;

            for (int j = 0; j < len; ++j) {
                s += s[pos + j];
            }
        }
    }

    HS ph(p), sh(s);

    int tl = s.length();

    int answ = 0;
    for (int i = 0; i <= tl - n; ++i) {
        answ += (ph.get(0, n) == sh.get(i, i + n));
    }

    cout << answ;

    return 0;
}


/*

3 4
aba
1 ab
2 1 3
2 3 3
2 1 8

*/