#include <iostream>
#include <climits>

using namespace std;

typedef long long ll;

const ll MOD = 998244353;

const int MAX_N = 1002;
const int MAX_M = 1002;

int n, m;

const int NO_VALUE = INT_MIN;

int cache1[MAX_M][MAX_M];
int cache2[MAX_N][MAX_M];
int lw[MAX_N][MAX_M];

int dp1(int i, int j);

int dp2(int i, int j);

int dp1(int i, int j) {
    if (cache1[i][j] != NO_VALUE) {
        return cache1[i][j];
    }
    if (i == n || j == m) {
        return 0;
    }
    if (lw[i][j] != NO_VALUE) {
        return lw[i][j];
    }
    return cache1[i][j] = min(dp2(i + 1, j), dp2(i, j + 1));
}


int dp2(int i, int j) {
    if (cache2[i][j] != NO_VALUE) {
        return cache2[i][j];
    }
    if (i == n || j == m) {
        return 0;
    }
    if (lw[i][j] != NO_VALUE) {
        return lw[i][j];
    }
    return cache2[i][j] = max(dp1(i + 1, j), dp1(i, j + 1));
}


int main() {
#ifdef LOCAL
    freopen("C.in", "r", stdin);
#endif

    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;
    int k;
    cin >> k;
    for (int i = 0; i <= n; ++i) {
        fill(begin(cache1[i]), end(cache1[i]), NO_VALUE);
        fill(begin(cache2[i]), end(cache2[i]), NO_VALUE);
        fill(begin(lw[i]), end(lw[i]), NO_VALUE);
    }
    for (int l = 0; l < k; ++l) {
        int i, j, v;
        cin >> i >> j >> v;
        i--, j--;
        lw[i][j] = v;
    }

    ll sum = 0;

    /*for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << dp1(i,j) << ' ';
        }
        cout << endl;
    }*/

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            sum += dp1(i, j);
            sum %= MOD;
        }
    }
    cout << (sum + MOD) % MOD;

    return 0;
}