#include<set>
#include<vector>
#include<string>
#include<utility>
#include<iostream>
#include<algorithm>
#include<assert.h>
#include<unordered_map>
using namespace std;

unordered_map<int, pair<long long, long long>> f_t;

void f_t_upd(int p, int x)
{
	p = 1e9 - p;
	while (p <= 1e9)
	{
		f_t[p].first += x;
		f_t[p].second += 1;
		p |= (p + 1);
	}
}

pair<long long, long long> get_f_t(int p)
{
	p = 1e9 - p;
	pair<long long, long long> res;
	while (p >= 0)
	{
		res.first += f_t[p].first;
		res.second += f_t[p].second;
		p = (p & (p + 1)) - 1;
	}
	return res;
}

struct act
{
	long long t, p;
	long long q_r;
};

bool operator < (act a, act b)
{
	if (a.p != b.p) return a.p < b.p;
	return a.t < b.t;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	f_t.rehash(1e6);
	int m, n, k;
	cin >> m >> n >> k;
	vector<vector<long long>> h(m, vector<long long> (2 * n));
	vector<pair<long long, long long>> d(k);
	multiset<act> line;

	for (int i = 0; i < k; i++) cin >> d[i].first >> d[i].second;
	for (int i = 0; i < m; i++)
	{
		for (int j = 0; j < 2 * n; j++) cin >> h[i][j];
		sort(h[i].begin(), h[i].end());
	}

	for (int i = 0; i < k; i++) line.insert({ 0, d[i].first, d[i].second });

	long long ans = 0;
	for (int j = 1; j < 2 * n; j += 2)
	{
		long long cur_ans = 2e18;

		for (int i = 0; i < m; i++)
		{
			line.insert({ 1, h[i][j - 1] });
			f_t_upd(h[i][j - 1], h[i][j - 1]);
			line.insert({ 1, h[i][j] });
			f_t_upd(h[i][j], h[i][j]);
		}

		long long back_sum = 0, back_cnt = 0;

		for (auto i : line)
		{
			if (i.t == 1)
			{
				back_sum += i.p;
				++back_cnt;
			}
			else
			{
				long long x = i.p * back_cnt - back_sum;
				auto[sum, cnt] = get_f_t(i.q_r + 1);
				x += sum - i.q_r * cnt;
				cur_ans = min(cur_ans, x);
			}
		}

		for (int i = 0; i < m; i++)
		{
			line.erase(line.find({ 1, h[i][j - 1] }));
			line.erase(line.find({ 1, h[i][j] }));
		}

		ans += cur_ans;
		f_t.clear();
	}

	cout << ans;
}