#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <algorithm>
#include <queue>

using namespace std;

typedef long long ll;
typedef double dl;

vector<ll> cntl, cntr;
ll inf = 1e15;

bool comp(ll i1, ll i2)
{
	if (min(cntl[i1], cntr[i1]) != min(cntr[i2], cntr[i2]))
		return min(cntl[i1], cntr[i1]) > min(cntr[i2], cntr[i2]);

	return max(cntl[i1], cntr[i1]) < max(cntr[i2], cntr[i2]);
}

vector<ll>  getans(vector<ll> used, vector<ll> a)
{
	vector<ll> cur;
	ll cnt1 = 0;
	for (int i = 0; i < a.size(); ++i)
	{
		if (a[i] == 0)
			cur.push_back(0);
		else if (used[i])
		{
			cur.push_back(1);
			cnt1 += 1;
		}
	}

	if (cnt1 == 0)
	{
		return {};
	}

	cur.push_back(1);

	ll minn = inf;
	ll cnt = 0;

	for (int i = 0; i < cur.size(); ++i)
	{
		if (cur[i] == 0)
			cnt += 1;

		if (cur[i] == 1)
		{
			minn = min(minn, cnt);
			cnt = 0;
		}
	}

	vector<ll> ans;
	for (int i = 0; i < cnt1; ++i)
	{
		for (int j = 0; j < minn; ++j)
			ans.push_back(0);
		ans.push_back(1);
	}
	for (int j = 0; j < minn; ++j)
		ans.push_back(0);

	return ans;
}

int main()
{
	//freopen("input.txt", "r", stdin);

	ll n;

	cin >> n;

	string str;
	cin >> str;

	vector<ll> a(n);

	for (int i = 0; i < n; ++i)
		a[i] = str[i] - '0';//	cin >> a[i];


	vector<ll> pred1(n, inf), next1(n, inf);

	cntl.resize(n, 0);
	cntr.resize(n, 0);

	ll cnt = 0;

	ll pos = inf;
	for (int i = 0; i < n; ++i)
	{
		if (a[i] == 0)
			cnt += 1;

		if (a[i] == 1)
		{
			cntl[i] = cnt;
			cnt = 0;

			pred1[i] = pos;
			pos = i;
		}
	}

	cnt = 0;
	pos = inf;
	for (int i = n - 1; i >= 0; --i)
	{
		if (a[i] == 0)
			cnt += 1;

		if (a[i] == 1)
		{
			cntr[i] = cnt;
			cnt = 0;

			next1[i] = pos;
			pos = i;
		}
	}

	vector<ll> order;

	for (int i = 0; i < n; ++i)
	{
		if (a[i] == 1)
			order.push_back(i);
	}


	vector<ll> used(n, 0);

	for (ll in : order)
		used[in] = 1;

	sort(order.begin(), order.end(), comp);

	ll maxx = 0;
	vector<ll> ans;
	for (int i = order.size() - 1; i >= 0; --i)
	{
		vector<ll> cur = getans(used, a);
		if (cur.size() > ans.size())
			ans = cur;

		used[order[i]] = 0;
	}

	cout << ans.size() << endl;

	for (ll in : ans)
		cout << in;
	
	puts("");
	return 0;
}

