#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <iomanip>
#include <deque>
#include <cmath>
#include <climits>
#include <cstdio>
#include <string>
#include <random>
int m, n, k;
std::vector<std::pair<int64_t, int64_t>> kinds;
std::vector<std::vector<int64_t>> people;
int64_t totald(const std::vector<int64_t>& h, const std::vector<int64_t>& k, const std::vector<int64_t>& order)
{
	int64_t td = 0;
	for(int i = 0; i < n; i++)
	{
		td += (std::abs(h[2 * i] - kinds[k[order[i]]].first) + std::abs(h[2 * i] - kinds[k[order[i]]].second) - kinds[k[order[i]]].second + kinds[k[order[i]]].first) / 2;
		td += (std::abs(h[2*i+1] - kinds[k[order[i]]].first) + std::abs(h[2*i+1] - kinds[k[order[i]]].second) - kinds[k[order[i]]].second + kinds[k[order[i]]].first) / 2;
	}
	return td;
}
int64_t bestd(const std::vector<int64_t>& h, const std::vector<int64_t>& k, std::vector<int64_t>& order)
{
	int64_t min = LLONG_MAX;
	do min = std::min(min, totald(h, k, order));
	while(std::next_permutation(order.begin(),order.end()));
	return min;
}
int64_t bdall(const std::vector<int64_t>& k)
{
	int64_t sum = 0;
	std::vector<int64_t> order (2 * n); for(int i = 0; i < 2 * n; i++) order[i] = i / 2;
	for(int i = 0; i < m; i++) sum += bestd(people[i], k, order);
	return sum;
}
std::vector<std::vector<int64_t>> vecs(int n, int max)
{
	if(n == 1)
	{
		std::vector<std::vector<int64_t>> ans(max, std::vector<int64_t>(1));
		for(int i = 0; i < n; i++) ans[i][0] = i;
		return ans;
	}
	std::vector<std::vector<int64_t>> prev = vecs(n - 1, max);
	std::vector<std::vector<int64_t>> next;
	for(auto vec : prev)
	{
		for(int i = 0; i < max; i++)
		{
			std::vector<int64_t> nw = vec;
			nw.push_back(i);
			next.push_back(nw);
		}
	}
	return next;
}
int main()
{
	std::cin >> m >> n >> k;
	kinds.resize(k);
	people.resize(m, std::vector<int64_t>(2 * n));
	for(int i = 0; i < k; i++) std::cin >> kinds[i].first >> kinds[i].second;
	for(int i = 0; i < m; i++)
		for(int j = 0; j < 2 * n; j++)
			std::cin >> people[i][j];

	int64_t min = LLONG_MAX;
	for(auto vec : vecs(n, k))
	{
		//if(std::is_sorted(vec.begin(), vec.end()))
		//{
		//std::vector<int> colors(k); std::iota(colors.begin(),colors.end(), 0);
		//do
		//{
		std::vector<int64_t> v2 = vec;
		//for(int i = 0; i < v2.size(); i++) v2[i] = colors[v2[i]];
		printf("trying:");
		for(int i : v2) printf(" %lld", v2[i]);
		printf("\n");
		min = std::min(min, bdall(v2));
		//}while(std::next_permutation(colors.begin(),colors.end()));
		//}
	}
	std::cout << min;
	return 0;
}
