#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <iomanip>
#include <numeric>
#include <queue>
#include <deque>
#include <string>
#include <algorithm>
#include <cstring>
#include <cassert>
#include <random>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream& out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(T &x, ostream &out = cerr) {
	output(all(x), out);
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const ll INF = 1e18;

struct segment {
	int l, r;
	segment(): l(0), r(0) {}
	segment(int _l, int _r): l(_l), r(_r) {}
};

bool operator < (segment a, segment b) {
	return a.l < b.l;
}

ll dist(int x, segment &s) {
	if (x >= s.l && x <= s.r) {
		return 0;
	}
	else {
		return min(abs(s.l - x), abs(s.r - x));
	}
}

int n, m, k;
vector<segment> s0, s;
vector<vector<int> > guys, a;

void read_s0() {
	s0.resize(k);
	for (int i = 0; i < k; ++i) {
		cin >> s0[i].l >> s0[i].r;
	}
}

void remove_nested() {
	sort(all(s0));
	int r = 0;
	for (int i = 0; i < k; ++i) {
		if (s0[i].r > r) {
			s.push_back(s0[i]);
			r = s0[i].r;
		}
	}
	k = s.size();
}

void read_guys() {
	guys.resize(m, vector<int> (2 * n));
	for (int i = 0; i < m; ++i) {
		for (int j = 0; j < 2 * n; ++j) {
			cin >> guys[i][j];
		}
	}
}

void make_a() {
	for (int i = 0; i < m; ++i) {
		sort(all(guys[i]));
	}
	a.resize(n);
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			a[i].push_back(guys[j][2 * i]);
			a[i].push_back(guys[j][2 * i + 1]);
		}
		sort(all(a[i]));
	}
}

ll ans;

ll distance(int pack_id, int seg_id) {
	ll res = 0;
	for (auto val : a[pack_id]) {
		res += dist(val, s[seg_id]);
	}
	return res;
}

void nmk_solution() {
	for (int i = 0; i < n; ++i) {
		ll best = INF;
		for (int x = 0; x < k; ++x) {
			ll cur = distance(i, x);
			chkmin(best, cur);
		}
		ans += best;
	}
}

void mk_solution() {
	int ptr = 0;
	for (int i = 0; i < n; ++i) {
		ll best = distance(i, ptr);
		while (ptr < k - 1) {
			ll new_best = distance(i, ptr + 1);
			if (chkmin(best, new_best)) {
				ptr++;
			}
			else {
				break;
			}
		}
		ans += best;
	}
}

int main() {
	fast_io();
	cin >> m >> n >> k;
	read_s0();
	remove_nested();
	read_guys();
	make_a();
	mk_solution();
	cout << ans << endl;
}
