#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <iomanip>
#include <numeric>
#include <queue>
#include <deque>
#include <string>
#include <algorithm>
#include <cstring>
#include <cassert>
#include <random>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream& out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(T &x, ostream &out = cerr) {
	output(all(x), out);
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

vector<int> prefix_function(string s) {
	vector<int> p(s.size());
	for (int i = 1; i < s.size(); ++i) {
		p[i] = p[i - 1];
		while (p[i] && s[p[i]] != s[i]) {
			p[i] = p[p[i] - 1];
		}
		if (s[p[i]] == s[i]) {
			p[i]++;
		}
	}
	return p;
}

vector<int> z_function(string s) {
	vector<int> z(s.size());
	int l = 0, r = 0;
	for (int i = 1; i < s.size(); ++i) {
		if (i <= r) {
			z[i] = min(r - i + 1, z[i - l]);
		}
		while (i + z[i] < s.size() && s[i + z[i]] == s[z[i]]) {
			z[i]++;
		}
		if (i + z[i] - 1 > r) {
			l = i;
			r = i + z[i] - 1;
		}
	}
	return z;
}

int n, m;
string t;
vector<pair<char, ll> > s;

int main() {
	fast_io();
	cin >> m >> n;
	cin >> t;
	ll L;
	for (int i = 0; i < n; ++i) {
		int type;
		cin >> type;
		if (type == 1) {
			string w;
			cin >> w;
			vector<pair<char, ll> > _s;
			int cnt = 0;
			for (int j = 0; j < w.size(); ++j) {
				cnt++;
				if (j == (int)w.size() - 1 || w[j] != w[j + 1]) {
					_s.push_back({w[j], cnt});
					cnt = 0;
				}
			}
			if (!s.empty() && s.back().first == _s[0].first) {
				s.back().second += _s[0].second;
			}
			else {
				s.push_back(_s[0]);
			}
			for (int j = 1; j < _s.size(); ++j) {
				s.push_back(_s[j]);
			}
			L += (ll)w.size();
		}
		if (type == 2) {
			ll pos;
			ll len;
			cin >> pos >> len;
			assert(pos == L);
			s.back().second += len;
			L += len;
		}
	}
	int ne = 0;
	for (int i = 1; i < t.size(); ++i) {
		if (t[i] != t[i - 1]) {
			ne = 1;
			break;
		}
	}
	if (!ne) {
		ll ans = 0;
		for (int i = 0; i < s.size(); ++i) {
			if (s[i].first == t[0]) {
				ans += max(s[i].second - (ll)t.size() + (ll)1, (ll)0);
			}
		}
		cout << ans << endl;
	}
	else {
		string str;
		for (auto pp : s) {
			for (int i = 0; i < min(pp.second, (ll)t.size() + 1); ++i) {
				str.push_back(pp.first);
			}
		}
		string S = t + "#" + str;
		vector<int> p = prefix_function(S);
		int ans = 0;
		for (int i = t.size() + 1; i < S.size(); ++i) {
			if (p[i] == t.size()) {
				ans++;
			}
		}
		cout << ans << endl;
	}
}
