#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <iomanip>
#include <numeric>
#include <queue>
#include <deque>
#include <string>
#include <algorithm>
#include <cstring>
#include <cassert>
#include <random>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream& out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(T &x, ostream &out = cerr) {
	output(all(x), out);
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

int n, m;
string t;


ll how_many_t(string s) {
	ll res = 0;
	for (int i = 0; i <= (int)s.size() - m; ++i) {
		if (s.substr(i, t.size()) == t) {
			res++;
		}
	}
	return res;
}


string get_begin(string s) {
	if (m == 1) {
		return "";
	}
	return (s.size() > m - 1 ? s.substr(0, m - 1) : s);
}


string get_end(string s) {
	if (m == 1) {
		return "";
	}
	return (s.size() > m - 1 ? s.substr((int)s.size() - m + 1, m - 1) : s);
}


struct block {
	ll len;
	ll cnt;
	string begin, end;

	block(string s) {
		len = s.size();
		begin = get_begin(s);
		end = get_end(s);
		cnt = how_many_t(s);
	}

	block() {}
};


block merge(block a, block b) {
	block res;
	res.len = a.len + b.len;
	res.begin = get_begin(a.begin + b.begin);
	res.end = get_end(a.end + b.end);
	res.cnt = a.cnt + b.cnt + how_many_t(a.end + b.begin);
}


const pair<ll, ll> NEUTRAL = {-1, -1};
vector<ll> start_pos;
vector<block> bl;
vector<pair<ll, ll> > seg;
vector<string> str;


block get_block(ll l, ll r, int q_id) {
	if (seg[q_id] == NEUTRAL) {
		string cur_str = str[q_id].substr(l - start_pos[q_id], r - l + 1)
		return block(cur_str);
	}
	l = (l - start_pos[q_id]) + seg[q_id].l;
	r = (r - start_pos[q_id]) + seg[q_id].l;
	int block_l = upper_bound(all(start_pos), l) - start_pos.begin() - 1;
	int block_r = upper_bound(all(start_pos), r) - start_pos.begin() - 1;
	if (block_l == block_r) {
		return get_block(l, r, block_l);
	}
	else {
		block res = get_block(l, start_pos[block_l + 1] - 1, block_l);
		for (int i = block_l + 1; i < block_r; ++i) {
			res = merge(res, bl[i]);
		}
		block R = get_block(start_pos[block_r], r, block_r);
		res = merge(res, R);
		return res;
	}
}

int main() {
	fast_io();
	cin >> m >> n;
	cin >> t;
	ll sp = 0;
	for (int i = 0; i < n; ++i) {
		start_pos.push_back(sp);
		int type;
		cin >> type;
		if (type == 1) {
			string w;
			cin >> w;
			str.push_back(w);
			seg.push_back(NEUTRAL);
			sp += (ll)w.size();
		}
		else {
			ll l, len, r;
			cin >> l >> len;
			l--;
			r = l + len - 1;
			str.push_back("");
			seg.push_back({l, r});
			sp += len;
		}
		block new_block = get_block(start_pos.back(), sp - 1, i);
	}
	block super = bl[0];
	for (int i = 1; i < n; ++i) {
		super = merge(super, bl[i]);
	}
	ll ans = super.cnt;
	cout << ans << endl;
}
