#include <bits/stdc++.h>

using namespace std;

#define __LOCAL

#ifdef __LOCAL
#define DBG(X) cout << #X << "=" << (X) << endl;
#else
#define DBG(X) 42;
#endif

using ll = long long int;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

const ll BEGIN = 1;
const ll POINT = 0;
const ll END = -1;

const ll LL_INF = (ll)2e18;

struct event
{
	ll x, type;

	event(ll _x, ll _type): x(_x), type(_type)
	{
	}

	bool operator<(const event& other) const
	{
		if(x != other.x)
			return x < other.x;

		return type < other.type;
	}
};

void fastio()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}

int n, m, k;
ll answ = 0;
vector<pll> seats;

ll dist(ll L, ll R, ll x)
{
	if(R < L)
		swap(L, R);

	if(L <= x && x <= R)
		return 0;

	return min(abs(x - L), abs(x - R));
}

void subsolve()
{
	vector<ll> pts(2 * n);

	for(auto& el: pts)
		cin >> el;

	sort(pts.begin(), pts.end());
	
	for(int i = 0; i < n; ++i)
	{
		ll x = pts[2 * i], y = pts[2 * i + 1];

		ll loc = LL_INF;

		for(auto seats: seats)
		{
			ll c1 = dist(seats.first, seats.second, x);
			ll c2 = dist(seats.first, seats.second, y);

			loc = min(loc, c1 + c2);
		}

		answ += loc;
	}
}

void solve()
{
	cin >> m >> n >> k;

	seats.resize(k);

	for(auto& el: seats)
		cin >> el.first >> el.second;

	for(int i = 0; i < m; ++i)
		subsolve();

	cout << answ << endl;
}

int main()
{
	fastio();
	solve();

	return 0;
}