#include <bits/stdc++.h>

using namespace std;

#define __LOCAL

#ifdef __LOCAL
#define DBG(X) cout << #X << "=" << (X) << endl;
#else
#define DBG(X) 42;
#endif

using ll = long long int;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

const ll BEGIN = 1;
const ll POINT = 0;
const ll END = -1;

const ll LL_INF = (ll)2e18;

struct event
{
	ll x, type;

	event(ll _x, ll _type): x(_x), type(_type)
	{
	}

	bool operator<(const event& other) const
	{
		if(x != other.x)
			return x < other.x;

		return type < other.type;
	}
};

void fastio()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}

const int MAX_M = (int)2e5 + 77;

int n, m, k;
ll answ = 0;
vector<pll> seats;
vector<ll> group[MAX_M];

ll dist(ll L, ll R, ll x)
{
	if(R < L)
		swap(L, R);

	if(L <= x && x <= R)
		return 0;

	return min(abs(x - L), abs(x - R));
}

void solve()
{
	cin >> m >> n >> k;
	
	seats.resize(k);

	for(auto& el: seats)
		cin >> el.first >> el.second;

	sort(seats.begin(), seats.end());

	for(int i = 0; i < m; ++i)
	{
		group[i].resize(2 * n);

		for(auto& el: group[i])
			cin >> el;

		sort(group[i].begin(), group[i].end());
	}

	int bests = 0;

	for(int pos = 0; pos < n; ++pos)
	{
		ll loc = LL_INF;

		for(int s = bests; s < k; ++s)
		{
			auto seat = seats[s];
			ll sm = 0;

			for(int i = 0; i < m; ++i)
			{
				sm += dist(seat.first, seat.second, group[i][2 * pos]);
				sm += dist(seat.first, seat.second, group[i][2 * pos + 1]);
			}

			if(sm < loc)
				bests = s;
			else
				break;

			loc = min(loc, sm);
		}

		answ += loc;
	}

	cout << answ << endl;
}

int main()
{
	fastio();
	solve();

	return 0;
}