#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#define int long long
using namespace std;

int m, n, k;
int L[500000], R[500000];
vector<int> sc[500000];
vector<int> f;
long long result;

inline long long abs(long long c)
{
    if (c > 0) return c; return -c;
}

inline long long abs2(long long i, long long j, int g)
{
    long long r = 0;
        if (L[j] <= sc[g][2 * i] && sc[g][2 * i] <= R[j])
            r += 0;
        else
            r += min(abs(L[j] - sc[g][2 * i]), abs(R[j] - sc[g][2 * i]));
        if (L[j] <= sc[g][2 * i + 1] && sc[g][2 * i + 1] <= R[j])
            r += 0;
        else
            r += min(abs(L[j] - sc[g][2 * i + 1]), abs(R[j] - sc[g][2 * i + 1]));
    return r;
}

inline long long abs3(int i, int j)
{
    long long res = 0;
    for (int g = 0; g < m; g++)
    {
        res += abs2(i, j, g);
    }
    return res;
}

void relax(vector<int> scolars, long long id)
{
    long long summ = 0;
    for (int i = 0; i < scolars.size(); i++)
    {
        summ += abs(scolars[i] - L[id]);
    }
    result = min(result, summ);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> m >> n >> k;
    for (int i = 0; i < k; i++)
    {
        cin >> L[i] >> R[i];
    }
    vector<pair<int, int> > p;
    for (int i = 0; i < k; i++)
        p.push_back({L[i], R[i]});
    sort(p.begin(), p.end());
    for (int i = 0; i < k; i++)
    {
        L[i] = p[i].first;
        R[i] = p[i].second;
    }
    for (int i = 0; i < m; i++)
    {
        for (int j = 0; j < 2 * n; j++)
        {
            int h;
            cin >> h;
            sc[i].push_back(h);
        }
        sort(sc[i].begin(), sc[i].end());
    }
    long long ans = 0;
    vector<int> new_groups[201000];
    for (int i = 0; i < n; i++)
    {
        for (int g = 0; g < m; g++)
        {
            new_groups[i].push_back(sc[g][2 * i]);
            new_groups[i].push_back(sc[g][2 * i + 1]);
        }
        sort(new_groups[i].begin(), new_groups[i].end());
        long long h1 = new_groups[i][2 * n - 1];
        long long h2 = new_groups[i][2 * n];
        long long l = 0, r = k;
        while (l + 1 < r)
        {
            int mid = (l + r) / 2;
            if (L[mid] <= h1)
                l = mid;
            else
                r = mid;
        }
        result = 1e18;
        if (l >= 0 && l < k)
            relax(new_groups[i], l);
        if (r >= 0 && r < k)
            relax(new_groups[i], r + 1);
        l = 0, r = k;
        while (l + 1 < r)
        {
            int mid = (l + r) / 2;
            if (L[mid] <= h2)
                l = mid;
            else
                r = mid;
        }
        if (l >= 0 && l < k)
            relax(new_groups[i], l);
        if (r >= 0 && r < k)
            relax(new_groups[i], r + 1);
        ans += result;
    }
    cout << ans;
}
/*

*/
