#include <bits/stdc++.h>

using namespace std;

struct even{
    int l, r;
};

bool cmp(even a, even b) {
    if (a.l != b.l)
        return a.l < b.l;
    return a.r > b.r;
}

bool cmp2(even a, even b) {
    if (a.r != b.r)
        return a.r < b.r;
    return a.l < b.r;
}

vector<even> L, R;
vector<int> q;

void relax(int x1, int x2, int l, int r, int& val) {
    int val2 = ((x1 >= l && x1 <= r) ? 0 : min(abs(x1 - l), abs(x1 - r))) + ((x2 >= l && x2 <= r) ? 0 : min(abs(x2 - l), abs(x2 - r)));
    val = min(val, val2);
}

int get(int x1, int x2, int l, int r) {
    int val2 = ((x1 >= l && x1 <= r) ? 0 : min(abs(x1 - l), abs(x1 - r))) + ((x2 >= l && x2 <= r) ? 0 : min(abs(x2 - l), abs(x2 - r)));
    return val2;
}

long long solve() {
    sort(q.begin(), q.end());

    long long sum = 0;

    for (int i = 0; i < q.size(); i += 2) {
        int ans = 2e9;
        even a, b;
        a.l = q[i], b.r = q[i + 1];

        auto A = lower_bound(L.begin(), L.end(), a, cmp);

        if (A != L.begin()) {
            a = *(A - 1);
            relax(q[i], q[i + 1], a.l, a.r, ans);
        }

        auto B = lower_bound(R.begin(), R.end(), b, cmp2);

        if (B != R.end()) {
            b = *B;
            relax(q[i], q[i + 1], b.l, b.r, ans);
        }

        while (A != L.end() && (*A).l <= q[i + 1]) {
            a = *A;
            relax(q[i], q[i + 1], a.l, a.r, ans);
            ++A;
        }

        sum += ans;
    }

    return sum;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);

    int m, n, k;
    cin >> m >> n >> k;

    vector<even> in(k);

    for (int i = 0; i < k; ++i) {
        cin >> in[i].l >> in[i].r;
    }

    if (m == 1) {

        L = in, R = in;

        sort(L.begin(), L.end(), cmp);
        sort(R.begin(), R.end(), cmp2);

        {
            vector<even> nl, nr;

            nl.push_back(L[0]);
            for (int i = 1; i < k; ++i) {
                if (L[i].l == L[i - 1].l || L[i].r <= nl.back().r)
                    continue;
                nl.push_back(L[i]);
            }

            nr.push_back(R[0]);
            for (int i = 1; i < k; ++i) {
                if (R[i].r == R[i - 1].r)
                    continue;
                while (nr.size() && nr.back().l >= R[i].l)
                    nr.pop_back();
                nr.push_back(R[i]);
            }

            L.swap(nl);
            R.swap(nr);
        }

        q.resize(2 * n);

        long long ans = 0;

        while (m--) {
            for (int i = 0; i < 2 * n; ++i)
                cin >> q[i];
            ans += solve();
        }

        cout << ans;
        return 0;
    }

    if (n == 1) {
        long long mn = 1e18;
        for (int i = 0; i < k; ++i) {
            long long sum = 0;
            for (int j = 0; j < m; ++j) {
                int a, b;
                cin >> a >> b;
                if (a > b)
                    swap(a, b);
                sum += get(a, b, in[i].l, in[i].r);
            }
            mn = min(mn, sum);
        }
        cout << mn;
        return 0;
    }
}