#include <bits/stdc++.h>

using namespace std;

#define endl '\n'
////////////////////////////////////////////////////////////////////


typedef long long ll;
typedef long double ld;
typedef pair<int, int> ii;
typedef pair<ii, int> iii;

const int INF = (int)1e9 + 1;
const ll INFLL = (ll)2e18 + 1;
const ld EPS = 1e-7;
const ll MOD = (ll)1e9 + 7;

#define all(a) a.begin(), a.end()
#define sz(a) ((int)a.size())
#define fi first
#define se second
////////////////////////////////////////////////////////////////////


const int MAX_M = (int)2e5;
const int MAX_N = (int)2e5;
const int MAX_K = (int)2e5;

struct event {
    int x, y, t;
};

bool cmp(event &a, event &b) {
    return a.x < b.x || a.x == b.x && a.t < b.t;
}

struct lst {
    int x, r;
};

int l[MAX_K], r[MAX_K];

lst last[MAX_M];

multiset<int> scr;
multiset<int> scl;
set<int> sl;
set<int> sr;

vector<int> a[MAX_M];

struct node {
    int mx, p;
    int l, r;
    node() {
        l = -1, r = -1;
        mx = -1, p = -1;
    }
};

int sz = 2;
node t[(int)2e7];

void upd(int v, int val) {
    t[v].mx = max(t[v].mx, val);
    t[v].p = max(t[v].p, val);
}

void push(int v) {
    if (t[v].l == -1) {
        //t[v].l = v * 2;
        t[v].l = sz++;
    }
    if (t[v].r == -1) {
        //t[v].r = v * 2 + 1;
        t[v].r = sz++;
    }
    if (t[v].p == -1)
        return;
    upd(t[v].l, t[v].p);
    upd(t[v].r, t[v].p);
    t[v].p = -1;
}

void update(int v, int tl, int tr, int l, int r, int val) {
    if (l > r)
        return;
    if (tl == l && tr == r) {
        upd(v, val);
    } else {
        push(v);
        int tm = (tl + tr) / 2;
        update(t[v].l, tl, tm, l, min(r, tm), val);
        update(t[v].r, tm + 1, tr, max(l, tm + 1), r, val);
        t[v].mx = max(t[t[v].l].mx, t[t[v].r].mx);
    }
}

int query(int v, int tl, int tr, int l, int r) {
    if (l > r)
        return -1;
    if (tl == l && tr == r) {
        return t[v].mx;
    }
    push(v);
    int tm = (tl + tr) / 2;
    return max(query(t[v].l, tl, tm, l, min(r, tm)),
               query(t[v].r, tm + 1, tr, max(l, tm + 1), r));
}

int MAX_X = (int)1e9;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int m, n, k;
    cin >> m >> n >> k;
    vector<event> e;
    for (int i = 0; i < k; ++i) {
        cin >> l[i] >> r[i];
        e.push_back({l[i], i, 0});
        e.push_back({r[i], i, 2});
        sl.insert(l[i]);
        sr.insert(r[i]);
        update(1, 0, MAX_X, l[i], r[i], r[i] - l[i]);
    }

    for (int i = 0; i < m; ++i) {
        last[i] = {-1, -1};
        a[i].assign(n * 2, 0);
        for (int j = 0; j < n * 2; ++j) {
            cin >> a[i][j];
            e.push_back({a[i][j], i, 1});
        }
    }

    sort(all(e), cmp);
    ll ans = 0;
    for (int i = 0; i < sz(e); ++i) {
        //cout << i << ": " << e[i].x << " " << e[i].y << " " << e[i].t << endl;
        if (e[i].t == 1) {
            int h = scl.empty() ? -1 : *scl.begin();
            int j = e[i].y;
            if (last[j].x == -1) {//если нет прошлой
                last[j].x = e[i].x;
                last[j].r = scr.empty() ? -1 : *(--scr.end());
            } else {// если есть прошлая
                //cout << ans << endl;
                if (last[j].r != -1 && last[j].r >= e[i].x) //если обе принадлежат одному отрезку
                    ans += 0;
                else { // если нет общего отрезка
                    if (last[j].r == -1 && h == -1) { // если оба не в отрезках, ищим ближайший от этих точек
                        int res = query(1, 0, MAX_X, last[j].x, e[i].x);//max на отрезке в неявном ДО
                        //cout << "res: " << res << endl;
                        if (res != -1)
                            ans += e[i].x - last[j].x + res;
                        else {
                            auto itl = sr.upper_bound(last[j].x);
                            auto itr = sl.upper_bound(e[i].x);
                            if (itl == sr.begin() || itr == sl.end())
                                h = itl == sr.begin() ? *itr : *(--itl);
                            else if (last[j].x - *(--itl) < *itr - e[i].x)
                                h = *itl;
                            else
                                h = *itr;
                            ans += abs(h - last[j].x) + abs(h - e[i].x);
                        }
                    } else {
                        if (h == -1 || last[j].r != -1 && e[i].x - last[j].r < h - last[j].x) //если новая не отрезке или лучше идти в отрезок прошлой
                            ans += e[i].x - last[j].r;
                        else //если прошлая не в отрезке или лучше идти в отрезок новой
                            ans += h - last[j].x;
                    }
                }
                //cout << ans << endl;
                last[j] = {-1, -1};
            }
        } else if (e[i].t == 0) {
            scl.insert(l[e[i].y]);
            scr.insert(r[e[i].y]);
        } else if (e[i].t == 2) {
            scl.erase(scl.find(l[e[i].y]));
            scr.erase(scr.find(r[e[i].y]));
        }
    }

    cout << ans << endl;

    return 0;
}


/*
5 1 5
1 6
12 17
9 9
2 4
6 7
2 5
5 7
8 10
9 17
14 14
-----------------------
8
*/
