#include <bits/stdc++.h>
using namespace std;
typedef vector<int> vint;
typedef string str;
#define pb push_back
#define int long long
#define rep(a, l, r) for (int a = l; a < r; a++)
#define sz(a) (int) a.size()
#define fs first
#define sc second

const long long inf = 1000000000000000000;

const int N = 4;//262144;

int val[N * 2], lazy[N * 2];

int version[N * 2];
int curVersion = 1;
inline void checkVersion(int cur) {
    if (version[cur] != curVersion) {
        version[cur] = curVersion;
        val[cur] = 0;
        lazy[cur] = 0;
    }
}

void pushdown(int cur) {
    checkVersion(cur);
    val[cur] += lazy[cur];
    if (cur < N) {
        checkVersion(cur << 1); checkVersion(cur << 1 | 1);
        val[cur << 1] += lazy[cur << 1];
        val[cur << 1 | 1] += lazy[cur << 1 | 1];
    }

    lazy[cur] = 0;
}

inline int query(int l, int r, int cur = 1, int ll = 1, int rr = N) {
    pushdown(cur);

    if (l > r)
        return inf;
    if (l == ll && r == rr)
        return val[cur];
    int mid = (ll + rr) >> 1;
    return min(query(l, min(mid, r), cur << 1, ll, mid), query(max(mid + 1, l), r, cur << 1 | 1, mid + 1, rr));
}

inline void upd(int l, int r, int v, int cur = 1, int ll = 1, int rr = N) {
    pushdown(cur);

    if (l > r)
        return;

    if (l == ll && r == rr) {
        lazy[cur] += v;
        pushdown(cur);
        return;
    }

    int mid = (ll + rr) >> 1;
    upd(l, min(r, mid), v, cur << 1, ll, mid);
    upd(max(l, mid + 1), r, v, cur << 1 | 1, mid + 1, rr);

    val[cur] = min(val[cur << 1], val[cur << 1 | 1]);
}

void run() {
    memset(version, 0, sizeof version);

    int m, n, k;
    cin >> m >> n >> k;

    pair<int, int> segRaw[k];
    for (int i = 0; i < k; i++)
        cin >> segRaw[i].fs >> segRaw[i].sc;

    sort(segRaw, segRaw + k);
    vector<pair<int, int>> willBeSeg;
    for (int i = 0; i < k; i++)
        if (willBeSeg.empty() || willBeSeg.back().sc < segRaw[i].sc)
            willBeSeg.pb(segRaw[i]);

    k = sz(willBeSeg);
    int L[k], R[k];
    for (int i = 0; i < k; i++) {
        L[i] = willBeSeg[i].fs;
        R[i] = willBeSeg[i].sc;
    }

    assert(is_sorted(L, L + k) && is_sorted(R, R + k));

    int where[n][2 * m];
    int h[2 * n];
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < 2 * n; j++)
            cin >> h[j];
        sort(h, h + 2 * n);

        for (int j = 0; j < n; j++) {
            where[j][i * 2] = h[j * 2];
            where[j][i * 2 + 1] = h[j * 2 + 1];
        }
    }

    int ans = 0;
    for (int i = 0; i < n; i++) {
        curVersion++;
        sort(where[i], where[i] + 2 * m);

        int l = k; ///1st segment where where[i][z] < L[l]
        int r = -1; ///last segment where R[r] < where[i][z]

        rep(z, 0, 2 * m) {
            int j = where[i][z];
            while (l && j < L[l - 1]) {
                l--;
                upd(l + 1, l + 1, L[l] * (2 * m - z));
            }
            upd(l + 1, k, -j); ///where value is L[i] - where[i][z]


            while (r < k - 1 && R[r + 1] < j) {
                r++;
                upd(r + 1, r + 1, -R[r] * z);
            }
            upd(1, r + 1, j); ///where value is where[i][z] - R[i]
        }

        //for (int z = 1; z <= k; z++) { cout << query(z, z) << " ";} cout << endl;

        ans += query(1, k);
    }

    cout << ans;
}

signed main() { ios::sync_with_stdio(0); cin.tie(0); run(); }
